(set-info :smt-lib-version 2.6)
(set-logic LRA)
(set-info :source |
Generated by: Eryk Kopczynski  erykk@mimuw.edu.pl
Generated on: 20160927
Generator: LOIS, http://www.mimuw.edu.pl/~erykk/lois/
Application: LOIS is a C++ library allowing iterating through certain infinite sets, in finite time. The resulting language has an intuitive semantics, corresponding to execution of infinitely many threads in parallel. This allows to merge the power of abstract mathematical constructions into imperative programming. Infinite sets are internally represented using first order formulas over some underlying logical structure. To effectively handle such sets, we use and implement SMT solvers for various first order theories. LOIS has applications in education, and in verification of infinite state systems. This is a technical documentation of LOIS, describing how to write programs using it. 
Target solver: CVC4, z3
Additional information: At the time when LOIS was presented at the SMT 2016 workshop, the SMT solvers we checked were much worse than the internal solver in LOIS, they failed on many queries. Today we have checked the newest nightly build of CVC4, and its performance is only slightly lower than internal. The newest Z3 from the GitHub repository is apparently still unable to solve some queries, though.
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?bkxv Real)
  (push 1)
    (declare-const ?bkxw Real)
    (push 1)
      (declare-const ?bkxx Real)
      (push 1)
        (assert
          (or (or (= ?bkxv ?bkxw)
              (= ?bkxv ?bkxx)
              )
            (= ?bkxw ?bkxx)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkxy Real)
  (declare-const ?bkxz Real)
  (declare-const ?bkya Real)
  (assert
    (or (or (= ?bkya ?bkxz)
        (= ?bkya ?bkxy)
        )
      (= ?bkxz ?bkxy)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?bkys Real)
    (declare-const ?bkyt Real)
    (declare-const ?bkyu Real)
    (assert
      (or (or (= ?bkyu ?bkyt)
          (= ?bkyu ?bkys)
          )
        (= ?bkyt ?bkys)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkyv Real)
  (push 1)
    (declare-const ?bkyw Real)
    (declare-const ?bkyx Real)
    (declare-const ?bkyy Real)
    (assert
      (or (or (= ?bkyy ?bkyx)
          (= ?bkyy ?bkyw)
          )
        (= ?bkyx ?bkyw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkyz Real)
  (declare-const ?bkza Real)
  (push 1)
    (declare-const ?bkzb Real)
    (declare-const ?bkzc Real)
    (declare-const ?bkzd Real)
    (assert
      (or (or (= ?bkzd ?bkzc)
          (= ?bkzd ?bkzb)
          )
        (= ?bkzc ?bkzb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkze Real)
  (declare-const ?bkzf Real)
  (declare-const ?bkzg Real)
  (push 1)
    (declare-const ?bkzh Real)
    (declare-const ?bkzi Real)
    (declare-const ?bkzj Real)
    (assert
      (or (or (= ?bkzj ?bkzi)
          (= ?bkzj ?bkzh)
          )
        (= ?bkzi ?bkzh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?bkzg ?bkzf))
          (not (= ?bkzg ?bkze))
          )
        (not (= ?bkzf ?bkze))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?bkzk Real)
    (declare-const ?bkzl Real)
    (declare-const ?bkzm Real)
    (assert
      (or (or (= ?bkzm ?bkzl)
          (= ?bkzm ?bkzk)
          )
        (= ?bkzl ?bkzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkzn Real)
  (declare-const ?bkzo Real)
  (declare-const ?bkzp Real)
  (assert
    (and (and (not (= ?bkzp ?bkzo))
        (not (= ?bkzp ?bkzn))
        )
      (not (= ?bkzo ?bkzn))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (declare-const ?bkzt Real)
      (declare-const ?bkzu Real)
      (declare-const ?bkzv Real)
      (assert
        (or (or (= ?bkzv ?bkzu)
            (= ?bkzv ?bkzt)
            )
          (= ?bkzu ?bkzt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkzw Real)
        (declare-const ?bkzx Real)
        (declare-const ?bkzy Real)
        (assert
          (or (or (= ?bkzy ?bkzx)
              (= ?bkzy ?bkzw)
              )
            (= ?bkzx ?bkzw)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bkzz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blaa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blab Real)
            (declare-const ?blac Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blad Real)
            (declare-const ?blae Real)
            (declare-const ?blaf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blag Real)
            (declare-const ?blah Real)
            (declare-const ?blai Real)
            (declare-const ?blaj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blak Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blal Real)
          (declare-const ?blam Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blan Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blao Real)
            (declare-const ?blap Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blaq Real)
            (declare-const ?blar Real)
            (declare-const ?blas Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blat Real)
            (declare-const ?blau Real)
            (declare-const ?blav Real)
            (declare-const ?blaw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blax Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blay Real)
          (declare-const ?blaz Real)
          (declare-const ?blba Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blbb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbc Real)
            (declare-const ?blbd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbe Real)
            (declare-const ?blbf Real)
            (declare-const ?blbg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbh Real)
            (declare-const ?blbi Real)
            (declare-const ?blbj Real)
            (declare-const ?blbk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blbm Real)
          (declare-const ?blbn Real)
          (declare-const ?blbo Real)
          (declare-const ?blbp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blbq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbr Real)
            (declare-const ?blbs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbt Real)
            (declare-const ?blbu Real)
            (declare-const ?blbv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blbw Real)
            (declare-const ?blbx Real)
            (declare-const ?blby Real)
            (declare-const ?blbz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?blbo ?bkzv)
                        (= ?blbn ?bkzu)
                        )
                      (= ?blbm ?bkzt)
                      )
                    (and (and (= ?blby ?bkzy)
                        (= ?blbx ?bkzx)
                        )
                      (= ?blbw ?bkzw)
                      )
                    )
                  (= ?blbp ?blbz)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?blca Real)
                  (declare-const ?blcb Real)
                  (declare-const ?blcc Real)
                  (assert
                    (or (or (= ?blcc ?blcb)
                        (= ?blcc ?blca)
                        )
                      (= ?blcb ?blca)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blcd Real)
                  (declare-const ?blce Real)
                  (declare-const ?blcf Real)
                  (assert
                    (or (or (= ?blcf ?blce)
                        (= ?blcf ?blcd)
                        )
                      (= ?blce ?blcd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blcg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blch Real)
                  (declare-const ?blci Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blcj Real)
                  (declare-const ?blck Real)
                  (declare-const ?blcl Real)
                  (assert
                    (and (and (not (= ?blcl ?blck))
                        (not (= ?blcl ?blcj))
                        )
                      (not (= ?blck ?blcj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blcm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blcn Real)
                  (declare-const ?blco Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blcp Real)
                  (declare-const ?blcq Real)
                  (declare-const ?blcr Real)
                  (assert
                    (and (and (not (= ?blcr ?blcq))
                        (not (= ?blcr ?blcp))
                        )
                      (not (= ?blcq ?blcp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?blcs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blct Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blcu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blcv Real)
            (declare-const ?blcw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blcx Real)
            (declare-const ?blcy Real)
            (declare-const ?blcz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blda Real)
            (declare-const ?bldb Real)
            (declare-const ?bldc Real)
            (declare-const ?bldd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blde Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bldf Real)
        (declare-const ?bldg Real)
        (declare-const ?bldh Real)
        (assert
          (or (or (= ?bldh ?bldg)
              (= ?bldh ?bldf)
              )
            (= ?bldg ?bldf)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (push 1)
          (declare-const ?bldi Real)
          (push 1)
            (declare-const ?bldj Real)
            (push 1)
              (assert
                (= ?bldi ?bldj)
                )
              (push 1)
                (push 1)
                  (declare-const ?bldk Real)
                  (declare-const ?bldl Real)
                  (declare-const ?bldm Real)
                  (assert
                    (or (or (= ?bldm ?bldl)
                        (= ?bldm ?bldk)
                        )
                      (= ?bldl ?bldk)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bldn Real)
                  (declare-const ?bldo Real)
                  (declare-const ?bldp Real)
                  (assert
                    (or (or (= ?bldp ?bldo)
                        (= ?bldp ?bldn)
                        )
                      (= ?bldo ?bldn)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bldq Real)
                  (declare-const ?bldr Real)
                  (declare-const ?blds Real)
                  (assert
                    (and (and (not (= ?blds ?bldr))
                        (not (= ?blds ?bldq))
                        )
                      (not (= ?bldr ?bldq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bldt Real)
                  (declare-const ?bldu Real)
                  (declare-const ?bldv Real)
                  (assert
                    (and (and (not (= ?bldv ?bldu))
                        (not (= ?bldv ?bldt))
                        )
                      (not (= ?bldu ?bldt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bldw Real)
        (push 1)
          (declare-const ?bldx Real)
          (push 1)
            (declare-const ?bldy Real)
            (declare-const ?bldz Real)
            (push 1)
              (assert
                (and (= ?bldy ?bldw)
                  (= ?bldx ?bldz)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?blea Real)
                  (declare-const ?bleb Real)
                  (declare-const ?blec Real)
                  (assert
                    (or (or (= ?blec ?bleb)
                        (= ?blec ?blea)
                        )
                      (= ?bleb ?blea)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bled Real)
                  (declare-const ?blee Real)
                  (declare-const ?blef Real)
                  (assert
                    (or (or (= ?blef ?blee)
                        (= ?blef ?bled)
                        )
                      (= ?blee ?bled)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bleg Real)
                  (declare-const ?bleh Real)
                  (declare-const ?blei Real)
                  (assert
                    (and (and (not (= ?blei ?bleh))
                        (not (= ?blei ?bleg))
                        )
                      (not (= ?bleh ?bleg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blej Real)
                  (declare-const ?blek Real)
                  (declare-const ?blel Real)
                  (assert
                    (and (and (not (= ?blel ?blek))
                        (not (= ?blel ?blej))
                        )
                      (not (= ?blek ?blej))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blem Real)
        (declare-const ?blen Real)
        (push 1)
          (declare-const ?bleo Real)
          (push 1)
            (declare-const ?blep Real)
            (declare-const ?bleq Real)
            (declare-const ?bler Real)
            (push 1)
              (assert
                (and (and (= ?bleq ?blen)
                    (= ?blep ?blem)
                    )
                  (= ?bleo ?bler)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?bles Real)
                  (declare-const ?blet Real)
                  (declare-const ?bleu Real)
                  (assert
                    (or (or (= ?bleu ?blet)
                        (= ?bleu ?bles)
                        )
                      (= ?blet ?bles)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blev Real)
                  (declare-const ?blew Real)
                  (declare-const ?blex Real)
                  (assert
                    (or (or (= ?blex ?blew)
                        (= ?blex ?blev)
                        )
                      (= ?blew ?blev)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bley Real)
                  (declare-const ?blez Real)
                  (declare-const ?blfa Real)
                  (assert
                    (and (and (not (= ?blfa ?blez))
                        (not (= ?blfa ?bley))
                        )
                      (not (= ?blez ?bley))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blfb Real)
                  (declare-const ?blfc Real)
                  (declare-const ?blfd Real)
                  (assert
                    (and (and (not (= ?blfd ?blfc))
                        (not (= ?blfd ?blfb))
                        )
                      (not (= ?blfc ?blfb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?bleq ?blep)
                      (= ?bleq ?bler)
                      )
                    (= ?blep ?bler)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?blen ?blem))
              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                  (not (= ?blem ?bler))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?blen ?blem)
              (exists ((?bler Real) )(or (= ?blen ?bler)
                  (= ?blem ?bler)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blfe Real)
        (declare-const ?blff Real)
        (declare-const ?blfg Real)
        (assert
          (and (and (not (= ?blfg ?blff))
              (not (= ?blfg ?blfe))
              )
            (not (= ?blff ?blfe))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?blfh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blfi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blfj Real)
            (declare-const ?blfk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blfl Real)
            (declare-const ?blfm Real)
            (declare-const ?blfn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blfo Real)
            (declare-const ?blfp Real)
            (declare-const ?blfq Real)
            (declare-const ?blfr Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?blfq ?blfg)
                      (= ?blfp ?blff)
                      )
                    (= ?blfo ?blfe)
                    )
                  (= ?blfh ?blfr)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?blfs Real)
                  (declare-const ?blft Real)
                  (declare-const ?blfu Real)
                  (assert
                    (or (or (= ?blfu ?blft)
                        (= ?blfu ?blfs)
                        )
                      (= ?blft ?blfs)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blfv Real)
                  (declare-const ?blfw Real)
                  (declare-const ?blfx Real)
                  (assert
                    (or (or (= ?blfx ?blfw)
                        (= ?blfx ?blfv)
                        )
                      (= ?blfw ?blfv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blfy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blfz Real)
                  (declare-const ?blga Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blgb Real)
                  (declare-const ?blgc Real)
                  (declare-const ?blgd Real)
                  (assert
                    (and (and (not (= ?blgd ?blgc))
                        (not (= ?blgd ?blgb))
                        )
                      (not (= ?blgc ?blgb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blge Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blgf Real)
                  (declare-const ?blgg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blgh Real)
                  (declare-const ?blgi Real)
                  (declare-const ?blgj Real)
                  (assert
                    (and (and (not (= ?blgj ?blgi))
                        (not (= ?blgj ?blgh))
                        )
                      (not (= ?blgi ?blgh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?blgk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blgl Real)
          (declare-const ?blgm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blgn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blgo Real)
            (declare-const ?blgp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blgq Real)
            (declare-const ?blgr Real)
            (declare-const ?blgs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blgt Real)
            (declare-const ?blgu Real)
            (declare-const ?blgv Real)
            (declare-const ?blgw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blgx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blgy Real)
          (declare-const ?blgz Real)
          (declare-const ?blha Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blhb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blhc Real)
            (declare-const ?blhd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blhe Real)
            (declare-const ?blhf Real)
            (declare-const ?blhg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blhh Real)
            (declare-const ?blhi Real)
            (declare-const ?blhj Real)
            (declare-const ?blhk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blhl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blhm Real)
          (declare-const ?blhn Real)
          (declare-const ?blho Real)
          (declare-const ?blhp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blhq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blhr Real)
            (declare-const ?blhs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blht Real)
            (declare-const ?blhu Real)
            (declare-const ?blhv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blhw Real)
            (declare-const ?blhx Real)
            (declare-const ?blhy Real)
            (declare-const ?blhz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blia Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blib Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blic Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blid Real)
            (declare-const ?blie Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blif Real)
            (declare-const ?blig Real)
            (declare-const ?blih Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blii Real)
            (declare-const ?blij Real)
            (declare-const ?blik Real)
            (declare-const ?blil Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blim Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?blin Real)
          (push 1)
            (declare-const ?blio Real)
            (push 1)
              (assert
                (= ?blin ?blio)
                )
              (push 1)
                (push 1)
                  (declare-const ?blip Real)
                  (declare-const ?bliq Real)
                  (declare-const ?blir Real)
                  (assert
                    (or (or (= ?blir ?bliq)
                        (= ?blir ?blip)
                        )
                      (= ?bliq ?blip)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blis Real)
                  (declare-const ?blit Real)
                  (declare-const ?bliu Real)
                  (assert
                    (or (or (= ?bliu ?blit)
                        (= ?bliu ?blis)
                        )
                      (= ?blit ?blis)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bliv Real)
                  (declare-const ?bliw Real)
                  (declare-const ?blix Real)
                  (assert
                    (and (and (not (= ?blix ?bliw))
                        (not (= ?blix ?bliv))
                        )
                      (not (= ?bliw ?bliv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bliy Real)
                  (declare-const ?bliz Real)
                  (declare-const ?blja Real)
                  (assert
                    (and (and (not (= ?blja ?bliz))
                        (not (= ?blja ?bliy))
                        )
                      (not (= ?bliz ?bliy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bljb Real)
        (declare-const ?bljc Real)
        (declare-const ?bljd Real)
        (assert
          (and (and (not (= ?bljd ?bljc))
              (not (= ?bljd ?bljb))
              )
            (not (= ?bljc ?bljb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?blje Real)
      (push 1)
        (push 1)
          (declare-const ?bljf Real)
          (declare-const ?bljg Real)
          (push 1)
            (declare-const ?bljh Real)
            (push 1)
              (assert
                (and (= ?bljf ?blje)
                  (= ?bljg ?bljh)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?blji Real)
                  (declare-const ?bljj Real)
                  (declare-const ?bljk Real)
                  (assert
                    (or (or (= ?bljk ?bljj)
                        (= ?bljk ?blji)
                        )
                      (= ?bljj ?blji)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bljl Real)
                  (declare-const ?bljm Real)
                  (declare-const ?bljn Real)
                  (assert
                    (or (or (= ?bljn ?bljm)
                        (= ?bljn ?bljl)
                        )
                      (= ?bljm ?bljl)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bljo Real)
                  (declare-const ?bljp Real)
                  (declare-const ?bljq Real)
                  (assert
                    (and (and (not (= ?bljq ?bljp))
                        (not (= ?bljq ?bljo))
                        )
                      (not (= ?bljp ?bljo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bljr Real)
                  (declare-const ?bljs Real)
                  (declare-const ?bljt Real)
                  (assert
                    (and (and (not (= ?bljt ?bljs))
                        (not (= ?bljt ?bljr))
                        )
                      (not (= ?bljs ?bljr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blju Real)
        (push 1)
          (declare-const ?bljv Real)
          (declare-const ?bljw Real)
          (push 1)
            (declare-const ?bljx Real)
            (declare-const ?bljy Real)
            (push 1)
              (assert
                (and (and (= ?bljv ?blje)
                    (= ?bljx ?blju)
                    )
                  (= ?bljw ?bljy)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?bljz Real)
                  (declare-const ?blka Real)
                  (declare-const ?blkb Real)
                  (assert
                    (or (or (= ?blkb ?blka)
                        (= ?blkb ?bljz)
                        )
                      (= ?blka ?bljz)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blkc Real)
                  (declare-const ?blkd Real)
                  (declare-const ?blke Real)
                  (assert
                    (or (or (= ?blke ?blkd)
                        (= ?blke ?blkc)
                        )
                      (= ?blkd ?blkc)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blkf Real)
                  (declare-const ?blkg Real)
                  (declare-const ?blkh Real)
                  (assert
                    (and (and (not (= ?blkh ?blkg))
                        (not (= ?blkh ?blkf))
                        )
                      (not (= ?blkg ?blkf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blki Real)
                  (declare-const ?blkj Real)
                  (declare-const ?blkk Real)
                  (assert
                    (and (and (not (= ?blkk ?blkj))
                        (not (= ?blkk ?blki))
                        )
                      (not (= ?blkj ?blki))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blkl Real)
        (declare-const ?blkm Real)
        (push 1)
          (declare-const ?blkn Real)
          (declare-const ?blko Real)
          (push 1)
            (declare-const ?blkp Real)
            (declare-const ?blkq Real)
            (declare-const ?blkr Real)
            (push 1)
              (assert
                (and (and (= ?blkn ?blje)
                    (and (= ?blkq ?blkm)
                      (= ?blkp ?blkl)
                      )
                    )
                  (= ?blko ?blkr)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?blks Real)
                  (declare-const ?blkt Real)
                  (declare-const ?blku Real)
                  (assert
                    (or (or (= ?blku ?blkt)
                        (= ?blku ?blks)
                        )
                      (= ?blkt ?blks)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blkv Real)
                  (declare-const ?blkw Real)
                  (declare-const ?blkx Real)
                  (assert
                    (or (or (= ?blkx ?blkw)
                        (= ?blkx ?blkv)
                        )
                      (= ?blkw ?blkv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blky Real)
                  (declare-const ?blkz Real)
                  (declare-const ?blla Real)
                  (assert
                    (and (and (not (= ?blla ?blkz))
                        (not (= ?blla ?blky))
                        )
                      (not (= ?blkz ?blky))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bllb Real)
                  (declare-const ?bllc Real)
                  (declare-const ?blld Real)
                  (assert
                    (and (and (not (= ?blld ?bllc))
                        (not (= ?blld ?bllb))
                        )
                      (not (= ?bllc ?bllb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?blkq ?blkp)
                      (= ?blkq ?blkr)
                      )
                    (= ?blkp ?blkr)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?blkm ?blkl))
              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                  (not (= ?blkl ?blkr))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?blkm ?blkl)
              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                  (= ?blkl ?blkr)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blle Real)
        (declare-const ?bllf Real)
        (declare-const ?bllg Real)
        (assert
          (and (and (not (= ?bllg ?bllf))
              (not (= ?bllg ?blle))
              )
            (not (= ?bllf ?blle))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bllh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blli Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bllj Real)
            (declare-const ?bllk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blll Real)
            (declare-const ?bllm Real)
            (declare-const ?blln Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bllo Real)
            (declare-const ?bllp Real)
            (declare-const ?bllq Real)
            (declare-const ?bllr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blls Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bllt Real)
          (declare-const ?bllu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bllv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bllw Real)
            (declare-const ?bllx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blly Real)
            (declare-const ?bllz Real)
            (declare-const ?blma Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blmb Real)
            (declare-const ?blmc Real)
            (declare-const ?blmd Real)
            (declare-const ?blme Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (= ?bllt ?blje)
                    (and (and (= ?blmd ?bllg)
                        (= ?blmc ?bllf)
                        )
                      (= ?blmb ?blle)
                      )
                    )
                  (= ?bllu ?blme)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?blmf Real)
                  (declare-const ?blmg Real)
                  (declare-const ?blmh Real)
                  (assert
                    (or (or (= ?blmh ?blmg)
                        (= ?blmh ?blmf)
                        )
                      (= ?blmg ?blmf)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blmi Real)
                  (declare-const ?blmj Real)
                  (declare-const ?blmk Real)
                  (assert
                    (or (or (= ?blmk ?blmj)
                        (= ?blmk ?blmi)
                        )
                      (= ?blmj ?blmi)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blml Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blmm Real)
                  (declare-const ?blmn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blmo Real)
                  (declare-const ?blmp Real)
                  (declare-const ?blmq Real)
                  (assert
                    (and (and (not (= ?blmq ?blmp))
                        (not (= ?blmq ?blmo))
                        )
                      (not (= ?blmp ?blmo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blmr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blms Real)
                  (declare-const ?blmt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blmu Real)
                  (declare-const ?blmv Real)
                  (declare-const ?blmw Real)
                  (assert
                    (and (and (not (= ?blmw ?blmv))
                        (not (= ?blmw ?blmu))
                        )
                      (not (= ?blmv ?blmu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?blmx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blmy Real)
          (declare-const ?blmz Real)
          (declare-const ?blna Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blnb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blnc Real)
            (declare-const ?blnd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blne Real)
            (declare-const ?blnf Real)
            (declare-const ?blng Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blnh Real)
            (declare-const ?blni Real)
            (declare-const ?blnj Real)
            (declare-const ?blnk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blnl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blnm Real)
          (declare-const ?blnn Real)
          (declare-const ?blno Real)
          (declare-const ?blnp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blnq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blnr Real)
            (declare-const ?blns Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blnt Real)
            (declare-const ?blnu Real)
            (declare-const ?blnv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blnw Real)
            (declare-const ?blnx Real)
            (declare-const ?blny Real)
            (declare-const ?blnz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bloa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blob Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bloc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blod Real)
            (declare-const ?bloe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blof Real)
            (declare-const ?blog Real)
            (declare-const ?bloh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bloi Real)
            (declare-const ?bloj Real)
            (declare-const ?blok Real)
            (declare-const ?blol Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blom Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?blon Real)
          (declare-const ?bloo Real)
          (push 1)
            (declare-const ?blop Real)
            (push 1)
              (assert
                (and (= ?blon ?blje)
                  (= ?bloo ?blop)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?bloq Real)
                  (declare-const ?blor Real)
                  (declare-const ?blos Real)
                  (assert
                    (or (or (= ?blos ?blor)
                        (= ?blos ?bloq)
                        )
                      (= ?blor ?bloq)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blot Real)
                  (declare-const ?blou Real)
                  (declare-const ?blov Real)
                  (assert
                    (or (or (= ?blov ?blou)
                        (= ?blov ?blot)
                        )
                      (= ?blou ?blot)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blow Real)
                  (declare-const ?blox Real)
                  (declare-const ?bloy Real)
                  (assert
                    (and (and (not (= ?bloy ?blox))
                        (not (= ?bloy ?blow))
                        )
                      (not (= ?blox ?blow))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bloz Real)
                  (declare-const ?blpa Real)
                  (declare-const ?blpb Real)
                  (assert
                    (and (and (not (= ?blpb ?blpa))
                        (not (= ?blpb ?bloz))
                        )
                      (not (= ?blpa ?bloz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blpc Real)
        (declare-const ?blpd Real)
        (declare-const ?blpe Real)
        (assert
          (and (and (not (= ?blpe ?blpd))
              (not (= ?blpe ?blpc))
              )
            (not (= ?blpd ?blpc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?blpf Real)
      (declare-const ?blpg Real)
      (push 1)
        (push 1)
          (declare-const ?blph Real)
          (declare-const ?blpi Real)
          (declare-const ?blpj Real)
          (push 1)
            (declare-const ?blpk Real)
            (push 1)
              (assert
                (and (and (= ?blpi ?blpg)
                    (= ?blph ?blpf)
                    )
                  (= ?blpj ?blpk)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?blpl Real)
                  (declare-const ?blpm Real)
                  (declare-const ?blpn Real)
                  (assert
                    (or (or (= ?blpn ?blpm)
                        (= ?blpn ?blpl)
                        )
                      (= ?blpm ?blpl)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blpo Real)
                  (declare-const ?blpp Real)
                  (declare-const ?blpq Real)
                  (assert
                    (or (or (= ?blpq ?blpp)
                        (= ?blpq ?blpo)
                        )
                      (= ?blpp ?blpo)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blpr Real)
                  (declare-const ?blps Real)
                  (declare-const ?blpt Real)
                  (assert
                    (and (and (not (= ?blpt ?blps))
                        (not (= ?blpt ?blpr))
                        )
                      (not (= ?blps ?blpr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blpu Real)
                  (declare-const ?blpv Real)
                  (declare-const ?blpw Real)
                  (assert
                    (and (and (not (= ?blpw ?blpv))
                        (not (= ?blpw ?blpu))
                        )
                      (not (= ?blpv ?blpu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?blpi ?blph)
                      (= ?blpi ?blpj)
                      )
                    (= ?blph ?blpj)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?blpg ?blpf))
              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                  (not (= ?blpf ?blpj))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?blpg ?blpf)
              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                  (= ?blpf ?blpj)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blpx Real)
        (push 1)
          (declare-const ?blpy Real)
          (declare-const ?blpz Real)
          (declare-const ?blqa Real)
          (push 1)
            (declare-const ?blqb Real)
            (declare-const ?blqc Real)
            (push 1)
              (assert
                (and (and (and (= ?blpz ?blpg)
                      (= ?blpy ?blpf)
                      )
                    (= ?blqb ?blpx)
                    )
                  (= ?blqa ?blqc)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?blqd Real)
                  (declare-const ?blqe Real)
                  (declare-const ?blqf Real)
                  (assert
                    (or (or (= ?blqf ?blqe)
                        (= ?blqf ?blqd)
                        )
                      (= ?blqe ?blqd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blqg Real)
                  (declare-const ?blqh Real)
                  (declare-const ?blqi Real)
                  (assert
                    (or (or (= ?blqi ?blqh)
                        (= ?blqi ?blqg)
                        )
                      (= ?blqh ?blqg)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blqj Real)
                  (declare-const ?blqk Real)
                  (declare-const ?blql Real)
                  (assert
                    (and (and (not (= ?blql ?blqk))
                        (not (= ?blql ?blqj))
                        )
                      (not (= ?blqk ?blqj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blqm Real)
                  (declare-const ?blqn Real)
                  (declare-const ?blqo Real)
                  (assert
                    (and (and (not (= ?blqo ?blqn))
                        (not (= ?blqo ?blqm))
                        )
                      (not (= ?blqn ?blqm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?blpz ?blpy)
                      (= ?blpz ?blqa)
                      )
                    (= ?blpy ?blqa)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?blpg ?blpf))
              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                  (not (= ?blpf ?blqc))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?blpg ?blpf)
              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                  (= ?blpf ?blqc)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blqp Real)
        (declare-const ?blqq Real)
        (push 1)
          (declare-const ?blqr Real)
          (declare-const ?blqs Real)
          (declare-const ?blqt Real)
          (push 1)
            (declare-const ?blqu Real)
            (declare-const ?blqv Real)
            (declare-const ?blqw Real)
            (push 1)
              (assert
                (and (and (and (= ?blqs ?blpg)
                      (= ?blqr ?blpf)
                      )
                    (and (= ?blqv ?blqq)
                      (= ?blqu ?blqp)
                      )
                    )
                  (= ?blqt ?blqw)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?blqx Real)
                  (declare-const ?blqy Real)
                  (declare-const ?blqz Real)
                  (assert
                    (or (or (= ?blqz ?blqy)
                        (= ?blqz ?blqx)
                        )
                      (= ?blqy ?blqx)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blra Real)
                  (declare-const ?blrb Real)
                  (declare-const ?blrc Real)
                  (assert
                    (or (or (= ?blrc ?blrb)
                        (= ?blrc ?blra)
                        )
                      (= ?blrb ?blra)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blrd Real)
                  (declare-const ?blre Real)
                  (declare-const ?blrf Real)
                  (assert
                    (and (and (not (= ?blrf ?blre))
                        (not (= ?blrf ?blrd))
                        )
                      (not (= ?blre ?blrd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blrg Real)
                  (declare-const ?blrh Real)
                  (declare-const ?blri Real)
                  (assert
                    (and (and (not (= ?blri ?blrh))
                        (not (= ?blri ?blrg))
                        )
                      (not (= ?blrh ?blrg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (and (or (or (= ?blqs ?blqr)
                          (= ?blqs ?blqt)
                          )
                        (= ?blqr ?blqt)
                        )
                      (and (and (not (= ?blqv ?blqu))
                          (not (= ?blqv ?blqw))
                          )
                        (not (= ?blqu ?blqw))
                        )
                      )
                    (and (and (and (not (= ?blqs ?blqr))
                          (not (= ?blqs ?blqt))
                          )
                        (not (= ?blqr ?blqt))
                        )
                      (or (or (= ?blqv ?blqu)
                          (= ?blqv ?blqw)
                          )
                        (= ?blqu ?blqw)
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                      (not (= ?blpg ?blqw))
                      )
                    (not (= ?blpf ?blqw))
                    )
                  (or (or (= ?blqq ?blqp)
                      (= ?blqq ?blqw)
                      )
                    (= ?blqp ?blqw)
                    )
                  )
                (or (or (or (= ?blpg ?blpf)
                      (= ?blpg ?blqw)
                      )
                    (= ?blpf ?blqw)
                    )
                  (and (and (not (= ?blqq ?blqp))
                      (not (= ?blqq ?blqw))
                      )
                    (not (= ?blqp ?blqw))
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                      (= ?blpg ?blqw)
                      )
                    (= ?blpf ?blqw)
                    )
                  (and (and (not (= ?blqq ?blqp))
                      (not (= ?blqq ?blqw))
                      )
                    (not (= ?blqp ?blqw))
                    )
                  )
                (and (and (and (not (= ?blpg ?blpf))
                      (not (= ?blpg ?blqw))
                      )
                    (not (= ?blpf ?blqw))
                    )
                  (or (or (= ?blqq ?blqp)
                      (= ?blqq ?blqw)
                      )
                    (= ?blqp ?blqw)
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blrj Real)
        (declare-const ?blrk Real)
        (declare-const ?blrl Real)
        (assert
          (and (and (not (= ?blrl ?blrk))
              (not (= ?blrl ?blrj))
              )
            (not (= ?blrk ?blrj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?blrm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blrn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blro Real)
            (declare-const ?blrp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blrq Real)
            (declare-const ?blrr Real)
            (declare-const ?blrs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blrt Real)
            (declare-const ?blru Real)
            (declare-const ?blrv Real)
            (declare-const ?blrw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blrx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blry Real)
          (declare-const ?blrz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blsa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsb Real)
            (declare-const ?blsc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsd Real)
            (declare-const ?blse Real)
            (declare-const ?blsf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsg Real)
            (declare-const ?blsh Real)
            (declare-const ?blsi Real)
            (declare-const ?blsj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blsl Real)
          (declare-const ?blsm Real)
          (declare-const ?blsn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blso Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsp Real)
            (declare-const ?blsq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsr Real)
            (declare-const ?blss Real)
            (declare-const ?blst Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blsu Real)
            (declare-const ?blsv Real)
            (declare-const ?blsw Real)
            (declare-const ?blsx Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?blsm ?blpg)
                      (= ?blsl ?blpf)
                      )
                    (and (and (= ?blsw ?blrl)
                        (= ?blsv ?blrk)
                        )
                      (= ?blsu ?blrj)
                      )
                    )
                  (= ?blsn ?blsx)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?blsy Real)
                  (declare-const ?blsz Real)
                  (declare-const ?blta Real)
                  (assert
                    (or (or (= ?blta ?blsz)
                        (= ?blta ?blsy)
                        )
                      (= ?blsz ?blsy)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bltb Real)
                  (declare-const ?bltc Real)
                  (declare-const ?bltd Real)
                  (assert
                    (or (or (= ?bltd ?bltc)
                        (= ?bltd ?bltb)
                        )
                      (= ?bltc ?bltb)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blte Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bltf Real)
                  (declare-const ?bltg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blth Real)
                  (declare-const ?blti Real)
                  (declare-const ?bltj Real)
                  (assert
                    (and (and (not (= ?bltj ?blti))
                        (not (= ?bltj ?blth))
                        )
                      (not (= ?blti ?blth))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bltk Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bltl Real)
                  (declare-const ?bltm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bltn Real)
                  (declare-const ?blto Real)
                  (declare-const ?bltp Real)
                  (assert
                    (and (and (not (= ?bltp ?blto))
                        (not (= ?bltp ?bltn))
                        )
                      (not (= ?blto ?bltn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?blsm ?blsl)
                      (= ?blsm ?blsn)
                      )
                    (= ?blsl ?blsn)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bltq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bltr Real)
          (declare-const ?blts Real)
          (declare-const ?bltt Real)
          (declare-const ?bltu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bltv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bltw Real)
            (declare-const ?bltx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blty Real)
            (declare-const ?bltz Real)
            (declare-const ?blua Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blub Real)
            (declare-const ?bluc Real)
            (declare-const ?blud Real)
            (declare-const ?blue Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bluf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blug Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bluh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blui Real)
            (declare-const ?bluj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bluk Real)
            (declare-const ?blul Real)
            (declare-const ?blum Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blun Real)
            (declare-const ?bluo Real)
            (declare-const ?blup Real)
            (declare-const ?bluq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blur Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?blpg ?blpf))
              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                  (not (= ?blpf ?blsx))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?blpg ?blpf)
              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                  (= ?blpf ?blsx)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?blus Real)
          (declare-const ?blut Real)
          (declare-const ?bluu Real)
          (push 1)
            (declare-const ?bluv Real)
            (push 1)
              (assert
                (and (and (= ?blut ?blpg)
                    (= ?blus ?blpf)
                    )
                  (= ?bluu ?bluv)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?bluw Real)
                  (declare-const ?blux Real)
                  (declare-const ?bluy Real)
                  (assert
                    (or (or (= ?bluy ?blux)
                        (= ?bluy ?bluw)
                        )
                      (= ?blux ?bluw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bluz Real)
                  (declare-const ?blva Real)
                  (declare-const ?blvb Real)
                  (assert
                    (or (or (= ?blvb ?blva)
                        (= ?blvb ?bluz)
                        )
                      (= ?blva ?bluz)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?blvc Real)
                  (declare-const ?blvd Real)
                  (declare-const ?blve Real)
                  (assert
                    (and (and (not (= ?blve ?blvd))
                        (not (= ?blve ?blvc))
                        )
                      (not (= ?blvd ?blvc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blvf Real)
                  (declare-const ?blvg Real)
                  (declare-const ?blvh Real)
                  (assert
                    (and (and (not (= ?blvh ?blvg))
                        (not (= ?blvh ?blvf))
                        )
                      (not (= ?blvg ?blvf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?blut ?blus)
                      (= ?blut ?bluu)
                      )
                    (= ?blus ?bluu)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?blpg ?blpf))
              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                  (not (= ?blpf ?bluu))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?blpg ?blpf)
              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                  (= ?blpf ?bluu)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blvi Real)
        (declare-const ?blvj Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                    (not (= ?blpg ?blqw))
                    )
                  (not (= ?blpf ?blqw))
                  )
                (or (or (= ?blvj ?blvi)
                    (= ?blvj ?blqw)
                    )
                  (= ?blvi ?blqw)
                  )
                )
              (or (or (or (= ?blpg ?blpf)
                    (= ?blpg ?blqw)
                    )
                  (= ?blpf ?blqw)
                  )
                (not (= ?blvj ?blvi))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?blvk Real)
      (declare-const ?blvl Real)
      (declare-const ?blvm Real)
      (assert
        (and (and (not (= ?blvm ?blvl))
            (not (= ?blvm ?blvk))
            )
          (not (= ?blvl ?blvk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?blvn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blvo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blvp Real)
            (declare-const ?blvq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blvr Real)
            (declare-const ?blvs Real)
            (declare-const ?blvt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blvu Real)
            (declare-const ?blvv Real)
            (declare-const ?blvw Real)
            (declare-const ?blvx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blvy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blvz Real)
          (declare-const ?blwa Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blwb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwc Real)
            (declare-const ?blwd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwe Real)
            (declare-const ?blwf Real)
            (declare-const ?blwg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwh Real)
            (declare-const ?blwi Real)
            (declare-const ?blwj Real)
            (declare-const ?blwk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blwm Real)
          (declare-const ?blwn Real)
          (declare-const ?blwo Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blwp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwq Real)
            (declare-const ?blwr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blws Real)
            (declare-const ?blwt Real)
            (declare-const ?blwu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwv Real)
            (declare-const ?blww Real)
            (declare-const ?blwx Real)
            (declare-const ?blwy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blwz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blxa Real)
          (declare-const ?blxb Real)
          (declare-const ?blxc Real)
          (declare-const ?blxd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blxe Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?blxc ?blvm)
                      (= ?blxb ?blvl)
                      )
                    (= ?blxa ?blvk)
                    )
                  (= ?blxd ?blxe)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?blxf Real)
                  (declare-const ?blxg Real)
                  (declare-const ?blxh Real)
                  (assert
                    (or (or (= ?blxh ?blxg)
                        (= ?blxh ?blxf)
                        )
                      (= ?blxg ?blxf)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxi Real)
                  (declare-const ?blxj Real)
                  (declare-const ?blxk Real)
                  (assert
                    (or (or (= ?blxk ?blxj)
                        (= ?blxk ?blxi)
                        )
                      (= ?blxj ?blxi)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxm Real)
                  (declare-const ?blxn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxo Real)
                  (declare-const ?blxp Real)
                  (declare-const ?blxq Real)
                  (assert
                    (and (and (not (= ?blxq ?blxp))
                        (not (= ?blxq ?blxo))
                        )
                      (not (= ?blxp ?blxo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxs Real)
                  (declare-const ?blxt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?blxu Real)
                  (declare-const ?blxv Real)
                  (declare-const ?blxw Real)
                  (assert
                    (and (and (not (= ?blxw ?blxv))
                        (not (= ?blxw ?blxu))
                        )
                      (not (= ?blxv ?blxu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?blxx Real)
            (declare-const ?blxy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blxz Real)
            (declare-const ?blya Real)
            (declare-const ?blyb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyc Real)
            (declare-const ?blyd Real)
            (declare-const ?blye Real)
            (declare-const ?blyf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blyh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blyi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyj Real)
            (declare-const ?blyk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyl Real)
            (declare-const ?blym Real)
            (declare-const ?blyn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyo Real)
            (declare-const ?blyp Real)
            (declare-const ?blyq Real)
            (declare-const ?blyr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blys Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?blyt Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?blyu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blyv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyw Real)
            (declare-const ?blyx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blyy Real)
            (declare-const ?blyz Real)
            (declare-const ?blza Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzb Real)
            (declare-const ?blzc Real)
            (declare-const ?blzd Real)
            (declare-const ?blze Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blzg Real)
          (declare-const ?blzh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blzi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzj Real)
            (declare-const ?blzk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzl Real)
            (declare-const ?blzm Real)
            (declare-const ?blzn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzo Real)
            (declare-const ?blzp Real)
            (declare-const ?blzq Real)
            (declare-const ?blzr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?blzt Real)
          (declare-const ?blzu Real)
          (declare-const ?blzv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?blzw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzx Real)
            (declare-const ?blzy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?blzz Real)
            (declare-const ?bmaa Real)
            (declare-const ?bmab Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmac Real)
            (declare-const ?bmad Real)
            (declare-const ?bmae Real)
            (declare-const ?bmaf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmag Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmah Real)
          (declare-const ?bmai Real)
          (declare-const ?bmaj Real)
          (declare-const ?bmak Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmal Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmam Real)
            (declare-const ?bman Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bmaj ?blvm)
                        (= ?bmai ?blvl)
                        )
                      (= ?bmah ?blvk)
                      )
                    (= ?bmam ?blyt)
                    )
                  (= ?bmak ?bman)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bmao Real)
                  (declare-const ?bmap Real)
                  (declare-const ?bmaq Real)
                  (assert
                    (or (or (= ?bmaq ?bmap)
                        (= ?bmaq ?bmao)
                        )
                      (= ?bmap ?bmao)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmar Real)
                  (declare-const ?bmas Real)
                  (declare-const ?bmat Real)
                  (assert
                    (or (or (= ?bmat ?bmas)
                        (= ?bmat ?bmar)
                        )
                      (= ?bmas ?bmar)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmau Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmav Real)
                  (declare-const ?bmaw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmax Real)
                  (declare-const ?bmay Real)
                  (declare-const ?bmaz Real)
                  (assert
                    (and (and (not (= ?bmaz ?bmay))
                        (not (= ?bmaz ?bmax))
                        )
                      (not (= ?bmay ?bmax))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmba Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmbb Real)
                  (declare-const ?bmbc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmbd Real)
                  (declare-const ?bmbe Real)
                  (declare-const ?bmbf Real)
                  (assert
                    (and (and (not (= ?bmbf ?bmbe))
                        (not (= ?bmbf ?bmbd))
                        )
                      (not (= ?bmbe ?bmbd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bmbg Real)
            (declare-const ?bmbh Real)
            (declare-const ?bmbi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmbj Real)
            (declare-const ?bmbk Real)
            (declare-const ?bmbl Real)
            (declare-const ?bmbm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmbn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmbo Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmbp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmbq Real)
            (declare-const ?bmbr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmbs Real)
            (declare-const ?bmbt Real)
            (declare-const ?bmbu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmbv Real)
            (declare-const ?bmbw Real)
            (declare-const ?bmbx Real)
            (declare-const ?bmby Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmbz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmca Real)
        (declare-const ?bmcb Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmcc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmcd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmce Real)
            (declare-const ?bmcf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmcg Real)
            (declare-const ?bmch Real)
            (declare-const ?bmci Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmcj Real)
            (declare-const ?bmck Real)
            (declare-const ?bmcl Real)
            (declare-const ?bmcm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmcn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmco Real)
          (declare-const ?bmcp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmcq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmcr Real)
            (declare-const ?bmcs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmct Real)
            (declare-const ?bmcu Real)
            (declare-const ?bmcv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmcw Real)
            (declare-const ?bmcx Real)
            (declare-const ?bmcy Real)
            (declare-const ?bmcz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmda Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmdb Real)
          (declare-const ?bmdc Real)
          (declare-const ?bmdd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmde Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmdf Real)
            (declare-const ?bmdg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmdh Real)
            (declare-const ?bmdi Real)
            (declare-const ?bmdj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmdk Real)
            (declare-const ?bmdl Real)
            (declare-const ?bmdm Real)
            (declare-const ?bmdn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmdo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmdp Real)
          (declare-const ?bmdq Real)
          (declare-const ?bmdr Real)
          (declare-const ?bmds Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmdt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmdu Real)
            (declare-const ?bmdv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmdw Real)
            (declare-const ?bmdx Real)
            (declare-const ?bmdy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bmdr ?blvm)
                        (= ?bmdq ?blvl)
                        )
                      (= ?bmdp ?blvk)
                      )
                    (and (= ?bmdx ?bmcb)
                      (= ?bmdw ?bmca)
                      )
                    )
                  (= ?bmds ?bmdy)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bmdz Real)
                  (declare-const ?bmea Real)
                  (declare-const ?bmeb Real)
                  (assert
                    (or (or (= ?bmeb ?bmea)
                        (= ?bmeb ?bmdz)
                        )
                      (= ?bmea ?bmdz)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmec Real)
                  (declare-const ?bmed Real)
                  (declare-const ?bmee Real)
                  (assert
                    (or (or (= ?bmee ?bmed)
                        (= ?bmee ?bmec)
                        )
                      (= ?bmed ?bmec)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmef Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmeg Real)
                  (declare-const ?bmeh Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmei Real)
                  (declare-const ?bmej Real)
                  (declare-const ?bmek Real)
                  (assert
                    (and (and (not (= ?bmek ?bmej))
                        (not (= ?bmek ?bmei))
                        )
                      (not (= ?bmej ?bmei))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmel Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmem Real)
                  (declare-const ?bmen Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmeo Real)
                  (declare-const ?bmep Real)
                  (declare-const ?bmeq Real)
                  (assert
                    (and (and (not (= ?bmeq ?bmep))
                        (not (= ?bmeq ?bmeo))
                        )
                      (not (= ?bmep ?bmeo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?bmdx ?bmdw)
                      (= ?bmdx ?bmdy)
                      )
                    (= ?bmdw ?bmdy)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bmer Real)
            (declare-const ?bmes Real)
            (declare-const ?bmet Real)
            (declare-const ?bmeu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmev Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmew Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmex Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmey Real)
            (declare-const ?bmez Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfa Real)
            (declare-const ?bmfb Real)
            (declare-const ?bmfc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfd Real)
            (declare-const ?bmfe Real)
            (declare-const ?bmff Real)
            (declare-const ?bmfg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?bmcb ?bmca))
              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                  (not (= ?bmca ?bmdy))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?bmcb ?bmca)
              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                  (= ?bmca ?bmdy)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmfi Real)
        (declare-const ?bmfj Real)
        (declare-const ?bmfk Real)
        (assert
          (and (and (not (= ?bmfk ?bmfj))
              (not (= ?bmfk ?bmfi))
              )
            (not (= ?bmfj ?bmfi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmfl Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmfm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfn Real)
            (declare-const ?bmfo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfp Real)
            (declare-const ?bmfq Real)
            (declare-const ?bmfr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfs Real)
            (declare-const ?bmft Real)
            (declare-const ?bmfu Real)
            (declare-const ?bmfv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmfw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmfx Real)
          (declare-const ?bmfy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmfz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmga Real)
            (declare-const ?bmgb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgc Real)
            (declare-const ?bmgd Real)
            (declare-const ?bmge Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgf Real)
            (declare-const ?bmgg Real)
            (declare-const ?bmgh Real)
            (declare-const ?bmgi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmgk Real)
          (declare-const ?bmgl Real)
          (declare-const ?bmgm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmgn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgo Real)
            (declare-const ?bmgp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgq Real)
            (declare-const ?bmgr Real)
            (declare-const ?bmgs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgt Real)
            (declare-const ?bmgu Real)
            (declare-const ?bmgv Real)
            (declare-const ?bmgw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmgx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmgy Real)
          (declare-const ?bmgz Real)
          (declare-const ?bmha Real)
          (declare-const ?bmhb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmhc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmhd Real)
            (declare-const ?bmhe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmhf Real)
            (declare-const ?bmhg Real)
            (declare-const ?bmhh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmhi Real)
            (declare-const ?bmhj Real)
            (declare-const ?bmhk Real)
            (declare-const ?bmhl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bmha ?blvm)
                        (= ?bmgz ?blvl)
                        )
                      (= ?bmgy ?blvk)
                      )
                    (and (and (= ?bmhk ?bmfk)
                        (= ?bmhj ?bmfj)
                        )
                      (= ?bmhi ?bmfi)
                      )
                    )
                  (= ?bmhb ?bmhl)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bmhm Real)
                  (declare-const ?bmhn Real)
                  (declare-const ?bmho Real)
                  (assert
                    (or (or (= ?bmho ?bmhn)
                        (= ?bmho ?bmhm)
                        )
                      (= ?bmhn ?bmhm)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmhp Real)
                  (declare-const ?bmhq Real)
                  (declare-const ?bmhr Real)
                  (assert
                    (or (or (= ?bmhr ?bmhq)
                        (= ?bmhr ?bmhp)
                        )
                      (= ?bmhq ?bmhp)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmhs Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmht Real)
                  (declare-const ?bmhu Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmhv Real)
                  (declare-const ?bmhw Real)
                  (declare-const ?bmhx Real)
                  (assert
                    (and (and (not (= ?bmhx ?bmhw))
                        (not (= ?bmhx ?bmhv))
                        )
                      (not (= ?bmhw ?bmhv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmhy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmhz Real)
                  (declare-const ?bmia Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmib Real)
                  (declare-const ?bmic Real)
                  (declare-const ?bmid Real)
                  (assert
                    (and (and (not (= ?bmid ?bmic))
                        (not (= ?bmid ?bmib))
                        )
                      (not (= ?bmic ?bmib))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bmie Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmif Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmig Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmih Real)
            (declare-const ?bmii Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmij Real)
            (declare-const ?bmik Real)
            (declare-const ?bmil Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmim Real)
            (declare-const ?bmin Real)
            (declare-const ?bmio Real)
            (declare-const ?bmip Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmiq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmir Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmis Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmit Real)
            (declare-const ?bmiu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmiv Real)
            (declare-const ?bmiw Real)
            (declare-const ?bmix Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmiy Real)
            (declare-const ?bmiz Real)
            (declare-const ?bmja Real)
            (declare-const ?bmjb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmjc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmjd Real)
          (declare-const ?bmje Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmjf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmjg Real)
            (declare-const ?bmjh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmji Real)
            (declare-const ?bmjj Real)
            (declare-const ?bmjk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmjl Real)
            (declare-const ?bmjm Real)
            (declare-const ?bmjn Real)
            (declare-const ?bmjo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmjp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmjq Real)
          (declare-const ?bmjr Real)
          (declare-const ?bmjs Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmjt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmju Real)
            (declare-const ?bmjv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmjw Real)
            (declare-const ?bmjx Real)
            (declare-const ?bmjy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmjz Real)
            (declare-const ?bmka Real)
            (declare-const ?bmkb Real)
            (declare-const ?bmkc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmkd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmke Real)
          (declare-const ?bmkf Real)
          (declare-const ?bmkg Real)
          (declare-const ?bmkh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmki Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmkj Real)
            (declare-const ?bmkk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmkl Real)
            (declare-const ?bmkm Real)
            (declare-const ?bmkn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmko Real)
            (declare-const ?bmkp Real)
            (declare-const ?bmkq Real)
            (declare-const ?bmkr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmks Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bmkg ?blvm)
                      (= ?bmkf ?blvl)
                      )
                    (= ?bmke ?blvk)
                    )
                  (= ?bmkh ?bmks)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bmkt Real)
                  (declare-const ?bmku Real)
                  (declare-const ?bmkv Real)
                  (assert
                    (or (or (= ?bmkv ?bmku)
                        (= ?bmkv ?bmkt)
                        )
                      (= ?bmku ?bmkt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmkw Real)
                  (declare-const ?bmkx Real)
                  (declare-const ?bmky Real)
                  (assert
                    (or (or (= ?bmky ?bmkx)
                        (= ?bmky ?bmkw)
                        )
                      (= ?bmkx ?bmkw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmkz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmla Real)
                  (declare-const ?bmlb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmlc Real)
                  (declare-const ?bmld Real)
                  (declare-const ?bmle Real)
                  (assert
                    (and (and (not (= ?bmle ?bmld))
                        (not (= ?bmle ?bmlc))
                        )
                      (not (= ?bmld ?bmlc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmlf Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmlg Real)
                  (declare-const ?bmlh Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmli Real)
                  (declare-const ?bmlj Real)
                  (declare-const ?bmlk Real)
                  (assert
                    (and (and (not (= ?bmlk ?bmlj))
                        (not (= ?bmlk ?bmli))
                        )
                      (not (= ?bmlj ?bmli))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmll Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmlm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmln Real)
            (declare-const ?bmlo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmlp Real)
            (declare-const ?bmlq Real)
            (declare-const ?bmlr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmls Real)
            (declare-const ?bmlt Real)
            (declare-const ?bmlu Real)
            (declare-const ?bmlv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmlw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bmlx Real)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bmly Real)
        (declare-const ?bmlz Real)
        (declare-const ?bmma Real)
        (assert
          (and (and (not (= ?bmma ?bmlz))
              (not (= ?bmma ?bmly))
              )
            (not (= ?bmlz ?bmly))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (push 1)
          (declare-const ?bmmb Real)
          (push 1)
            (declare-const ?bmmc Real)
            (push 1)
              (assert
                (= ?bmmb ?bmmc)
                )
              (push 1)
                (push 1)
                  (declare-const ?bmmd Real)
                  (declare-const ?bmme Real)
                  (declare-const ?bmmf Real)
                  (assert
                    (or (or (= ?bmmf ?bmme)
                        (= ?bmmf ?bmmd)
                        )
                      (= ?bmme ?bmmd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmmg Real)
                  (declare-const ?bmmh Real)
                  (declare-const ?bmmi Real)
                  (assert
                    (or (or (= ?bmmi ?bmmh)
                        (= ?bmmi ?bmmg)
                        )
                      (= ?bmmh ?bmmg)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bmmj Real)
                  (declare-const ?bmmk Real)
                  (declare-const ?bmml Real)
                  (assert
                    (and (and (not (= ?bmml ?bmmk))
                        (not (= ?bmml ?bmmj))
                        )
                      (not (= ?bmmk ?bmmj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmmm Real)
                  (declare-const ?bmmn Real)
                  (declare-const ?bmmo Real)
                  (assert
                    (and (and (not (= ?bmmo ?bmmn))
                        (not (= ?bmmo ?bmmm))
                        )
                      (not (= ?bmmn ?bmmm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmmp Real)
        (push 1)
          (declare-const ?bmmq Real)
          (push 1)
            (declare-const ?bmmr Real)
            (declare-const ?bmms Real)
            (push 1)
              (assert
                (and (= ?bmmr ?bmmp)
                  (= ?bmmq ?bmms)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?bmmt Real)
                  (declare-const ?bmmu Real)
                  (declare-const ?bmmv Real)
                  (assert
                    (or (or (= ?bmmv ?bmmu)
                        (= ?bmmv ?bmmt)
                        )
                      (= ?bmmu ?bmmt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmmw Real)
                  (declare-const ?bmmx Real)
                  (declare-const ?bmmy Real)
                  (assert
                    (or (or (= ?bmmy ?bmmx)
                        (= ?bmmy ?bmmw)
                        )
                      (= ?bmmx ?bmmw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bmmz Real)
                  (declare-const ?bmna Real)
                  (declare-const ?bmnb Real)
                  (assert
                    (and (and (not (= ?bmnb ?bmna))
                        (not (= ?bmnb ?bmmz))
                        )
                      (not (= ?bmna ?bmmz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmnc Real)
                  (declare-const ?bmnd Real)
                  (declare-const ?bmne Real)
                  (assert
                    (and (and (not (= ?bmne ?bmnd))
                        (not (= ?bmne ?bmnc))
                        )
                      (not (= ?bmnd ?bmnc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmnf Real)
        (declare-const ?bmng Real)
        (push 1)
          (declare-const ?bmnh Real)
          (push 1)
            (declare-const ?bmni Real)
            (declare-const ?bmnj Real)
            (declare-const ?bmnk Real)
            (push 1)
              (assert
                (and (and (= ?bmnj ?bmng)
                    (= ?bmni ?bmnf)
                    )
                  (= ?bmnh ?bmnk)
                  )
                )
              (push 1)
                (push 1)
                  (declare-const ?bmnl Real)
                  (declare-const ?bmnm Real)
                  (declare-const ?bmnn Real)
                  (assert
                    (or (or (= ?bmnn ?bmnm)
                        (= ?bmnn ?bmnl)
                        )
                      (= ?bmnm ?bmnl)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmno Real)
                  (declare-const ?bmnp Real)
                  (declare-const ?bmnq Real)
                  (assert
                    (or (or (= ?bmnq ?bmnp)
                        (= ?bmnq ?bmno)
                        )
                      (= ?bmnp ?bmno)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bmnr Real)
                  (declare-const ?bmns Real)
                  (declare-const ?bmnt Real)
                  (assert
                    (and (and (not (= ?bmnt ?bmns))
                        (not (= ?bmnt ?bmnr))
                        )
                      (not (= ?bmns ?bmnr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmnu Real)
                  (declare-const ?bmnv Real)
                  (declare-const ?bmnw Real)
                  (assert
                    (and (and (not (= ?bmnw ?bmnv))
                        (not (= ?bmnw ?bmnu))
                        )
                      (not (= ?bmnv ?bmnu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (or (= ?bmnj ?bmni)
                      (= ?bmnj ?bmnk)
                      )
                    (= ?bmni ?bmnk)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmnx Real)
        (declare-const ?bmny Real)
        (declare-const ?bmnz Real)
        (assert
          (and (and (not (= ?bmnz ?bmny))
              (not (= ?bmnz ?bmnx))
              )
            (not (= ?bmny ?bmnx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmoa Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmob Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmoc Real)
            (declare-const ?bmod Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmoe Real)
            (declare-const ?bmof Real)
            (declare-const ?bmog Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmoh Real)
            (declare-const ?bmoi Real)
            (declare-const ?bmoj Real)
            (declare-const ?bmok Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmol Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmom Real)
          (declare-const ?bmon Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmoo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmop Real)
            (declare-const ?bmoq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmor Real)
            (declare-const ?bmos Real)
            (declare-const ?bmot Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmou Real)
            (declare-const ?bmov Real)
            (declare-const ?bmow Real)
            (declare-const ?bmox Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmoy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmoz Real)
          (declare-const ?bmpa Real)
          (declare-const ?bmpb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmpc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmpd Real)
            (declare-const ?bmpe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmpf Real)
            (declare-const ?bmpg Real)
            (declare-const ?bmph Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmpi Real)
            (declare-const ?bmpj Real)
            (declare-const ?bmpk Real)
            (declare-const ?bmpl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmpm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmpn Real)
          (declare-const ?bmpo Real)
          (declare-const ?bmpp Real)
          (declare-const ?bmpq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmpr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmps Real)
            (declare-const ?bmpt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmpu Real)
            (declare-const ?bmpv Real)
            (declare-const ?bmpw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmpx Real)
            (declare-const ?bmpy Real)
            (declare-const ?bmpz Real)
            (declare-const ?bmqa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmqb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bmqc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bmqd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmqe Real)
            (declare-const ?bmqf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmqg Real)
            (declare-const ?bmqh Real)
            (declare-const ?bmqi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bmqj Real)
            (declare-const ?bmqk Real)
            (declare-const ?bmql Real)
            (declare-const ?bmqm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bmql ?bmnz)
                      (= ?bmqk ?bmny)
                      )
                    (= ?bmqj ?bmnx)
                    )
                  (= ?bmqc ?bmqm)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bmqn Real)
                  (declare-const ?bmqo Real)
                  (declare-const ?bmqp Real)
                  (assert
                    (or (or (= ?bmqp ?bmqo)
                        (= ?bmqp ?bmqn)
                        )
                      (= ?bmqo ?bmqn)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmqq Real)
                  (declare-const ?bmqr Real)
                  (declare-const ?bmqs Real)
                  (assert
                    (or (or (= ?bmqs ?bmqr)
                        (= ?bmqs ?bmqq)
                        )
                      (= ?bmqr ?bmqq)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmqt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmqu Real)
                  (declare-const ?bmqv Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmqw Real)
                  (declare-const ?bmqx Real)
                  (declare-const ?bmqy Real)
                  (assert
                    (and (and (not (= ?bmqy ?bmqx))
                        (not (= ?bmqy ?bmqw))
                        )
                      (not (= ?bmqx ?bmqw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmqz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmra Real)
                  (declare-const ?bmrb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmrc Real)
                  (declare-const ?bmrd Real)
                  (declare-const ?bmre Real)
                  (assert
                    (and (and (not (= ?bmre ?bmrd))
                        (not (= ?bmre ?bmrc))
                        )
                      (not (= ?bmrd ?bmrc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bmrf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmrg Real)
          (push 1)
            (declare-const ?bmrh Real)
            (push 1)
              (assert
                (= ?bmrg ?bmrh)
                )
              (push 1)
                (push 1)
                  (declare-const ?bmri Real)
                  (declare-const ?bmrj Real)
                  (declare-const ?bmrk Real)
                  (assert
                    (or (or (= ?bmrk ?bmrj)
                        (= ?bmrk ?bmri)
                        )
                      (= ?bmrj ?bmri)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmrl Real)
                  (declare-const ?bmrm Real)
                  (declare-const ?bmrn Real)
                  (assert
                    (or (or (= ?bmrn ?bmrm)
                        (= ?bmrn ?bmrl)
                        )
                      (= ?bmrm ?bmrl)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (push 1)
                  (declare-const ?bmro Real)
                  (declare-const ?bmrp Real)
                  (declare-const ?bmrq Real)
                  (assert
                    (and (and (not (= ?bmrq ?bmrp))
                        (not (= ?bmrq ?bmro))
                        )
                      (not (= ?bmrp ?bmro))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bmrr Real)
                  (declare-const ?bmrs Real)
                  (declare-const ?bmrt Real)
                  (assert
                    (and (and (not (= ?bmrt ?bmrs))
                        (not (= ?bmrt ?bmrr))
                        )
                      (not (= ?bmrs ?bmrr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmru Real)
        (declare-const ?bmrv Real)
        (declare-const ?bmrw Real)
        (assert
          (and (and (not (= ?bmrw ?bmrv))
              (not (= ?bmrw ?bmru))
              )
            (not (= ?bmrv ?bmru))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bmrx Real)
        (declare-const ?bmry Real)
        (declare-const ?bmrz Real)
        (assert
          (or (or (= ?bmrz ?bmry)
              (= ?bmrz ?bmrx)
              )
            (= ?bmry ?bmrx)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmsa Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmsb Real)
          (declare-const ?bmsc Real)
          (declare-const ?bmsd Real)
          (assert
            (and (and (not (= ?bmsd ?bmsc))
                (not (= ?bmsd ?bmsb))
                )
              (not (= ?bmsc ?bmsb))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmse Real)
          (declare-const ?bmsf Real)
          (declare-const ?bmsg Real)
          (assert
            (or (or (= ?bmsg ?bmsf)
                (= ?bmsg ?bmse)
                )
              (= ?bmsf ?bmse)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmsh Real)
        (push 1)
          (declare-const ?bmsi Real)
          (declare-const ?bmsj Real)
          (declare-const ?bmsk Real)
          (assert
            (or (or (= ?bmsk ?bmsj)
                (= ?bmsk ?bmsi)
                )
              (= ?bmsj ?bmsi)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmsl Real)
        (declare-const ?bmsm Real)
        (declare-const ?bmsn Real)
        (assert
          (and (and (not (= ?bmsn ?bmsm))
              (not (= ?bmsn ?bmsl))
              )
            (not (= ?bmsm ?bmsl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmso Real)
          (declare-const ?bmsp Real)
          (declare-const ?bmsq Real)
          (assert
            (or (or (= ?bmsq ?bmsp)
                (= ?bmsq ?bmso)
                )
              (= ?bmsp ?bmso)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmsr Real)
          (declare-const ?bmss Real)
          (declare-const ?bmst Real)
          (assert
            (or (or (= ?bmst ?bmss)
                (= ?bmst ?bmsr)
                )
              (= ?bmss ?bmsr)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bmsu Real)
        (declare-const ?bmsv Real)
        (declare-const ?bmsw Real)
        (assert
          (or (or (= ?bmsw ?bmsv)
              (= ?bmsw ?bmsu)
              )
            (= ?bmsv ?bmsu)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmsx Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmsy Real)
          (declare-const ?bmsz Real)
          (declare-const ?bmta Real)
          (assert
            (and (and (not (= ?bmta ?bmsz))
                (not (= ?bmta ?bmsy))
                )
              (not (= ?bmsz ?bmsy))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmtb Real)
          (declare-const ?bmtc Real)
          (declare-const ?bmtd Real)
          (assert
            (or (or (= ?bmtd ?bmtc)
                (= ?bmtd ?bmtb)
                )
              (= ?bmtc ?bmtb)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmte Real)
        (push 1)
          (declare-const ?bmtf Real)
          (declare-const ?bmtg Real)
          (declare-const ?bmth Real)
          (assert
            (or (or (= ?bmth ?bmtg)
                (= ?bmth ?bmtf)
                )
              (= ?bmtg ?bmtf)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmti Real)
        (declare-const ?bmtj Real)
        (declare-const ?bmtk Real)
        (assert
          (and (and (not (= ?bmtk ?bmtj))
              (not (= ?bmtk ?bmti))
              )
            (not (= ?bmtj ?bmti))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmtl Real)
          (declare-const ?bmtm Real)
          (declare-const ?bmtn Real)
          (assert
            (or (or (= ?bmtn ?bmtm)
                (= ?bmtn ?bmtl)
                )
              (= ?bmtm ?bmtl)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmto Real)
          (declare-const ?bmtp Real)
          (declare-const ?bmtq Real)
          (assert
            (or (or (= ?bmtq ?bmtp)
                (= ?bmtq ?bmto)
                )
              (= ?bmtp ?bmto)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (push 1)
          (declare-const ?bmtr Real)
          (declare-const ?bmts Real)
          (declare-const ?bmtt Real)
          (assert
            (and (and (not (= ?bmtt ?bmts))
                (not (= ?bmtt ?bmtr))
                )
              (not (= ?bmts ?bmtr))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmtu Real)
        (push 1)
          (declare-const ?bmtv Real)
          (declare-const ?bmtw Real)
          (declare-const ?bmtx Real)
          (assert
            (and (and (not (= ?bmtx ?bmtw))
                (not (= ?bmtx ?bmtv))
                )
              (not (= ?bmtw ?bmtv))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmty Real)
        (declare-const ?bmtz Real)
        (declare-const ?bmua Real)
        (assert
          (and (and (not (= ?bmua ?bmtz))
              (not (= ?bmua ?bmty))
              )
            (not (= ?bmtz ?bmty))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmub Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmuc Real)
          (declare-const ?bmud Real)
          (declare-const ?bmue Real)
          (assert
            (and (and (not (= ?bmue ?bmud))
                (not (= ?bmue ?bmuc))
                )
              (not (= ?bmud ?bmuc))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmuf Real)
          (declare-const ?bmug Real)
          (declare-const ?bmuh Real)
          (assert
            (and (and (not (= ?bmuh ?bmug))
                (not (= ?bmuh ?bmuf))
                )
              (not (= ?bmug ?bmuf))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmui Real)
          (declare-const ?bmuj Real)
          (declare-const ?bmuk Real)
          (assert
            (and (and (not (= ?bmuk ?bmuj))
                (not (= ?bmuk ?bmui))
                )
              (not (= ?bmuj ?bmui))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmul Real)
        (push 1)
          (declare-const ?bmum Real)
          (declare-const ?bmun Real)
          (declare-const ?bmuo Real)
          (assert
            (and (and (not (= ?bmuo ?bmun))
                (not (= ?bmuo ?bmum))
                )
              (not (= ?bmun ?bmum))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmup Real)
        (declare-const ?bmuq Real)
        (declare-const ?bmur Real)
        (assert
          (and (and (not (= ?bmur ?bmuq))
              (not (= ?bmur ?bmup))
              )
            (not (= ?bmuq ?bmup))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmus Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmut Real)
          (declare-const ?bmuu Real)
          (declare-const ?bmuv Real)
          (assert
            (and (and (not (= ?bmuv ?bmuu))
                (not (= ?bmuv ?bmut))
                )
              (not (= ?bmuu ?bmut))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmuw Real)
          (declare-const ?bmux Real)
          (declare-const ?bmuy Real)
          (assert
            (and (and (not (= ?bmuy ?bmux))
                (not (= ?bmuy ?bmuw))
                )
              (not (= ?bmux ?bmuw))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bmuq Real) (?bmup Real) )(and (not (= ?bmuq ?bmup))
              (exists ((?bmur Real) )(and (not (= ?bmur ?bmuq))
                  (and (not (= ?bmur ?bmup))
                    (or (or (= ?bmur ?bmuq)
                        (= ?bmur ?bmup)
                        )
                      (= ?bmuq ?bmup)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bmtz Real) (?bmty Real) )(and (not (= ?bmtz ?bmty))
              (exists ((?bmua Real) )(and (not (= ?bmua ?bmtz))
                  (and (not (= ?bmua ?bmty))
                    (or (or (= ?bmua ?bmtz)
                        (= ?bmua ?bmty)
                        )
                      (= ?bmtz ?bmty)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bmuz Real)
    (declare-const ?bmva Real)
    (push 1)
      (push 1)
        (declare-const ?bmvb Real)
        (declare-const ?bmvc Real)
        (declare-const ?bmvd Real)
        (assert
          (or (or (= ?bmvd ?bmvc)
              (= ?bmvd ?bmvb)
              )
            (= ?bmvc ?bmvb)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmve Real)
          (declare-const ?bmvf Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                      (not (= ?bmva ?blqw))
                      )
                    (not (= ?bmuz ?blqw))
                    )
                  (or (or (= ?bmvf ?bmve)
                      (= ?bmvf ?blqw)
                      )
                    (= ?bmve ?blqw)
                    )
                  )
                (or (or (or (= ?bmva ?bmuz)
                      (= ?bmva ?blqw)
                      )
                    (= ?bmuz ?blqw)
                    )
                  (not (= ?bmvf ?bmve))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmvg Real)
        (declare-const ?bmvh Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                    (not (= ?bmva ?blqw))
                    )
                  (not (= ?bmuz ?blqw))
                  )
                (or (or (= ?bmvh ?bmvg)
                    (= ?bmvh ?blqw)
                    )
                  (= ?bmvg ?blqw)
                  )
                )
              (or (or (or (= ?bmva ?bmuz)
                    (= ?bmva ?blqw)
                    )
                  (= ?bmuz ?blqw)
                  )
                (not (= ?bmvh ?bmvg))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmvi Real)
          (declare-const ?bmvj Real)
          (declare-const ?bmvk Real)
          (assert
            (or (or (= ?bmvk ?bmvj)
                (= ?bmvk ?bmvi)
                )
              (= ?bmvj ?bmvi)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (push 1)
          (declare-const ?bmvl Real)
          (declare-const ?bmvm Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                      (not (= ?bmva ?blqw))
                      )
                    (not (= ?bmuz ?blqw))
                    )
                  (or (or (= ?bmvm ?bmvl)
                      (= ?bmvm ?blqw)
                      )
                    (= ?bmvl ?blqw)
                    )
                  )
                (or (or (or (= ?bmva ?bmuz)
                      (= ?bmva ?blqw)
                      )
                    (= ?bmuz ?blqw)
                    )
                  (not (= ?bmvm ?bmvl))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmvn Real)
        (push 1)
          (declare-const ?bmvo Real)
          (declare-const ?bmvp Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                      (not (= ?bmva ?blqw))
                      )
                    (not (= ?bmuz ?blqw))
                    )
                  (or (or (= ?bmvp ?bmvo)
                      (= ?bmvp ?blqw)
                      )
                    (= ?bmvo ?blqw)
                    )
                  )
                (or (or (or (= ?bmva ?bmuz)
                      (= ?bmva ?blqw)
                      )
                    (= ?bmuz ?blqw)
                    )
                  (not (= ?bmvp ?bmvo))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmvq Real)
        (declare-const ?bmvr Real)
        (declare-const ?bmvs Real)
        (assert
          (and (and (not (= ?bmvs ?bmvr))
              (not (= ?bmvs ?bmvq))
              )
            (not (= ?bmvr ?bmvq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmvt Real)
          (declare-const ?bmvu Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                      (not (= ?bmva ?blqw))
                      )
                    (not (= ?bmuz ?blqw))
                    )
                  (or (or (= ?bmvu ?bmvt)
                      (= ?bmvu ?blqw)
                      )
                    (= ?bmvt ?blqw)
                    )
                  )
                (or (or (or (= ?bmva ?bmuz)
                      (= ?bmva ?blqw)
                      )
                    (= ?bmuz ?blqw)
                    )
                  (not (= ?bmvu ?bmvt))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmvv Real)
          (declare-const ?bmvw Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                      (not (= ?bmva ?blqw))
                      )
                    (not (= ?bmuz ?blqw))
                    )
                  (or (or (= ?bmvw ?bmvv)
                      (= ?bmvw ?blqw)
                      )
                    (= ?bmvv ?blqw)
                    )
                  )
                (or (or (or (= ?bmva ?bmuz)
                      (= ?bmva ?blqw)
                      )
                    (= ?bmuz ?blqw)
                    )
                  (not (= ?bmvw ?bmvv))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmvx Real)
        (declare-const ?bmvy Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                    (not (= ?bmva ?blqw))
                    )
                  (not (= ?bmuz ?blqw))
                  )
                (or (or (= ?bmvy ?bmvx)
                    (= ?bmvy ?blqw)
                    )
                  (= ?bmvx ?blqw)
                  )
                )
              (or (or (or (= ?bmva ?bmuz)
                    (= ?bmva ?blqw)
                    )
                  (= ?bmuz ?blqw)
                  )
                (not (= ?bmvy ?bmvx))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmvz Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmwa Real)
          (declare-const ?bmwb Real)
          (declare-const ?bmwc Real)
          (assert
            (and (and (not (= ?bmwc ?bmwb))
                (not (= ?bmwc ?bmwa))
                )
              (not (= ?bmwb ?bmwa))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bmvg Real) (?bmvh Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bmva ?bmuz))
                      (not (= ?bmva ?blqw))
                      )
                    (not (= ?bmuz ?blqw))
                    )
                  (or (or (= ?bmvh ?bmvg)
                      (= ?bmvh ?blqw)
                      )
                    (= ?bmvg ?blqw)
                    )
                  )
                (or (or (or (= ?bmva ?bmuz)
                      (= ?bmva ?blqw)
                      )
                    (= ?bmuz ?blqw)
                    )
                  (not (= ?bmvh ?bmvg))
                  )
                )
              )
            )
          (exists ((?bmvc Real) (?bmvb Real) )(or (= ?bmvc ?bmvb)
              (exists ((?bmvd Real) )(or (= ?bmvd ?bmvc)
                  (= ?bmvd ?bmvb)
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bmwd Real)
        (declare-const ?bmwe Real)
        (declare-const ?bmwf Real)
        (assert
          (or (or (= ?bmwf ?bmwe)
              (= ?bmwf ?bmwd)
              )
            (= ?bmwe ?bmwd)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmwg Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmwh Real)
          (declare-const ?bmwi Real)
          (declare-const ?bmwj Real)
          (assert
            (and (and (not (= ?bmwj ?bmwi))
                (not (= ?bmwj ?bmwh))
                )
              (not (= ?bmwi ?bmwh))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmwk Real)
          (declare-const ?bmwl Real)
          (declare-const ?bmwm Real)
          (assert
            (or (or (= ?bmwm ?bmwl)
                (= ?bmwm ?bmwk)
                )
              (= ?bmwl ?bmwk)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmwn Real)
        (push 1)
          (declare-const ?bmwo Real)
          (declare-const ?bmwp Real)
          (declare-const ?bmwq Real)
          (assert
            (or (or (= ?bmwq ?bmwp)
                (= ?bmwq ?bmwo)
                )
              (= ?bmwp ?bmwo)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmwr Real)
        (declare-const ?bmws Real)
        (declare-const ?bmwt Real)
        (assert
          (and (and (not (= ?bmwt ?bmws))
              (not (= ?bmwt ?bmwr))
              )
            (not (= ?bmws ?bmwr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmwu Real)
          (declare-const ?bmwv Real)
          (declare-const ?bmww Real)
          (assert
            (or (or (= ?bmww ?bmwv)
                (= ?bmww ?bmwu)
                )
              (= ?bmwv ?bmwu)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmwx Real)
          (declare-const ?bmwy Real)
          (declare-const ?bmwz Real)
          (assert
            (or (or (= ?bmwz ?bmwy)
                (= ?bmwz ?bmwx)
                )
              (= ?bmwy ?bmwx)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (push 1)
          (declare-const ?bmxa Real)
          (declare-const ?bmxb Real)
          (declare-const ?bmxc Real)
          (assert
            (and (and (not (= ?bmxc ?bmxb))
                (not (= ?bmxc ?bmxa))
                )
              (not (= ?bmxb ?bmxa))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmxd Real)
        (push 1)
          (declare-const ?bmxe Real)
          (declare-const ?bmxf Real)
          (declare-const ?bmxg Real)
          (assert
            (and (and (not (= ?bmxg ?bmxf))
                (not (= ?bmxg ?bmxe))
                )
              (not (= ?bmxf ?bmxe))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmxh Real)
        (declare-const ?bmxi Real)
        (declare-const ?bmxj Real)
        (assert
          (and (and (not (= ?bmxj ?bmxi))
              (not (= ?bmxj ?bmxh))
              )
            (not (= ?bmxi ?bmxh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmxk Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmxl Real)
          (declare-const ?bmxm Real)
          (declare-const ?bmxn Real)
          (assert
            (and (and (not (= ?bmxn ?bmxm))
                (not (= ?bmxn ?bmxl))
                )
              (not (= ?bmxm ?bmxl))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmxo Real)
          (declare-const ?bmxp Real)
          (declare-const ?bmxq Real)
          (assert
            (and (and (not (= ?bmxq ?bmxp))
                (not (= ?bmxq ?bmxo))
                )
              (not (= ?bmxp ?bmxo))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmxr Real)
          (declare-const ?bmxs Real)
          (declare-const ?bmxt Real)
          (assert
            (and (and (not (= ?bmxt ?bmxs))
                (not (= ?bmxt ?bmxr))
                )
              (not (= ?bmxs ?bmxr))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmxu Real)
        (push 1)
          (declare-const ?bmxv Real)
          (declare-const ?bmxw Real)
          (declare-const ?bmxx Real)
          (assert
            (and (and (not (= ?bmxx ?bmxw))
                (not (= ?bmxx ?bmxv))
                )
              (not (= ?bmxw ?bmxv))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmxy Real)
        (declare-const ?bmxz Real)
        (declare-const ?bmya Real)
        (assert
          (and (and (not (= ?bmya ?bmxz))
              (not (= ?bmya ?bmxy))
              )
            (not (= ?bmxz ?bmxy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmyb Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmyc Real)
          (declare-const ?bmyd Real)
          (declare-const ?bmye Real)
          (assert
            (and (and (not (= ?bmye ?bmyd))
                (not (= ?bmye ?bmyc))
                )
              (not (= ?bmyd ?bmyc))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmyf Real)
          (declare-const ?bmyg Real)
          (declare-const ?bmyh Real)
          (assert
            (and (and (not (= ?bmyh ?bmyg))
                (not (= ?bmyh ?bmyf))
                )
              (not (= ?bmyg ?bmyf))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bmyi Real)
      (declare-const ?bmyj Real)
      (push 1)
        (declare-const ?bmyk Real)
        (declare-const ?bmyl Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bmyj ?bmyi))
                    (not (= ?bmyj ?blqw))
                    )
                  (not (= ?bmyi ?blqw))
                  )
                (or (or (= ?bmyl ?bmyk)
                    (= ?bmyl ?blqw)
                    )
                  (= ?bmyk ?blqw)
                  )
                )
              (or (or (or (= ?bmyj ?bmyi)
                    (= ?bmyj ?blqw)
                    )
                  (= ?bmyi ?blqw)
                  )
                (not (= ?bmyl ?bmyk))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmym Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmyn Real)
          (declare-const ?bmyo Real)
          (declare-const ?bmyp Real)
          (assert
            (and (and (not (= ?bmyp ?bmyo))
                (not (= ?bmyp ?bmyn))
                )
              (not (= ?bmyo ?bmyn))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmyq Real)
          (declare-const ?bmyr Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmyj ?bmyi))
                      (not (= ?bmyj ?blqw))
                      )
                    (not (= ?bmyi ?blqw))
                    )
                  (or (or (= ?bmyr ?bmyq)
                      (= ?bmyr ?blqw)
                      )
                    (= ?bmyq ?blqw)
                    )
                  )
                (or (or (or (= ?bmyj ?bmyi)
                      (= ?bmyj ?blqw)
                      )
                    (= ?bmyi ?blqw)
                    )
                  (not (= ?bmyr ?bmyq))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmys Real)
        (push 1)
          (declare-const ?bmyt Real)
          (declare-const ?bmyu Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmyj ?bmyi))
                      (not (= ?bmyj ?blqw))
                      )
                    (not (= ?bmyi ?blqw))
                    )
                  (or (or (= ?bmyu ?bmyt)
                      (= ?bmyu ?blqw)
                      )
                    (= ?bmyt ?blqw)
                    )
                  )
                (or (or (or (= ?bmyj ?bmyi)
                      (= ?bmyj ?blqw)
                      )
                    (= ?bmyi ?blqw)
                    )
                  (not (= ?bmyu ?bmyt))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmyv Real)
        (declare-const ?bmyw Real)
        (declare-const ?bmyx Real)
        (assert
          (and (and (not (= ?bmyx ?bmyw))
              (not (= ?bmyx ?bmyv))
              )
            (not (= ?bmyw ?bmyv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmyy Real)
          (declare-const ?bmyz Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmyj ?bmyi))
                      (not (= ?bmyj ?blqw))
                      )
                    (not (= ?bmyi ?blqw))
                    )
                  (or (or (= ?bmyz ?bmyy)
                      (= ?bmyz ?blqw)
                      )
                    (= ?bmyy ?blqw)
                    )
                  )
                (or (or (or (= ?bmyj ?bmyi)
                      (= ?bmyj ?blqw)
                      )
                    (= ?bmyi ?blqw)
                    )
                  (not (= ?bmyz ?bmyy))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmza Real)
          (declare-const ?bmzb Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bmyj ?bmyi))
                      (not (= ?bmyj ?blqw))
                      )
                    (not (= ?bmyi ?blqw))
                    )
                  (or (or (= ?bmzb ?bmza)
                      (= ?bmzb ?blqw)
                      )
                    (= ?bmza ?blqw)
                    )
                  )
                (or (or (or (= ?bmyj ?bmyi)
                      (= ?bmyj ?blqw)
                      )
                    (= ?bmyi ?blqw)
                    )
                  (not (= ?bmzb ?bmza))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bmxz Real) (?bmxy Real) )(and (not (= ?bmxz ?bmxy))
              (exists ((?bmya Real) )(and (not (= ?bmya ?bmxz))
                  (and (not (= ?bmya ?bmxy))
                    (or (or (= ?bmya ?bmxz)
                        (= ?bmya ?bmxy)
                        )
                      (= ?bmxz ?bmxy)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bmxi Real) (?bmxh Real) )(and (not (= ?bmxi ?bmxh))
              (exists ((?bmxj Real) )(and (not (= ?bmxj ?bmxi))
                  (and (not (= ?bmxj ?bmxh))
                    (or (or (= ?bmxj ?bmxi)
                        (= ?bmxj ?bmxh)
                        )
                      (= ?bmxi ?bmxh)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bmzc Real)
        (declare-const ?bmzd Real)
        (declare-const ?bmze Real)
        (assert
          (or (or (= ?bmze ?bmzd)
              (= ?bmze ?bmzc)
              )
            (= ?bmzd ?bmzc)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmzf Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bmzg Real)
          (declare-const ?bmzh Real)
          (declare-const ?bmzi Real)
          (assert
            (and (and (not (= ?bmzi ?bmzh))
                (not (= ?bmzi ?bmzg))
                )
              (not (= ?bmzh ?bmzg))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmzj Real)
          (declare-const ?bmzk Real)
          (declare-const ?bmzl Real)
          (assert
            (or (or (= ?bmzl ?bmzk)
                (= ?bmzl ?bmzj)
                )
              (= ?bmzk ?bmzj)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmzm Real)
        (push 1)
          (declare-const ?bmzn Real)
          (declare-const ?bmzo Real)
          (declare-const ?bmzp Real)
          (assert
            (or (or (= ?bmzp ?bmzo)
                (= ?bmzp ?bmzn)
                )
              (= ?bmzo ?bmzn)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bmzq Real)
        (declare-const ?bmzr Real)
        (declare-const ?bmzs Real)
        (assert
          (and (and (not (= ?bmzs ?bmzr))
              (not (= ?bmzs ?bmzq))
              )
            (not (= ?bmzr ?bmzq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bmzt Real)
          (declare-const ?bmzu Real)
          (declare-const ?bmzv Real)
          (assert
            (or (or (= ?bmzv ?bmzu)
                (= ?bmzv ?bmzt)
                )
              (= ?bmzu ?bmzt)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bmzw Real)
          (declare-const ?bmzx Real)
          (declare-const ?bmzy Real)
          (assert
            (or (or (= ?bmzy ?bmzx)
                (= ?bmzy ?bmzw)
                )
              (= ?bmzx ?bmzw)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (push 1)
          (declare-const ?bmzz Real)
          (declare-const ?bnaa Real)
          (declare-const ?bnab Real)
          (assert
            (and (and (not (= ?bnab ?bnaa))
                (not (= ?bnab ?bmzz))
                )
              (not (= ?bnaa ?bmzz))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnac Real)
        (push 1)
          (declare-const ?bnad Real)
          (declare-const ?bnae Real)
          (declare-const ?bnaf Real)
          (assert
            (and (and (not (= ?bnaf ?bnae))
                (not (= ?bnaf ?bnad))
                )
              (not (= ?bnae ?bnad))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnag Real)
        (declare-const ?bnah Real)
        (declare-const ?bnai Real)
        (assert
          (and (and (not (= ?bnai ?bnah))
              (not (= ?bnai ?bnag))
              )
            (not (= ?bnah ?bnag))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bnaj Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bnak Real)
          (declare-const ?bnal Real)
          (declare-const ?bnam Real)
          (assert
            (and (and (not (= ?bnam ?bnal))
                (not (= ?bnam ?bnak))
                )
              (not (= ?bnal ?bnak))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bnan Real)
          (declare-const ?bnao Real)
          (declare-const ?bnap Real)
          (assert
            (and (and (not (= ?bnap ?bnao))
                (not (= ?bnap ?bnan))
                )
              (not (= ?bnao ?bnan))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bnaq Real)
          (declare-const ?bnar Real)
          (declare-const ?bnas Real)
          (assert
            (and (and (not (= ?bnas ?bnar))
                (not (= ?bnas ?bnaq))
                )
              (not (= ?bnar ?bnaq))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnat Real)
        (push 1)
          (declare-const ?bnau Real)
          (declare-const ?bnav Real)
          (declare-const ?bnaw Real)
          (assert
            (and (and (not (= ?bnaw ?bnav))
                (not (= ?bnaw ?bnau))
                )
              (not (= ?bnav ?bnau))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnax Real)
        (declare-const ?bnay Real)
        (declare-const ?bnaz Real)
        (assert
          (and (and (not (= ?bnaz ?bnay))
              (not (= ?bnaz ?bnax))
              )
            (not (= ?bnay ?bnax))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bnba Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bnbb Real)
          (declare-const ?bnbc Real)
          (declare-const ?bnbd Real)
          (assert
            (and (and (not (= ?bnbd ?bnbc))
                (not (= ?bnbd ?bnbb))
                )
              (not (= ?bnbc ?bnbb))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bnbe Real)
          (declare-const ?bnbf Real)
          (declare-const ?bnbg Real)
          (assert
            (and (and (not (= ?bnbg ?bnbf))
                (not (= ?bnbg ?bnbe))
                )
              (not (= ?bnbf ?bnbe))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bnbh Real)
      (declare-const ?bnbi Real)
      (push 1)
        (declare-const ?bnbj Real)
        (declare-const ?bnbk Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnbi ?bnbh))
                    (not (= ?bnbi ?blqw))
                    )
                  (not (= ?bnbh ?blqw))
                  )
                (or (or (= ?bnbk ?bnbj)
                    (= ?bnbk ?blqw)
                    )
                  (= ?bnbj ?blqw)
                  )
                )
              (or (or (or (= ?bnbi ?bnbh)
                    (= ?bnbi ?blqw)
                    )
                  (= ?bnbh ?blqw)
                  )
                (not (= ?bnbk ?bnbj))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bnbl Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bnbm Real)
          (declare-const ?bnbn Real)
          (declare-const ?bnbo Real)
          (assert
            (and (and (not (= ?bnbo ?bnbn))
                (not (= ?bnbo ?bnbm))
                )
              (not (= ?bnbn ?bnbm))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bnbp Real)
          (declare-const ?bnbq Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnbi ?bnbh))
                      (not (= ?bnbi ?blqw))
                      )
                    (not (= ?bnbh ?blqw))
                    )
                  (or (or (= ?bnbq ?bnbp)
                      (= ?bnbq ?blqw)
                      )
                    (= ?bnbp ?blqw)
                    )
                  )
                (or (or (or (= ?bnbi ?bnbh)
                      (= ?bnbi ?blqw)
                      )
                    (= ?bnbh ?blqw)
                    )
                  (not (= ?bnbq ?bnbp))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnbr Real)
        (push 1)
          (declare-const ?bnbs Real)
          (declare-const ?bnbt Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnbi ?bnbh))
                      (not (= ?bnbi ?blqw))
                      )
                    (not (= ?bnbh ?blqw))
                    )
                  (or (or (= ?bnbt ?bnbs)
                      (= ?bnbt ?blqw)
                      )
                    (= ?bnbs ?blqw)
                    )
                  )
                (or (or (or (= ?bnbi ?bnbh)
                      (= ?bnbi ?blqw)
                      )
                    (= ?bnbh ?blqw)
                    )
                  (not (= ?bnbt ?bnbs))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnbu Real)
        (declare-const ?bnbv Real)
        (declare-const ?bnbw Real)
        (assert
          (and (and (not (= ?bnbw ?bnbv))
              (not (= ?bnbw ?bnbu))
              )
            (not (= ?bnbv ?bnbu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnbx Real)
          (declare-const ?bnby Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnbi ?bnbh))
                      (not (= ?bnbi ?blqw))
                      )
                    (not (= ?bnbh ?blqw))
                    )
                  (or (or (= ?bnby ?bnbx)
                      (= ?bnby ?blqw)
                      )
                    (= ?bnbx ?blqw)
                    )
                  )
                (or (or (or (= ?bnbi ?bnbh)
                      (= ?bnbi ?blqw)
                      )
                    (= ?bnbh ?blqw)
                    )
                  (not (= ?bnby ?bnbx))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bnbz Real)
          (declare-const ?bnca Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnbi ?bnbh))
                      (not (= ?bnbi ?blqw))
                      )
                    (not (= ?bnbh ?blqw))
                    )
                  (or (or (= ?bnca ?bnbz)
                      (= ?bnca ?blqw)
                      )
                    (= ?bnbz ?blqw)
                    )
                  )
                (or (or (or (= ?bnbi ?bnbh)
                      (= ?bnbi ?blqw)
                      )
                    (= ?bnbh ?blqw)
                    )
                  (not (= ?bnca ?bnbz))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bnay Real) (?bnax Real) )(and (not (= ?bnay ?bnax))
              (exists ((?bnaz Real) )(and (not (= ?bnaz ?bnay))
                  (and (not (= ?bnaz ?bnax))
                    (or (or (= ?bnaz ?bnay)
                        (= ?bnaz ?bnax)
                        )
                      (= ?bnay ?bnax)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bnah Real) (?bnag Real) )(and (not (= ?bnah ?bnag))
              (exists ((?bnai Real) )(and (not (= ?bnai ?bnah))
                  (and (not (= ?bnai ?bnag))
                    (or (or (= ?bnai ?bnah)
                        (= ?bnai ?bnag)
                        )
                      (= ?bnah ?bnag)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
              (= ?bmnf ?bmnk)
              )
            )
          )
        )
      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                (not (= ?bmnf ?bmnk))
                )
              )
            )
          )
        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                    (not (= ?blvm ?blvk))
                    )
                  )
                )
              )
            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                    (= ?bmca ?bmdy)
                    )
                  )
                )
              )
            )
          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                      (= ?blvm ?blvk)
                      )
                    )
                  )
                )
              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                      (not (= ?bmca ?bmdy))
                      )
                    )
                  )
                )
              )
            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                      (= ?blpf ?bluu)
                      )
                    )
                  )
                )
              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                        (not (= ?blpf ?bluu))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                            (= ?blpf ?blsx)
                            )
                          )
                        )
                      )
                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                            (not (= ?blrl ?blrj))
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                              (not (= ?blpf ?blsx))
                              )
                            )
                          )
                        )
                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                              (= ?blrl ?blrj)
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                  (= ?blpg ?blqw)
                                  )
                                (= ?blpf ?blqw)
                                )
                              (and (and (not (= ?blqq ?blqp))
                                  (not (= ?blqq ?blqw))
                                  )
                                (not (= ?blqp ?blqw))
                                )
                              )
                            (and (and (and (not (= ?blpg ?blpf))
                                  (not (= ?blpg ?blqw))
                                  )
                                (not (= ?blpf ?blqw))
                                )
                              (or (or (= ?blqq ?blqp)
                                  (= ?blqq ?blqw)
                                  )
                                (= ?blqp ?blqw)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              (or (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                  (= ?blpf ?blqc)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                    (not (= ?blpf ?blqc))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                      (= ?blpf ?blpj)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                        (not (= ?blpf ?blpj))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                          (= ?blkl ?blkr)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                            (not (= ?blkl ?blkr))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                            (= ?blem ?bler)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bnce Real)
      (declare-const ?bncf Real)
      (declare-const ?bncg Real)
      (assert
        (or (or (= ?bncg ?bncf)
            (= ?bncg ?bnce)
            )
          (= ?bncf ?bnce)
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bnch Real)
        (declare-const ?bnci Real)
        (declare-const ?bncj Real)
        (assert
          (or (or (= ?bncj ?bnci)
              (= ?bncj ?bnch)
              )
            (= ?bnci ?bnch)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnck Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bncl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bncm Real)
            (declare-const ?bncn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnco Real)
            (declare-const ?bncp Real)
            (declare-const ?bncq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bncr Real)
            (declare-const ?bncs Real)
            (declare-const ?bnct Real)
            (declare-const ?bncu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bncv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bncw Real)
          (declare-const ?bncx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bncy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bncz Real)
            (declare-const ?bnda Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bndb Real)
            (declare-const ?bndc Real)
            (declare-const ?bndd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnde Real)
            (declare-const ?bndf Real)
            (declare-const ?bndg Real)
            (declare-const ?bndh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bndi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bndj Real)
          (declare-const ?bndk Real)
          (declare-const ?bndl Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bndm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bndn Real)
            (declare-const ?bndo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bndp Real)
            (declare-const ?bndq Real)
            (declare-const ?bndr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnds Real)
            (declare-const ?bndt Real)
            (declare-const ?bndu Real)
            (declare-const ?bndv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bndw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bndx Real)
          (declare-const ?bndy Real)
          (declare-const ?bndz Real)
          (declare-const ?bnea Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bneb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnec Real)
            (declare-const ?bned Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnee Real)
            (declare-const ?bnef Real)
            (declare-const ?bneg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bneh Real)
            (declare-const ?bnei Real)
            (declare-const ?bnej Real)
            (declare-const ?bnek Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bndz ?bncg)
                        (= ?bndy ?bncf)
                        )
                      (= ?bndx ?bnce)
                      )
                    (and (and (= ?bnej ?bncj)
                        (= ?bnei ?bnci)
                        )
                      (= ?bneh ?bnch)
                      )
                    )
                  (= ?bnea ?bnek)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnel Real)
                (declare-const ?bnem Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnen Real)
                (declare-const ?bneo Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnep Real)
                  (declare-const ?bneq Real)
                  (declare-const ?bner Real)
                  (assert
                    (or (or (= ?bner ?bneq)
                        (= ?bner ?bnep)
                        )
                      (= ?bneq ?bnep)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnes Real)
                  (declare-const ?bnet Real)
                  (declare-const ?bneu Real)
                  (assert
                    (or (or (= ?bneu ?bnet)
                        (= ?bneu ?bnes)
                        )
                      (= ?bnet ?bnes)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnev Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnew Real)
                  (declare-const ?bnex Real)
                  (declare-const ?bney Real)
                  (assert
                    (and (and (not (= ?bney ?bnex))
                        (not (= ?bney ?bnew))
                        )
                      (not (= ?bnex ?bnew))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnez Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnfa Real)
                  (declare-const ?bnfb Real)
                  (declare-const ?bnfc Real)
                  (assert
                    (and (and (not (= ?bnfc ?bnfb))
                        (not (= ?bnfc ?bnfa))
                        )
                      (not (= ?bnfb ?bnfa))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bnfd Real)
                (declare-const ?bnfe Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnff Real)
                  (declare-const ?bnfg Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnfe ?bnfd))
                              (not (= ?bnfe ?blqw))
                              )
                            (not (= ?bnfd ?blqw))
                            )
                          (or (or (= ?bnfg ?bnff)
                              (= ?bnfg ?blqw)
                              )
                            (= ?bnff ?blqw)
                            )
                          )
                        (or (or (or (= ?bnfe ?bnfd)
                              (= ?bnfe ?blqw)
                              )
                            (= ?bnfd ?blqw)
                            )
                          (not (= ?bnfg ?bnff))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnfh Real)
                  (declare-const ?bnfi Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnfe ?bnfd))
                              (not (= ?bnfe ?blqw))
                              )
                            (not (= ?bnfd ?blqw))
                            )
                          (or (or (= ?bnfi ?bnfh)
                              (= ?bnfi ?blqw)
                              )
                            (= ?bnfh ?blqw)
                            )
                          )
                        (or (or (or (= ?bnfe ?bnfd)
                              (= ?bnfe ?blqw)
                              )
                            (= ?bnfd ?blqw)
                            )
                          (not (= ?bnfi ?bnfh))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bnfj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnfk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnfl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnfm Real)
            (declare-const ?bnfn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnfo Real)
            (declare-const ?bnfp Real)
            (declare-const ?bnfq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnfr Real)
            (declare-const ?bnfs Real)
            (declare-const ?bnft Real)
            (declare-const ?bnfu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnfv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnfw Real)
        (declare-const ?bnfx Real)
        (declare-const ?bnfy Real)
        (assert
          (or (or (= ?bnfy ?bnfx)
              (= ?bnfy ?bnfw)
              )
            (= ?bnfx ?bnfw)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnfz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnga Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bnfz ?bnga)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bngb Real)
                (declare-const ?bngc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bngd Real)
                (declare-const ?bnge Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bngf Real)
                  (declare-const ?bngg Real)
                  (declare-const ?bngh Real)
                  (assert
                    (or (or (= ?bngh ?bngg)
                        (= ?bngh ?bngf)
                        )
                      (= ?bngg ?bngf)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bngi Real)
                  (declare-const ?bngj Real)
                  (declare-const ?bngk Real)
                  (assert
                    (or (or (= ?bngk ?bngj)
                        (= ?bngk ?bngi)
                        )
                      (= ?bngj ?bngi)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bngl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bngm Real)
                  (declare-const ?bngn Real)
                  (declare-const ?bngo Real)
                  (assert
                    (and (and (not (= ?bngo ?bngn))
                        (not (= ?bngo ?bngm))
                        )
                      (not (= ?bngn ?bngm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bngp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bngq Real)
                  (declare-const ?bngr Real)
                  (declare-const ?bngs Real)
                  (assert
                    (and (and (not (= ?bngs ?bngr))
                        (not (= ?bngs ?bngq))
                        )
                      (not (= ?bngr ?bngq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bngt Real)
                (declare-const ?bngu Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bngv Real)
                  (declare-const ?bngw Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bngu ?bngt))
                              (not (= ?bngu ?blqw))
                              )
                            (not (= ?bngt ?blqw))
                            )
                          (or (or (= ?bngw ?bngv)
                              (= ?bngw ?blqw)
                              )
                            (= ?bngv ?blqw)
                            )
                          )
                        (or (or (or (= ?bngu ?bngt)
                              (= ?bngu ?blqw)
                              )
                            (= ?bngt ?blqw)
                            )
                          (not (= ?bngw ?bngv))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bngx Real)
                  (declare-const ?bngy Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bngu ?bngt))
                              (not (= ?bngu ?blqw))
                              )
                            (not (= ?bngt ?blqw))
                            )
                          (or (or (= ?bngy ?bngx)
                              (= ?bngy ?blqw)
                              )
                            (= ?bngx ?blqw)
                            )
                          )
                        (or (or (or (= ?bngu ?bngt)
                              (= ?bngu ?blqw)
                              )
                            (= ?bngt ?blqw)
                            )
                          (not (= ?bngy ?bngx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bngz Real)
            (declare-const ?bnha Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnhb Real)
            (declare-const ?bnhc Real)
            (declare-const ?bnhd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnhe Real)
            (declare-const ?bnhf Real)
            (declare-const ?bnhg Real)
            (declare-const ?bnhh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnhi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnhj Real)
          (declare-const ?bnhk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnhl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnhm Real)
            (declare-const ?bnhn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnho Real)
            (declare-const ?bnhp Real)
            (declare-const ?bnhq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnhr Real)
            (declare-const ?bnhs Real)
            (declare-const ?bnht Real)
            (declare-const ?bnhu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnhv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnhw Real)
          (declare-const ?bnhx Real)
          (declare-const ?bnhy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnhz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnia Real)
            (declare-const ?bnib Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnic Real)
            (declare-const ?bnid Real)
            (declare-const ?bnie Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnif Real)
            (declare-const ?bnig Real)
            (declare-const ?bnih Real)
            (declare-const ?bnii Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnij Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnik Real)
          (declare-const ?bnil Real)
          (declare-const ?bnim Real)
          (declare-const ?bnin Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnio Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnip Real)
            (declare-const ?bniq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnir Real)
            (declare-const ?bnis Real)
            (declare-const ?bnit Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bniu Real)
            (declare-const ?bniv Real)
            (declare-const ?bniw Real)
            (declare-const ?bnix Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bniy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bniz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnja Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnjb Real)
            (declare-const ?bnjc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnjd Real)
            (declare-const ?bnje Real)
            (declare-const ?bnjf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnjg Real)
            (declare-const ?bnjh Real)
            (declare-const ?bnji Real)
            (declare-const ?bnjj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnjk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnjl Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnjm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnjn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnjo Real)
            (declare-const ?bnjp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (= ?bnjo ?bnjl)
                  (= ?bnjm ?bnjp)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnjq Real)
                (declare-const ?bnjr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnjs Real)
                (declare-const ?bnjt Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnju Real)
                  (declare-const ?bnjv Real)
                  (declare-const ?bnjw Real)
                  (assert
                    (or (or (= ?bnjw ?bnjv)
                        (= ?bnjw ?bnju)
                        )
                      (= ?bnjv ?bnju)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnjx Real)
                  (declare-const ?bnjy Real)
                  (declare-const ?bnjz Real)
                  (assert
                    (or (or (= ?bnjz ?bnjy)
                        (= ?bnjz ?bnjx)
                        )
                      (= ?bnjy ?bnjx)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnka Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnkb Real)
                  (declare-const ?bnkc Real)
                  (declare-const ?bnkd Real)
                  (assert
                    (and (and (not (= ?bnkd ?bnkc))
                        (not (= ?bnkd ?bnkb))
                        )
                      (not (= ?bnkc ?bnkb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnke Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnkf Real)
                  (declare-const ?bnkg Real)
                  (declare-const ?bnkh Real)
                  (assert
                    (and (and (not (= ?bnkh ?bnkg))
                        (not (= ?bnkh ?bnkf))
                        )
                      (not (= ?bnkg ?bnkf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bnki Real)
                (declare-const ?bnkj Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnkk Real)
                  (declare-const ?bnkl Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnkj ?bnki))
                              (not (= ?bnkj ?blqw))
                              )
                            (not (= ?bnki ?blqw))
                            )
                          (or (or (= ?bnkl ?bnkk)
                              (= ?bnkl ?blqw)
                              )
                            (= ?bnkk ?blqw)
                            )
                          )
                        (or (or (or (= ?bnkj ?bnki)
                              (= ?bnkj ?blqw)
                              )
                            (= ?bnki ?blqw)
                            )
                          (not (= ?bnkl ?bnkk))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnkm Real)
                  (declare-const ?bnkn Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnkj ?bnki))
                              (not (= ?bnkj ?blqw))
                              )
                            (not (= ?bnki ?blqw))
                            )
                          (or (or (= ?bnkn ?bnkm)
                              (= ?bnkn ?blqw)
                              )
                            (= ?bnkm ?blqw)
                            )
                          )
                        (or (or (or (= ?bnkj ?bnki)
                              (= ?bnkj ?blqw)
                              )
                            (= ?bnki ?blqw)
                            )
                          (not (= ?bnkn ?bnkm))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bnko Real)
            (declare-const ?bnkp Real)
            (declare-const ?bnkq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnkr Real)
            (declare-const ?bnks Real)
            (declare-const ?bnkt Real)
            (declare-const ?bnku Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnkv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnkw Real)
          (declare-const ?bnkx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnky Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnkz Real)
            (declare-const ?bnla Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnlb Real)
            (declare-const ?bnlc Real)
            (declare-const ?bnld Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnle Real)
            (declare-const ?bnlf Real)
            (declare-const ?bnlg Real)
            (declare-const ?bnlh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnli Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnlj Real)
          (declare-const ?bnlk Real)
          (declare-const ?bnll Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnlm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnln Real)
            (declare-const ?bnlo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnlp Real)
            (declare-const ?bnlq Real)
            (declare-const ?bnlr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnls Real)
            (declare-const ?bnlt Real)
            (declare-const ?bnlu Real)
            (declare-const ?bnlv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnlw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnlx Real)
          (declare-const ?bnly Real)
          (declare-const ?bnlz Real)
          (declare-const ?bnma Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnmb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnmc Real)
            (declare-const ?bnmd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnme Real)
            (declare-const ?bnmf Real)
            (declare-const ?bnmg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnmh Real)
            (declare-const ?bnmi Real)
            (declare-const ?bnmj Real)
            (declare-const ?bnmk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnml Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnmm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnmn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnmo Real)
            (declare-const ?bnmp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnmq Real)
            (declare-const ?bnmr Real)
            (declare-const ?bnms Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnmt Real)
            (declare-const ?bnmu Real)
            (declare-const ?bnmv Real)
            (declare-const ?bnmw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnmx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnmy Real)
        (declare-const ?bnmz Real)
        (declare-const ?bnna Real)
        (assert
          (and (and (not (= ?bnna ?bnmz))
              (not (= ?bnna ?bnmy))
              )
            (not (= ?bnmz ?bnmy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnnb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnnc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnnd Real)
            (declare-const ?bnne Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnnf Real)
            (declare-const ?bnng Real)
            (declare-const ?bnnh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnni Real)
            (declare-const ?bnnj Real)
            (declare-const ?bnnk Real)
            (declare-const ?bnnl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bnnk ?bnna)
                      (= ?bnnj ?bnmz)
                      )
                    (= ?bnni ?bnmy)
                    )
                  (= ?bnnb ?bnnl)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnnm Real)
                (declare-const ?bnnn Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnno Real)
                (declare-const ?bnnp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnnq Real)
                  (declare-const ?bnnr Real)
                  (declare-const ?bnns Real)
                  (assert
                    (or (or (= ?bnns ?bnnr)
                        (= ?bnns ?bnnq)
                        )
                      (= ?bnnr ?bnnq)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnnt Real)
                  (declare-const ?bnnu Real)
                  (declare-const ?bnnv Real)
                  (assert
                    (or (or (= ?bnnv ?bnnu)
                        (= ?bnnv ?bnnt)
                        )
                      (= ?bnnu ?bnnt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnnw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnnx Real)
                  (declare-const ?bnny Real)
                  (declare-const ?bnnz Real)
                  (assert
                    (and (and (not (= ?bnnz ?bnny))
                        (not (= ?bnnz ?bnnx))
                        )
                      (not (= ?bnny ?bnnx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnoa Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnob Real)
                  (declare-const ?bnoc Real)
                  (declare-const ?bnod Real)
                  (assert
                    (and (and (not (= ?bnod ?bnoc))
                        (not (= ?bnod ?bnob))
                        )
                      (not (= ?bnoc ?bnob))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bnoe Real)
                (declare-const ?bnof Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnog Real)
                  (declare-const ?bnoh Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnof ?bnoe))
                              (not (= ?bnof ?blqw))
                              )
                            (not (= ?bnoe ?blqw))
                            )
                          (or (or (= ?bnoh ?bnog)
                              (= ?bnoh ?blqw)
                              )
                            (= ?bnog ?blqw)
                            )
                          )
                        (or (or (or (= ?bnof ?bnoe)
                              (= ?bnof ?blqw)
                              )
                            (= ?bnoe ?blqw)
                            )
                          (not (= ?bnoh ?bnog))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnoi Real)
                  (declare-const ?bnoj Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnof ?bnoe))
                              (not (= ?bnof ?blqw))
                              )
                            (not (= ?bnoe ?blqw))
                            )
                          (or (or (= ?bnoj ?bnoi)
                              (= ?bnoj ?blqw)
                              )
                            (= ?bnoi ?blqw)
                            )
                          )
                        (or (or (or (= ?bnof ?bnoe)
                              (= ?bnof ?blqw)
                              )
                            (= ?bnoe ?blqw)
                            )
                          (not (= ?bnoj ?bnoi))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bnok Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnol Real)
          (declare-const ?bnom Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnon Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnoo Real)
            (declare-const ?bnop Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnoq Real)
            (declare-const ?bnor Real)
            (declare-const ?bnos Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnot Real)
            (declare-const ?bnou Real)
            (declare-const ?bnov Real)
            (declare-const ?bnow Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnox Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnoy Real)
          (declare-const ?bnoz Real)
          (declare-const ?bnpa Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnpb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnpc Real)
            (declare-const ?bnpd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnpe Real)
            (declare-const ?bnpf Real)
            (declare-const ?bnpg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnph Real)
            (declare-const ?bnpi Real)
            (declare-const ?bnpj Real)
            (declare-const ?bnpk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnpl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnpm Real)
          (declare-const ?bnpn Real)
          (declare-const ?bnpo Real)
          (declare-const ?bnpp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnpq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnpr Real)
            (declare-const ?bnps Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnpt Real)
            (declare-const ?bnpu Real)
            (declare-const ?bnpv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnpw Real)
            (declare-const ?bnpx Real)
            (declare-const ?bnpy Real)
            (declare-const ?bnpz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnqb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnqc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqd Real)
            (declare-const ?bnqe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqf Real)
            (declare-const ?bnqg Real)
            (declare-const ?bnqh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqi Real)
            (declare-const ?bnqj Real)
            (declare-const ?bnqk Real)
            (declare-const ?bnql Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnqn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnqo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqp Real)
            (declare-const ?bnqq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqr Real)
            (declare-const ?bnqs Real)
            (declare-const ?bnqt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqu Real)
            (declare-const ?bnqv Real)
            (declare-const ?bnqw Real)
            (declare-const ?bnqx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnqy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bnqn ?bnqy)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnqz Real)
                (declare-const ?bnra Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnrb Real)
                (declare-const ?bnrc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnrd Real)
                  (declare-const ?bnre Real)
                  (declare-const ?bnrf Real)
                  (assert
                    (or (or (= ?bnrf ?bnre)
                        (= ?bnrf ?bnrd)
                        )
                      (= ?bnre ?bnrd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnrg Real)
                  (declare-const ?bnrh Real)
                  (declare-const ?bnri Real)
                  (assert
                    (or (or (= ?bnri ?bnrh)
                        (= ?bnri ?bnrg)
                        )
                      (= ?bnrh ?bnrg)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnrj Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnrk Real)
                  (declare-const ?bnrl Real)
                  (declare-const ?bnrm Real)
                  (assert
                    (and (and (not (= ?bnrm ?bnrl))
                        (not (= ?bnrm ?bnrk))
                        )
                      (not (= ?bnrl ?bnrk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnrn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnro Real)
                  (declare-const ?bnrp Real)
                  (declare-const ?bnrq Real)
                  (assert
                    (and (and (not (= ?bnrq ?bnrp))
                        (not (= ?bnrq ?bnro))
                        )
                      (not (= ?bnrp ?bnro))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bnrr Real)
                (declare-const ?bnrs Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnrt Real)
                  (declare-const ?bnru Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnrs ?bnrr))
                              (not (= ?bnrs ?blqw))
                              )
                            (not (= ?bnrr ?blqw))
                            )
                          (or (or (= ?bnru ?bnrt)
                              (= ?bnru ?blqw)
                              )
                            (= ?bnrt ?blqw)
                            )
                          )
                        (or (or (or (= ?bnrs ?bnrr)
                              (= ?bnrs ?blqw)
                              )
                            (= ?bnrr ?blqw)
                            )
                          (not (= ?bnru ?bnrt))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnrv Real)
                  (declare-const ?bnrw Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnrs ?bnrr))
                              (not (= ?bnrs ?blqw))
                              )
                            (not (= ?bnrr ?blqw))
                            )
                          (or (or (= ?bnrw ?bnrv)
                              (= ?bnrw ?blqw)
                              )
                            (= ?bnrv ?blqw)
                            )
                          )
                        (or (or (or (= ?bnrs ?bnrr)
                              (= ?bnrs ?blqw)
                              )
                            (= ?bnrr ?blqw)
                            )
                          (not (= ?bnrw ?bnrv))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnrx Real)
          (declare-const ?bnry Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnrz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnsa Real)
            (declare-const ?bnsb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnsc Real)
            (declare-const ?bnsd Real)
            (declare-const ?bnse Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnsf Real)
            (declare-const ?bnsg Real)
            (declare-const ?bnsh Real)
            (declare-const ?bnsi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnsj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnsk Real)
          (declare-const ?bnsl Real)
          (declare-const ?bnsm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnsn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnso Real)
            (declare-const ?bnsp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnsq Real)
            (declare-const ?bnsr Real)
            (declare-const ?bnss Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnst Real)
            (declare-const ?bnsu Real)
            (declare-const ?bnsv Real)
            (declare-const ?bnsw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnsx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnsy Real)
          (declare-const ?bnsz Real)
          (declare-const ?bnta Real)
          (declare-const ?bntb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bntc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bntd Real)
            (declare-const ?bnte Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bntf Real)
            (declare-const ?bntg Real)
            (declare-const ?bnth Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnti Real)
            (declare-const ?bntj Real)
            (declare-const ?bntk Real)
            (declare-const ?bntl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bntm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bntn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnto Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bntp Real)
            (declare-const ?bntq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bntr Real)
            (declare-const ?bnts Real)
            (declare-const ?bntt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bntu Real)
            (declare-const ?bntv Real)
            (declare-const ?bntw Real)
            (declare-const ?bntx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnty Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bntz Real)
        (declare-const ?bnua Real)
        (declare-const ?bnub Real)
        (assert
          (and (and (not (= ?bnub ?bnua))
              (not (= ?bnub ?bntz))
              )
            (not (= ?bnua ?bntz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bnuc Real)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnud Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnue Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnuf Real)
            (declare-const ?bnug Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnuh Real)
            (declare-const ?bnui Real)
            (declare-const ?bnuj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnuk Real)
            (declare-const ?bnul Real)
            (declare-const ?bnum Real)
            (declare-const ?bnun Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnuo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnup Real)
          (declare-const ?bnuq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnur Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (= ?bnup ?bnuc)
                  (= ?bnuq ?bnur)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnus Real)
                (declare-const ?bnut Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnuu Real)
                (declare-const ?bnuv Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnuw Real)
                  (declare-const ?bnux Real)
                  (declare-const ?bnuy Real)
                  (assert
                    (or (or (= ?bnuy ?bnux)
                        (= ?bnuy ?bnuw)
                        )
                      (= ?bnux ?bnuw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnuz Real)
                  (declare-const ?bnva Real)
                  (declare-const ?bnvb Real)
                  (assert
                    (or (or (= ?bnvb ?bnva)
                        (= ?bnvb ?bnuz)
                        )
                      (= ?bnva ?bnuz)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnvc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnvd Real)
                  (declare-const ?bnve Real)
                  (declare-const ?bnvf Real)
                  (assert
                    (and (and (not (= ?bnvf ?bnve))
                        (not (= ?bnvf ?bnvd))
                        )
                      (not (= ?bnve ?bnvd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnvg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnvh Real)
                  (declare-const ?bnvi Real)
                  (declare-const ?bnvj Real)
                  (assert
                    (and (and (not (= ?bnvj ?bnvi))
                        (not (= ?bnvj ?bnvh))
                        )
                      (not (= ?bnvi ?bnvh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bnvk Real)
                (declare-const ?bnvl Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnvm Real)
                  (declare-const ?bnvn Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                              (not (= ?bnvl ?blqw))
                              )
                            (not (= ?bnvk ?blqw))
                            )
                          (or (or (= ?bnvn ?bnvm)
                              (= ?bnvn ?blqw)
                              )
                            (= ?bnvm ?blqw)
                            )
                          )
                        (or (or (or (= ?bnvl ?bnvk)
                              (= ?bnvl ?blqw)
                              )
                            (= ?bnvk ?blqw)
                            )
                          (not (= ?bnvn ?bnvm))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnvo Real)
                  (declare-const ?bnvp Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                              (not (= ?bnvl ?blqw))
                              )
                            (not (= ?bnvk ?blqw))
                            )
                          (or (or (= ?bnvp ?bnvo)
                              (= ?bnvp ?blqw)
                              )
                            (= ?bnvo ?blqw)
                            )
                          )
                        (or (or (or (= ?bnvl ?bnvk)
                              (= ?bnvl ?blqw)
                              )
                            (= ?bnvk ?blqw)
                            )
                          (not (= ?bnvp ?bnvo))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                              (not (= ?bnvl ?blqw))
                              )
                            (not (= ?bnvk ?blqw))
                            )
                          (or (or (= ?bnup ?bnuq)
                              (= ?bnup ?blqw)
                              )
                            (= ?bnuq ?blqw)
                            )
                          )
                        (or (or (or (= ?bnvl ?bnvk)
                              (= ?bnvl ?blqw)
                              )
                            (= ?bnvk ?blqw)
                            )
                          (not (= ?bnup ?bnuq))
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bnvq Real)
            (declare-const ?bnvr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnvs Real)
            (declare-const ?bnvt Real)
            (declare-const ?bnvu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnvv Real)
            (declare-const ?bnvw Real)
            (declare-const ?bnvx Real)
            (declare-const ?bnvy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnvz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnwa Real)
          (declare-const ?bnwb Real)
          (declare-const ?bnwc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnwd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwe Real)
            (declare-const ?bnwf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwg Real)
            (declare-const ?bnwh Real)
            (declare-const ?bnwi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwj Real)
            (declare-const ?bnwk Real)
            (declare-const ?bnwl Real)
            (declare-const ?bnwm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnwo Real)
          (declare-const ?bnwp Real)
          (declare-const ?bnwq Real)
          (declare-const ?bnwr Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnws Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwt Real)
            (declare-const ?bnwu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwv Real)
            (declare-const ?bnww Real)
            (declare-const ?bnwx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnwy Real)
            (declare-const ?bnwz Real)
            (declare-const ?bnxa Real)
            (declare-const ?bnxb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnxd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnxe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxf Real)
            (declare-const ?bnxg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxh Real)
            (declare-const ?bnxi Real)
            (declare-const ?bnxj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxk Real)
            (declare-const ?bnxl Real)
            (declare-const ?bnxm Real)
            (declare-const ?bnxn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                          (= ?bnvl ?blqw)
                          )
                        (= ?bnvk ?blqw)
                        )
                      (and (and (not (= ?bnuc ?bnuq))
                          (not (= ?bnuc ?blqw))
                          )
                        (not (= ?bnuq ?blqw))
                        )
                      )
                    (and (and (and (not (= ?bnvl ?bnvk))
                          (not (= ?bnvl ?blqw))
                          )
                        (not (= ?bnvk ?blqw))
                        )
                      (= ?bnuc ?bnuq)
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                          (not (= ?bnvl ?blqw))
                          )
                        (not (= ?bnvk ?blqw))
                        )
                      (or (or (= ?bnuc ?bnuq)
                          (= ?bnuc ?blqw)
                          )
                        (= ?bnuq ?blqw)
                        )
                      )
                    (or (or (or (= ?bnvl ?bnvk)
                          (= ?bnvl ?blqw)
                          )
                        (= ?bnvk ?blqw)
                        )
                      (not (= ?bnuc ?bnuq))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bnxp Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bnxq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnxr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxs Real)
            (declare-const ?bnxt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxu Real)
            (declare-const ?bnxv Real)
            (declare-const ?bnxw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnxx Real)
            (declare-const ?bnxy Real)
            (declare-const ?bnxz Real)
            (declare-const ?bnya Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnyb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnyc Real)
          (declare-const ?bnyd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnye Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnyf Real)
            (declare-const ?bnyg Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (= ?bnyc ?bnuc)
                    (= ?bnyf ?bnxp)
                    )
                  (= ?bnyd ?bnyg)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnyh Real)
                (declare-const ?bnyi Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bnyj Real)
                (declare-const ?bnyk Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnyl Real)
                  (declare-const ?bnym Real)
                  (declare-const ?bnyn Real)
                  (assert
                    (or (or (= ?bnyn ?bnym)
                        (= ?bnyn ?bnyl)
                        )
                      (= ?bnym ?bnyl)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnyo Real)
                  (declare-const ?bnyp Real)
                  (declare-const ?bnyq Real)
                  (assert
                    (or (or (= ?bnyq ?bnyp)
                        (= ?bnyq ?bnyo)
                        )
                      (= ?bnyp ?bnyo)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnyr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnys Real)
                  (declare-const ?bnyt Real)
                  (declare-const ?bnyu Real)
                  (assert
                    (and (and (not (= ?bnyu ?bnyt))
                        (not (= ?bnyu ?bnys))
                        )
                      (not (= ?bnyt ?bnys))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnyv Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnyw Real)
                  (declare-const ?bnyx Real)
                  (declare-const ?bnyy Real)
                  (assert
                    (and (and (not (= ?bnyy ?bnyx))
                        (not (= ?bnyy ?bnyw))
                        )
                      (not (= ?bnyx ?bnyw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bnyz Real)
                (declare-const ?bnza Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bnzb Real)
                  (declare-const ?bnzc Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                              (not (= ?bnza ?blqw))
                              )
                            (not (= ?bnyz ?blqw))
                            )
                          (or (or (= ?bnzc ?bnzb)
                              (= ?bnzc ?blqw)
                              )
                            (= ?bnzb ?blqw)
                            )
                          )
                        (or (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (not (= ?bnzc ?bnzb))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bnzd Real)
                  (declare-const ?bnze Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                              (not (= ?bnza ?blqw))
                              )
                            (not (= ?bnyz ?blqw))
                            )
                          (or (or (= ?bnze ?bnzd)
                              (= ?bnze ?blqw)
                              )
                            (= ?bnzd ?blqw)
                            )
                          )
                        (or (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (not (= ?bnze ?bnzd))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (or (or (= ?bnyc ?bnyd)
                                (= ?bnyc ?blqw)
                                )
                              (= ?bnyd ?blqw)
                              )
                            )
                          (or (or (or (= ?bnza ?bnyz)
                                (= ?bnza ?blqw)
                                )
                              (= ?bnyz ?blqw)
                              )
                            (not (= ?bnyc ?bnyd))
                            )
                          )
                        )
                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                (= ?bnza ?blqw)
                                )
                              (= ?bnyz ?blqw)
                              )
                            (and (and (not (= ?bnyf ?bnyg))
                                (not (= ?bnyf ?blqw))
                                )
                              (not (= ?bnyg ?blqw))
                              )
                            )
                          (and (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (= ?bnyf ?bnyg)
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bnzf Real)
            (declare-const ?bnzg Real)
            (declare-const ?bnzh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnzi Real)
            (declare-const ?bnzj Real)
            (declare-const ?bnzk Real)
            (declare-const ?bnzl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnzm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bnzn Real)
          (declare-const ?bnzo Real)
          (declare-const ?bnzp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bnzq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnzr Real)
            (declare-const ?bnzs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnzt Real)
            (declare-const ?bnzu Real)
            (declare-const ?bnzv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bnzw Real)
            (declare-const ?bnzx Real)
            (declare-const ?bnzy Real)
            (declare-const ?bnzz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boaa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boab Real)
          (declare-const ?boac Real)
          (declare-const ?boad Real)
          (declare-const ?boae Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boaf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boag Real)
            (declare-const ?boah Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boai Real)
            (declare-const ?boaj Real)
            (declare-const ?boak Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boal Real)
            (declare-const ?boam Real)
            (declare-const ?boan Real)
            (declare-const ?boao Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boap Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boaq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boar Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boas Real)
            (declare-const ?boat Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boau Real)
            (declare-const ?boav Real)
            (declare-const ?boaw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boax Real)
            (declare-const ?boay Real)
            (declare-const ?boaz Real)
            (declare-const ?boba Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (and (not (= ?bnuc ?bnyg))
                            (not (= ?bnuc ?blqw))
                            )
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      (and (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (= ?bnuc ?bnyg)
                        )
                      )
                    )
                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (or (= ?bnxp ?bnyg)
                            (= ?bnxp ?blqw)
                            )
                          (= ?bnyg ?blqw)
                          )
                        )
                      (or (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (not (= ?bnxp ?bnyg))
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (or (= ?bnuc ?bnyg)
                            (= ?bnuc ?blqw)
                            )
                          (= ?bnyg ?blqw)
                          )
                        )
                      (or (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (not (= ?bnuc ?bnyg))
                        )
                      )
                    )
                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (and (not (= ?bnxp ?bnyg))
                            (not (= ?bnxp ?blqw))
                            )
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      (and (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (= ?bnxp ?bnyg)
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bobc Real)
        (declare-const ?bobd Real)
        (declare-const ?bobe Real)
        (assert
          (and (and (not (= ?bobe ?bobd))
              (not (= ?bobe ?bobc))
              )
            (not (= ?bobd ?bobc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bobf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bobg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobh Real)
            (declare-const ?bobi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobj Real)
            (declare-const ?bobk Real)
            (declare-const ?bobl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobm Real)
            (declare-const ?bobn Real)
            (declare-const ?bobo Real)
            (declare-const ?bobp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bobr Real)
          (declare-const ?bobs Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bobt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobu Real)
            (declare-const ?bobv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobw Real)
            (declare-const ?bobx Real)
            (declare-const ?boby Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bobz Real)
            (declare-const ?boca Real)
            (declare-const ?bocb Real)
            (declare-const ?bocc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (= ?bobr ?bnuc)
                    (and (and (= ?bocb ?bobe)
                        (= ?boca ?bobd)
                        )
                      (= ?bobz ?bobc)
                      )
                    )
                  (= ?bobs ?bocc)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bocd Real)
                (declare-const ?boce Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bocf Real)
                (declare-const ?bocg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?boch Real)
                  (declare-const ?boci Real)
                  (declare-const ?bocj Real)
                  (assert
                    (or (or (= ?bocj ?boci)
                        (= ?bocj ?boch)
                        )
                      (= ?boci ?boch)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bock Real)
                  (declare-const ?bocl Real)
                  (declare-const ?bocm Real)
                  (assert
                    (or (or (= ?bocm ?bocl)
                        (= ?bocm ?bock)
                        )
                      (= ?bocl ?bock)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bocn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boco Real)
                  (declare-const ?bocp Real)
                  (declare-const ?bocq Real)
                  (assert
                    (and (and (not (= ?bocq ?bocp))
                        (not (= ?bocq ?boco))
                        )
                      (not (= ?bocp ?boco))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bocr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bocs Real)
                  (declare-const ?boct Real)
                  (declare-const ?bocu Real)
                  (assert
                    (and (and (not (= ?bocu ?boct))
                        (not (= ?bocu ?bocs))
                        )
                      (not (= ?boct ?bocs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bocv Real)
                (declare-const ?bocw Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bocx Real)
                  (declare-const ?bocy Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                              (not (= ?bocw ?blqw))
                              )
                            (not (= ?bocv ?blqw))
                            )
                          (or (or (= ?bocy ?bocx)
                              (= ?bocy ?blqw)
                              )
                            (= ?bocx ?blqw)
                            )
                          )
                        (or (or (or (= ?bocw ?bocv)
                              (= ?bocw ?blqw)
                              )
                            (= ?bocv ?blqw)
                            )
                          (not (= ?bocy ?bocx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bocz Real)
                  (declare-const ?boda Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                              (not (= ?bocw ?blqw))
                              )
                            (not (= ?bocv ?blqw))
                            )
                          (or (or (= ?boda ?bocz)
                              (= ?boda ?blqw)
                              )
                            (= ?bocz ?blqw)
                            )
                          )
                        (or (or (or (= ?bocw ?bocv)
                              (= ?bocw ?blqw)
                              )
                            (= ?bocv ?blqw)
                            )
                          (not (= ?boda ?bocz))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                              (not (= ?bocw ?blqw))
                              )
                            (not (= ?bocv ?blqw))
                            )
                          (or (or (= ?bobr ?bobs)
                              (= ?bobr ?blqw)
                              )
                            (= ?bobs ?blqw)
                            )
                          )
                        (or (or (or (= ?bocw ?bocv)
                              (= ?bocw ?blqw)
                              )
                            (= ?bocv ?blqw)
                            )
                          (not (= ?bobr ?bobs))
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bodb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bodc Real)
          (declare-const ?bodd Real)
          (declare-const ?bode Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bodf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bodg Real)
            (declare-const ?bodh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bodi Real)
            (declare-const ?bodj Real)
            (declare-const ?bodk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bodl Real)
            (declare-const ?bodm Real)
            (declare-const ?bodn Real)
            (declare-const ?bodo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bodp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bodq Real)
          (declare-const ?bodr Real)
          (declare-const ?bods Real)
          (declare-const ?bodt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bodu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bodv Real)
            (declare-const ?bodw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bodx Real)
            (declare-const ?body Real)
            (declare-const ?bodz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boea Real)
            (declare-const ?boeb Real)
            (declare-const ?boec Real)
            (declare-const ?boed Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boee Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boef Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boeg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boeh Real)
            (declare-const ?boei Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boej Real)
            (declare-const ?boek Real)
            (declare-const ?boel Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boem Real)
            (declare-const ?boen Real)
            (declare-const ?boeo Real)
            (declare-const ?boep Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boeq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                          (= ?bocw ?blqw)
                          )
                        (= ?bocv ?blqw)
                        )
                      (and (and (not (= ?bnuc ?bocc))
                          (not (= ?bnuc ?blqw))
                          )
                        (not (= ?bocc ?blqw))
                        )
                      )
                    (and (and (and (not (= ?bocw ?bocv))
                          (not (= ?bocw ?blqw))
                          )
                        (not (= ?bocv ?blqw))
                        )
                      (= ?bnuc ?bocc)
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                          (not (= ?bocw ?blqw))
                          )
                        (not (= ?bocv ?blqw))
                        )
                      (or (or (= ?bnuc ?bocc)
                          (= ?bnuc ?blqw)
                          )
                        (= ?bocc ?blqw)
                        )
                      )
                    (or (or (or (= ?bocw ?bocv)
                          (= ?bocw ?blqw)
                          )
                        (= ?bocv ?blqw)
                        )
                      (not (= ?bnuc ?bocc))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?boer Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boes Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boet Real)
            (declare-const ?boeu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boev Real)
            (declare-const ?boew Real)
            (declare-const ?boex Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boey Real)
            (declare-const ?boez Real)
            (declare-const ?bofa Real)
            (declare-const ?bofb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bofc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bofd Real)
          (declare-const ?bofe Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boff Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bofg Real)
            (declare-const ?bofh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bofi Real)
            (declare-const ?bofj Real)
            (declare-const ?bofk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bofl Real)
            (declare-const ?bofm Real)
            (declare-const ?bofn Real)
            (declare-const ?bofo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bofp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (= ?bofd ?bnuc)
                  (= ?bofe ?bofp)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bofq Real)
                (declare-const ?bofr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bofs Real)
                (declare-const ?boft Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bofu Real)
                  (declare-const ?bofv Real)
                  (declare-const ?bofw Real)
                  (assert
                    (or (or (= ?bofw ?bofv)
                        (= ?bofw ?bofu)
                        )
                      (= ?bofv ?bofu)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bofx Real)
                  (declare-const ?bofy Real)
                  (declare-const ?bofz Real)
                  (assert
                    (or (or (= ?bofz ?bofy)
                        (= ?bofz ?bofx)
                        )
                      (= ?bofy ?bofx)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boga Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bogb Real)
                  (declare-const ?bogc Real)
                  (declare-const ?bogd Real)
                  (assert
                    (and (and (not (= ?bogd ?bogc))
                        (not (= ?bogd ?bogb))
                        )
                      (not (= ?bogc ?bogb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boge Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bogf Real)
                  (declare-const ?bogg Real)
                  (declare-const ?bogh Real)
                  (assert
                    (and (and (not (= ?bogh ?bogg))
                        (not (= ?bogh ?bogf))
                        )
                      (not (= ?bogg ?bogf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bogi Real)
                (declare-const ?bogj Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bogk Real)
                  (declare-const ?bogl Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                              (not (= ?bogj ?blqw))
                              )
                            (not (= ?bogi ?blqw))
                            )
                          (or (or (= ?bogl ?bogk)
                              (= ?bogl ?blqw)
                              )
                            (= ?bogk ?blqw)
                            )
                          )
                        (or (or (or (= ?bogj ?bogi)
                              (= ?bogj ?blqw)
                              )
                            (= ?bogi ?blqw)
                            )
                          (not (= ?bogl ?bogk))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bogm Real)
                  (declare-const ?bogn Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                              (not (= ?bogj ?blqw))
                              )
                            (not (= ?bogi ?blqw))
                            )
                          (or (or (= ?bogn ?bogm)
                              (= ?bogn ?blqw)
                              )
                            (= ?bogm ?blqw)
                            )
                          )
                        (or (or (or (= ?bogj ?bogi)
                              (= ?bogj ?blqw)
                              )
                            (= ?bogi ?blqw)
                            )
                          (not (= ?bogn ?bogm))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                              (not (= ?bogj ?blqw))
                              )
                            (not (= ?bogi ?blqw))
                            )
                          (or (or (= ?bofd ?bofe)
                              (= ?bofd ?blqw)
                              )
                            (= ?bofe ?blqw)
                            )
                          )
                        (or (or (or (= ?bogj ?bogi)
                              (= ?bogj ?blqw)
                              )
                            (= ?bogi ?blqw)
                            )
                          (not (= ?bofd ?bofe))
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bogo Real)
          (declare-const ?bogp Real)
          (declare-const ?bogq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bogr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bogs Real)
            (declare-const ?bogt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bogu Real)
            (declare-const ?bogv Real)
            (declare-const ?bogw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bogx Real)
            (declare-const ?bogy Real)
            (declare-const ?bogz Real)
            (declare-const ?boha Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bohc Real)
          (declare-const ?bohd Real)
          (declare-const ?bohe Real)
          (declare-const ?bohf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bohg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohh Real)
            (declare-const ?bohi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohj Real)
            (declare-const ?bohk Real)
            (declare-const ?bohl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohm Real)
            (declare-const ?bohn Real)
            (declare-const ?boho Real)
            (declare-const ?bohp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bohr Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bohs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boht Real)
            (declare-const ?bohu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohv Real)
            (declare-const ?bohw Real)
            (declare-const ?bohx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bohy Real)
            (declare-const ?bohz Real)
            (declare-const ?boia Real)
            (declare-const ?boib Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boic Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                          (= ?bogj ?blqw)
                          )
                        (= ?bogi ?blqw)
                        )
                      (and (and (not (= ?bnuc ?bofe))
                          (not (= ?bnuc ?blqw))
                          )
                        (not (= ?bofe ?blqw))
                        )
                      )
                    (and (and (and (not (= ?bogj ?bogi))
                          (not (= ?bogj ?blqw))
                          )
                        (not (= ?bogi ?blqw))
                        )
                      (= ?bnuc ?bofe)
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                          (not (= ?bogj ?blqw))
                          )
                        (not (= ?bogi ?blqw))
                        )
                      (or (or (= ?bnuc ?bofe)
                          (= ?bnuc ?blqw)
                          )
                        (= ?bofe ?blqw)
                        )
                      )
                    (or (or (or (= ?bogj ?bogi)
                          (= ?bogj ?blqw)
                          )
                        (= ?bogi ?blqw)
                        )
                      (not (= ?bnuc ?bofe))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?boid Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?boid ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bnuc ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bnuc ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?boid ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?boie Real)
      (declare-const ?boif Real)
      (declare-const ?boig Real)
      (assert
        (and (and (not (= ?boig ?boif))
            (not (= ?boig ?boie))
            )
          (not (= ?boif ?boie))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?boih Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boii Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boij Real)
            (declare-const ?boik Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boil Real)
            (declare-const ?boim Real)
            (declare-const ?boin Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boio Real)
            (declare-const ?boip Real)
            (declare-const ?boiq Real)
            (declare-const ?boir Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bois Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boit Real)
          (declare-const ?boiu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boiv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boiw Real)
            (declare-const ?boix Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boiy Real)
            (declare-const ?boiz Real)
            (declare-const ?boja Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bojb Real)
            (declare-const ?bojc Real)
            (declare-const ?bojd Real)
            (declare-const ?boje Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bojf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bojg Real)
          (declare-const ?bojh Real)
          (declare-const ?boji Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bojj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bojk Real)
            (declare-const ?bojl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bojm Real)
            (declare-const ?bojn Real)
            (declare-const ?bojo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bojp Real)
            (declare-const ?bojq Real)
            (declare-const ?bojr Real)
            (declare-const ?bojs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bojt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boju Real)
          (declare-const ?bojv Real)
          (declare-const ?bojw Real)
          (declare-const ?bojx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bojy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bojw ?boig)
                      (= ?bojv ?boif)
                      )
                    (= ?boju ?boie)
                    )
                  (= ?bojx ?bojy)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bojz Real)
                (declare-const ?boka Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bokb Real)
                (declare-const ?bokc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bokd Real)
                  (declare-const ?boke Real)
                  (declare-const ?bokf Real)
                  (assert
                    (or (or (= ?bokf ?boke)
                        (= ?bokf ?bokd)
                        )
                      (= ?boke ?bokd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bokg Real)
                  (declare-const ?bokh Real)
                  (declare-const ?boki Real)
                  (assert
                    (or (or (= ?boki ?bokh)
                        (= ?boki ?bokg)
                        )
                      (= ?bokh ?bokg)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bokj Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bokk Real)
                  (declare-const ?bokl Real)
                  (declare-const ?bokm Real)
                  (assert
                    (and (and (not (= ?bokm ?bokl))
                        (not (= ?bokm ?bokk))
                        )
                      (not (= ?bokl ?bokk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bokn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boko Real)
                  (declare-const ?bokp Real)
                  (declare-const ?bokq Real)
                  (assert
                    (and (and (not (= ?bokq ?bokp))
                        (not (= ?bokq ?boko))
                        )
                      (not (= ?bokp ?boko))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bokr Real)
                (declare-const ?boks Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bokt Real)
                  (declare-const ?boku Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?boks ?bokr))
                              (not (= ?boks ?blqw))
                              )
                            (not (= ?bokr ?blqw))
                            )
                          (or (or (= ?boku ?bokt)
                              (= ?boku ?blqw)
                              )
                            (= ?bokt ?blqw)
                            )
                          )
                        (or (or (or (= ?boks ?bokr)
                              (= ?boks ?blqw)
                              )
                            (= ?bokr ?blqw)
                            )
                          (not (= ?boku ?bokt))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bokv Real)
                  (declare-const ?bokw Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?boks ?bokr))
                              (not (= ?boks ?blqw))
                              )
                            (not (= ?bokr ?blqw))
                            )
                          (or (or (= ?bokw ?bokv)
                              (= ?bokw ?blqw)
                              )
                            (= ?bokv ?blqw)
                            )
                          )
                        (or (or (or (= ?boks ?bokr)
                              (= ?boks ?blqw)
                              )
                            (= ?bokr ?blqw)
                            )
                          (not (= ?bokw ?bokv))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bokx Real)
            (declare-const ?boky Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bokz Real)
            (declare-const ?bola Real)
            (declare-const ?bolb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bolc Real)
            (declare-const ?bold Real)
            (declare-const ?bole Real)
            (declare-const ?bolf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bolg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bolh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boli Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bolj Real)
            (declare-const ?bolk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boll Real)
            (declare-const ?bolm Real)
            (declare-const ?boln Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bolo Real)
            (declare-const ?bolp Real)
            (declare-const ?bolq Real)
            (declare-const ?bolr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bols Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bolt Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bolu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bolv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bolw Real)
            (declare-const ?bolx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boly Real)
            (declare-const ?bolz Real)
            (declare-const ?boma Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bomb Real)
            (declare-const ?bomc Real)
            (declare-const ?bomd Real)
            (declare-const ?bome Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bomf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bomg Real)
          (declare-const ?bomh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bomi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bomj Real)
            (declare-const ?bomk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boml Real)
            (declare-const ?bomm Real)
            (declare-const ?bomn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bomo Real)
            (declare-const ?bomp Real)
            (declare-const ?bomq Real)
            (declare-const ?bomr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boms Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bomt Real)
          (declare-const ?bomu Real)
          (declare-const ?bomv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bomw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bomx Real)
            (declare-const ?bomy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bomz Real)
            (declare-const ?bona Real)
            (declare-const ?bonb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bonc Real)
            (declare-const ?bond Real)
            (declare-const ?bone Real)
            (declare-const ?bonf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bong Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bonh Real)
          (declare-const ?boni Real)
          (declare-const ?bonj Real)
          (declare-const ?bonk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bonl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bonm Real)
            (declare-const ?bonn Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bonj ?boig)
                        (= ?boni ?boif)
                        )
                      (= ?bonh ?boie)
                      )
                    (= ?bonm ?bolt)
                    )
                  (= ?bonk ?bonn)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bono Real)
                (declare-const ?bonp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bonq Real)
                (declare-const ?bonr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bons Real)
                  (declare-const ?bont Real)
                  (declare-const ?bonu Real)
                  (assert
                    (or (or (= ?bonu ?bont)
                        (= ?bonu ?bons)
                        )
                      (= ?bont ?bons)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bonv Real)
                  (declare-const ?bonw Real)
                  (declare-const ?bonx Real)
                  (assert
                    (or (or (= ?bonx ?bonw)
                        (= ?bonx ?bonv)
                        )
                      (= ?bonw ?bonv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bony Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bonz Real)
                  (declare-const ?booa Real)
                  (declare-const ?boob Real)
                  (assert
                    (and (and (not (= ?boob ?booa))
                        (not (= ?boob ?bonz))
                        )
                      (not (= ?booa ?bonz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?booc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bood Real)
                  (declare-const ?booe Real)
                  (declare-const ?boof Real)
                  (assert
                    (and (and (not (= ?boof ?booe))
                        (not (= ?boof ?bood))
                        )
                      (not (= ?booe ?bood))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?boog Real)
                (declare-const ?booh Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?booi Real)
                  (declare-const ?booj Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?booh ?boog))
                              (not (= ?booh ?blqw))
                              )
                            (not (= ?boog ?blqw))
                            )
                          (or (or (= ?booj ?booi)
                              (= ?booj ?blqw)
                              )
                            (= ?booi ?blqw)
                            )
                          )
                        (or (or (or (= ?booh ?boog)
                              (= ?booh ?blqw)
                              )
                            (= ?boog ?blqw)
                            )
                          (not (= ?booj ?booi))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?book Real)
                  (declare-const ?bool Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?booh ?boog))
                              (not (= ?booh ?blqw))
                              )
                            (not (= ?boog ?blqw))
                            )
                          (or (or (= ?bool ?book)
                              (= ?bool ?blqw)
                              )
                            (= ?book ?blqw)
                            )
                          )
                        (or (or (or (= ?booh ?boog)
                              (= ?booh ?blqw)
                              )
                            (= ?boog ?blqw)
                            )
                          (not (= ?bool ?book))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?boom Real)
            (declare-const ?boon Real)
            (declare-const ?booo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boop Real)
            (declare-const ?booq Real)
            (declare-const ?boor Real)
            (declare-const ?boos Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boot Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boou Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boov Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boow Real)
            (declare-const ?boox Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?booy Real)
            (declare-const ?booz Real)
            (declare-const ?bopa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopb Real)
            (declare-const ?bopc Real)
            (declare-const ?bopd Real)
            (declare-const ?bope Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bopg Real)
        (declare-const ?boph Real)
        (declare-const ?bopi Real)
        (assert
          (and (and (not (= ?bopi ?boph))
              (not (= ?bopi ?bopg))
              )
            (not (= ?boph ?bopg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bopj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bopk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopl Real)
            (declare-const ?bopm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopn Real)
            (declare-const ?bopo Real)
            (declare-const ?bopp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopq Real)
            (declare-const ?bopr Real)
            (declare-const ?bops Real)
            (declare-const ?bopt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bopv Real)
          (declare-const ?bopw Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bopx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bopy Real)
            (declare-const ?bopz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqa Real)
            (declare-const ?boqb Real)
            (declare-const ?boqc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqd Real)
            (declare-const ?boqe Real)
            (declare-const ?boqf Real)
            (declare-const ?boqg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boqi Real)
          (declare-const ?boqj Real)
          (declare-const ?boqk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boql Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqm Real)
            (declare-const ?boqn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqo Real)
            (declare-const ?boqp Real)
            (declare-const ?boqq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqr Real)
            (declare-const ?boqs Real)
            (declare-const ?boqt Real)
            (declare-const ?boqu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boqv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boqw Real)
          (declare-const ?boqx Real)
          (declare-const ?boqy Real)
          (declare-const ?boqz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bora Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?borb Real)
            (declare-const ?borc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bord Real)
            (declare-const ?bore Real)
            (declare-const ?borf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?borg Real)
            (declare-const ?borh Real)
            (declare-const ?bori Real)
            (declare-const ?borj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?boqy ?boig)
                        (= ?boqx ?boif)
                        )
                      (= ?boqw ?boie)
                      )
                    (and (and (= ?bori ?bopi)
                        (= ?borh ?boph)
                        )
                      (= ?borg ?bopg)
                      )
                    )
                  (= ?boqz ?borj)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bork Real)
                (declare-const ?borl Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?borm Real)
                (declare-const ?born Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?boro Real)
                  (declare-const ?borp Real)
                  (declare-const ?borq Real)
                  (assert
                    (or (or (= ?borq ?borp)
                        (= ?borq ?boro)
                        )
                      (= ?borp ?boro)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?borr Real)
                  (declare-const ?bors Real)
                  (declare-const ?bort Real)
                  (assert
                    (or (or (= ?bort ?bors)
                        (= ?bort ?borr)
                        )
                      (= ?bors ?borr)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boru Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?borv Real)
                  (declare-const ?borw Real)
                  (declare-const ?borx Real)
                  (assert
                    (and (and (not (= ?borx ?borw))
                        (not (= ?borx ?borv))
                        )
                      (not (= ?borw ?borv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bory Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?borz Real)
                  (declare-const ?bosa Real)
                  (declare-const ?bosb Real)
                  (assert
                    (and (and (not (= ?bosb ?bosa))
                        (not (= ?bosb ?borz))
                        )
                      (not (= ?bosa ?borz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bosc Real)
                (declare-const ?bosd Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bose Real)
                  (declare-const ?bosf Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bosd ?bosc))
                              (not (= ?bosd ?blqw))
                              )
                            (not (= ?bosc ?blqw))
                            )
                          (or (or (= ?bosf ?bose)
                              (= ?bosf ?blqw)
                              )
                            (= ?bose ?blqw)
                            )
                          )
                        (or (or (or (= ?bosd ?bosc)
                              (= ?bosd ?blqw)
                              )
                            (= ?bosc ?blqw)
                            )
                          (not (= ?bosf ?bose))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bosg Real)
                  (declare-const ?bosh Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bosd ?bosc))
                              (not (= ?bosd ?blqw))
                              )
                            (not (= ?bosc ?blqw))
                            )
                          (or (or (= ?bosh ?bosg)
                              (= ?bosh ?blqw)
                              )
                            (= ?bosg ?blqw)
                            )
                          )
                        (or (or (or (= ?bosd ?bosc)
                              (= ?bosd ?blqw)
                              )
                            (= ?bosc ?blqw)
                            )
                          (not (= ?bosh ?bosg))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bosi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bosj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bosk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bosl Real)
            (declare-const ?bosm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bosn Real)
            (declare-const ?boso Real)
            (declare-const ?bosp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bosq Real)
            (declare-const ?bosr Real)
            (declare-const ?boss Real)
            (declare-const ?bost Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bosu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bosv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bosw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bosx Real)
            (declare-const ?bosy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bosz Real)
            (declare-const ?bota Real)
            (declare-const ?botb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?botc Real)
            (declare-const ?botd Real)
            (declare-const ?bote Real)
            (declare-const ?botf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?botg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?both Real)
          (declare-const ?boti Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?botj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?botk Real)
            (declare-const ?botl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?botm Real)
            (declare-const ?botn Real)
            (declare-const ?boto Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?botp Real)
            (declare-const ?botq Real)
            (declare-const ?botr Real)
            (declare-const ?bots Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bott Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?botu Real)
          (declare-const ?botv Real)
          (declare-const ?botw Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?botx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boty Real)
            (declare-const ?botz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boua Real)
            (declare-const ?boub Real)
            (declare-const ?bouc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boud Real)
            (declare-const ?boue Real)
            (declare-const ?bouf Real)
            (declare-const ?boug Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bouh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boui Real)
          (declare-const ?bouj Real)
          (declare-const ?bouk Real)
          (declare-const ?boul Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boum Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boun Real)
            (declare-const ?bouo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boup Real)
            (declare-const ?bouq Real)
            (declare-const ?bour Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bous Real)
            (declare-const ?bout Real)
            (declare-const ?bouu Real)
            (declare-const ?bouv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bouw Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bouk ?boig)
                      (= ?bouj ?boif)
                      )
                    (= ?boui ?boie)
                    )
                  (= ?boul ?bouw)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?boux Real)
                (declare-const ?bouy Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bouz Real)
                (declare-const ?bova Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bovb Real)
                  (declare-const ?bovc Real)
                  (declare-const ?bovd Real)
                  (assert
                    (or (or (= ?bovd ?bovc)
                        (= ?bovd ?bovb)
                        )
                      (= ?bovc ?bovb)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bove Real)
                  (declare-const ?bovf Real)
                  (declare-const ?bovg Real)
                  (assert
                    (or (or (= ?bovg ?bovf)
                        (= ?bovg ?bove)
                        )
                      (= ?bovf ?bove)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bovh Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bovi Real)
                  (declare-const ?bovj Real)
                  (declare-const ?bovk Real)
                  (assert
                    (and (and (not (= ?bovk ?bovj))
                        (not (= ?bovk ?bovi))
                        )
                      (not (= ?bovj ?bovi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bovl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bovm Real)
                  (declare-const ?bovn Real)
                  (declare-const ?bovo Real)
                  (assert
                    (and (and (not (= ?bovo ?bovn))
                        (not (= ?bovo ?bovm))
                        )
                      (not (= ?bovn ?bovm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bovp Real)
                (declare-const ?bovq Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bovr Real)
                  (declare-const ?bovs Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bovq ?bovp))
                              (not (= ?bovq ?blqw))
                              )
                            (not (= ?bovp ?blqw))
                            )
                          (or (or (= ?bovs ?bovr)
                              (= ?bovs ?blqw)
                              )
                            (= ?bovr ?blqw)
                            )
                          )
                        (or (or (or (= ?bovq ?bovp)
                              (= ?bovq ?blqw)
                              )
                            (= ?bovp ?blqw)
                            )
                          (not (= ?bovs ?bovr))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bovt Real)
                  (declare-const ?bovu Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bovq ?bovp))
                              (not (= ?bovq ?blqw))
                              )
                            (not (= ?bovp ?blqw))
                            )
                          (or (or (= ?bovu ?bovt)
                              (= ?bovu ?blqw)
                              )
                            (= ?bovt ?blqw)
                            )
                          )
                        (or (or (or (= ?bovq ?bovp)
                              (= ?bovq ?blqw)
                              )
                            (= ?bovp ?blqw)
                            )
                          (not (= ?bovu ?bovt))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bovv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bovw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bovx Real)
            (declare-const ?bovy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bovz Real)
            (declare-const ?bowa Real)
            (declare-const ?bowb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowc Real)
            (declare-const ?bowd Real)
            (declare-const ?bowe Real)
            (declare-const ?bowf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bowh Real)
        (declare-const ?bowi Real)
        (declare-const ?bowj Real)
        (assert
          (and (and (not (= ?bowj ?bowi))
              (not (= ?bowj ?bowh))
              )
            (not (= ?bowi ?bowh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bowk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bowl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowm Real)
            (declare-const ?bown Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowo Real)
            (declare-const ?bowp Real)
            (declare-const ?bowq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowr Real)
            (declare-const ?bows Real)
            (declare-const ?bowt Real)
            (declare-const ?bowu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boww Real)
          (declare-const ?bowx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bowy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bowz Real)
            (declare-const ?boxa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxb Real)
            (declare-const ?boxc Real)
            (declare-const ?boxd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxe Real)
            (declare-const ?boxf Real)
            (declare-const ?boxg Real)
            (declare-const ?boxh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boxj Real)
          (declare-const ?boxk Real)
          (declare-const ?boxl Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boxm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxn Real)
            (declare-const ?boxo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxp Real)
            (declare-const ?boxq Real)
            (declare-const ?boxr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxs Real)
            (declare-const ?boxt Real)
            (declare-const ?boxu Real)
            (declare-const ?boxv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boxw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boxx Real)
          (declare-const ?boxy Real)
          (declare-const ?boxz Real)
          (declare-const ?boya Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boyb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boyc Real)
            (declare-const ?boyd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boye Real)
            (declare-const ?boyf Real)
            (declare-const ?boyg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boyh Real)
            (declare-const ?boyi Real)
            (declare-const ?boyj Real)
            (declare-const ?boyk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?boyl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?boym Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?boyn Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?boym ?boyn)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?boyo Real)
                (declare-const ?boyp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?boyq Real)
                (declare-const ?boyr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?boys Real)
                  (declare-const ?boyt Real)
                  (declare-const ?boyu Real)
                  (assert
                    (or (or (= ?boyu ?boyt)
                        (= ?boyu ?boys)
                        )
                      (= ?boyt ?boys)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boyv Real)
                  (declare-const ?boyw Real)
                  (declare-const ?boyx Real)
                  (assert
                    (or (or (= ?boyx ?boyw)
                        (= ?boyx ?boyv)
                        )
                      (= ?boyw ?boyv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boyy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?boyz Real)
                  (declare-const ?boza Real)
                  (declare-const ?bozb Real)
                  (assert
                    (and (and (not (= ?bozb ?boza))
                        (not (= ?bozb ?boyz))
                        )
                      (not (= ?boza ?boyz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bozc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bozd Real)
                  (declare-const ?boze Real)
                  (declare-const ?bozf Real)
                  (assert
                    (and (and (not (= ?bozf ?boze))
                        (not (= ?bozf ?bozd))
                        )
                      (not (= ?boze ?bozd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bozg Real)
                (declare-const ?bozh Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bozi Real)
                  (declare-const ?bozj Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bozh ?bozg))
                              (not (= ?bozh ?blqw))
                              )
                            (not (= ?bozg ?blqw))
                            )
                          (or (or (= ?bozj ?bozi)
                              (= ?bozj ?blqw)
                              )
                            (= ?bozi ?blqw)
                            )
                          )
                        (or (or (or (= ?bozh ?bozg)
                              (= ?bozh ?blqw)
                              )
                            (= ?bozg ?blqw)
                            )
                          (not (= ?bozj ?bozi))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bozk Real)
                  (declare-const ?bozl Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bozh ?bozg))
                              (not (= ?bozh ?blqw))
                              )
                            (not (= ?bozg ?blqw))
                            )
                          (or (or (= ?bozl ?bozk)
                              (= ?bozl ?blqw)
                              )
                            (= ?bozk ?blqw)
                            )
                          )
                        (or (or (or (= ?bozh ?bozg)
                              (= ?bozh ?blqw)
                              )
                            (= ?bozg ?blqw)
                            )
                          (not (= ?bozl ?bozk))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bozm Real)
            (declare-const ?bozn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bozo Real)
            (declare-const ?bozp Real)
            (declare-const ?bozq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bozr Real)
            (declare-const ?bozs Real)
            (declare-const ?bozt Real)
            (declare-const ?bozu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bozv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bozw Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bozx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bozy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bozz Real)
            (declare-const ?bpaa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpab Real)
            (declare-const ?bpac Real)
            (declare-const ?bpad Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpae Real)
            (declare-const ?bpaf Real)
            (declare-const ?bpag Real)
            (declare-const ?bpah Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpai Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpaj Real)
          (declare-const ?bpak Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpal Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpam Real)
            (declare-const ?bpan Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpao Real)
            (declare-const ?bpap Real)
            (declare-const ?bpaq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpar Real)
            (declare-const ?bpas Real)
            (declare-const ?bpat Real)
            (declare-const ?bpau Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpav Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpaw Real)
          (declare-const ?bpax Real)
          (declare-const ?bpay Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpaz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpba Real)
            (declare-const ?bpbb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpbc Real)
            (declare-const ?bpbd Real)
            (declare-const ?bpbe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpbf Real)
            (declare-const ?bpbg Real)
            (declare-const ?bpbh Real)
            (declare-const ?bpbi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpbj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpbk Real)
          (declare-const ?bpbl Real)
          (declare-const ?bpbm Real)
          (declare-const ?bpbn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpbo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpbp Real)
            (declare-const ?bpbq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpbr Real)
            (declare-const ?bpbs Real)
            (declare-const ?bpbt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpbu Real)
            (declare-const ?bpbv Real)
            (declare-const ?bpbw Real)
            (declare-const ?bpbx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpby Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpbz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpca Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpcb Real)
            (declare-const ?bpcc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (= ?bpcb ?bozw)
                  (= ?bpbz ?bpcc)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpcd Real)
                (declare-const ?bpce Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpcf Real)
                (declare-const ?bpcg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpch Real)
                  (declare-const ?bpci Real)
                  (declare-const ?bpcj Real)
                  (assert
                    (or (or (= ?bpcj ?bpci)
                        (= ?bpcj ?bpch)
                        )
                      (= ?bpci ?bpch)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpck Real)
                  (declare-const ?bpcl Real)
                  (declare-const ?bpcm Real)
                  (assert
                    (or (or (= ?bpcm ?bpcl)
                        (= ?bpcm ?bpck)
                        )
                      (= ?bpcl ?bpck)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpcn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpco Real)
                  (declare-const ?bpcp Real)
                  (declare-const ?bpcq Real)
                  (assert
                    (and (and (not (= ?bpcq ?bpcp))
                        (not (= ?bpcq ?bpco))
                        )
                      (not (= ?bpcp ?bpco))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpcr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpcs Real)
                  (declare-const ?bpct Real)
                  (declare-const ?bpcu Real)
                  (assert
                    (and (and (not (= ?bpcu ?bpct))
                        (not (= ?bpcu ?bpcs))
                        )
                      (not (= ?bpct ?bpcs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bpcv Real)
                (declare-const ?bpcw Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpcx Real)
                  (declare-const ?bpcy Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpcw ?bpcv))
                              (not (= ?bpcw ?blqw))
                              )
                            (not (= ?bpcv ?blqw))
                            )
                          (or (or (= ?bpcy ?bpcx)
                              (= ?bpcy ?blqw)
                              )
                            (= ?bpcx ?blqw)
                            )
                          )
                        (or (or (or (= ?bpcw ?bpcv)
                              (= ?bpcw ?blqw)
                              )
                            (= ?bpcv ?blqw)
                            )
                          (not (= ?bpcy ?bpcx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpcz Real)
                  (declare-const ?bpda Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpcw ?bpcv))
                              (not (= ?bpcw ?blqw))
                              )
                            (not (= ?bpcv ?blqw))
                            )
                          (or (or (= ?bpda ?bpcz)
                              (= ?bpda ?blqw)
                              )
                            (= ?bpcz ?blqw)
                            )
                          )
                        (or (or (or (= ?bpcw ?bpcv)
                              (= ?bpcw ?blqw)
                              )
                            (= ?bpcv ?blqw)
                            )
                          (not (= ?bpda ?bpcz))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bpdb Real)
            (declare-const ?bpdc Real)
            (declare-const ?bpdd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpde Real)
            (declare-const ?bpdf Real)
            (declare-const ?bpdg Real)
            (declare-const ?bpdh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpdi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpdj Real)
        (declare-const ?bpdk Real)
        (declare-const ?bpdl Real)
        (assert
          (and (and (not (= ?bpdl ?bpdk))
              (not (= ?bpdl ?bpdj))
              )
            (not (= ?bpdk ?bpdj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpdm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpdn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpdo Real)
            (declare-const ?bpdp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpdq Real)
            (declare-const ?bpdr Real)
            (declare-const ?bpds Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpdt Real)
            (declare-const ?bpdu Real)
            (declare-const ?bpdv Real)
            (declare-const ?bpdw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpdx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpdy Real)
          (declare-const ?bpdz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpea Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpeb Real)
            (declare-const ?bpec Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bped Real)
            (declare-const ?bpee Real)
            (declare-const ?bpef Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpeg Real)
            (declare-const ?bpeh Real)
            (declare-const ?bpei Real)
            (declare-const ?bpej Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpek Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpel Real)
          (declare-const ?bpem Real)
          (declare-const ?bpen Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpeo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpep Real)
            (declare-const ?bpeq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bper Real)
            (declare-const ?bpes Real)
            (declare-const ?bpet Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpeu Real)
            (declare-const ?bpev Real)
            (declare-const ?bpew Real)
            (declare-const ?bpex Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpey Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpez Real)
          (declare-const ?bpfa Real)
          (declare-const ?bpfb Real)
          (declare-const ?bpfc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpfd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfe Real)
            (declare-const ?bpff Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfg Real)
            (declare-const ?bpfh Real)
            (declare-const ?bpfi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfj Real)
            (declare-const ?bpfk Real)
            (declare-const ?bpfl Real)
            (declare-const ?bpfm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpfo Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpfp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfq Real)
            (declare-const ?bpfr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfs Real)
            (declare-const ?bpft Real)
            (declare-const ?bpfu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpfv Real)
            (declare-const ?bpfw Real)
            (declare-const ?bpfx Real)
            (declare-const ?bpfy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bpfx ?bpdl)
                      (= ?bpfw ?bpdk)
                      )
                    (= ?bpfv ?bpdj)
                    )
                  (= ?bpfo ?bpfy)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpfz Real)
                (declare-const ?bpga Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpgb Real)
                (declare-const ?bpgc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpgd Real)
                  (declare-const ?bpge Real)
                  (declare-const ?bpgf Real)
                  (assert
                    (or (or (= ?bpgf ?bpge)
                        (= ?bpgf ?bpgd)
                        )
                      (= ?bpge ?bpgd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpgg Real)
                  (declare-const ?bpgh Real)
                  (declare-const ?bpgi Real)
                  (assert
                    (or (or (= ?bpgi ?bpgh)
                        (= ?bpgi ?bpgg)
                        )
                      (= ?bpgh ?bpgg)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpgj Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpgk Real)
                  (declare-const ?bpgl Real)
                  (declare-const ?bpgm Real)
                  (assert
                    (and (and (not (= ?bpgm ?bpgl))
                        (not (= ?bpgm ?bpgk))
                        )
                      (not (= ?bpgl ?bpgk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpgn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpgo Real)
                  (declare-const ?bpgp Real)
                  (declare-const ?bpgq Real)
                  (assert
                    (and (and (not (= ?bpgq ?bpgp))
                        (not (= ?bpgq ?bpgo))
                        )
                      (not (= ?bpgp ?bpgo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bpgr Real)
                (declare-const ?bpgs Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpgt Real)
                  (declare-const ?bpgu Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpgs ?bpgr))
                              (not (= ?bpgs ?blqw))
                              )
                            (not (= ?bpgr ?blqw))
                            )
                          (or (or (= ?bpgu ?bpgt)
                              (= ?bpgu ?blqw)
                              )
                            (= ?bpgt ?blqw)
                            )
                          )
                        (or (or (or (= ?bpgs ?bpgr)
                              (= ?bpgs ?blqw)
                              )
                            (= ?bpgr ?blqw)
                            )
                          (not (= ?bpgu ?bpgt))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpgv Real)
                  (declare-const ?bpgw Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpgs ?bpgr))
                              (not (= ?bpgs ?blqw))
                              )
                            (not (= ?bpgr ?blqw))
                            )
                          (or (or (= ?bpgw ?bpgv)
                              (= ?bpgw ?blqw)
                              )
                            (= ?bpgv ?blqw)
                            )
                          )
                        (or (or (or (= ?bpgs ?bpgr)
                              (= ?bpgs ?blqw)
                              )
                            (= ?bpgr ?blqw)
                            )
                          (not (= ?bpgw ?bpgv))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bpgx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpgy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpgz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpha Real)
            (declare-const ?bphb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphc Real)
            (declare-const ?bphd Real)
            (declare-const ?bphe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphf Real)
            (declare-const ?bphg Real)
            (declare-const ?bphh Real)
            (declare-const ?bphi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bphk Real)
          (declare-const ?bphl Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bphm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphn Real)
            (declare-const ?bpho Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphp Real)
            (declare-const ?bphq Real)
            (declare-const ?bphr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphs Real)
            (declare-const ?bpht Real)
            (declare-const ?bphu Real)
            (declare-const ?bphv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bphw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bphx Real)
          (declare-const ?bphy Real)
          (declare-const ?bphz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpia Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpib Real)
            (declare-const ?bpic Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpid Real)
            (declare-const ?bpie Real)
            (declare-const ?bpif Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpig Real)
            (declare-const ?bpih Real)
            (declare-const ?bpii Real)
            (declare-const ?bpij Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpik Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpil Real)
          (declare-const ?bpim Real)
          (declare-const ?bpin Real)
          (declare-const ?bpio Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpip Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpiq Real)
            (declare-const ?bpir Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpis Real)
            (declare-const ?bpit Real)
            (declare-const ?bpiu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpiv Real)
            (declare-const ?bpiw Real)
            (declare-const ?bpix Real)
            (declare-const ?bpiy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpiz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpja Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpjb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpjc Real)
            (declare-const ?bpjd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpje Real)
            (declare-const ?bpjf Real)
            (declare-const ?bpjg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpjh Real)
            (declare-const ?bpji Real)
            (declare-const ?bpjj Real)
            (declare-const ?bpjk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpjl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bpja ?bpjl)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpjm Real)
                (declare-const ?bpjn Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpjo Real)
                (declare-const ?bpjp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpjq Real)
                  (declare-const ?bpjr Real)
                  (declare-const ?bpjs Real)
                  (assert
                    (or (or (= ?bpjs ?bpjr)
                        (= ?bpjs ?bpjq)
                        )
                      (= ?bpjr ?bpjq)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpjt Real)
                  (declare-const ?bpju Real)
                  (declare-const ?bpjv Real)
                  (assert
                    (or (or (= ?bpjv ?bpju)
                        (= ?bpjv ?bpjt)
                        )
                      (= ?bpju ?bpjt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpjw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpjx Real)
                  (declare-const ?bpjy Real)
                  (declare-const ?bpjz Real)
                  (assert
                    (and (and (not (= ?bpjz ?bpjy))
                        (not (= ?bpjz ?bpjx))
                        )
                      (not (= ?bpjy ?bpjx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpka Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpkb Real)
                  (declare-const ?bpkc Real)
                  (declare-const ?bpkd Real)
                  (assert
                    (and (and (not (= ?bpkd ?bpkc))
                        (not (= ?bpkd ?bpkb))
                        )
                      (not (= ?bpkc ?bpkb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bpke Real)
                (declare-const ?bpkf Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpkg Real)
                  (declare-const ?bpkh Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpkf ?bpke))
                              (not (= ?bpkf ?blqw))
                              )
                            (not (= ?bpke ?blqw))
                            )
                          (or (or (= ?bpkh ?bpkg)
                              (= ?bpkh ?blqw)
                              )
                            (= ?bpkg ?blqw)
                            )
                          )
                        (or (or (or (= ?bpkf ?bpke)
                              (= ?bpkf ?blqw)
                              )
                            (= ?bpke ?blqw)
                            )
                          (not (= ?bpkh ?bpkg))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpki Real)
                  (declare-const ?bpkj Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpkf ?bpke))
                              (not (= ?bpkf ?blqw))
                              )
                            (not (= ?bpke ?blqw))
                            )
                          (or (or (= ?bpkj ?bpki)
                              (= ?bpkj ?blqw)
                              )
                            (= ?bpki ?blqw)
                            )
                          )
                        (or (or (or (= ?bpkf ?bpke)
                              (= ?bpkf ?blqw)
                              )
                            (= ?bpke ?blqw)
                            )
                          (not (= ?bpkj ?bpki))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bpkk Real)
        (declare-const ?bpkl Real)
        (declare-const ?bpkm Real)
        (assert
          (and (and (not (= ?bpkm ?bpkl))
              (not (= ?bpkm ?bpkk))
              )
            (not (= ?bpkl ?bpkk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bpkn Real)
    (declare-const ?bpko Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bpkp Real)
      (declare-const ?bpkq Real)
      (assert
        (forall ((?blqw Real) )(and (or (and (and (not (= ?bpko ?bpkn))
                  (not (= ?bpko ?blqw))
                  )
                (not (= ?bpkn ?blqw))
                )
              (or (or (= ?bpkq ?bpkp)
                  (= ?bpkq ?blqw)
                  )
                (= ?bpkp ?blqw)
                )
              )
            (or (or (or (= ?bpko ?bpkn)
                  (= ?bpko ?blqw)
                  )
                (= ?bpkn ?blqw)
                )
              (not (= ?bpkq ?bpkp))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bpkr Real)
        (declare-const ?bpks Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bpko ?bpkn))
                    (not (= ?bpko ?blqw))
                    )
                  (not (= ?bpkn ?blqw))
                  )
                (or (or (= ?bpks ?bpkr)
                    (= ?bpks ?blqw)
                    )
                  (= ?bpkr ?blqw)
                  )
                )
              (or (or (or (= ?bpko ?bpkn)
                    (= ?bpko ?blqw)
                    )
                  (= ?bpkn ?blqw)
                  )
                (not (= ?bpks ?bpkr))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpkt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpku Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpkv Real)
            (declare-const ?bpkw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpkx Real)
            (declare-const ?bpky Real)
            (declare-const ?bpkz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpla Real)
            (declare-const ?bplb Real)
            (declare-const ?bplc Real)
            (declare-const ?bpld Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bple Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bplf Real)
          (declare-const ?bplg Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bplh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpli Real)
            (declare-const ?bplj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bplk Real)
            (declare-const ?bpll Real)
            (declare-const ?bplm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpln Real)
            (declare-const ?bplo Real)
            (declare-const ?bplp Real)
            (declare-const ?bplq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bplr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpls Real)
          (declare-const ?bplt Real)
          (declare-const ?bplu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bplv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bplw Real)
            (declare-const ?bplx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bply Real)
            (declare-const ?bplz Real)
            (declare-const ?bpma Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bplt ?bpkq)
                      (= ?bpls ?bpkp)
                      )
                    (and (= ?bplz ?bpks)
                      (= ?bply ?bpkr)
                      )
                    )
                  (= ?bplu ?bpma)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpmb Real)
                (declare-const ?bpmc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpmd Real)
                (declare-const ?bpme Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpmf Real)
                  (declare-const ?bpmg Real)
                  (declare-const ?bpmh Real)
                  (assert
                    (or (or (= ?bpmh ?bpmg)
                        (= ?bpmh ?bpmf)
                        )
                      (= ?bpmg ?bpmf)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpmi Real)
                  (declare-const ?bpmj Real)
                  (declare-const ?bpmk Real)
                  (assert
                    (or (or (= ?bpmk ?bpmj)
                        (= ?bpmk ?bpmi)
                        )
                      (= ?bpmj ?bpmi)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpml Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpmm Real)
                  (declare-const ?bpmn Real)
                  (declare-const ?bpmo Real)
                  (assert
                    (and (and (not (= ?bpmo ?bpmn))
                        (not (= ?bpmo ?bpmm))
                        )
                      (not (= ?bpmn ?bpmm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpmp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpmq Real)
                  (declare-const ?bpmr Real)
                  (declare-const ?bpms Real)
                  (assert
                    (and (and (not (= ?bpms ?bpmr))
                        (not (= ?bpms ?bpmq))
                        )
                      (not (= ?bpmr ?bpmq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bpmt Real)
                (declare-const ?bpmu Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpmv Real)
                  (declare-const ?bpmw Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpmu ?bpmt))
                              (not (= ?bpmu ?blqw))
                              )
                            (not (= ?bpmt ?blqw))
                            )
                          (or (or (= ?bpmw ?bpmv)
                              (= ?bpmw ?blqw)
                              )
                            (= ?bpmv ?blqw)
                            )
                          )
                        (or (or (or (= ?bpmu ?bpmt)
                              (= ?bpmu ?blqw)
                              )
                            (= ?bpmt ?blqw)
                            )
                          (not (= ?bpmw ?bpmv))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpmx Real)
                  (declare-const ?bpmy Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpmu ?bpmt))
                              (not (= ?bpmu ?blqw))
                              )
                            (not (= ?bpmt ?blqw))
                            )
                          (or (or (= ?bpmy ?bpmx)
                              (= ?bpmy ?blqw)
                              )
                            (= ?bpmx ?blqw)
                            )
                          )
                        (or (or (or (= ?bpmu ?bpmt)
                              (= ?bpmu ?blqw)
                              )
                            (= ?bpmt ?blqw)
                            )
                          (not (= ?bpmy ?bpmx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (and (or (or (= ?bplt ?bpls)
                          (= ?bplt ?bplu)
                          )
                        (= ?bpls ?bplu)
                        )
                      (and (and (not (= ?bplz ?bply))
                          (not (= ?bplz ?bpma))
                          )
                        (not (= ?bply ?bpma))
                        )
                      )
                    (and (and (and (not (= ?bplt ?bpls))
                          (not (= ?bplt ?bplu))
                          )
                        (not (= ?bpls ?bplu))
                        )
                      (or (or (= ?bplz ?bply)
                          (= ?bplz ?bpma)
                          )
                        (= ?bply ?bpma)
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bpmz Real)
            (declare-const ?bpna Real)
            (declare-const ?bpnb Real)
            (declare-const ?bpnc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpnd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpne Real)
          (declare-const ?bpnf Real)
          (declare-const ?bpng Real)
          (declare-const ?bpnh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpni Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpnj Real)
            (declare-const ?bpnk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpnl Real)
            (declare-const ?bpnm Real)
            (declare-const ?bpnn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpno Real)
            (declare-const ?bpnp Real)
            (declare-const ?bpnq Real)
            (declare-const ?bpnr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpns Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpnt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpnu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpnv Real)
            (declare-const ?bpnw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpnx Real)
            (declare-const ?bpny Real)
            (declare-const ?bpnz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpoa Real)
            (declare-const ?bpob Real)
            (declare-const ?bpoc Real)
            (declare-const ?bpod Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpoe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpof Real)
        (declare-const ?bpog Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bpko ?bpkn))
                    (not (= ?bpko ?blqw))
                    )
                  (not (= ?bpkn ?blqw))
                  )
                (or (or (= ?bpog ?bpof)
                    (= ?bpog ?blqw)
                    )
                  (= ?bpof ?blqw)
                  )
                )
              (or (or (or (= ?bpko ?bpkn)
                    (= ?bpko ?blqw)
                    )
                  (= ?bpkn ?blqw)
                  )
                (not (= ?bpog ?bpof))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bpoh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bpoi Real)
    (declare-const ?bpoj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bpok Real)
        (declare-const ?bpol Real)
        (declare-const ?bpom Real)
        (assert
          (or (or (= ?bpom ?bpol)
              (= ?bpom ?bpok)
              )
            (= ?bpol ?bpok)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpon Real)
          (declare-const ?bpoo Real)
          (declare-const ?bpop Real)
          (assert
            (and (and (not (= ?bpop ?bpoo))
                (not (= ?bpop ?bpon))
                )
              (not (= ?bpoo ?bpon))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpoq Real)
          (declare-const ?bpor Real)
          (declare-const ?bpos Real)
          (assert
            (or (or (= ?bpos ?bpor)
                (= ?bpos ?bpoq)
                )
              (= ?bpor ?bpoq)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpot Real)
        (declare-const ?bpou Real)
        (declare-const ?bpov Real)
        (assert
          (and (and (not (= ?bpov ?bpou))
              (not (= ?bpov ?bpot))
              )
            (not (= ?bpou ?bpot))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpow Real)
          (declare-const ?bpox Real)
          (declare-const ?bpoy Real)
          (assert
            (or (or (= ?bpoy ?bpox)
                (= ?bpoy ?bpow)
                )
              (= ?bpox ?bpow)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpoz Real)
          (declare-const ?bppa Real)
          (declare-const ?bppb Real)
          (assert
            (or (or (= ?bppb ?bppa)
                (= ?bppb ?bpoz)
                )
              (= ?bppa ?bpoz)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bppc Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bppd Real)
        (declare-const ?bppe Real)
        (declare-const ?bppf Real)
        (assert
          (or (or (= ?bppf ?bppe)
              (= ?bppf ?bppd)
              )
            (= ?bppe ?bppd)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bppg Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bppg ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bppc ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bppg ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpph Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bpph ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bppc ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bpph ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bppi Real)
          (declare-const ?bppj Real)
          (declare-const ?bppk Real)
          (assert
            (or (or (= ?bppk ?bppj)
                (= ?bppk ?bppi)
                )
              (= ?bppj ?bppi)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bppl Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bppl ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bppc ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bppl ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bppm Real)
        (declare-const ?bppn Real)
        (declare-const ?bppo Real)
        (assert
          (and (and (not (= ?bppo ?bppn))
              (not (= ?bppo ?bppm))
              )
            (not (= ?bppn ?bppm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bppp Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bppp ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bppc ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bppp ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bppq Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bppq ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bppc ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bppq ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bppr Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bppr ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bppc ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bppr ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpps Real)
          (declare-const ?bppt Real)
          (declare-const ?bppu Real)
          (assert
            (and (and (not (= ?bppu ?bppt))
                (not (= ?bppu ?bpps))
                )
              (not (= ?bppt ?bpps))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bpph Real) )(forall ((?bnyg Real) )(or (= ?bpph ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bppc ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bppc ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bpph ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bppe Real) (?bppd Real) )(or (= ?bppe ?bppd)
              (exists ((?bppf Real) )(or (= ?bppf ?bppe)
                  (= ?bppf ?bppd)
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bppv Real)
        (declare-const ?bppw Real)
        (declare-const ?bppx Real)
        (assert
          (or (or (= ?bppx ?bppw)
              (= ?bppx ?bppv)
              )
            (= ?bppw ?bppv)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bppy Real)
          (declare-const ?bppz Real)
          (declare-const ?bpqa Real)
          (assert
            (and (and (not (= ?bpqa ?bppz))
                (not (= ?bpqa ?bppy))
                )
              (not (= ?bppz ?bppy))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpqb Real)
          (declare-const ?bpqc Real)
          (declare-const ?bpqd Real)
          (assert
            (or (or (= ?bpqd ?bpqc)
                (= ?bpqd ?bpqb)
                )
              (= ?bpqc ?bpqb)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpqe Real)
        (declare-const ?bpqf Real)
        (declare-const ?bpqg Real)
        (assert
          (and (and (not (= ?bpqg ?bpqf))
              (not (= ?bpqg ?bpqe))
              )
            (not (= ?bpqf ?bpqe))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpqh Real)
          (declare-const ?bpqi Real)
          (declare-const ?bpqj Real)
          (assert
            (or (or (= ?bpqj ?bpqi)
                (= ?bpqj ?bpqh)
                )
              (= ?bpqi ?bpqh)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpqk Real)
          (declare-const ?bpql Real)
          (declare-const ?bpqm Real)
          (assert
            (or (or (= ?bpqm ?bpql)
                (= ?bpqm ?bpqk)
                )
              (= ?bpql ?bpqk)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpqn Real)
          (declare-const ?bpqo Real)
          (declare-const ?bpqp Real)
          (assert
            (and (and (not (= ?bpqp ?bpqo))
                (not (= ?bpqp ?bpqn))
                )
              (not (= ?bpqo ?bpqn))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpqq Real)
        (declare-const ?bpqr Real)
        (declare-const ?bpqs Real)
        (assert
          (and (and (not (= ?bpqs ?bpqr))
              (not (= ?bpqs ?bpqq))
              )
            (not (= ?bpqr ?bpqq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpqt Real)
          (declare-const ?bpqu Real)
          (declare-const ?bpqv Real)
          (assert
            (and (and (not (= ?bpqv ?bpqu))
                (not (= ?bpqv ?bpqt))
                )
              (not (= ?bpqu ?bpqt))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpqw Real)
          (declare-const ?bpqx Real)
          (declare-const ?bpqy Real)
          (assert
            (and (and (not (= ?bpqy ?bpqx))
                (not (= ?bpqy ?bpqw))
                )
              (not (= ?bpqx ?bpqw))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpqz Real)
          (declare-const ?bpra Real)
          (declare-const ?bprb Real)
          (assert
            (and (and (not (= ?bprb ?bpra))
                (not (= ?bprb ?bpqz))
                )
              (not (= ?bpra ?bpqz))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bprc Real)
        (declare-const ?bprd Real)
        (declare-const ?bpre Real)
        (assert
          (and (and (not (= ?bpre ?bprd))
              (not (= ?bpre ?bprc))
              )
            (not (= ?bprd ?bprc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bprf Real)
          (declare-const ?bprg Real)
          (declare-const ?bprh Real)
          (assert
            (and (and (not (= ?bprh ?bprg))
                (not (= ?bprh ?bprf))
                )
              (not (= ?bprg ?bprf))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpri Real)
          (declare-const ?bprj Real)
          (declare-const ?bprk Real)
          (assert
            (and (and (not (= ?bprk ?bprj))
                (not (= ?bprk ?bpri))
                )
              (not (= ?bprj ?bpri))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bprl Real)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bprm Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bprm ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bprl ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bprl ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bprm ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bprn Real)
          (declare-const ?bpro Real)
          (declare-const ?bprp Real)
          (assert
            (and (and (not (= ?bprp ?bpro))
                (not (= ?bprp ?bprn))
                )
              (not (= ?bpro ?bprn))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bprq Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bprq ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bprl ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bprl ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bprq ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bprr Real)
        (declare-const ?bprs Real)
        (declare-const ?bprt Real)
        (assert
          (and (and (not (= ?bprt ?bprs))
              (not (= ?bprt ?bprr))
              )
            (not (= ?bprs ?bprr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpru Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bpru ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bprl ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bprl ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bpru ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bprv Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bprv ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bprl ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bprl ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bprv ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bprd Real) (?bprc Real) )(and (not (= ?bprd ?bprc))
              (exists ((?bpre Real) )(and (not (= ?bpre ?bprd))
                  (and (not (= ?bpre ?bprc))
                    (or (or (= ?bpre ?bprd)
                        (= ?bpre ?bprc)
                        )
                      (= ?bprd ?bprc)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bpqr Real) (?bpqq Real) )(and (not (= ?bpqr ?bpqq))
              (exists ((?bpqs Real) )(and (not (= ?bpqs ?bpqr))
                  (and (not (= ?bpqs ?bpqq))
                    (or (or (= ?bpqs ?bpqr)
                        (= ?bpqs ?bpqq)
                        )
                      (= ?bpqr ?bpqq)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bprw Real)
        (declare-const ?bprx Real)
        (declare-const ?bpry Real)
        (assert
          (or (or (= ?bpry ?bprx)
              (= ?bpry ?bprw)
              )
            (= ?bprx ?bprw)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bprz Real)
          (declare-const ?bpsa Real)
          (declare-const ?bpsb Real)
          (assert
            (and (and (not (= ?bpsb ?bpsa))
                (not (= ?bpsb ?bprz))
                )
              (not (= ?bpsa ?bprz))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpsc Real)
          (declare-const ?bpsd Real)
          (declare-const ?bpse Real)
          (assert
            (or (or (= ?bpse ?bpsd)
                (= ?bpse ?bpsc)
                )
              (= ?bpsd ?bpsc)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpsf Real)
        (declare-const ?bpsg Real)
        (declare-const ?bpsh Real)
        (assert
          (and (and (not (= ?bpsh ?bpsg))
              (not (= ?bpsh ?bpsf))
              )
            (not (= ?bpsg ?bpsf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpsi Real)
          (declare-const ?bpsj Real)
          (declare-const ?bpsk Real)
          (assert
            (or (or (= ?bpsk ?bpsj)
                (= ?bpsk ?bpsi)
                )
              (= ?bpsj ?bpsi)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpsl Real)
          (declare-const ?bpsm Real)
          (declare-const ?bpsn Real)
          (assert
            (or (or (= ?bpsn ?bpsm)
                (= ?bpsn ?bpsl)
                )
              (= ?bpsm ?bpsl)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpso Real)
          (declare-const ?bpsp Real)
          (declare-const ?bpsq Real)
          (assert
            (and (and (not (= ?bpsq ?bpsp))
                (not (= ?bpsq ?bpso))
                )
              (not (= ?bpsp ?bpso))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpsr Real)
        (declare-const ?bpss Real)
        (declare-const ?bpst Real)
        (assert
          (and (and (not (= ?bpst ?bpss))
              (not (= ?bpst ?bpsr))
              )
            (not (= ?bpss ?bpsr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpsu Real)
          (declare-const ?bpsv Real)
          (declare-const ?bpsw Real)
          (assert
            (and (and (not (= ?bpsw ?bpsv))
                (not (= ?bpsw ?bpsu))
                )
              (not (= ?bpsv ?bpsu))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpsx Real)
          (declare-const ?bpsy Real)
          (declare-const ?bpsz Real)
          (assert
            (and (and (not (= ?bpsz ?bpsy))
                (not (= ?bpsz ?bpsx))
                )
              (not (= ?bpsy ?bpsx))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpta Real)
          (declare-const ?bptb Real)
          (declare-const ?bptc Real)
          (assert
            (and (and (not (= ?bptc ?bptb))
                (not (= ?bptc ?bpta))
                )
              (not (= ?bptb ?bpta))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bptd Real)
        (declare-const ?bpte Real)
        (declare-const ?bptf Real)
        (assert
          (and (and (not (= ?bptf ?bpte))
              (not (= ?bptf ?bptd))
              )
            (not (= ?bpte ?bptd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bptg Real)
          (declare-const ?bpth Real)
          (declare-const ?bpti Real)
          (assert
            (and (and (not (= ?bpti ?bpth))
                (not (= ?bpti ?bptg))
                )
              (not (= ?bpth ?bptg))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bptj Real)
          (declare-const ?bptk Real)
          (declare-const ?bptl Real)
          (assert
            (and (and (not (= ?bptl ?bptk))
                (not (= ?bptl ?bptj))
                )
              (not (= ?bptk ?bptj))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bptm Real)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bptn Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bptn ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bptm ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bptm ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bptn ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpto Real)
          (declare-const ?bptp Real)
          (declare-const ?bptq Real)
          (assert
            (and (and (not (= ?bptq ?bptp))
                (not (= ?bptq ?bpto))
                )
              (not (= ?bptp ?bpto))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bptr Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bptr ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bptm ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bptm ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bptr ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpts Real)
        (declare-const ?bptt Real)
        (declare-const ?bptu Real)
        (assert
          (and (and (not (= ?bptu ?bptt))
              (not (= ?bptu ?bpts))
              )
            (not (= ?bptt ?bpts))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bptv Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bptv ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bptm ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bptm ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bptv ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bptw Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bptw ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bptm ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bptm ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bptw ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bpte Real) (?bptd Real) )(and (not (= ?bpte ?bptd))
              (exists ((?bptf Real) )(and (not (= ?bptf ?bpte))
                  (and (not (= ?bptf ?bptd))
                    (or (or (= ?bptf ?bpte)
                        (= ?bptf ?bptd)
                        )
                      (= ?bpte ?bptd)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bpss Real) (?bpsr Real) )(and (not (= ?bpss ?bpsr))
              (exists ((?bpst Real) )(and (not (= ?bpst ?bpss))
                  (and (not (= ?bpst ?bpsr))
                    (or (or (= ?bpst ?bpss)
                        (= ?bpst ?bpsr)
                        )
                      (= ?bpss ?bpsr)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bptx Real)
    (declare-const ?bpty Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bptz Real)
        (declare-const ?bpua Real)
        (declare-const ?bpub Real)
        (assert
          (or (or (= ?bpub ?bpua)
              (= ?bpub ?bptz)
              )
            (= ?bpua ?bptz)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpuc Real)
          (declare-const ?bpud Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                      (not (= ?bpty ?blqw))
                      )
                    (not (= ?bptx ?blqw))
                    )
                  (or (or (= ?bpud ?bpuc)
                      (= ?bpud ?blqw)
                      )
                    (= ?bpuc ?blqw)
                    )
                  )
                (or (or (or (= ?bpty ?bptx)
                      (= ?bpty ?blqw)
                      )
                    (= ?bptx ?blqw)
                    )
                  (not (= ?bpud ?bpuc))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpue Real)
        (declare-const ?bpuf Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                    (not (= ?bpty ?blqw))
                    )
                  (not (= ?bptx ?blqw))
                  )
                (or (or (= ?bpuf ?bpue)
                    (= ?bpuf ?blqw)
                    )
                  (= ?bpue ?blqw)
                  )
                )
              (or (or (or (= ?bpty ?bptx)
                    (= ?bpty ?blqw)
                    )
                  (= ?bptx ?blqw)
                  )
                (not (= ?bpuf ?bpue))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpug Real)
          (declare-const ?bpuh Real)
          (declare-const ?bpui Real)
          (assert
            (or (or (= ?bpui ?bpuh)
                (= ?bpui ?bpug)
                )
              (= ?bpuh ?bpug)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpuj Real)
          (declare-const ?bpuk Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                      (not (= ?bpty ?blqw))
                      )
                    (not (= ?bptx ?blqw))
                    )
                  (or (or (= ?bpuk ?bpuj)
                      (= ?bpuk ?blqw)
                      )
                    (= ?bpuj ?blqw)
                    )
                  )
                (or (or (or (= ?bpty ?bptx)
                      (= ?bpty ?blqw)
                      )
                    (= ?bptx ?blqw)
                    )
                  (not (= ?bpuk ?bpuj))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpul Real)
        (declare-const ?bpum Real)
        (declare-const ?bpun Real)
        (assert
          (and (and (not (= ?bpun ?bpum))
              (not (= ?bpun ?bpul))
              )
            (not (= ?bpum ?bpul))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpuo Real)
          (declare-const ?bpup Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                      (not (= ?bpty ?blqw))
                      )
                    (not (= ?bptx ?blqw))
                    )
                  (or (or (= ?bpup ?bpuo)
                      (= ?bpup ?blqw)
                      )
                    (= ?bpuo ?blqw)
                    )
                  )
                (or (or (or (= ?bpty ?bptx)
                      (= ?bpty ?blqw)
                      )
                    (= ?bptx ?blqw)
                    )
                  (not (= ?bpup ?bpuo))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpuq Real)
          (declare-const ?bpur Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                      (not (= ?bpty ?blqw))
                      )
                    (not (= ?bptx ?blqw))
                    )
                  (or (or (= ?bpur ?bpuq)
                      (= ?bpur ?blqw)
                      )
                    (= ?bpuq ?blqw)
                    )
                  )
                (or (or (or (= ?bpty ?bptx)
                      (= ?bpty ?blqw)
                      )
                    (= ?bptx ?blqw)
                    )
                  (not (= ?bpur ?bpuq))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpus Real)
        (declare-const ?bput Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                    (not (= ?bpty ?blqw))
                    )
                  (not (= ?bptx ?blqw))
                  )
                (or (or (= ?bput ?bpus)
                    (= ?bput ?blqw)
                    )
                  (= ?bpus ?blqw)
                  )
                )
              (or (or (or (= ?bpty ?bptx)
                    (= ?bpty ?blqw)
                    )
                  (= ?bptx ?blqw)
                  )
                (not (= ?bput ?bpus))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bpuu Real)
          (declare-const ?bpuv Real)
          (declare-const ?bpuw Real)
          (assert
            (and (and (not (= ?bpuw ?bpuv))
                (not (= ?bpuw ?bpuu))
                )
              (not (= ?bpuv ?bpuu))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bpux Real)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bpuy Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bpuy ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bpux ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bpux ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bpuy ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpuz Real)
          (declare-const ?bpva Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                      (not (= ?bpty ?blqw))
                      )
                    (not (= ?bptx ?blqw))
                    )
                  (or (or (= ?bpva ?bpuz)
                      (= ?bpva ?blqw)
                      )
                    (= ?bpuz ?blqw)
                    )
                  )
                (or (or (or (= ?bpty ?bptx)
                      (= ?bpty ?blqw)
                      )
                    (= ?bptx ?blqw)
                    )
                  (not (= ?bpva ?bpuz))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpvb Real)
        (declare-const ?bpvc Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                    (not (= ?bpty ?blqw))
                    )
                  (not (= ?bptx ?blqw))
                  )
                (or (or (= ?bpvc ?bpvb)
                    (= ?bpvc ?blqw)
                    )
                  (= ?bpvb ?blqw)
                  )
                )
              (or (or (or (= ?bpty ?bptx)
                    (= ?bpty ?blqw)
                    )
                  (= ?bptx ?blqw)
                  )
                (not (= ?bpvc ?bpvb))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpvd Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bpvd ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bpux ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bpux ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bpvd ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (or (exists ((?bpue Real) (?bpuf Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                        (not (= ?bpty ?blqw))
                        )
                      (not (= ?bptx ?blqw))
                      )
                    (or (or (= ?bpuf ?bpue)
                        (= ?bpuf ?blqw)
                        )
                      (= ?bpue ?blqw)
                      )
                    )
                  (or (or (or (= ?bpty ?bptx)
                        (= ?bpty ?blqw)
                        )
                      (= ?bptx ?blqw)
                      )
                    (not (= ?bpuf ?bpue))
                    )
                  )
                )
              )
            (exists ((?bpua Real) (?bptz Real) )(or (= ?bpua ?bptz)
                (exists ((?bpub Real) )(or (= ?bpub ?bpua)
                    (= ?bpub ?bptz)
                    )
                  )
                )
              )
            )
          (or (exists ((?bpvb Real) (?bpvc Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bpty ?bptx))
                        (not (= ?bpty ?blqw))
                        )
                      (not (= ?bptx ?blqw))
                      )
                    (or (or (= ?bpvc ?bpvb)
                        (= ?bpvc ?blqw)
                        )
                      (= ?bpvb ?blqw)
                      )
                    )
                  (or (or (or (= ?bpty ?bptx)
                        (= ?bpty ?blqw)
                        )
                      (= ?bptx ?blqw)
                      )
                    (not (= ?bpvc ?bpvb))
                    )
                  )
                )
              )
            (forall ((?bpux Real) )(exists ((?bpuy Real) )(forall ((?bnyg Real) )(or (= ?bpuy ?bnyg)
                    (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bpux ?bnyg))
                          (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                  (= ?bnza ?blqw)
                                  )
                                (= ?bnyz ?blqw)
                                )
                              (and (not (= ?bpux ?blqw))
                                (not (= ?bnyg ?blqw))
                                )
                              )
                            )
                          )
                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (or (= ?bpuy ?blqw)
                              (= ?bnyg ?blqw)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bpve Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bpvf Real)
    (declare-const ?bpvg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                (not (= ?bmnf ?bmnk))
                )
              )
            )
          )
        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                      (= ?blvm ?blvk)
                      )
                    )
                  )
                )
              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                      (not (= ?bmca ?bmdy))
                      )
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                        (not (= ?blpf ?bluu))
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                              (not (= ?blpf ?blsx))
                              )
                            )
                          )
                        )
                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                              (= ?blrl ?blrj)
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              (or (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                    (not (= ?blpf ?blqc))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                        (not (= ?blpf ?blpj))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                            (not (= ?blkl ?blkr))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                              (not (= ?blem ?bler))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                (= ?bmnf ?bmnk)
                )
              )
            )
          )
        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                      (not (= ?blvm ?blvk))
                      )
                    )
                  )
                )
              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                      (= ?bmca ?bmdy)
                      )
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                        (= ?blpf ?bluu)
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                              (= ?blpf ?blsx)
                              )
                            )
                          )
                        )
                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                              (not (= ?blrl ?blrj))
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                    (= ?blpf ?blqc)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                        (= ?blpf ?blpj)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                            (= ?blkl ?blkr)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                              (= ?blem ?bler)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                (not (= ?bmnf ?bmnk))
                )
              )
            )
          )
        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                      (= ?blvm ?blvk)
                      )
                    )
                  )
                )
              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                      (not (= ?bmca ?bmdy))
                      )
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                        (not (= ?blpf ?bluu))
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                              (not (= ?blpf ?blsx))
                              )
                            )
                          )
                        )
                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                              (= ?blrl ?blrj)
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              (or (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                    (not (= ?blpf ?blqc))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                        (not (= ?blpf ?blpj))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                            (not (= ?blkl ?blkr))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                              (not (= ?blem ?bler))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                (= ?bmnf ?bmnk)
                )
              )
            )
          )
        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                      (not (= ?blvm ?blvk))
                      )
                    )
                  )
                )
              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                      (= ?bmca ?bmdy)
                      )
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                        (= ?blpf ?bluu)
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                              (= ?blpf ?blsx)
                              )
                            )
                          )
                        )
                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                              (not (= ?blrl ?blrj))
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                    (= ?blpf ?blqc)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                        (= ?blpf ?blpj)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                            (= ?blkl ?blkr)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                              (= ?blem ?bler)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bpvh Real)
  (declare-const ?bpvi Real)
  (push 1)
    (assert
      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                (not (= ?bmnf ?bmnk))
                )
              )
            )
          )
        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                      (= ?blvm ?blvk)
                      )
                    )
                  )
                )
              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                      (not (= ?bmca ?bmdy))
                      )
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                        (not (= ?blpf ?bluu))
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                              (not (= ?blpf ?blsx))
                              )
                            )
                          )
                        )
                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                              (= ?blrl ?blrj)
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              (or (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                    (not (= ?blpf ?blqc))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                        (not (= ?blpf ?blpj))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                            (not (= ?blkl ?blkr))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                              (not (= ?blem ?bler))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                (= ?bmnf ?bmnk)
                )
              )
            )
          )
        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                      (not (= ?blvm ?blvk))
                      )
                    )
                  )
                )
              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                      (= ?bmca ?bmdy)
                      )
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                        (= ?blpf ?bluu)
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                              (= ?blpf ?blsx)
                              )
                            )
                          )
                        )
                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                              (not (= ?blrl ?blrj))
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                    (= ?blpf ?blqc)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                        (= ?blpf ?blpj)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                            (= ?blkl ?blkr)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                              (= ?blem ?bler)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
              (= ?bmnf ?bmnk)
              )
            )
          )
        )
      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                (not (= ?bmnf ?bmnk))
                )
              )
            )
          )
        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                    (not (= ?blvm ?blvk))
                    )
                  )
                )
              )
            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                    (= ?bmca ?bmdy)
                    )
                  )
                )
              )
            )
          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                      (= ?blvm ?blvk)
                      )
                    )
                  )
                )
              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                      (not (= ?bmca ?bmdy))
                      )
                    )
                  )
                )
              )
            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                      (= ?blpf ?bluu)
                      )
                    )
                  )
                )
              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                        (not (= ?blpf ?bluu))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                            (= ?blpf ?blsx)
                            )
                          )
                        )
                      )
                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                            (not (= ?blrl ?blrj))
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                              (not (= ?blpf ?blsx))
                              )
                            )
                          )
                        )
                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                              (= ?blrl ?blrj)
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                  (= ?blpg ?blqw)
                                  )
                                (= ?blpf ?blqw)
                                )
                              (and (and (not (= ?blqq ?blqp))
                                  (not (= ?blqq ?blqw))
                                  )
                                (not (= ?blqp ?blqw))
                                )
                              )
                            (and (and (and (not (= ?blpg ?blpf))
                                  (not (= ?blpg ?blqw))
                                  )
                                (not (= ?blpf ?blqw))
                                )
                              (or (or (= ?blqq ?blqp)
                                  (= ?blqq ?blqw)
                                  )
                                (= ?blqp ?blqw)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              (or (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                  (= ?blpf ?blqc)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                    (not (= ?blpf ?blqc))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                      (= ?blpf ?blpj)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                        (not (= ?blpf ?blpj))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                          (= ?blkl ?blkr)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                            (not (= ?blkl ?blkr))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                            (= ?blem ?bler)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bpvj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bpvk Real)
    (declare-const ?bpvl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                (= ?bmnf ?bmnk)
                )
              )
            )
          )
        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                      (not (= ?blvm ?blvk))
                      )
                    )
                  )
                )
              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                      (= ?bmca ?bmdy)
                      )
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                        (= ?blpf ?bluu)
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                              (= ?blpf ?blsx)
                              )
                            )
                          )
                        )
                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                              (not (= ?blrl ?blrj))
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                    (= ?blpf ?blqc)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                        (= ?blpf ?blpj)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                            (= ?blkl ?blkr)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                              (= ?blem ?bler)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                (not (= ?blem ?bler))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                    (not (= ?boig ?boie))
                    )
                  )
                )
              )
            )
          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                  (forall ((?boig Real) )(or (= ?boig ?boif)
                      (= ?boig ?boie)
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                (not (= ?bogj ?blqw))
                                )
                              (not (= ?bogi ?blqw))
                              )
                            (or (or (= ?bnuc ?bofe)
                                (= ?bnuc ?blqw)
                                )
                              (= ?bofe ?blqw)
                              )
                            )
                          (or (or (or (= ?bogj ?bogi)
                                (= ?bogj ?blqw)
                                )
                              (= ?bogi ?blqw)
                              )
                            (not (= ?bnuc ?bofe))
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (and (and (not (= ?bnuc ?bofe))
                                  (not (= ?bnuc ?blqw))
                                  )
                                (not (= ?bofe ?blqw))
                                )
                              )
                            (and (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (= ?bnuc ?bofe)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                      (not (= ?bocw ?blqw))
                                      )
                                    (not (= ?bocv ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bocc)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bocc ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bocw ?bocv)
                                      (= ?bocw ?blqw)
                                      )
                                    (= ?bocv ?blqw)
                                    )
                                  (not (= ?bnuc ?bocc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                              (not (= ?bobe ?bobc))
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bocc))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bocc ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (= ?bnuc ?bocc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                (= ?bobe ?bobc)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bnyg)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (not (= ?bnuc ?bnyg))
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (and (not (= ?bnxp ?bnyg))
                                          (not (= ?bnxp ?blqw))
                                          )
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (= ?bnxp ?bnyg)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bnyg))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnuc ?bnyg)
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnxp ?bnyg)
                                            (= ?bnxp ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnxp ?bnyg))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                            (not (= ?bnvl ?blqw))
                                            )
                                          (not (= ?bnvk ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnuq)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnuq ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnvl ?bnvk)
                                            (= ?bnvl ?blqw)
                                            )
                                          (= ?bnvk ?blqw)
                                          )
                                        (not (= ?bnuc ?bnuq))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnuq))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnuq ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (= ?bnuc ?bnuq)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bpvm Real)
      (declare-const ?bpvn Real)
      (declare-const ?bpvo Real)
      (assert
        (or (or (= ?bpvo ?bpvn)
            (= ?bpvo ?bpvm)
            )
          (= ?bpvn ?bpvm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bpvp Real)
        (declare-const ?bpvq Real)
        (declare-const ?bpvr Real)
        (assert
          (or (or (= ?bpvr ?bpvq)
              (= ?bpvr ?bpvp)
              )
            (= ?bpvq ?bpvp)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpvs Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpvt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpvu Real)
            (declare-const ?bpvv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpvw Real)
            (declare-const ?bpvx Real)
            (declare-const ?bpvy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpvz Real)
            (declare-const ?bpwa Real)
            (declare-const ?bpwb Real)
            (declare-const ?bpwc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpwe Real)
          (declare-const ?bpwf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpwg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwh Real)
            (declare-const ?bpwi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwj Real)
            (declare-const ?bpwk Real)
            (declare-const ?bpwl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwm Real)
            (declare-const ?bpwn Real)
            (declare-const ?bpwo Real)
            (declare-const ?bpwp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpwr Real)
          (declare-const ?bpws Real)
          (declare-const ?bpwt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpwu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwv Real)
            (declare-const ?bpww Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpwx Real)
            (declare-const ?bpwy Real)
            (declare-const ?bpwz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpxa Real)
            (declare-const ?bpxb Real)
            (declare-const ?bpxc Real)
            (declare-const ?bpxd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpxe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpxf Real)
          (declare-const ?bpxg Real)
          (declare-const ?bpxh Real)
          (declare-const ?bpxi Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpxj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpxk Real)
            (declare-const ?bpxl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpxm Real)
            (declare-const ?bpxn Real)
            (declare-const ?bpxo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpxp Real)
            (declare-const ?bpxq Real)
            (declare-const ?bpxr Real)
            (declare-const ?bpxs Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bpxh ?bpvo)
                        (= ?bpxg ?bpvn)
                        )
                      (= ?bpxf ?bpvm)
                      )
                    (and (and (= ?bpxr ?bpvr)
                        (= ?bpxq ?bpvq)
                        )
                      (= ?bpxp ?bpvp)
                      )
                    )
                  (= ?bpxi ?bpxs)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpxt Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpxu Real)
                (declare-const ?bpxv Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpxw Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpxx Real)
                (declare-const ?bpxy Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpxz Real)
                  (declare-const ?bpya Real)
                  (declare-const ?bpyb Real)
                  (assert
                    (or (or (= ?bpyb ?bpya)
                        (= ?bpyb ?bpxz)
                        )
                      (= ?bpya ?bpxz)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpyc Real)
                  (declare-const ?bpyd Real)
                  (declare-const ?bpye Real)
                  (assert
                    (or (or (= ?bpye ?bpyd)
                        (= ?bpye ?bpyc)
                        )
                      (= ?bpyd ?bpyc)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpyf Real)
                  (declare-const ?bpyg Real)
                  (declare-const ?bpyh Real)
                  (assert
                    (and (and (not (= ?bpyh ?bpyg))
                        (not (= ?bpyh ?bpyf))
                        )
                      (not (= ?bpyg ?bpyf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpyi Real)
                  (declare-const ?bpyj Real)
                  (declare-const ?bpyk Real)
                  (assert
                    (and (and (not (= ?bpyk ?bpyj))
                        (not (= ?bpyk ?bpyi))
                        )
                      (not (= ?bpyj ?bpyi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bpyl Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpym Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bpym ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bpyl ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bpyl ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bpym ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpyn Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bpyn ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bpyl ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bpyl ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bpyn ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bpyo Real)
                (declare-const ?bpyp Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpyq Real)
                  (declare-const ?bpyr Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpyp ?bpyo))
                              (not (= ?bpyp ?blqw))
                              )
                            (not (= ?bpyo ?blqw))
                            )
                          (or (or (= ?bpyr ?bpyq)
                              (= ?bpyr ?blqw)
                              )
                            (= ?bpyq ?blqw)
                            )
                          )
                        (or (or (or (= ?bpyp ?bpyo)
                              (= ?bpyp ?blqw)
                              )
                            (= ?bpyo ?blqw)
                            )
                          (not (= ?bpyr ?bpyq))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpys Real)
                  (declare-const ?bpyt Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bpyp ?bpyo))
                              (not (= ?bpyp ?blqw))
                              )
                            (not (= ?bpyo ?blqw))
                            )
                          (or (or (= ?bpyt ?bpys)
                              (= ?bpyt ?blqw)
                              )
                            (= ?bpys ?blqw)
                            )
                          )
                        (or (or (or (= ?bpyp ?bpyo)
                              (= ?bpyp ?blqw)
                              )
                            (= ?bpyo ?blqw)
                            )
                          (not (= ?bpyt ?bpys))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bpyu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bpyv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpyw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpyx Real)
            (declare-const ?bpyy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpyz Real)
            (declare-const ?bpza Real)
            (declare-const ?bpzb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpzc Real)
            (declare-const ?bpzd Real)
            (declare-const ?bpze Real)
            (declare-const ?bpzf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bpzg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bpzh Real)
        (declare-const ?bpzi Real)
        (declare-const ?bpzj Real)
        (assert
          (or (or (= ?bpzj ?bpzi)
              (= ?bpzj ?bpzh)
              )
            (= ?bpzi ?bpzh)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bpzk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bpzl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bpzk ?bpzl)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpzm Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpzn Real)
                (declare-const ?bpzo Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpzp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bpzq Real)
                (declare-const ?bpzr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bpzs Real)
                  (declare-const ?bpzt Real)
                  (declare-const ?bpzu Real)
                  (assert
                    (or (or (= ?bpzu ?bpzt)
                        (= ?bpzu ?bpzs)
                        )
                      (= ?bpzt ?bpzs)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpzv Real)
                  (declare-const ?bpzw Real)
                  (declare-const ?bpzx Real)
                  (assert
                    (or (or (= ?bpzx ?bpzw)
                        (= ?bpzx ?bpzv)
                        )
                      (= ?bpzw ?bpzv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bpzy Real)
                  (declare-const ?bpzz Real)
                  (declare-const ?bqaa Real)
                  (assert
                    (and (and (not (= ?bqaa ?bpzz))
                        (not (= ?bqaa ?bpzy))
                        )
                      (not (= ?bpzz ?bpzy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqab Real)
                  (declare-const ?bqac Real)
                  (declare-const ?bqad Real)
                  (assert
                    (and (and (not (= ?bqad ?bqac))
                        (not (= ?bqad ?bqab))
                        )
                      (not (= ?bqac ?bqab))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqae Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqaf Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqaf ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqae ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqae ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqaf ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqag Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqag ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqae ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqae ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqag ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqah Real)
                (declare-const ?bqai Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqaj Real)
                  (declare-const ?bqak Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqai ?bqah))
                              (not (= ?bqai ?blqw))
                              )
                            (not (= ?bqah ?blqw))
                            )
                          (or (or (= ?bqak ?bqaj)
                              (= ?bqak ?blqw)
                              )
                            (= ?bqaj ?blqw)
                            )
                          )
                        (or (or (or (= ?bqai ?bqah)
                              (= ?bqai ?blqw)
                              )
                            (= ?bqah ?blqw)
                            )
                          (not (= ?bqak ?bqaj))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqal Real)
                  (declare-const ?bqam Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqai ?bqah))
                              (not (= ?bqai ?blqw))
                              )
                            (not (= ?bqah ?blqw))
                            )
                          (or (or (= ?bqam ?bqal)
                              (= ?bqam ?blqw)
                              )
                            (= ?bqal ?blqw)
                            )
                          )
                        (or (or (or (= ?bqai ?bqah)
                              (= ?bqai ?blqw)
                              )
                            (= ?bqah ?blqw)
                            )
                          (not (= ?bqam ?bqal))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bqae Real) )(and (forall ((?bnyg Real) )(or (= ?bpzk ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqae ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqae ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bpzk ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnyg Real) )(and (not (= ?bpzl ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqae ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqae ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bpzl ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bqan Real)
            (declare-const ?bqao Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqap Real)
            (declare-const ?bqaq Real)
            (declare-const ?bqar Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqas Real)
            (declare-const ?bqat Real)
            (declare-const ?bqau Real)
            (declare-const ?bqav Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqaw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqax Real)
          (declare-const ?bqay Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqaz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqba Real)
            (declare-const ?bqbb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbc Real)
            (declare-const ?bqbd Real)
            (declare-const ?bqbe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbf Real)
            (declare-const ?bqbg Real)
            (declare-const ?bqbh Real)
            (declare-const ?bqbi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqbk Real)
          (declare-const ?bqbl Real)
          (declare-const ?bqbm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqbn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbo Real)
            (declare-const ?bqbp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbq Real)
            (declare-const ?bqbr Real)
            (declare-const ?bqbs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbt Real)
            (declare-const ?bqbu Real)
            (declare-const ?bqbv Real)
            (declare-const ?bqbw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqbx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqby Real)
          (declare-const ?bqbz Real)
          (declare-const ?bqca Real)
          (declare-const ?bqcb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqcc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcd Real)
            (declare-const ?bqce Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcf Real)
            (declare-const ?bqcg Real)
            (declare-const ?bqch Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqci Real)
            (declare-const ?bqcj Real)
            (declare-const ?bqck Real)
            (declare-const ?bqcl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqcn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqco Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcp Real)
            (declare-const ?bqcq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcr Real)
            (declare-const ?bqcs Real)
            (declare-const ?bqct Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcu Real)
            (declare-const ?bqcv Real)
            (declare-const ?bqcw Real)
            (declare-const ?bqcx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqcy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bqcz Real)
        (declare-const ?bqda Real)
        (declare-const ?bqdb Real)
        (assert
          (and (and (not (= ?bqdb ?bqda))
              (not (= ?bqdb ?bqcz))
              )
            (not (= ?bqda ?bqcz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqdc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqdd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqde Real)
            (declare-const ?bqdf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqdg Real)
            (declare-const ?bqdh Real)
            (declare-const ?bqdi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqdj Real)
            (declare-const ?bqdk Real)
            (declare-const ?bqdl Real)
            (declare-const ?bqdm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bqdl ?bqdb)
                      (= ?bqdk ?bqda)
                      )
                    (= ?bqdj ?bqcz)
                    )
                  (= ?bqdc ?bqdm)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqdn Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqdo Real)
                (declare-const ?bqdp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqdq Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqdr Real)
                (declare-const ?bqds Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqdt Real)
                  (declare-const ?bqdu Real)
                  (declare-const ?bqdv Real)
                  (assert
                    (or (or (= ?bqdv ?bqdu)
                        (= ?bqdv ?bqdt)
                        )
                      (= ?bqdu ?bqdt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqdw Real)
                  (declare-const ?bqdx Real)
                  (declare-const ?bqdy Real)
                  (assert
                    (or (or (= ?bqdy ?bqdx)
                        (= ?bqdy ?bqdw)
                        )
                      (= ?bqdx ?bqdw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqdz Real)
                  (declare-const ?bqea Real)
                  (declare-const ?bqeb Real)
                  (assert
                    (and (and (not (= ?bqeb ?bqea))
                        (not (= ?bqeb ?bqdz))
                        )
                      (not (= ?bqea ?bqdz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqec Real)
                  (declare-const ?bqed Real)
                  (declare-const ?bqee Real)
                  (assert
                    (and (and (not (= ?bqee ?bqed))
                        (not (= ?bqee ?bqec))
                        )
                      (not (= ?bqed ?bqec))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqef Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqeg Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqeg ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqef ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqeg ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqeh Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqeh ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqef ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqeh ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqei Real)
                (declare-const ?bqej Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqek Real)
                  (declare-const ?bqel Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqej ?bqei))
                              (not (= ?bqej ?blqw))
                              )
                            (not (= ?bqei ?blqw))
                            )
                          (or (or (= ?bqel ?bqek)
                              (= ?bqel ?blqw)
                              )
                            (= ?bqek ?blqw)
                            )
                          )
                        (or (or (or (= ?bqej ?bqei)
                              (= ?bqej ?blqw)
                              )
                            (= ?bqei ?blqw)
                            )
                          (not (= ?bqel ?bqek))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqem Real)
                  (declare-const ?bqen Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqej ?bqei))
                              (not (= ?bqej ?blqw))
                              )
                            (not (= ?bqei ?blqw))
                            )
                          (or (or (= ?bqen ?bqem)
                              (= ?bqen ?blqw)
                              )
                            (= ?bqem ?blqw)
                            )
                          )
                        (or (or (or (= ?bqej ?bqei)
                              (= ?bqej ?blqw)
                              )
                            (= ?bqei ?blqw)
                            )
                          (not (= ?bqen ?bqem))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdc ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqef ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqdc ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bqeo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqep Real)
          (declare-const ?bqeq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqer Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqes Real)
            (declare-const ?bqet Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqeu Real)
            (declare-const ?bqev Real)
            (declare-const ?bqew Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqex Real)
            (declare-const ?bqey Real)
            (declare-const ?bqez Real)
            (declare-const ?bqfa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqfc Real)
          (declare-const ?bqfd Real)
          (declare-const ?bqfe Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqff Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfg Real)
            (declare-const ?bqfh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfi Real)
            (declare-const ?bqfj Real)
            (declare-const ?bqfk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfl Real)
            (declare-const ?bqfm Real)
            (declare-const ?bqfn Real)
            (declare-const ?bqfo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqfq Real)
          (declare-const ?bqfr Real)
          (declare-const ?bqfs Real)
          (declare-const ?bqft Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqfu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfv Real)
            (declare-const ?bqfw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqfx Real)
            (declare-const ?bqfy Real)
            (declare-const ?bqfz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqga Real)
            (declare-const ?bqgb Real)
            (declare-const ?bqgc Real)
            (declare-const ?bqgd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqge Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqgf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqgg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgh Real)
            (declare-const ?bqgi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgj Real)
            (declare-const ?bqgk Real)
            (declare-const ?bqgl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgm Real)
            (declare-const ?bqgn Real)
            (declare-const ?bqgo Real)
            (declare-const ?bqgp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                    (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                          (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                  (not (= ?bnza ?blqw))
                                  )
                                (not (= ?bnyz ?blqw))
                                )
                              (or (= ?bqef ?blqw)
                                (= ?bnyg ?blqw)
                                )
                              )
                            )
                          )
                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                (= ?bnza ?blqw)
                                )
                              (= ?bnyz ?blqw)
                              )
                            (and (not (= ?bqdm ?blqw))
                              (not (= ?bnyg ?blqw))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                    (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                          (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                  (= ?bnza ?blqw)
                                  )
                                (= ?bnyz ?blqw)
                                )
                              (and (not (= ?bqef ?blqw))
                                (not (= ?bnyg ?blqw))
                                )
                              )
                            )
                          )
                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (or (= ?bqdm ?blqw)
                              (= ?bnyg ?blqw)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqgr Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqgs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgt Real)
            (declare-const ?bqgu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgv Real)
            (declare-const ?bqgw Real)
            (declare-const ?bqgx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqgy Real)
            (declare-const ?bqgz Real)
            (declare-const ?bqha Real)
            (declare-const ?bqhb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqhc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bqgr ?bqhc)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqhd Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqhe Real)
                (declare-const ?bqhf Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqhg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqhh Real)
                (declare-const ?bqhi Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqhj Real)
                  (declare-const ?bqhk Real)
                  (declare-const ?bqhl Real)
                  (assert
                    (or (or (= ?bqhl ?bqhk)
                        (= ?bqhl ?bqhj)
                        )
                      (= ?bqhk ?bqhj)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqhm Real)
                  (declare-const ?bqhn Real)
                  (declare-const ?bqho Real)
                  (assert
                    (or (or (= ?bqho ?bqhn)
                        (= ?bqho ?bqhm)
                        )
                      (= ?bqhn ?bqhm)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqhp Real)
                  (declare-const ?bqhq Real)
                  (declare-const ?bqhr Real)
                  (assert
                    (and (and (not (= ?bqhr ?bqhq))
                        (not (= ?bqhr ?bqhp))
                        )
                      (not (= ?bqhq ?bqhp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqhs Real)
                  (declare-const ?bqht Real)
                  (declare-const ?bqhu Real)
                  (assert
                    (and (and (not (= ?bqhu ?bqht))
                        (not (= ?bqhu ?bqhs))
                        )
                      (not (= ?bqht ?bqhs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqhv Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqhw Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqhw ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqhv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqhw ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqhx Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqhx ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqhv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqhx ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqhy Real)
                (declare-const ?bqhz Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqia Real)
                  (declare-const ?bqib Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqhz ?bqhy))
                              (not (= ?bqhz ?blqw))
                              )
                            (not (= ?bqhy ?blqw))
                            )
                          (or (or (= ?bqib ?bqia)
                              (= ?bqib ?blqw)
                              )
                            (= ?bqia ?blqw)
                            )
                          )
                        (or (or (or (= ?bqhz ?bqhy)
                              (= ?bqhz ?blqw)
                              )
                            (= ?bqhy ?blqw)
                            )
                          (not (= ?bqib ?bqia))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqic Real)
                  (declare-const ?bqid Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqhz ?bqhy))
                              (not (= ?bqhz ?blqw))
                              )
                            (not (= ?bqhy ?blqw))
                            )
                          (or (or (= ?bqid ?bqic)
                              (= ?bqid ?blqw)
                              )
                            (= ?bqic ?blqw)
                            )
                          )
                        (or (or (or (= ?bqhz ?bqhy)
                              (= ?bqhz ?blqw)
                              )
                            (= ?bqhy ?blqw)
                            )
                          (not (= ?bqid ?bqic))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqhv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqgr ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqie Real)
          (declare-const ?bqif Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqig Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqih Real)
            (declare-const ?bqii Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqij Real)
            (declare-const ?bqik Real)
            (declare-const ?bqil Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqim Real)
            (declare-const ?bqin Real)
            (declare-const ?bqio Real)
            (declare-const ?bqip Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqiq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqir Real)
          (declare-const ?bqis Real)
          (declare-const ?bqit Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqiu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqiv Real)
            (declare-const ?bqiw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqix Real)
            (declare-const ?bqiy Real)
            (declare-const ?bqiz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqja Real)
            (declare-const ?bqjb Real)
            (declare-const ?bqjc Real)
            (declare-const ?bqjd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqje Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqjf Real)
          (declare-const ?bqjg Real)
          (declare-const ?bqjh Real)
          (declare-const ?bqji Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqjj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqjk Real)
            (declare-const ?bqjl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqjm Real)
            (declare-const ?bqjn Real)
            (declare-const ?bqjo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqjp Real)
            (declare-const ?bqjq Real)
            (declare-const ?bqjr Real)
            (declare-const ?bqjs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqjt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqju Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqjv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqjw Real)
            (declare-const ?bqjx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqjy Real)
            (declare-const ?bqjz Real)
            (declare-const ?bqka Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqkb Real)
            (declare-const ?bqkc Real)
            (declare-const ?bqkd Real)
            (declare-const ?bqke Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqkf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                    (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                          (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                  (not (= ?bnza ?blqw))
                                  )
                                (not (= ?bnyz ?blqw))
                                )
                              (or (= ?bqhv ?blqw)
                                (= ?bnyg ?blqw)
                                )
                              )
                            )
                          )
                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                (= ?bnza ?blqw)
                                )
                              (= ?bnyz ?blqw)
                              )
                            (and (not (= ?bqgr ?blqw))
                              (not (= ?bnyg ?blqw))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                    (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                          (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                  (= ?bnza ?blqw)
                                  )
                                (= ?bnyz ?blqw)
                                )
                              (and (not (= ?bqhv ?blqw))
                                (not (= ?bnyg ?blqw))
                                )
                              )
                            )
                          )
                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (or (= ?bqgr ?blqw)
                              (= ?bnyg ?blqw)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bqkg Real)
      (declare-const ?bqkh Real)
      (declare-const ?bqki Real)
      (assert
        (and (and (not (= ?bqki ?bqkh))
            (not (= ?bqki ?bqkg))
            )
          (not (= ?bqkh ?bqkg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqkj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqkk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqkl Real)
            (declare-const ?bqkm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqkn Real)
            (declare-const ?bqko Real)
            (declare-const ?bqkp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqkq Real)
            (declare-const ?bqkr Real)
            (declare-const ?bqks Real)
            (declare-const ?bqkt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqku Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqkv Real)
          (declare-const ?bqkw Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqkx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqky Real)
            (declare-const ?bqkz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqla Real)
            (declare-const ?bqlb Real)
            (declare-const ?bqlc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqld Real)
            (declare-const ?bqle Real)
            (declare-const ?bqlf Real)
            (declare-const ?bqlg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqlh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqli Real)
          (declare-const ?bqlj Real)
          (declare-const ?bqlk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqll Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqlm Real)
            (declare-const ?bqln Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqlo Real)
            (declare-const ?bqlp Real)
            (declare-const ?bqlq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqlr Real)
            (declare-const ?bqls Real)
            (declare-const ?bqlt Real)
            (declare-const ?bqlu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqlv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqlw Real)
          (declare-const ?bqlx Real)
          (declare-const ?bqly Real)
          (declare-const ?bqlz Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqma Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bqly ?bqki)
                      (= ?bqlx ?bqkh)
                      )
                    (= ?bqlw ?bqkg)
                    )
                  (= ?bqlz ?bqma)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqmb Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqmc Real)
                (declare-const ?bqmd Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqme Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqmf Real)
                (declare-const ?bqmg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqmh Real)
                  (declare-const ?bqmi Real)
                  (declare-const ?bqmj Real)
                  (assert
                    (or (or (= ?bqmj ?bqmi)
                        (= ?bqmj ?bqmh)
                        )
                      (= ?bqmi ?bqmh)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqmk Real)
                  (declare-const ?bqml Real)
                  (declare-const ?bqmm Real)
                  (assert
                    (or (or (= ?bqmm ?bqml)
                        (= ?bqmm ?bqmk)
                        )
                      (= ?bqml ?bqmk)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqmn Real)
                  (declare-const ?bqmo Real)
                  (declare-const ?bqmp Real)
                  (assert
                    (and (and (not (= ?bqmp ?bqmo))
                        (not (= ?bqmp ?bqmn))
                        )
                      (not (= ?bqmo ?bqmn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqmq Real)
                  (declare-const ?bqmr Real)
                  (declare-const ?bqms Real)
                  (assert
                    (and (and (not (= ?bqms ?bqmr))
                        (not (= ?bqms ?bqmq))
                        )
                      (not (= ?bqmr ?bqmq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqmt Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqmu Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqmu ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqmt ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqmt ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqmu ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqmv Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqmv ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqmt ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqmt ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqmv ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqmw Real)
                (declare-const ?bqmx Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqmy Real)
                  (declare-const ?bqmz Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqmx ?bqmw))
                              (not (= ?bqmx ?blqw))
                              )
                            (not (= ?bqmw ?blqw))
                            )
                          (or (or (= ?bqmz ?bqmy)
                              (= ?bqmz ?blqw)
                              )
                            (= ?bqmy ?blqw)
                            )
                          )
                        (or (or (or (= ?bqmx ?bqmw)
                              (= ?bqmx ?blqw)
                              )
                            (= ?bqmw ?blqw)
                            )
                          (not (= ?bqmz ?bqmy))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqna Real)
                  (declare-const ?bqnb Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqmx ?bqmw))
                              (not (= ?bqmx ?blqw))
                              )
                            (not (= ?bqmw ?blqw))
                            )
                          (or (or (= ?bqnb ?bqna)
                              (= ?bqnb ?blqw)
                              )
                            (= ?bqna ?blqw)
                            )
                          )
                        (or (or (or (= ?bqmx ?bqmw)
                              (= ?bqmx ?blqw)
                              )
                            (= ?bqmw ?blqw)
                            )
                          (not (= ?bqnb ?bqna))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bqnc Real)
            (declare-const ?bqnd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqne Real)
            (declare-const ?bqnf Real)
            (declare-const ?bqng Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqnh Real)
            (declare-const ?bqni Real)
            (declare-const ?bqnj Real)
            (declare-const ?bqnk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqnl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqnm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqnn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqno Real)
            (declare-const ?bqnp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqnq Real)
            (declare-const ?bqnr Real)
            (declare-const ?bqns Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqnt Real)
            (declare-const ?bqnu Real)
            (declare-const ?bqnv Real)
            (declare-const ?bqnw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqnx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bqny Real)
        (declare-const ?bqnz Real)
        (declare-const ?bqoa Real)
        (assert
          (and (and (not (= ?bqoa ?bqnz))
              (not (= ?bqoa ?bqny))
              )
            (not (= ?bqnz ?bqny))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqob Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqoc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqod Real)
            (declare-const ?bqoe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqof Real)
            (declare-const ?bqog Real)
            (declare-const ?bqoh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqoi Real)
            (declare-const ?bqoj Real)
            (declare-const ?bqok Real)
            (declare-const ?bqol Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqom Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqon Real)
          (declare-const ?bqoo Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqop Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqoq Real)
            (declare-const ?bqor Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqos Real)
            (declare-const ?bqot Real)
            (declare-const ?bqou Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqov Real)
            (declare-const ?bqow Real)
            (declare-const ?bqox Real)
            (declare-const ?bqoy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqoz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqpa Real)
          (declare-const ?bqpb Real)
          (declare-const ?bqpc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqpd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpe Real)
            (declare-const ?bqpf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpg Real)
            (declare-const ?bqph Real)
            (declare-const ?bqpi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpj Real)
            (declare-const ?bqpk Real)
            (declare-const ?bqpl Real)
            (declare-const ?bqpm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqpo Real)
          (declare-const ?bqpp Real)
          (declare-const ?bqpq Real)
          (declare-const ?bqpr Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqps Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpt Real)
            (declare-const ?bqpu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpv Real)
            (declare-const ?bqpw Real)
            (declare-const ?bqpx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqpy Real)
            (declare-const ?bqpz Real)
            (declare-const ?bqqa Real)
            (declare-const ?bqqb Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bqpq ?bqki)
                        (= ?bqpp ?bqkh)
                        )
                      (= ?bqpo ?bqkg)
                      )
                    (and (and (= ?bqqa ?bqoa)
                        (= ?bqpz ?bqnz)
                        )
                      (= ?bqpy ?bqny)
                      )
                    )
                  (= ?bqpr ?bqqb)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqqc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqqd Real)
                (declare-const ?bqqe Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqqf Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqqg Real)
                (declare-const ?bqqh Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqqi Real)
                  (declare-const ?bqqj Real)
                  (declare-const ?bqqk Real)
                  (assert
                    (or (or (= ?bqqk ?bqqj)
                        (= ?bqqk ?bqqi)
                        )
                      (= ?bqqj ?bqqi)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqql Real)
                  (declare-const ?bqqm Real)
                  (declare-const ?bqqn Real)
                  (assert
                    (or (or (= ?bqqn ?bqqm)
                        (= ?bqqn ?bqql)
                        )
                      (= ?bqqm ?bqql)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqqo Real)
                  (declare-const ?bqqp Real)
                  (declare-const ?bqqq Real)
                  (assert
                    (and (and (not (= ?bqqq ?bqqp))
                        (not (= ?bqqq ?bqqo))
                        )
                      (not (= ?bqqp ?bqqo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqqr Real)
                  (declare-const ?bqqs Real)
                  (declare-const ?bqqt Real)
                  (assert
                    (and (and (not (= ?bqqt ?bqqs))
                        (not (= ?bqqt ?bqqr))
                        )
                      (not (= ?bqqs ?bqqr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqqu Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqqv Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqqv ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqqu ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqqu ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqqv ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqqw Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqqw ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqqu ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqqu ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqqw ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqqx Real)
                (declare-const ?bqqy Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqqz Real)
                  (declare-const ?bqra Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqqy ?bqqx))
                              (not (= ?bqqy ?blqw))
                              )
                            (not (= ?bqqx ?blqw))
                            )
                          (or (or (= ?bqra ?bqqz)
                              (= ?bqra ?blqw)
                              )
                            (= ?bqqz ?blqw)
                            )
                          )
                        (or (or (or (= ?bqqy ?bqqx)
                              (= ?bqqy ?blqw)
                              )
                            (= ?bqqx ?blqw)
                            )
                          (not (= ?bqra ?bqqz))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqrb Real)
                  (declare-const ?bqrc Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqqy ?bqqx))
                              (not (= ?bqqy ?blqw))
                              )
                            (not (= ?bqqx ?blqw))
                            )
                          (or (or (= ?bqrc ?bqrb)
                              (= ?bqrc ?blqw)
                              )
                            (= ?bqrb ?blqw)
                            )
                          )
                        (or (or (or (= ?bqqy ?bqqx)
                              (= ?bqqy ?blqw)
                              )
                            (= ?bqqx ?blqw)
                            )
                          (not (= ?bqrc ?bqrb))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bqrd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqre Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqrf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqrg Real)
            (declare-const ?bqrh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqri Real)
            (declare-const ?bqrj Real)
            (declare-const ?bqrk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqrl Real)
            (declare-const ?bqrm Real)
            (declare-const ?bqrn Real)
            (declare-const ?bqro Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqrp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqrq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqrr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqrs Real)
            (declare-const ?bqrt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqru Real)
            (declare-const ?bqrv Real)
            (declare-const ?bqrw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqrx Real)
            (declare-const ?bqry Real)
            (declare-const ?bqrz Real)
            (declare-const ?bqsa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqsb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqsc Real)
          (declare-const ?bqsd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqse Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqsf Real)
            (declare-const ?bqsg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqsh Real)
            (declare-const ?bqsi Real)
            (declare-const ?bqsj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqsk Real)
            (declare-const ?bqsl Real)
            (declare-const ?bqsm Real)
            (declare-const ?bqsn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqso Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqsp Real)
          (declare-const ?bqsq Real)
          (declare-const ?bqsr Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqss Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqst Real)
            (declare-const ?bqsu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqsv Real)
            (declare-const ?bqsw Real)
            (declare-const ?bqsx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqsy Real)
            (declare-const ?bqsz Real)
            (declare-const ?bqta Real)
            (declare-const ?bqtb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqtc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqtd Real)
          (declare-const ?bqte Real)
          (declare-const ?bqtf Real)
          (declare-const ?bqtg Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqth Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqti Real)
            (declare-const ?bqtj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqtk Real)
            (declare-const ?bqtl Real)
            (declare-const ?bqtm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqtn Real)
            (declare-const ?bqto Real)
            (declare-const ?bqtp Real)
            (declare-const ?bqtq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqtr Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bqtf ?bqki)
                      (= ?bqte ?bqkh)
                      )
                    (= ?bqtd ?bqkg)
                    )
                  (= ?bqtg ?bqtr)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqts Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqtt Real)
                (declare-const ?bqtu Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqtv Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqtw Real)
                (declare-const ?bqtx Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqty Real)
                  (declare-const ?bqtz Real)
                  (declare-const ?bqua Real)
                  (assert
                    (or (or (= ?bqua ?bqtz)
                        (= ?bqua ?bqty)
                        )
                      (= ?bqtz ?bqty)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqub Real)
                  (declare-const ?bquc Real)
                  (declare-const ?bqud Real)
                  (assert
                    (or (or (= ?bqud ?bquc)
                        (= ?bqud ?bqub)
                        )
                      (= ?bquc ?bqub)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bque Real)
                  (declare-const ?bquf Real)
                  (declare-const ?bqug Real)
                  (assert
                    (and (and (not (= ?bqug ?bquf))
                        (not (= ?bqug ?bque))
                        )
                      (not (= ?bquf ?bque))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bquh Real)
                  (declare-const ?bqui Real)
                  (declare-const ?bquj Real)
                  (assert
                    (and (and (not (= ?bquj ?bqui))
                        (not (= ?bquj ?bquh))
                        )
                      (not (= ?bqui ?bquh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bquk Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqul Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqul ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bquk ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bquk ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqul ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqum Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqum ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bquk ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bquk ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqum ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqun Real)
                (declare-const ?bquo Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqup Real)
                  (declare-const ?bquq Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bquo ?bqun))
                              (not (= ?bquo ?blqw))
                              )
                            (not (= ?bqun ?blqw))
                            )
                          (or (or (= ?bquq ?bqup)
                              (= ?bquq ?blqw)
                              )
                            (= ?bqup ?blqw)
                            )
                          )
                        (or (or (or (= ?bquo ?bqun)
                              (= ?bquo ?blqw)
                              )
                            (= ?bqun ?blqw)
                            )
                          (not (= ?bquq ?bqup))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqur Real)
                  (declare-const ?bqus Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bquo ?bqun))
                              (not (= ?bquo ?blqw))
                              )
                            (not (= ?bqun ?blqw))
                            )
                          (or (or (= ?bqus ?bqur)
                              (= ?bqus ?blqw)
                              )
                            (= ?bqur ?blqw)
                            )
                          )
                        (or (or (or (= ?bquo ?bqun)
                              (= ?bquo ?blqw)
                              )
                            (= ?bqun ?blqw)
                            )
                          (not (= ?bqus ?bqur))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqut Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bquu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bquv Real)
            (declare-const ?bquw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqux Real)
            (declare-const ?bquy Real)
            (declare-const ?bquz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqva Real)
            (declare-const ?bqvb Real)
            (declare-const ?bqvc Real)
            (declare-const ?bqvd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqve Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bqvf Real)
        (declare-const ?bqvg Real)
        (declare-const ?bqvh Real)
        (assert
          (and (and (not (= ?bqvh ?bqvg))
              (not (= ?bqvh ?bqvf))
              )
            (not (= ?bqvg ?bqvf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqvi Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqvj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqvk Real)
            (declare-const ?bqvl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqvm Real)
            (declare-const ?bqvn Real)
            (declare-const ?bqvo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqvp Real)
            (declare-const ?bqvq Real)
            (declare-const ?bqvr Real)
            (declare-const ?bqvs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqvt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqvu Real)
          (declare-const ?bqvv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqvw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqvx Real)
            (declare-const ?bqvy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqvz Real)
            (declare-const ?bqwa Real)
            (declare-const ?bqwb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqwc Real)
            (declare-const ?bqwd Real)
            (declare-const ?bqwe Real)
            (declare-const ?bqwf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqwg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqwh Real)
          (declare-const ?bqwi Real)
          (declare-const ?bqwj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqwk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqwl Real)
            (declare-const ?bqwm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqwn Real)
            (declare-const ?bqwo Real)
            (declare-const ?bqwp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqwq Real)
            (declare-const ?bqwr Real)
            (declare-const ?bqws Real)
            (declare-const ?bqwt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqwu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqwv Real)
          (declare-const ?bqww Real)
          (declare-const ?bqwx Real)
          (declare-const ?bqwy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqwz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqxa Real)
            (declare-const ?bqxb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqxc Real)
            (declare-const ?bqxd Real)
            (declare-const ?bqxe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqxf Real)
            (declare-const ?bqxg Real)
            (declare-const ?bqxh Real)
            (declare-const ?bqxi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqxj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqxk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqxl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bqxk ?bqxl)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqxm Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqxn Real)
                (declare-const ?bqxo Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqxp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bqxq Real)
                (declare-const ?bqxr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqxs Real)
                  (declare-const ?bqxt Real)
                  (declare-const ?bqxu Real)
                  (assert
                    (or (or (= ?bqxu ?bqxt)
                        (= ?bqxu ?bqxs)
                        )
                      (= ?bqxt ?bqxs)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqxv Real)
                  (declare-const ?bqxw Real)
                  (declare-const ?bqxx Real)
                  (assert
                    (or (or (= ?bqxx ?bqxw)
                        (= ?bqxx ?bqxv)
                        )
                      (= ?bqxw ?bqxv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqxy Real)
                  (declare-const ?bqxz Real)
                  (declare-const ?bqya Real)
                  (assert
                    (and (and (not (= ?bqya ?bqxz))
                        (not (= ?bqya ?bqxy))
                        )
                      (not (= ?bqxz ?bqxy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqyb Real)
                  (declare-const ?bqyc Real)
                  (declare-const ?bqyd Real)
                  (assert
                    (and (and (not (= ?bqyd ?bqyc))
                        (not (= ?bqyd ?bqyb))
                        )
                      (not (= ?bqyc ?bqyb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqye Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqyf Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqyf ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqye ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqye ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqyf ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqyg Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bqyg ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqye ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqye ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqyg ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bqyh Real)
                (declare-const ?bqyi Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bqyj Real)
                  (declare-const ?bqyk Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqyi ?bqyh))
                              (not (= ?bqyi ?blqw))
                              )
                            (not (= ?bqyh ?blqw))
                            )
                          (or (or (= ?bqyk ?bqyj)
                              (= ?bqyk ?blqw)
                              )
                            (= ?bqyj ?blqw)
                            )
                          )
                        (or (or (or (= ?bqyi ?bqyh)
                              (= ?bqyi ?blqw)
                              )
                            (= ?bqyh ?blqw)
                            )
                          (not (= ?bqyk ?bqyj))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bqyl Real)
                  (declare-const ?bqym Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bqyi ?bqyh))
                              (not (= ?bqyi ?blqw))
                              )
                            (not (= ?bqyh ?blqw))
                            )
                          (or (or (= ?bqym ?bqyl)
                              (= ?bqym ?blqw)
                              )
                            (= ?bqyl ?blqw)
                            )
                          )
                        (or (or (or (= ?bqyi ?bqyh)
                              (= ?bqyi ?blqw)
                              )
                            (= ?bqyh ?blqw)
                            )
                          (not (= ?bqym ?bqyl))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bqyn Real)
            (declare-const ?bqyo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqyp Real)
            (declare-const ?bqyq Real)
            (declare-const ?bqyr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqys Real)
            (declare-const ?bqyt Real)
            (declare-const ?bqyu Real)
            (declare-const ?bqyv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqyw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bqyx Real)
        (declare-const ?bqyy Real)
        (declare-const ?bqyz Real)
        (assert
          (and (and (not (= ?bqyz ?bqyy))
              (not (= ?bqyz ?bqyx))
              )
            (not (= ?bqyy ?bqyx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bqza Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqzb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzc Real)
            (declare-const ?bqzd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqze Real)
            (declare-const ?bqzf Real)
            (declare-const ?bqzg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzh Real)
            (declare-const ?bqzi Real)
            (declare-const ?bqzj Real)
            (declare-const ?bqzk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqzm Real)
          (declare-const ?bqzn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bqzo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzp Real)
            (declare-const ?bqzq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzr Real)
            (declare-const ?bqzs Real)
            (declare-const ?bqzt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzu Real)
            (declare-const ?bqzv Real)
            (declare-const ?bqzw Real)
            (declare-const ?bqzx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bqzy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bqzz Real)
          (declare-const ?braa Real)
          (declare-const ?brab Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brac Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brad Real)
            (declare-const ?brae Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?braf Real)
            (declare-const ?brag Real)
            (declare-const ?brah Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brai Real)
            (declare-const ?braj Real)
            (declare-const ?brak Real)
            (declare-const ?bral Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bram Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bran Real)
          (declare-const ?brao Real)
          (declare-const ?brap Real)
          (declare-const ?braq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brar Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bras Real)
            (declare-const ?brat Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brau Real)
            (declare-const ?brav Real)
            (declare-const ?braw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brax Real)
            (declare-const ?bray Real)
            (declare-const ?braz Real)
            (declare-const ?brba Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brbb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brbc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brbd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brbe Real)
            (declare-const ?brbf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brbg Real)
            (declare-const ?brbh Real)
            (declare-const ?brbi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brbj Real)
            (declare-const ?brbk Real)
            (declare-const ?brbl Real)
            (declare-const ?brbm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?brbl ?bqyz)
                      (= ?brbk ?bqyy)
                      )
                    (= ?brbj ?bqyx)
                    )
                  (= ?brbc ?brbm)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brbn Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brbo Real)
                (declare-const ?brbp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brbq Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brbr Real)
                (declare-const ?brbs Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brbt Real)
                  (declare-const ?brbu Real)
                  (declare-const ?brbv Real)
                  (assert
                    (or (or (= ?brbv ?brbu)
                        (= ?brbv ?brbt)
                        )
                      (= ?brbu ?brbt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brbw Real)
                  (declare-const ?brbx Real)
                  (declare-const ?brby Real)
                  (assert
                    (or (or (= ?brby ?brbx)
                        (= ?brby ?brbw)
                        )
                      (= ?brbx ?brbw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brbz Real)
                  (declare-const ?brca Real)
                  (declare-const ?brcb Real)
                  (assert
                    (and (and (not (= ?brcb ?brca))
                        (not (= ?brcb ?brbz))
                        )
                      (not (= ?brca ?brbz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brcc Real)
                  (declare-const ?brcd Real)
                  (declare-const ?brce Real)
                  (assert
                    (and (and (not (= ?brce ?brcd))
                        (not (= ?brce ?brcc))
                        )
                      (not (= ?brcd ?brcc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brcf Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brcg Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brcg ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brcf ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brcf ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brcg ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brch Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brch ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brcf ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brcf ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brch ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brci Real)
                (declare-const ?brcj Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brck Real)
                  (declare-const ?brcl Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brcj ?brci))
                              (not (= ?brcj ?blqw))
                              )
                            (not (= ?brci ?blqw))
                            )
                          (or (or (= ?brcl ?brck)
                              (= ?brcl ?blqw)
                              )
                            (= ?brck ?blqw)
                            )
                          )
                        (or (or (or (= ?brcj ?brci)
                              (= ?brcj ?blqw)
                              )
                            (= ?brci ?blqw)
                            )
                          (not (= ?brcl ?brck))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brcm Real)
                  (declare-const ?brcn Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brcj ?brci))
                              (not (= ?brcj ?blqw))
                              )
                            (not (= ?brci ?blqw))
                            )
                          (or (or (= ?brcn ?brcm)
                              (= ?brcn ?blqw)
                              )
                            (= ?brcm ?blqw)
                            )
                          )
                        (or (or (or (= ?brcj ?brci)
                              (= ?brcj ?blqw)
                              )
                            (= ?brci ?blqw)
                            )
                          (not (= ?brcn ?brcm))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?brco Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brcp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brcq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brcr Real)
            (declare-const ?brcs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brct Real)
            (declare-const ?brcu Real)
            (declare-const ?brcv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brcw Real)
            (declare-const ?brcx Real)
            (declare-const ?brcy Real)
            (declare-const ?brcz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brda Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brdb Real)
          (declare-const ?brdc Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brdd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brde Real)
            (declare-const ?brdf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brdg Real)
            (declare-const ?brdh Real)
            (declare-const ?brdi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brdj Real)
            (declare-const ?brdk Real)
            (declare-const ?brdl Real)
            (declare-const ?brdm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brdn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brdo Real)
          (declare-const ?brdp Real)
          (declare-const ?brdq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brdr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brds Real)
            (declare-const ?brdt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brdu Real)
            (declare-const ?brdv Real)
            (declare-const ?brdw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brdx Real)
            (declare-const ?brdy Real)
            (declare-const ?brdz Real)
            (declare-const ?brea Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?breb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brec Real)
          (declare-const ?bred Real)
          (declare-const ?bree Real)
          (declare-const ?bref Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?breg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?breh Real)
            (declare-const ?brei Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brej Real)
            (declare-const ?brek Real)
            (declare-const ?brel Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brem Real)
            (declare-const ?bren Real)
            (declare-const ?breo Real)
            (declare-const ?brep Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?breq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brer Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bres Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bret Real)
            (declare-const ?breu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brev Real)
            (declare-const ?brew Real)
            (declare-const ?brex Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brey Real)
            (declare-const ?brez Real)
            (declare-const ?brfa Real)
            (declare-const ?brfb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brfc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?brer ?brfc)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brfd Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brfe Real)
                (declare-const ?brff Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brfg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brfh Real)
                (declare-const ?brfi Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brfj Real)
                  (declare-const ?brfk Real)
                  (declare-const ?brfl Real)
                  (assert
                    (or (or (= ?brfl ?brfk)
                        (= ?brfl ?brfj)
                        )
                      (= ?brfk ?brfj)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brfm Real)
                  (declare-const ?brfn Real)
                  (declare-const ?brfo Real)
                  (assert
                    (or (or (= ?brfo ?brfn)
                        (= ?brfo ?brfm)
                        )
                      (= ?brfn ?brfm)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brfp Real)
                  (declare-const ?brfq Real)
                  (declare-const ?brfr Real)
                  (assert
                    (and (and (not (= ?brfr ?brfq))
                        (not (= ?brfr ?brfp))
                        )
                      (not (= ?brfq ?brfp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brfs Real)
                  (declare-const ?brft Real)
                  (declare-const ?brfu Real)
                  (assert
                    (and (and (not (= ?brfu ?brft))
                        (not (= ?brfu ?brfs))
                        )
                      (not (= ?brft ?brfs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brfv Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brfw Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brfw ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brfv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brfv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brfw ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brfx Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brfx ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brfv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brfv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brfx ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brfy Real)
                (declare-const ?brfz Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brga Real)
                  (declare-const ?brgb Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brfz ?brfy))
                              (not (= ?brfz ?blqw))
                              )
                            (not (= ?brfy ?blqw))
                            )
                          (or (or (= ?brgb ?brga)
                              (= ?brgb ?blqw)
                              )
                            (= ?brga ?blqw)
                            )
                          )
                        (or (or (or (= ?brfz ?brfy)
                              (= ?brfz ?blqw)
                              )
                            (= ?brfy ?blqw)
                            )
                          (not (= ?brgb ?brga))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brgc Real)
                  (declare-const ?brgd Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brfz ?brfy))
                              (not (= ?brfz ?blqw))
                              )
                            (not (= ?brfy ?blqw))
                            )
                          (or (or (= ?brgd ?brgc)
                              (= ?brgd ?blqw)
                              )
                            (= ?brgc ?blqw)
                            )
                          )
                        (or (or (or (= ?brfz ?brfy)
                              (= ?brfz ?blqw)
                              )
                            (= ?brfy ?blqw)
                            )
                          (not (= ?brgd ?brgc))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brge Real)
        (declare-const ?brgf Real)
        (declare-const ?brgg Real)
        (assert
          (and (and (not (= ?brgg ?brgf))
              (not (= ?brgg ?brge))
              )
            (not (= ?brgf ?brge))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?brgh Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?brgi Real)
      (assert
        (forall ((?bnyg Real) )(or (= ?brgi ?bnyg)
            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brgh ?bnyg))
                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                          (= ?bnza ?blqw)
                          )
                        (= ?bnyz ?blqw)
                        )
                      (and (not (= ?brgh ?blqw))
                        (not (= ?bnyg ?blqw))
                        )
                      )
                    )
                  )
                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                        (not (= ?bnza ?blqw))
                        )
                      (not (= ?bnyz ?blqw))
                      )
                    (or (= ?brgi ?blqw)
                      (= ?bnyg ?blqw)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brgj Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?brgj ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brgh ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?brgh ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?brgj ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brgk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brgl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brgm Real)
            (declare-const ?brgn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brgo Real)
            (declare-const ?brgp Real)
            (declare-const ?brgq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brgr Real)
            (declare-const ?brgs Real)
            (declare-const ?brgt Real)
            (declare-const ?brgu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brgv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brgw Real)
          (declare-const ?brgx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brgy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brgz Real)
            (declare-const ?brha Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (= ?brgw ?brgi)
                    (= ?brgz ?brgj)
                    )
                  (= ?brgx ?brha)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brhb Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brhc Real)
                (declare-const ?brhd Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brhe Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brhf Real)
                (declare-const ?brhg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brhh Real)
                  (declare-const ?brhi Real)
                  (declare-const ?brhj Real)
                  (assert
                    (or (or (= ?brhj ?brhi)
                        (= ?brhj ?brhh)
                        )
                      (= ?brhi ?brhh)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brhk Real)
                  (declare-const ?brhl Real)
                  (declare-const ?brhm Real)
                  (assert
                    (or (or (= ?brhm ?brhl)
                        (= ?brhm ?brhk)
                        )
                      (= ?brhl ?brhk)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brhn Real)
                  (declare-const ?brho Real)
                  (declare-const ?brhp Real)
                  (assert
                    (and (and (not (= ?brhp ?brho))
                        (not (= ?brhp ?brhn))
                        )
                      (not (= ?brho ?brhn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brhq Real)
                  (declare-const ?brhr Real)
                  (declare-const ?brhs Real)
                  (assert
                    (and (and (not (= ?brhs ?brhr))
                        (not (= ?brhs ?brhq))
                        )
                      (not (= ?brhr ?brhq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brht Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brhu Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brhu ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brht ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brht ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brhu ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brhv Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brhv ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brht ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brht ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brhv ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brhw Real)
                (declare-const ?brhx Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brhy Real)
                  (declare-const ?brhz Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brhx ?brhw))
                              (not (= ?brhx ?blqw))
                              )
                            (not (= ?brhw ?blqw))
                            )
                          (or (or (= ?brhz ?brhy)
                              (= ?brhz ?blqw)
                              )
                            (= ?brhy ?blqw)
                            )
                          )
                        (or (or (or (= ?brhx ?brhw)
                              (= ?brhx ?blqw)
                              )
                            (= ?brhw ?blqw)
                            )
                          (not (= ?brhz ?brhy))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bria Real)
                  (declare-const ?brib Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brhx ?brhw))
                              (not (= ?brhx ?blqw))
                              )
                            (not (= ?brhw ?blqw))
                            )
                          (or (or (= ?brib ?bria)
                              (= ?brib ?blqw)
                              )
                            (= ?bria ?blqw)
                            )
                          )
                        (or (or (or (= ?brhx ?brhw)
                              (= ?brhx ?blqw)
                              )
                            (= ?brhw ?blqw)
                            )
                          (not (= ?brib ?bria))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?brhw Real) (?brhx Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?brhx ?brhw))
                                (not (= ?brhx ?blqw))
                                )
                              (not (= ?brhw ?blqw))
                              )
                            (or (or (= ?brgw ?brgx)
                                (= ?brgw ?blqw)
                                )
                              (= ?brgx ?blqw)
                              )
                            )
                          (or (or (or (= ?brhx ?brhw)
                                (= ?brhx ?blqw)
                                )
                              (= ?brhw ?blqw)
                              )
                            (not (= ?brgw ?brgx))
                            )
                          )
                        )
                      (exists ((?blqw Real) )(or (and (or (or (= ?brhx ?brhw)
                                (= ?brhx ?blqw)
                                )
                              (= ?brhw ?blqw)
                              )
                            (and (and (not (= ?brgz ?brha))
                                (not (= ?brgz ?blqw))
                                )
                              (not (= ?brha ?blqw))
                              )
                            )
                          (and (and (and (not (= ?brhx ?brhw))
                                (not (= ?brhx ?blqw))
                                )
                              (not (= ?brhw ?blqw))
                              )
                            (= ?brgz ?brha)
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bric Real)
            (declare-const ?brid Real)
            (declare-const ?brie Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brif Real)
            (declare-const ?brig Real)
            (declare-const ?brih Real)
            (declare-const ?brii Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brij Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brik Real)
          (declare-const ?bril Real)
          (declare-const ?brim Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brin Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brio Real)
            (declare-const ?brip Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?briq Real)
            (declare-const ?brir Real)
            (declare-const ?bris Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brit Real)
            (declare-const ?briu Real)
            (declare-const ?briv Real)
            (declare-const ?briw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brix Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?briy Real)
          (declare-const ?briz Real)
          (declare-const ?brja Real)
          (declare-const ?brjb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brjc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brjd Real)
            (declare-const ?brje Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brjf Real)
            (declare-const ?brjg Real)
            (declare-const ?brjh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brji Real)
            (declare-const ?brjj Real)
            (declare-const ?brjk Real)
            (declare-const ?brjl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brjm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brjn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brjo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brjp Real)
            (declare-const ?brjq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brjr Real)
            (declare-const ?brjs Real)
            (declare-const ?brjt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brju Real)
            (declare-const ?brjv Real)
            (declare-const ?brjw Real)
            (declare-const ?brjx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brjy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brjz Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?brjz ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brgh ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?brgh ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?brjz ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?brka Real)
    (declare-const ?brkb Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?brkc Real)
      (declare-const ?brkd Real)
      (assert
        (forall ((?blqw Real) )(and (or (and (and (not (= ?brkb ?brka))
                  (not (= ?brkb ?blqw))
                  )
                (not (= ?brka ?blqw))
                )
              (or (or (= ?brkd ?brkc)
                  (= ?brkd ?blqw)
                  )
                (= ?brkc ?blqw)
                )
              )
            (or (or (or (= ?brkb ?brka)
                  (= ?brkb ?blqw)
                  )
                (= ?brka ?blqw)
                )
              (not (= ?brkd ?brkc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brke Real)
        (declare-const ?brkf Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?brkb ?brka))
                    (not (= ?brkb ?blqw))
                    )
                  (not (= ?brka ?blqw))
                  )
                (or (or (= ?brkf ?brke)
                    (= ?brkf ?blqw)
                    )
                  (= ?brke ?blqw)
                  )
                )
              (or (or (or (= ?brkb ?brka)
                    (= ?brkb ?blqw)
                    )
                  (= ?brka ?blqw)
                  )
                (not (= ?brkf ?brke))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brkg Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brkh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brki Real)
            (declare-const ?brkj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brkk Real)
            (declare-const ?brkl Real)
            (declare-const ?brkm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brkn Real)
            (declare-const ?brko Real)
            (declare-const ?brkp Real)
            (declare-const ?brkq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brkr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brks Real)
          (declare-const ?brkt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brku Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brkv Real)
            (declare-const ?brkw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brkx Real)
            (declare-const ?brky Real)
            (declare-const ?brkz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brla Real)
            (declare-const ?brlb Real)
            (declare-const ?brlc Real)
            (declare-const ?brld Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brle Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brlf Real)
          (declare-const ?brlg Real)
          (declare-const ?brlh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brli Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brlj Real)
            (declare-const ?brlk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brll Real)
            (declare-const ?brlm Real)
            (declare-const ?brln Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?brlg ?brkd)
                      (= ?brlf ?brkc)
                      )
                    (and (= ?brlm ?brkf)
                      (= ?brll ?brke)
                      )
                    )
                  (= ?brlh ?brln)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brlo Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brlp Real)
                (declare-const ?brlq Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brlr Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brls Real)
                (declare-const ?brlt Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brlu Real)
                  (declare-const ?brlv Real)
                  (declare-const ?brlw Real)
                  (assert
                    (or (or (= ?brlw ?brlv)
                        (= ?brlw ?brlu)
                        )
                      (= ?brlv ?brlu)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brlx Real)
                  (declare-const ?brly Real)
                  (declare-const ?brlz Real)
                  (assert
                    (or (or (= ?brlz ?brly)
                        (= ?brlz ?brlx)
                        )
                      (= ?brly ?brlx)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brma Real)
                  (declare-const ?brmb Real)
                  (declare-const ?brmc Real)
                  (assert
                    (and (and (not (= ?brmc ?brmb))
                        (not (= ?brmc ?brma))
                        )
                      (not (= ?brmb ?brma))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brmd Real)
                  (declare-const ?brme Real)
                  (declare-const ?brmf Real)
                  (assert
                    (and (and (not (= ?brmf ?brme))
                        (not (= ?brmf ?brmd))
                        )
                      (not (= ?brme ?brmd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brmg Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brmh Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brmh ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brmg ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brmg ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brmh ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brmi Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brmi ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brmg ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brmg ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brmi ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brmj Real)
                (declare-const ?brmk Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brml Real)
                  (declare-const ?brmm Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brmk ?brmj))
                              (not (= ?brmk ?blqw))
                              )
                            (not (= ?brmj ?blqw))
                            )
                          (or (or (= ?brmm ?brml)
                              (= ?brmm ?blqw)
                              )
                            (= ?brml ?blqw)
                            )
                          )
                        (or (or (or (= ?brmk ?brmj)
                              (= ?brmk ?blqw)
                              )
                            (= ?brmj ?blqw)
                            )
                          (not (= ?brmm ?brml))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brmn Real)
                  (declare-const ?brmo Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brmk ?brmj))
                              (not (= ?brmk ?blqw))
                              )
                            (not (= ?brmj ?blqw))
                            )
                          (or (or (= ?brmo ?brmn)
                              (= ?brmo ?blqw)
                              )
                            (= ?brmn ?blqw)
                            )
                          )
                        (or (or (or (= ?brmk ?brmj)
                              (= ?brmk ?blqw)
                              )
                            (= ?brmj ?blqw)
                            )
                          (not (= ?brmo ?brmn))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (and (or (or (= ?brlg ?brlf)
                          (= ?brlg ?brlh)
                          )
                        (= ?brlf ?brlh)
                        )
                      (and (and (not (= ?brlm ?brll))
                          (not (= ?brlm ?brln))
                          )
                        (not (= ?brll ?brln))
                        )
                      )
                    (and (and (and (not (= ?brlg ?brlf))
                          (not (= ?brlg ?brlh))
                          )
                        (not (= ?brlf ?brlh))
                        )
                      (or (or (= ?brlm ?brll)
                          (= ?brlm ?brln)
                          )
                        (= ?brll ?brln)
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?brmp Real)
            (declare-const ?brmq Real)
            (declare-const ?brmr Real)
            (declare-const ?brms Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brmt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brmu Real)
          (declare-const ?brmv Real)
          (declare-const ?brmw Real)
          (declare-const ?brmx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brmy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brmz Real)
            (declare-const ?brna Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brnb Real)
            (declare-const ?brnc Real)
            (declare-const ?brnd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brne Real)
            (declare-const ?brnf Real)
            (declare-const ?brng Real)
            (declare-const ?brnh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brni Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brnj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brnk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brnl Real)
            (declare-const ?brnm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brnn Real)
            (declare-const ?brno Real)
            (declare-const ?brnp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brnq Real)
            (declare-const ?brnr Real)
            (declare-const ?brns Real)
            (declare-const ?brnt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brnu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brnv Real)
        (declare-const ?brnw Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?brkb ?brka))
                    (not (= ?brkb ?blqw))
                    )
                  (not (= ?brka ?blqw))
                  )
                (or (or (= ?brnw ?brnv)
                    (= ?brnw ?blqw)
                    )
                  (= ?brnv ?blqw)
                  )
                )
              (or (or (or (= ?brkb ?brka)
                    (= ?brkb ?blqw)
                    )
                  (= ?brka ?blqw)
                  )
                (not (= ?brnw ?brnv))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?brnx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?brny Real)
    (declare-const ?brnz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?broa Real)
        (declare-const ?brob Real)
        (declare-const ?broc Real)
        (assert
          (or (or (= ?broc ?brob)
              (= ?broc ?broa)
              )
            (= ?brob ?broa)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brod Real)
          (declare-const ?broe Real)
          (declare-const ?brof Real)
          (assert
            (or (or (= ?brof ?broe)
                (= ?brof ?brod)
                )
              (= ?broe ?brod)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brog Real)
        (declare-const ?broh Real)
        (declare-const ?broi Real)
        (assert
          (or (or (= ?broi ?broh)
              (= ?broi ?brog)
              )
            (= ?broh ?brog)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?broj Real)
          (declare-const ?brok Real)
          (declare-const ?brol Real)
          (assert
            (and (and (not (= ?brol ?brok))
                (not (= ?brol ?broj))
                )
              (not (= ?brok ?broj))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brom Real)
        (declare-const ?bron Real)
        (declare-const ?broo Real)
        (assert
          (and (and (not (= ?broo ?bron))
              (not (= ?broo ?brom))
              )
            (not (= ?bron ?brom))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brop Real)
          (declare-const ?broq Real)
          (declare-const ?bror Real)
          (assert
            (or (or (= ?bror ?broq)
                (= ?bror ?brop)
                )
              (= ?broq ?brop)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bros Real)
          (declare-const ?brot Real)
          (declare-const ?brou Real)
          (assert
            (or (or (= ?brou ?brot)
                (= ?brou ?bros)
                )
              (= ?brot ?bros)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brov Real)
          (declare-const ?brow Real)
          (declare-const ?brox Real)
          (assert
            (and (and (not (= ?brox ?brow))
                (not (= ?brox ?brov))
                )
              (not (= ?brow ?brov))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?broy Real)
        (declare-const ?broz Real)
        (declare-const ?brpa Real)
        (assert
          (and (and (not (= ?brpa ?broz))
              (not (= ?brpa ?broy))
              )
            (not (= ?broz ?broy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brpb Real)
        (declare-const ?brpc Real)
        (declare-const ?brpd Real)
        (assert
          (or (or (= ?brpd ?brpc)
              (= ?brpd ?brpb)
              )
            (= ?brpc ?brpb)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brpe Real)
          (declare-const ?brpf Real)
          (declare-const ?brpg Real)
          (assert
            (and (and (not (= ?brpg ?brpf))
                (not (= ?brpg ?brpe))
                )
              (not (= ?brpf ?brpe))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brph Real)
        (declare-const ?brpi Real)
        (declare-const ?brpj Real)
        (assert
          (and (and (not (= ?brpj ?brpi))
              (not (= ?brpj ?brph))
              )
            (not (= ?brpi ?brph))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brpk Real)
          (declare-const ?brpl Real)
          (declare-const ?brpm Real)
          (assert
            (or (or (= ?brpm ?brpl)
                (= ?brpm ?brpk)
                )
              (= ?brpl ?brpk)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brpn Real)
          (declare-const ?brpo Real)
          (declare-const ?brpp Real)
          (assert
            (or (or (= ?brpp ?brpo)
                (= ?brpp ?brpn)
                )
              (= ?brpo ?brpn)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brpq Real)
          (declare-const ?brpr Real)
          (declare-const ?brps Real)
          (assert
            (and (and (not (= ?brps ?brpr))
                (not (= ?brps ?brpq))
                )
              (not (= ?brpr ?brpq))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brpt Real)
        (declare-const ?brpu Real)
        (declare-const ?brpv Real)
        (assert
          (and (and (not (= ?brpv ?brpu))
              (not (= ?brpv ?brpt))
              )
            (not (= ?brpu ?brpt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brpw Real)
        (declare-const ?brpx Real)
        (declare-const ?brpy Real)
        (assert
          (and (and (not (= ?brpy ?brpx))
              (not (= ?brpy ?brpw))
              )
            (not (= ?brpx ?brpw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brpz Real)
          (declare-const ?brqa Real)
          (declare-const ?brqb Real)
          (assert
            (and (and (not (= ?brqb ?brqa))
                (not (= ?brqb ?brpz))
                )
              (not (= ?brqa ?brpz))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brqc Real)
          (declare-const ?brqd Real)
          (declare-const ?brqe Real)
          (assert
            (and (and (not (= ?brqe ?brqd))
                (not (= ?brqe ?brqc))
                )
              (not (= ?brqd ?brqc))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brqf Real)
        (declare-const ?brqg Real)
        (declare-const ?brqh Real)
        (assert
          (and (and (not (= ?brqh ?brqg))
              (not (= ?brqh ?brqf))
              )
            (not (= ?brqg ?brqf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brqi Real)
          (declare-const ?brqj Real)
          (declare-const ?brqk Real)
          (assert
            (and (and (not (= ?brqk ?brqj))
                (not (= ?brqk ?brqi))
                )
              (not (= ?brqj ?brqi))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brql Real)
          (declare-const ?brqm Real)
          (declare-const ?brqn Real)
          (assert
            (and (and (not (= ?brqn ?brqm))
                (not (= ?brqn ?brql))
                )
              (not (= ?brqm ?brql))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?brqg Real) (?brqf Real) )(and (not (= ?brqg ?brqf))
              (exists ((?brqh Real) )(and (not (= ?brqh ?brqg))
                  (and (not (= ?brqh ?brqf))
                    (or (or (= ?brqh ?brqg)
                        (= ?brqh ?brqf)
                        )
                      (= ?brqg ?brqf)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?brpx Real) (?brpw Real) )(and (not (= ?brpx ?brpw))
              (exists ((?brpy Real) )(and (not (= ?brpy ?brpx))
                  (and (not (= ?brpy ?brpw))
                    (or (or (= ?brpy ?brpx)
                        (= ?brpy ?brpw)
                        )
                      (= ?brpx ?brpw)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?brqo Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brqp Real)
        (declare-const ?brqq Real)
        (declare-const ?brqr Real)
        (assert
          (or (or (= ?brqr ?brqq)
              (= ?brqr ?brqp)
              )
            (= ?brqq ?brqp)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brqs Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?brqs ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?brqo ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?brqs ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brqt Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?brqt ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?brqo ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?brqt ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brqu Real)
          (declare-const ?brqv Real)
          (declare-const ?brqw Real)
          (assert
            (or (or (= ?brqw ?brqv)
                (= ?brqw ?brqu)
                )
              (= ?brqv ?brqu)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brqx Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?brqx ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?brqo ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?brqx ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brqy Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?brqy ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?brqo ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?brqy ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brqz Real)
        (declare-const ?brra Real)
        (declare-const ?brrb Real)
        (assert
          (and (and (not (= ?brrb ?brra))
              (not (= ?brrb ?brqz))
              )
            (not (= ?brra ?brqz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brrc Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?brrc ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?brqo ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?brrc ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brrd Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?brrd ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?brqo ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?brrd ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brre Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?brre ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?brqo ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?brre ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brrf Real)
          (declare-const ?brrg Real)
          (declare-const ?brrh Real)
          (assert
            (and (and (not (= ?brrh ?brrg))
                (not (= ?brrh ?brrf))
                )
              (not (= ?brrg ?brrf))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?brqt Real) )(forall ((?bnyg Real) )(or (= ?brqt ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brqo ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?brqo ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?brqt ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (exists ((?brqq Real) (?brqp Real) )(or (= ?brqq ?brqp)
              (exists ((?brqr Real) )(or (= ?brqr ?brqq)
                  (= ?brqr ?brqp)
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?brri Real)
    (declare-const ?brrj Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brrk Real)
        (declare-const ?brrl Real)
        (declare-const ?brrm Real)
        (assert
          (or (or (= ?brrm ?brrl)
              (= ?brrm ?brrk)
              )
            (= ?brrl ?brrk)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brrn Real)
          (declare-const ?brro Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                      (not (= ?brrj ?blqw))
                      )
                    (not (= ?brri ?blqw))
                    )
                  (or (or (= ?brro ?brrn)
                      (= ?brro ?blqw)
                      )
                    (= ?brrn ?blqw)
                    )
                  )
                (or (or (or (= ?brrj ?brri)
                      (= ?brrj ?blqw)
                      )
                    (= ?brri ?blqw)
                    )
                  (not (= ?brro ?brrn))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brrp Real)
        (declare-const ?brrq Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                    (not (= ?brrj ?blqw))
                    )
                  (not (= ?brri ?blqw))
                  )
                (or (or (= ?brrq ?brrp)
                    (= ?brrq ?blqw)
                    )
                  (= ?brrp ?blqw)
                  )
                )
              (or (or (or (= ?brrj ?brri)
                    (= ?brrj ?blqw)
                    )
                  (= ?brri ?blqw)
                  )
                (not (= ?brrq ?brrp))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brrr Real)
          (declare-const ?brrs Real)
          (declare-const ?brrt Real)
          (assert
            (or (or (= ?brrt ?brrs)
                (= ?brrt ?brrr)
                )
              (= ?brrs ?brrr)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brru Real)
          (declare-const ?brrv Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                      (not (= ?brrj ?blqw))
                      )
                    (not (= ?brri ?blqw))
                    )
                  (or (or (= ?brrv ?brru)
                      (= ?brrv ?blqw)
                      )
                    (= ?brru ?blqw)
                    )
                  )
                (or (or (or (= ?brrj ?brri)
                      (= ?brrj ?blqw)
                      )
                    (= ?brri ?blqw)
                    )
                  (not (= ?brrv ?brru))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brrw Real)
        (declare-const ?brrx Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                    (not (= ?brrj ?blqw))
                    )
                  (not (= ?brri ?blqw))
                  )
                (or (or (= ?brrx ?brrw)
                    (= ?brrx ?blqw)
                    )
                  (= ?brrw ?blqw)
                  )
                )
              (or (or (or (= ?brrj ?brri)
                    (= ?brrj ?blqw)
                    )
                  (= ?brri ?blqw)
                  )
                (not (= ?brrx ?brrw))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brry Real)
        (declare-const ?brrz Real)
        (declare-const ?brsa Real)
        (assert
          (and (and (not (= ?brsa ?brrz))
              (not (= ?brsa ?brry))
              )
            (not (= ?brrz ?brry))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brsb Real)
          (declare-const ?brsc Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                      (not (= ?brrj ?blqw))
                      )
                    (not (= ?brri ?blqw))
                    )
                  (or (or (= ?brsc ?brsb)
                      (= ?brsc ?blqw)
                      )
                    (= ?brsb ?blqw)
                    )
                  )
                (or (or (or (= ?brrj ?brri)
                      (= ?brrj ?blqw)
                      )
                    (= ?brri ?blqw)
                    )
                  (not (= ?brsc ?brsb))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brsd Real)
          (declare-const ?brse Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                      (not (= ?brrj ?blqw))
                      )
                    (not (= ?brri ?blqw))
                    )
                  (or (or (= ?brse ?brsd)
                      (= ?brse ?blqw)
                      )
                    (= ?brsd ?blqw)
                    )
                  )
                (or (or (or (= ?brrj ?brri)
                      (= ?brrj ?blqw)
                      )
                    (= ?brri ?blqw)
                    )
                  (not (= ?brse ?brsd))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brsf Real)
        (declare-const ?brsg Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                    (not (= ?brrj ?blqw))
                    )
                  (not (= ?brri ?blqw))
                  )
                (or (or (= ?brsg ?brsf)
                    (= ?brsg ?blqw)
                    )
                  (= ?brsf ?blqw)
                  )
                )
              (or (or (or (= ?brrj ?brri)
                    (= ?brrj ?blqw)
                    )
                  (= ?brri ?blqw)
                  )
                (not (= ?brsg ?brsf))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brsh Real)
          (declare-const ?brsi Real)
          (declare-const ?brsj Real)
          (assert
            (and (and (not (= ?brsj ?brsi))
                (not (= ?brsj ?brsh))
                )
              (not (= ?brsi ?brsh))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?brsk Real)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brsl Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?brsl ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brsk ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?brsk ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?brsl ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brsm Real)
          (declare-const ?brsn Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                      (not (= ?brrj ?blqw))
                      )
                    (not (= ?brri ?blqw))
                    )
                  (or (or (= ?brsn ?brsm)
                      (= ?brsn ?blqw)
                      )
                    (= ?brsm ?blqw)
                    )
                  )
                (or (or (or (= ?brrj ?brri)
                      (= ?brrj ?blqw)
                      )
                    (= ?brri ?blqw)
                    )
                  (not (= ?brsn ?brsm))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brso Real)
        (declare-const ?brsp Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                    (not (= ?brrj ?blqw))
                    )
                  (not (= ?brri ?blqw))
                  )
                (or (or (= ?brsp ?brso)
                    (= ?brsp ?blqw)
                    )
                  (= ?brso ?blqw)
                  )
                )
              (or (or (or (= ?brrj ?brri)
                    (= ?brrj ?blqw)
                    )
                  (= ?brri ?blqw)
                  )
                (not (= ?brsp ?brso))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brsq Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?brsq ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brsk ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?brsk ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?brsq ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (or (exists ((?brrp Real) (?brrq Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                        (not (= ?brrj ?blqw))
                        )
                      (not (= ?brri ?blqw))
                      )
                    (or (or (= ?brrq ?brrp)
                        (= ?brrq ?blqw)
                        )
                      (= ?brrp ?blqw)
                      )
                    )
                  (or (or (or (= ?brrj ?brri)
                        (= ?brrj ?blqw)
                        )
                      (= ?brri ?blqw)
                      )
                    (not (= ?brrq ?brrp))
                    )
                  )
                )
              )
            (exists ((?brrl Real) (?brrk Real) )(or (= ?brrl ?brrk)
                (exists ((?brrm Real) )(or (= ?brrm ?brrl)
                    (= ?brrm ?brrk)
                    )
                  )
                )
              )
            )
          (or (exists ((?brso Real) (?brsp Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?brrj ?brri))
                        (not (= ?brrj ?blqw))
                        )
                      (not (= ?brri ?blqw))
                      )
                    (or (or (= ?brsp ?brso)
                        (= ?brsp ?blqw)
                        )
                      (= ?brso ?blqw)
                      )
                    )
                  (or (or (or (= ?brrj ?brri)
                        (= ?brrj ?blqw)
                        )
                      (= ?brri ?blqw)
                      )
                    (not (= ?brsp ?brso))
                    )
                  )
                )
              )
            (forall ((?brsk Real) )(exists ((?brsl Real) )(forall ((?bnyg Real) )(or (= ?brsl ?bnyg)
                    (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brsk ?bnyg))
                          (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                  (= ?bnza ?blqw)
                                  )
                                (= ?bnyz ?blqw)
                                )
                              (and (not (= ?brsk ?blqw))
                                (not (= ?bnyg ?blqw))
                                )
                              )
                            )
                          )
                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (or (= ?brsl ?blqw)
                              (= ?bnyg ?blqw)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?brsr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?brss Real)
    (declare-const ?brst Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                (not (= ?blem ?bler))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                  (forall ((?boig Real) )(or (= ?boig ?boif)
                      (= ?boig ?boie)
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (and (and (not (= ?bnuc ?bofe))
                                  (not (= ?bnuc ?blqw))
                                  )
                                (not (= ?bofe ?blqw))
                                )
                              )
                            (and (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (= ?bnuc ?bofe)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bocc))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bocc ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (= ?bnuc ?bocc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                (= ?bobe ?bobc)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bnyg))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnuc ?bnyg)
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnxp ?bnyg)
                                            (= ?bnxp ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnxp ?bnyg))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnuq))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnuq ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (= ?bnuc ?bnuq)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                (= ?blem ?bler)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                      (not (= ?boig ?boie))
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (or (or (= ?bnuc ?bofe)
                                  (= ?bnuc ?blqw)
                                  )
                                (= ?bofe ?blqw)
                                )
                              )
                            (or (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (not (= ?bnuc ?bofe))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bocc)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bocc ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (not (= ?bnuc ?bocc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                (not (= ?bobe ?bobc))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnyg)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnuc ?bnyg))
                                        )
                                      )
                                    )
                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnxp ?bnyg))
                                            (not (= ?bnxp ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnxp ?bnyg)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnuq)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnuq ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (not (= ?bnuc ?bnuq))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                (not (= ?blem ?bler))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                  (forall ((?boig Real) )(or (= ?boig ?boif)
                      (= ?boig ?boie)
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (and (and (not (= ?bnuc ?bofe))
                                  (not (= ?bnuc ?blqw))
                                  )
                                (not (= ?bofe ?blqw))
                                )
                              )
                            (and (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (= ?bnuc ?bofe)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bocc))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bocc ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (= ?bnuc ?bocc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                (= ?bobe ?bobc)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bnyg))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnuc ?bnyg)
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnxp ?bnyg)
                                            (= ?bnxp ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnxp ?bnyg))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnuq))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnuq ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (= ?bnuc ?bnuq)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                (= ?blem ?bler)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                      (not (= ?boig ?boie))
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (or (or (= ?bnuc ?bofe)
                                  (= ?bnuc ?blqw)
                                  )
                                (= ?bofe ?blqw)
                                )
                              )
                            (or (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (not (= ?bnuc ?bofe))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bocc)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bocc ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (not (= ?bnuc ?bocc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                (not (= ?bobe ?bobc))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnyg)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnuc ?bnyg))
                                        )
                                      )
                                    )
                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnxp ?bnyg))
                                            (not (= ?bnxp ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnxp ?bnyg)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnuq)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnuq ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (not (= ?bnuc ?bnuq))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?brsu Real)
  (push 1)
    (assert
      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                (not (= ?blem ?bler))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                  (forall ((?boig Real) )(or (= ?boig ?boif)
                      (= ?boig ?boie)
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (and (and (not (= ?bnuc ?bofe))
                                  (not (= ?bnuc ?blqw))
                                  )
                                (not (= ?bofe ?blqw))
                                )
                              )
                            (and (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (= ?bnuc ?bofe)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bocc))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bocc ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (= ?bnuc ?bocc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                (= ?bobe ?bobc)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bnyg))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnuc ?bnyg)
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnxp ?bnyg)
                                            (= ?bnxp ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnxp ?bnyg))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnuq))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnuq ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (= ?bnuc ?bnuq)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                (= ?blem ?bler)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                      (not (= ?boig ?boie))
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (or (or (= ?bnuc ?bofe)
                                  (= ?bnuc ?blqw)
                                  )
                                (= ?bofe ?blqw)
                                )
                              )
                            (or (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (not (= ?bnuc ?bofe))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bocc)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bocc ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (not (= ?bnuc ?bocc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                (not (= ?bobe ?bobc))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnyg)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnuc ?bnyg))
                                        )
                                      )
                                    )
                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnxp ?bnyg))
                                            (not (= ?bnxp ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnxp ?bnyg)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnuq)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnuq ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (not (= ?bnuc ?bnuq))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?brsv Real)
  (declare-const ?brsw Real)
  (push 1)
    (assert
      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                (not (= ?blem ?bler))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                  (forall ((?boig Real) )(or (= ?boig ?boif)
                      (= ?boig ?boie)
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (and (and (not (= ?bnuc ?bofe))
                                  (not (= ?bnuc ?blqw))
                                  )
                                (not (= ?bofe ?blqw))
                                )
                              )
                            (and (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (= ?bnuc ?bofe)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bocc))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bocc ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (= ?bnuc ?bocc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                (= ?bobe ?bobc)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bnyg))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnuc ?bnyg)
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnxp ?bnyg)
                                            (= ?bnxp ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnxp ?bnyg))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnuq))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnuq ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (= ?bnuc ?bnuq)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                (= ?blem ?bler)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                      (not (= ?boig ?boie))
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (or (or (= ?bnuc ?bofe)
                                  (= ?bnuc ?blqw)
                                  )
                                (= ?bofe ?blqw)
                                )
                              )
                            (or (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (not (= ?bnuc ?bofe))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bocc)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bocc ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (not (= ?bnuc ?bocc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                (not (= ?bobe ?bobc))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnyg)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnuc ?bnyg))
                                        )
                                      )
                                    )
                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnxp ?bnyg))
                                            (not (= ?bnxp ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnxp ?bnyg)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnuq)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnuq ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (not (= ?bnuc ?bnuq))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                (= ?bmnf ?bmnk)
                )
              )
            )
          )
        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                      (not (= ?blvm ?blvk))
                      )
                    )
                  )
                )
              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                      (= ?bmca ?bmdy)
                      )
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                        (= ?blpf ?bluu)
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                              (= ?blpf ?blsx)
                              )
                            )
                          )
                        )
                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                              (not (= ?blrl ?blrj))
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                    (= ?blpg ?blqw)
                                    )
                                  (= ?blpf ?blqw)
                                  )
                                (and (and (not (= ?blqq ?blqp))
                                    (not (= ?blqq ?blqw))
                                    )
                                  (not (= ?blqp ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?blpg ?blpf))
                                    (not (= ?blpg ?blqw))
                                    )
                                  (not (= ?blpf ?blqw))
                                  )
                                (or (or (= ?blqq ?blqp)
                                    (= ?blqq ?blqw)
                                    )
                                  (= ?blqp ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                    (= ?blpf ?blqc)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                        (= ?blpf ?blpj)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                            (= ?blkl ?blkr)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                              (= ?blem ?bler)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                  (not (= ?bmnf ?bmnk))
                  )
                )
              )
            )
          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                        (= ?blvm ?blvk)
                        )
                      )
                    )
                  )
                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                        (not (= ?bmca ?bmdy))
                        )
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                          (not (= ?blpf ?bluu))
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                (not (= ?blpf ?blsx))
                                )
                              )
                            )
                          )
                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                (= ?blrl ?blrj)
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                (or (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                      (not (= ?blpf ?blqc))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                          (not (= ?blpf ?blpj))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                              (not (= ?blkl ?blkr))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                (not (= ?blem ?bler))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                    (not (= ?boig ?boie))
                    )
                  )
                )
              )
            )
          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                  (forall ((?boig Real) )(or (= ?boig ?boif)
                      (= ?boig ?boie)
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                (not (= ?bogj ?blqw))
                                )
                              (not (= ?bogi ?blqw))
                              )
                            (or (or (= ?bnuc ?bofe)
                                (= ?bnuc ?blqw)
                                )
                              (= ?bofe ?blqw)
                              )
                            )
                          (or (or (or (= ?bogj ?bogi)
                                (= ?bogj ?blqw)
                                )
                              (= ?bogi ?blqw)
                              )
                            (not (= ?bnuc ?bofe))
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (and (and (not (= ?bnuc ?bofe))
                                  (not (= ?bnuc ?blqw))
                                  )
                                (not (= ?bofe ?blqw))
                                )
                              )
                            (and (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (= ?bnuc ?bofe)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                      (not (= ?bocw ?blqw))
                                      )
                                    (not (= ?bocv ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bocc)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bocc ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bocw ?bocv)
                                      (= ?bocw ?blqw)
                                      )
                                    (= ?bocv ?blqw)
                                    )
                                  (not (= ?bnuc ?bocc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                              (not (= ?bobe ?bobc))
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bocc))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bocc ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (= ?bnuc ?bocc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                (= ?bobe ?bobc)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bnyg)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (not (= ?bnuc ?bnyg))
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (and (not (= ?bnxp ?bnyg))
                                          (not (= ?bnxp ?blqw))
                                          )
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (= ?bnxp ?bnyg)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bnyg))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnuc ?bnyg)
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnxp ?bnyg)
                                            (= ?bnxp ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnxp ?bnyg))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                            (not (= ?bnvl ?blqw))
                                            )
                                          (not (= ?bnvk ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnuq)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnuq ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnvl ?bnvk)
                                            (= ?bnvl ?blqw)
                                            )
                                          (= ?bnvk ?blqw)
                                          )
                                        (not (= ?bnuc ?bnuq))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnuq))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnuq ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (= ?bnuc ?bnuq)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?brsx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?brsy Real)
    (declare-const ?brsz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                (= ?blem ?bler)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                      (not (= ?boig ?boie))
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (or (or (= ?bnuc ?bofe)
                                  (= ?bnuc ?blqw)
                                  )
                                (= ?bofe ?blqw)
                                )
                              )
                            (or (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (not (= ?bnuc ?bofe))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bocc)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bocc ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (not (= ?bnuc ?bocc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                (not (= ?bobe ?bobc))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnyg)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnuc ?bnyg))
                                        )
                                      )
                                    )
                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnxp ?bnyg))
                                            (not (= ?bnxp ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnxp ?bnyg)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnuq)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnuq ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (not (= ?bnuc ?bnuq))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                    (not (= ?bqki ?bqkg))
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqhv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqgr ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqef ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqdm ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                          (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                              (not (= ?bqdb ?bqcz))
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?brta Real)
      (declare-const ?brtb Real)
      (declare-const ?brtc Real)
      (assert
        (or (or (= ?brtc ?brtb)
            (= ?brtc ?brta)
            )
          (= ?brtb ?brta)
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?brtd Real)
        (declare-const ?brte Real)
        (declare-const ?brtf Real)
        (assert
          (or (or (= ?brtf ?brte)
              (= ?brtf ?brtd)
              )
            (= ?brte ?brtd)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brtg Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brth Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brti Real)
            (declare-const ?brtj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brtk Real)
            (declare-const ?brtl Real)
            (declare-const ?brtm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brtn Real)
            (declare-const ?brto Real)
            (declare-const ?brtp Real)
            (declare-const ?brtq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brtr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brts Real)
          (declare-const ?brtt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brtu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brtv Real)
            (declare-const ?brtw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brtx Real)
            (declare-const ?brty Real)
            (declare-const ?brtz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brua Real)
            (declare-const ?brub Real)
            (declare-const ?bruc Real)
            (declare-const ?brud Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brue Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bruf Real)
          (declare-const ?brug Real)
          (declare-const ?bruh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brui Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bruj Real)
            (declare-const ?bruk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brul Real)
            (declare-const ?brum Real)
            (declare-const ?brun Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bruo Real)
            (declare-const ?brup Real)
            (declare-const ?bruq Real)
            (declare-const ?brur Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brus Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brut Real)
          (declare-const ?bruu Real)
          (declare-const ?bruv Real)
          (declare-const ?bruw Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brux Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bruy Real)
            (declare-const ?bruz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brva Real)
            (declare-const ?brvb Real)
            (declare-const ?brvc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brvd Real)
            (declare-const ?brve Real)
            (declare-const ?brvf Real)
            (declare-const ?brvg Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bruv ?brtc)
                        (= ?bruu ?brtb)
                        )
                      (= ?brut ?brta)
                      )
                    (and (and (= ?brvf ?brtf)
                        (= ?brve ?brte)
                        )
                      (= ?brvd ?brtd)
                      )
                    )
                  (= ?bruw ?brvg)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brvh Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brvi Real)
                (declare-const ?brvj Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brvk Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brvl Real)
                (declare-const ?brvm Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brvn Real)
                  (declare-const ?brvo Real)
                  (declare-const ?brvp Real)
                  (assert
                    (or (or (= ?brvp ?brvo)
                        (= ?brvp ?brvn)
                        )
                      (= ?brvo ?brvn)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brvq Real)
                  (declare-const ?brvr Real)
                  (declare-const ?brvs Real)
                  (assert
                    (or (or (= ?brvs ?brvr)
                        (= ?brvs ?brvq)
                        )
                      (= ?brvr ?brvq)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brvt Real)
                  (declare-const ?brvu Real)
                  (declare-const ?brvv Real)
                  (assert
                    (and (and (not (= ?brvv ?brvu))
                        (not (= ?brvv ?brvt))
                        )
                      (not (= ?brvu ?brvt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brvw Real)
                  (declare-const ?brvx Real)
                  (declare-const ?brvy Real)
                  (assert
                    (and (and (not (= ?brvy ?brvx))
                        (not (= ?brvy ?brvw))
                        )
                      (not (= ?brvx ?brvw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brvz Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brwa Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brwa ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brvz ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brvz ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brwa ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brwb Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brwb ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brvz ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brvz ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brwb ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brwc Real)
                (declare-const ?brwd Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brwe Real)
                  (declare-const ?brwf Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brwd ?brwc))
                              (not (= ?brwd ?blqw))
                              )
                            (not (= ?brwc ?blqw))
                            )
                          (or (or (= ?brwf ?brwe)
                              (= ?brwf ?blqw)
                              )
                            (= ?brwe ?blqw)
                            )
                          )
                        (or (or (or (= ?brwd ?brwc)
                              (= ?brwd ?blqw)
                              )
                            (= ?brwc ?blqw)
                            )
                          (not (= ?brwf ?brwe))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brwg Real)
                  (declare-const ?brwh Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brwd ?brwc))
                              (not (= ?brwd ?blqw))
                              )
                            (not (= ?brwc ?blqw))
                            )
                          (or (or (= ?brwh ?brwg)
                              (= ?brwh ?blqw)
                              )
                            (= ?brwg ?blqw)
                            )
                          )
                        (or (or (or (= ?brwd ?brwc)
                              (= ?brwd ?blqw)
                              )
                            (= ?brwc ?blqw)
                            )
                          (not (= ?brwh ?brwg))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?brwi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brwj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brwk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brwl Real)
            (declare-const ?brwm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brwn Real)
            (declare-const ?brwo Real)
            (declare-const ?brwp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brwq Real)
            (declare-const ?brwr Real)
            (declare-const ?brws Real)
            (declare-const ?brwt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brwu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?brwv Real)
        (declare-const ?brww Real)
        (declare-const ?brwx Real)
        (assert
          (or (or (= ?brwx ?brww)
              (= ?brwx ?brwv)
              )
            (= ?brww ?brwv)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?brwy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brwz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?brwy ?brwz)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brxa Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brxb Real)
                (declare-const ?brxc Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brxd Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?brxe Real)
                (declare-const ?brxf Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brxg Real)
                  (declare-const ?brxh Real)
                  (declare-const ?brxi Real)
                  (assert
                    (or (or (= ?brxi ?brxh)
                        (= ?brxi ?brxg)
                        )
                      (= ?brxh ?brxg)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brxj Real)
                  (declare-const ?brxk Real)
                  (declare-const ?brxl Real)
                  (assert
                    (or (or (= ?brxl ?brxk)
                        (= ?brxl ?brxj)
                        )
                      (= ?brxk ?brxj)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brxm Real)
                  (declare-const ?brxn Real)
                  (declare-const ?brxo Real)
                  (assert
                    (and (and (not (= ?brxo ?brxn))
                        (not (= ?brxo ?brxm))
                        )
                      (not (= ?brxn ?brxm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brxp Real)
                  (declare-const ?brxq Real)
                  (declare-const ?brxr Real)
                  (assert
                    (and (and (not (= ?brxr ?brxq))
                        (not (= ?brxr ?brxp))
                        )
                      (not (= ?brxq ?brxp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brxs Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brxt Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brxt ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brxs ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brxs ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brxt ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brxu Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?brxu ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brxs ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brxs ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?brxu ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?brxv Real)
                (declare-const ?brxw Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?brxx Real)
                  (declare-const ?brxy Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brxw ?brxv))
                              (not (= ?brxw ?blqw))
                              )
                            (not (= ?brxv ?blqw))
                            )
                          (or (or (= ?brxy ?brxx)
                              (= ?brxy ?blqw)
                              )
                            (= ?brxx ?blqw)
                            )
                          )
                        (or (or (or (= ?brxw ?brxv)
                              (= ?brxw ?blqw)
                              )
                            (= ?brxv ?blqw)
                            )
                          (not (= ?brxy ?brxx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?brxz Real)
                  (declare-const ?brya Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?brxw ?brxv))
                              (not (= ?brxw ?blqw))
                              )
                            (not (= ?brxv ?blqw))
                            )
                          (or (or (= ?brya ?brxz)
                              (= ?brya ?blqw)
                              )
                            (= ?brxz ?blqw)
                            )
                          )
                        (or (or (or (= ?brxw ?brxv)
                              (= ?brxw ?blqw)
                              )
                            (= ?brxv ?blqw)
                            )
                          (not (= ?brya ?brxz))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?brxs Real) )(and (forall ((?bnyg Real) )(or (= ?brwy ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?brxs ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?brxs ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?brwy ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnyg Real) )(and (not (= ?brwz ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?brxs ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?brxs ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?brwz ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bryb Real)
            (declare-const ?bryc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryd Real)
            (declare-const ?brye Real)
            (declare-const ?bryf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryg Real)
            (declare-const ?bryh Real)
            (declare-const ?bryi Real)
            (declare-const ?bryj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bryl Real)
          (declare-const ?brym Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bryn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryo Real)
            (declare-const ?bryp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryq Real)
            (declare-const ?bryr Real)
            (declare-const ?brys Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryt Real)
            (declare-const ?bryu Real)
            (declare-const ?bryv Real)
            (declare-const ?bryw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bryx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bryy Real)
          (declare-const ?bryz Real)
          (declare-const ?brza Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brzb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brzc Real)
            (declare-const ?brzd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brze Real)
            (declare-const ?brzf Real)
            (declare-const ?brzg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brzh Real)
            (declare-const ?brzi Real)
            (declare-const ?brzj Real)
            (declare-const ?brzk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brzl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?brzm Real)
          (declare-const ?brzn Real)
          (declare-const ?brzo Real)
          (declare-const ?brzp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?brzq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brzr Real)
            (declare-const ?brzs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brzt Real)
            (declare-const ?brzu Real)
            (declare-const ?brzv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?brzw Real)
            (declare-const ?brzx Real)
            (declare-const ?brzy Real)
            (declare-const ?brzz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsaa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsab Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsac Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsad Real)
            (declare-const ?bsae Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsaf Real)
            (declare-const ?bsag Real)
            (declare-const ?bsah Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsai Real)
            (declare-const ?bsaj Real)
            (declare-const ?bsak Real)
            (declare-const ?bsal Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsam Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bsan Real)
      (declare-const ?bsao Real)
      (declare-const ?bsap Real)
      (assert
        (and (and (not (= ?bsap ?bsao))
            (not (= ?bsap ?bsan))
            )
          (not (= ?bsao ?bsan))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsaq Real)
        (declare-const ?bsar Real)
        (declare-const ?bsas Real)
        (assert
          (and (and (not (= ?bsas ?bsar))
              (not (= ?bsas ?bsaq))
              )
            (not (= ?bsar ?bsaq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsat Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsau Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsav Real)
            (declare-const ?bsaw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsax Real)
            (declare-const ?bsay Real)
            (declare-const ?bsaz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsba Real)
            (declare-const ?bsbb Real)
            (declare-const ?bsbc Real)
            (declare-const ?bsbd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsbe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsbf Real)
          (declare-const ?bsbg Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsbh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsbi Real)
            (declare-const ?bsbj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsbk Real)
            (declare-const ?bsbl Real)
            (declare-const ?bsbm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsbn Real)
            (declare-const ?bsbo Real)
            (declare-const ?bsbp Real)
            (declare-const ?bsbq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsbr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsbs Real)
          (declare-const ?bsbt Real)
          (declare-const ?bsbu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsbv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsbw Real)
            (declare-const ?bsbx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsby Real)
            (declare-const ?bsbz Real)
            (declare-const ?bsca Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bscb Real)
            (declare-const ?bscc Real)
            (declare-const ?bscd Real)
            (declare-const ?bsce Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bscf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bscg Real)
          (declare-const ?bsch Real)
          (declare-const ?bsci Real)
          (declare-const ?bscj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsck Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bscl Real)
            (declare-const ?bscm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bscn Real)
            (declare-const ?bsco Real)
            (declare-const ?bscp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bscq Real)
            (declare-const ?bscr Real)
            (declare-const ?bscs Real)
            (declare-const ?bsct Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (and (= ?bsci ?bsap)
                        (= ?bsch ?bsao)
                        )
                      (= ?bscg ?bsan)
                      )
                    (and (and (= ?bscs ?bsas)
                        (= ?bscr ?bsar)
                        )
                      (= ?bscq ?bsaq)
                      )
                    )
                  (= ?bscj ?bsct)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bscu Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bscv Real)
                (declare-const ?bscw Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bscx Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bscy Real)
                (declare-const ?bscz Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsda Real)
                  (declare-const ?bsdb Real)
                  (declare-const ?bsdc Real)
                  (assert
                    (or (or (= ?bsdc ?bsdb)
                        (= ?bsdc ?bsda)
                        )
                      (= ?bsdb ?bsda)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsdd Real)
                  (declare-const ?bsde Real)
                  (declare-const ?bsdf Real)
                  (assert
                    (or (or (= ?bsdf ?bsde)
                        (= ?bsdf ?bsdd)
                        )
                      (= ?bsde ?bsdd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsdg Real)
                  (declare-const ?bsdh Real)
                  (declare-const ?bsdi Real)
                  (assert
                    (and (and (not (= ?bsdi ?bsdh))
                        (not (= ?bsdi ?bsdg))
                        )
                      (not (= ?bsdh ?bsdg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsdj Real)
                  (declare-const ?bsdk Real)
                  (declare-const ?bsdl Real)
                  (assert
                    (and (and (not (= ?bsdl ?bsdk))
                        (not (= ?bsdl ?bsdj))
                        )
                      (not (= ?bsdk ?bsdj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsdm Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsdn Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsdn ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsdm ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsdm ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsdn ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsdo Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsdo ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsdm ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsdm ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsdo ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsdp Real)
                (declare-const ?bsdq Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsdr Real)
                  (declare-const ?bsds Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bsdq ?bsdp))
                              (not (= ?bsdq ?blqw))
                              )
                            (not (= ?bsdp ?blqw))
                            )
                          (or (or (= ?bsds ?bsdr)
                              (= ?bsds ?blqw)
                              )
                            (= ?bsdr ?blqw)
                            )
                          )
                        (or (or (or (= ?bsdq ?bsdp)
                              (= ?bsdq ?blqw)
                              )
                            (= ?bsdp ?blqw)
                            )
                          (not (= ?bsds ?bsdr))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsdt Real)
                  (declare-const ?bsdu Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bsdq ?bsdp))
                              (not (= ?bsdq ?blqw))
                              )
                            (not (= ?bsdp ?blqw))
                            )
                          (or (or (= ?bsdu ?bsdt)
                              (= ?bsdu ?blqw)
                              )
                            (= ?bsdt ?blqw)
                            )
                          )
                        (or (or (or (= ?bsdq ?bsdp)
                              (= ?bsdq ?blqw)
                              )
                            (= ?bsdp ?blqw)
                            )
                          (not (= ?bsdu ?bsdt))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bsdv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsdw Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsdx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsdy Real)
            (declare-const ?bsdz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsea Real)
            (declare-const ?bseb Real)
            (declare-const ?bsec Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsed Real)
            (declare-const ?bsee Real)
            (declare-const ?bsef Real)
            (declare-const ?bseg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bseh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsei Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsej Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsek Real)
            (declare-const ?bsel Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsem Real)
            (declare-const ?bsen Real)
            (declare-const ?bseo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsep Real)
            (declare-const ?bseq Real)
            (declare-const ?bser Real)
            (declare-const ?bses Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bset Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bseu Real)
          (declare-const ?bsev Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsew Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsex Real)
            (declare-const ?bsey Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsez Real)
            (declare-const ?bsfa Real)
            (declare-const ?bsfb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsfc Real)
            (declare-const ?bsfd Real)
            (declare-const ?bsfe Real)
            (declare-const ?bsff Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsfg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsfh Real)
          (declare-const ?bsfi Real)
          (declare-const ?bsfj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsfk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsfl Real)
            (declare-const ?bsfm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsfn Real)
            (declare-const ?bsfo Real)
            (declare-const ?bsfp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsfq Real)
            (declare-const ?bsfr Real)
            (declare-const ?bsfs Real)
            (declare-const ?bsft Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsfu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsfv Real)
          (declare-const ?bsfw Real)
          (declare-const ?bsfx Real)
          (declare-const ?bsfy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsfz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsga Real)
            (declare-const ?bsgb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsgc Real)
            (declare-const ?bsgd Real)
            (declare-const ?bsge Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsgf Real)
            (declare-const ?bsgg Real)
            (declare-const ?bsgh Real)
            (declare-const ?bsgi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsgj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bsfx ?bsap)
                      (= ?bsfw ?bsao)
                      )
                    (= ?bsfv ?bsan)
                    )
                  (= ?bsfy ?bsgj)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsgk Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsgl Real)
                (declare-const ?bsgm Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsgn Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsgo Real)
                (declare-const ?bsgp Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsgq Real)
                  (declare-const ?bsgr Real)
                  (declare-const ?bsgs Real)
                  (assert
                    (or (or (= ?bsgs ?bsgr)
                        (= ?bsgs ?bsgq)
                        )
                      (= ?bsgr ?bsgq)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsgt Real)
                  (declare-const ?bsgu Real)
                  (declare-const ?bsgv Real)
                  (assert
                    (or (or (= ?bsgv ?bsgu)
                        (= ?bsgv ?bsgt)
                        )
                      (= ?bsgu ?bsgt)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsgw Real)
                  (declare-const ?bsgx Real)
                  (declare-const ?bsgy Real)
                  (assert
                    (and (and (not (= ?bsgy ?bsgx))
                        (not (= ?bsgy ?bsgw))
                        )
                      (not (= ?bsgx ?bsgw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsgz Real)
                  (declare-const ?bsha Real)
                  (declare-const ?bshb Real)
                  (assert
                    (and (and (not (= ?bshb ?bsha))
                        (not (= ?bshb ?bsgz))
                        )
                      (not (= ?bsha ?bsgz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bshc Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bshd Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bshd ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bshc ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bshc ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bshd ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bshe Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bshe ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bshc ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bshc ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bshe ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bshf Real)
                (declare-const ?bshg Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bshh Real)
                  (declare-const ?bshi Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bshg ?bshf))
                              (not (= ?bshg ?blqw))
                              )
                            (not (= ?bshf ?blqw))
                            )
                          (or (or (= ?bshi ?bshh)
                              (= ?bshi ?blqw)
                              )
                            (= ?bshh ?blqw)
                            )
                          )
                        (or (or (or (= ?bshg ?bshf)
                              (= ?bshg ?blqw)
                              )
                            (= ?bshf ?blqw)
                            )
                          (not (= ?bshi ?bshh))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bshj Real)
                  (declare-const ?bshk Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bshg ?bshf))
                              (not (= ?bshg ?blqw))
                              )
                            (not (= ?bshf ?blqw))
                            )
                          (or (or (= ?bshk ?bshj)
                              (= ?bshk ?blqw)
                              )
                            (= ?bshj ?blqw)
                            )
                          )
                        (or (or (or (= ?bshg ?bshf)
                              (= ?bshg ?blqw)
                              )
                            (= ?bshf ?blqw)
                            )
                          (not (= ?bshk ?bshj))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bshl Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bshm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bshn Real)
            (declare-const ?bsho Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bshp Real)
            (declare-const ?bshq Real)
            (declare-const ?bshr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bshs Real)
            (declare-const ?bsht Real)
            (declare-const ?bshu Real)
            (declare-const ?bshv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bshw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bshx Real)
        (declare-const ?bshy Real)
        (declare-const ?bshz Real)
        (assert
          (and (and (not (= ?bshz ?bshy))
              (not (= ?bshz ?bshx))
              )
            (not (= ?bshy ?bshx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsia Real)
        (declare-const ?bsib Real)
        (declare-const ?bsic Real)
        (assert
          (and (and (not (= ?bsic ?bsib))
              (not (= ?bsic ?bsia))
              )
            (not (= ?bsib ?bsia))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsid Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsie Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsif Real)
            (declare-const ?bsig Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsih Real)
            (declare-const ?bsii Real)
            (declare-const ?bsij Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsik Real)
            (declare-const ?bsil Real)
            (declare-const ?bsim Real)
            (declare-const ?bsin Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsio Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsip Real)
          (declare-const ?bsiq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsir Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsis Real)
            (declare-const ?bsit Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsiu Real)
            (declare-const ?bsiv Real)
            (declare-const ?bsiw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsix Real)
            (declare-const ?bsiy Real)
            (declare-const ?bsiz Real)
            (declare-const ?bsja Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsjb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsjc Real)
          (declare-const ?bsjd Real)
          (declare-const ?bsje Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsjf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsjg Real)
            (declare-const ?bsjh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsji Real)
            (declare-const ?bsjj Real)
            (declare-const ?bsjk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsjl Real)
            (declare-const ?bsjm Real)
            (declare-const ?bsjn Real)
            (declare-const ?bsjo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsjp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsjq Real)
          (declare-const ?bsjr Real)
          (declare-const ?bsjs Real)
          (declare-const ?bsjt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsju Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsjv Real)
            (declare-const ?bsjw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsjx Real)
            (declare-const ?bsjy Real)
            (declare-const ?bsjz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bska Real)
            (declare-const ?bskb Real)
            (declare-const ?bskc Real)
            (declare-const ?bskd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bske Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bskf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bskg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bskh Real)
            (declare-const ?bski Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bskj Real)
            (declare-const ?bskk Real)
            (declare-const ?bskl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bskm Real)
            (declare-const ?bskn Real)
            (declare-const ?bsko Real)
            (declare-const ?bskp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bsko ?bsic)
                      (= ?bskn ?bsib)
                      )
                    (= ?bskm ?bsia)
                    )
                  (= ?bskf ?bskp)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bskq Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bskr Real)
                (declare-const ?bsks Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bskt Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsku Real)
                (declare-const ?bskv Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bskw Real)
                  (declare-const ?bskx Real)
                  (declare-const ?bsky Real)
                  (assert
                    (or (or (= ?bsky ?bskx)
                        (= ?bsky ?bskw)
                        )
                      (= ?bskx ?bskw)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bskz Real)
                  (declare-const ?bsla Real)
                  (declare-const ?bslb Real)
                  (assert
                    (or (or (= ?bslb ?bsla)
                        (= ?bslb ?bskz)
                        )
                      (= ?bsla ?bskz)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bslc Real)
                  (declare-const ?bsld Real)
                  (declare-const ?bsle Real)
                  (assert
                    (and (and (not (= ?bsle ?bsld))
                        (not (= ?bsle ?bslc))
                        )
                      (not (= ?bsld ?bslc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bslf Real)
                  (declare-const ?bslg Real)
                  (declare-const ?bslh Real)
                  (assert
                    (and (and (not (= ?bslh ?bslg))
                        (not (= ?bslh ?bslf))
                        )
                      (not (= ?bslg ?bslf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsli Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bslj Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bslj ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsli ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsli ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bslj ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bslk Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bslk ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsli ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsli ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bslk ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsll Real)
                (declare-const ?bslm Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsln Real)
                  (declare-const ?bslo Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bslm ?bsll))
                              (not (= ?bslm ?blqw))
                              )
                            (not (= ?bsll ?blqw))
                            )
                          (or (or (= ?bslo ?bsln)
                              (= ?bslo ?blqw)
                              )
                            (= ?bsln ?blqw)
                            )
                          )
                        (or (or (or (= ?bslm ?bsll)
                              (= ?bslm ?blqw)
                              )
                            (= ?bsll ?blqw)
                            )
                          (not (= ?bslo ?bsln))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bslp Real)
                  (declare-const ?bslq Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bslm ?bsll))
                              (not (= ?bslm ?blqw))
                              )
                            (not (= ?bsll ?blqw))
                            )
                          (or (or (= ?bslq ?bslp)
                              (= ?bslq ?blqw)
                              )
                            (= ?bslp ?blqw)
                            )
                          )
                        (or (or (or (= ?bslm ?bsll)
                              (= ?bslm ?blqw)
                              )
                            (= ?bsll ?blqw)
                            )
                          (not (= ?bslq ?bslp))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bslr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsls Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bslt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bslu Real)
            (declare-const ?bslv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bslw Real)
            (declare-const ?bslx Real)
            (declare-const ?bsly Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bslz Real)
            (declare-const ?bsma Real)
            (declare-const ?bsmb Real)
            (declare-const ?bsmc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsme Real)
          (declare-const ?bsmf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsmg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmh Real)
            (declare-const ?bsmi Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmj Real)
            (declare-const ?bsmk Real)
            (declare-const ?bsml Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmm Real)
            (declare-const ?bsmn Real)
            (declare-const ?bsmo Real)
            (declare-const ?bsmp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsmr Real)
          (declare-const ?bsms Real)
          (declare-const ?bsmt Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsmu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmv Real)
            (declare-const ?bsmw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsmx Real)
            (declare-const ?bsmy Real)
            (declare-const ?bsmz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsna Real)
            (declare-const ?bsnb Real)
            (declare-const ?bsnc Real)
            (declare-const ?bsnd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsne Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsnf Real)
          (declare-const ?bsng Real)
          (declare-const ?bsnh Real)
          (declare-const ?bsni Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsnj Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsnk Real)
            (declare-const ?bsnl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsnm Real)
            (declare-const ?bsnn Real)
            (declare-const ?bsno Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsnp Real)
            (declare-const ?bsnq Real)
            (declare-const ?bsnr Real)
            (declare-const ?bsns Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsnt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsnu Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsnv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsnw Real)
            (declare-const ?bsnx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsny Real)
            (declare-const ?bsnz Real)
            (declare-const ?bsoa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsob Real)
            (declare-const ?bsoc Real)
            (declare-const ?bsod Real)
            (declare-const ?bsoe Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsof Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (= ?bsnu ?bsof)
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsog Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsoh Real)
                (declare-const ?bsoi Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsoj Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsok Real)
                (declare-const ?bsol Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsom Real)
                  (declare-const ?bson Real)
                  (declare-const ?bsoo Real)
                  (assert
                    (or (or (= ?bsoo ?bson)
                        (= ?bsoo ?bsom)
                        )
                      (= ?bson ?bsom)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsop Real)
                  (declare-const ?bsoq Real)
                  (declare-const ?bsor Real)
                  (assert
                    (or (or (= ?bsor ?bsoq)
                        (= ?bsor ?bsop)
                        )
                      (= ?bsoq ?bsop)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsos Real)
                  (declare-const ?bsot Real)
                  (declare-const ?bsou Real)
                  (assert
                    (and (and (not (= ?bsou ?bsot))
                        (not (= ?bsou ?bsos))
                        )
                      (not (= ?bsot ?bsos))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsov Real)
                  (declare-const ?bsow Real)
                  (declare-const ?bsox Real)
                  (assert
                    (and (and (not (= ?bsox ?bsow))
                        (not (= ?bsox ?bsov))
                        )
                      (not (= ?bsow ?bsov))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsoy Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsoz Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsoz ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsoy ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsoy ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsoz ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bspa Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bspa ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsoy ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsoy ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bspa ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bspb Real)
                (declare-const ?bspc Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bspd Real)
                  (declare-const ?bspe Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bspc ?bspb))
                              (not (= ?bspc ?blqw))
                              )
                            (not (= ?bspb ?blqw))
                            )
                          (or (or (= ?bspe ?bspd)
                              (= ?bspe ?blqw)
                              )
                            (= ?bspd ?blqw)
                            )
                          )
                        (or (or (or (= ?bspc ?bspb)
                              (= ?bspc ?blqw)
                              )
                            (= ?bspb ?blqw)
                            )
                          (not (= ?bspe ?bspd))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bspf Real)
                  (declare-const ?bspg Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bspc ?bspb))
                              (not (= ?bspc ?blqw))
                              )
                            (not (= ?bspb ?blqw))
                            )
                          (or (or (= ?bspg ?bspf)
                              (= ?bspg ?blqw)
                              )
                            (= ?bspf ?blqw)
                            )
                          )
                        (or (or (or (= ?bspc ?bspb)
                              (= ?bspc ?blqw)
                              )
                            (= ?bspb ?blqw)
                            )
                          (not (= ?bspg ?bspf))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bsph Real)
        (declare-const ?bspi Real)
        (declare-const ?bspj Real)
        (assert
          (and (and (not (= ?bspj ?bspi))
              (not (= ?bspj ?bsph))
              )
            (not (= ?bspi ?bsph))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bspk Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bspl Real)
      (assert
        (forall ((?bnyg Real) )(or (= ?bspl ?bnyg)
            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bspk ?bnyg))
                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                          (= ?bnza ?blqw)
                          )
                        (= ?bnyz ?blqw)
                        )
                      (and (not (= ?bspk ?blqw))
                        (not (= ?bnyg ?blqw))
                        )
                      )
                    )
                  )
                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                        (not (= ?bnza ?blqw))
                        )
                      (not (= ?bnyz ?blqw))
                      )
                    (or (= ?bspl ?blqw)
                      (= ?bnyg ?blqw)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bspm Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bspm ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bspk ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bspk ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bspm ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bspn Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bspo Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bspp Real)
            (declare-const ?bspq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bspr Real)
            (declare-const ?bsps Real)
            (declare-const ?bspt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bspu Real)
            (declare-const ?bspv Real)
            (declare-const ?bspw Real)
            (declare-const ?bspx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bspy Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bspz Real)
          (declare-const ?bsqa Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsqb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsqc Real)
            (declare-const ?bsqd Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (= ?bspz ?bspl)
                    (= ?bsqc ?bspm)
                    )
                  (= ?bsqa ?bsqd)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsqe Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsqf Real)
                (declare-const ?bsqg Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsqh Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsqi Real)
                (declare-const ?bsqj Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsqk Real)
                  (declare-const ?bsql Real)
                  (declare-const ?bsqm Real)
                  (assert
                    (or (or (= ?bsqm ?bsql)
                        (= ?bsqm ?bsqk)
                        )
                      (= ?bsql ?bsqk)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsqn Real)
                  (declare-const ?bsqo Real)
                  (declare-const ?bsqp Real)
                  (assert
                    (or (or (= ?bsqp ?bsqo)
                        (= ?bsqp ?bsqn)
                        )
                      (= ?bsqo ?bsqn)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsqq Real)
                  (declare-const ?bsqr Real)
                  (declare-const ?bsqs Real)
                  (assert
                    (and (and (not (= ?bsqs ?bsqr))
                        (not (= ?bsqs ?bsqq))
                        )
                      (not (= ?bsqr ?bsqq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsqt Real)
                  (declare-const ?bsqu Real)
                  (declare-const ?bsqv Real)
                  (assert
                    (and (and (not (= ?bsqv ?bsqu))
                        (not (= ?bsqv ?bsqt))
                        )
                      (not (= ?bsqu ?bsqt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsqw Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsqx Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsqx ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsqw ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsqw ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsqx ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsqy Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsqy ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsqw ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsqw ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsqy ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsqz Real)
                (declare-const ?bsra Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsrb Real)
                  (declare-const ?bsrc Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bsra ?bsqz))
                              (not (= ?bsra ?blqw))
                              )
                            (not (= ?bsqz ?blqw))
                            )
                          (or (or (= ?bsrc ?bsrb)
                              (= ?bsrc ?blqw)
                              )
                            (= ?bsrb ?blqw)
                            )
                          )
                        (or (or (or (= ?bsra ?bsqz)
                              (= ?bsra ?blqw)
                              )
                            (= ?bsqz ?blqw)
                            )
                          (not (= ?bsrc ?bsrb))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsrd Real)
                  (declare-const ?bsre Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bsra ?bsqz))
                              (not (= ?bsra ?blqw))
                              )
                            (not (= ?bsqz ?blqw))
                            )
                          (or (or (= ?bsre ?bsrd)
                              (= ?bsre ?blqw)
                              )
                            (= ?bsrd ?blqw)
                            )
                          )
                        (or (or (or (= ?bsra ?bsqz)
                              (= ?bsra ?blqw)
                              )
                            (= ?bsqz ?blqw)
                            )
                          (not (= ?bsre ?bsrd))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (exists ((?bsqz Real) (?bsra Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bsra ?bsqz))
                                (not (= ?bsra ?blqw))
                                )
                              (not (= ?bsqz ?blqw))
                              )
                            (or (or (= ?bspz ?bsqa)
                                (= ?bspz ?blqw)
                                )
                              (= ?bsqa ?blqw)
                              )
                            )
                          (or (or (or (= ?bsra ?bsqz)
                                (= ?bsra ?blqw)
                                )
                              (= ?bsqz ?blqw)
                              )
                            (not (= ?bspz ?bsqa))
                            )
                          )
                        )
                      (exists ((?blqw Real) )(or (and (or (or (= ?bsra ?bsqz)
                                (= ?bsra ?blqw)
                                )
                              (= ?bsqz ?blqw)
                              )
                            (and (and (not (= ?bsqc ?bsqd))
                                (not (= ?bsqc ?blqw))
                                )
                              (not (= ?bsqd ?blqw))
                              )
                            )
                          (and (and (and (not (= ?bsra ?bsqz))
                                (not (= ?bsra ?blqw))
                                )
                              (not (= ?bsqz ?blqw))
                              )
                            (= ?bsqc ?bsqd)
                            )
                          )
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bsrf Real)
            (declare-const ?bsrg Real)
            (declare-const ?bsrh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsri Real)
            (declare-const ?bsrj Real)
            (declare-const ?bsrk Real)
            (declare-const ?bsrl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsrm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsrn Real)
          (declare-const ?bsro Real)
          (declare-const ?bsrp Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsrq Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsrr Real)
            (declare-const ?bsrs Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsrt Real)
            (declare-const ?bsru Real)
            (declare-const ?bsrv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsrw Real)
            (declare-const ?bsrx Real)
            (declare-const ?bsry Real)
            (declare-const ?bsrz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssa Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bssb Real)
          (declare-const ?bssc Real)
          (declare-const ?bssd Real)
          (declare-const ?bsse Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bssf Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssg Real)
            (declare-const ?bssh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssi Real)
            (declare-const ?bssj Real)
            (declare-const ?bssk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssl Real)
            (declare-const ?bssm Real)
            (declare-const ?bssn Real)
            (declare-const ?bsso Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bssq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bssr Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsss Real)
            (declare-const ?bsst Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssu Real)
            (declare-const ?bssv Real)
            (declare-const ?bssw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bssx Real)
            (declare-const ?bssy Real)
            (declare-const ?bssz Real)
            (declare-const ?bsta Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bstb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bstc Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bstc ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bspk ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bspk ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bstc ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bstd Real)
    (declare-const ?bste Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bstf Real)
      (declare-const ?bstg Real)
      (assert
        (forall ((?blqw Real) )(and (or (and (and (not (= ?bste ?bstd))
                  (not (= ?bste ?blqw))
                  )
                (not (= ?bstd ?blqw))
                )
              (or (or (= ?bstg ?bstf)
                  (= ?bstg ?blqw)
                  )
                (= ?bstf ?blqw)
                )
              )
            (or (or (or (= ?bste ?bstd)
                  (= ?bste ?blqw)
                  )
                (= ?bstd ?blqw)
                )
              (not (= ?bstg ?bstf))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsth Real)
        (declare-const ?bsti Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bste ?bstd))
                    (not (= ?bste ?blqw))
                    )
                  (not (= ?bstd ?blqw))
                  )
                (or (or (= ?bsti ?bsth)
                    (= ?bsti ?blqw)
                    )
                  (= ?bsth ?blqw)
                  )
                )
              (or (or (or (= ?bste ?bstd)
                    (= ?bste ?blqw)
                    )
                  (= ?bstd ?blqw)
                  )
                (not (= ?bsti ?bsth))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bstj Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bstk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bstl Real)
            (declare-const ?bstm Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bstn Real)
            (declare-const ?bsto Real)
            (declare-const ?bstp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bstq Real)
            (declare-const ?bstr Real)
            (declare-const ?bsts Real)
            (declare-const ?bstt Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bstu Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bstv Real)
          (declare-const ?bstw Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bstx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsty Real)
            (declare-const ?bstz Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsua Real)
            (declare-const ?bsub Real)
            (declare-const ?bsuc Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsud Real)
            (declare-const ?bsue Real)
            (declare-const ?bsuf Real)
            (declare-const ?bsug Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsuh Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsui Real)
          (declare-const ?bsuj Real)
          (declare-const ?bsuk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bsul Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsum Real)
            (declare-const ?bsun Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsuo Real)
            (declare-const ?bsup Real)
            (declare-const ?bsuq Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (assert
                (and (and (and (= ?bsuj ?bstg)
                      (= ?bsui ?bstf)
                      )
                    (and (= ?bsup ?bsti)
                      (= ?bsuo ?bsth)
                      )
                    )
                  (= ?bsuk ?bsuq)
                  )
                )
(set-info :status unknown)
              (check-sat)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsur Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsus Real)
                (declare-const ?bsut Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsuu Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
                (declare-const ?bsuv Real)
                (declare-const ?bsuw Real)
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsux Real)
                  (declare-const ?bsuy Real)
                  (declare-const ?bsuz Real)
                  (assert
                    (or (or (= ?bsuz ?bsuy)
                        (= ?bsuz ?bsux)
                        )
                      (= ?bsuy ?bsux)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsva Real)
                  (declare-const ?bsvb Real)
                  (declare-const ?bsvc Real)
                  (assert
                    (or (or (= ?bsvc ?bsvb)
                        (= ?bsvc ?bsva)
                        )
                      (= ?bsvb ?bsva)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsvd Real)
                  (declare-const ?bsve Real)
                  (declare-const ?bsvf Real)
                  (assert
                    (and (and (not (= ?bsvf ?bsve))
                        (not (= ?bsvf ?bsvd))
                        )
                      (not (= ?bsve ?bsvd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsvg Real)
                  (declare-const ?bsvh Real)
                  (declare-const ?bsvi Real)
                  (assert
                    (and (and (not (= ?bsvi ?bsvh))
                        (not (= ?bsvi ?bsvg))
                        )
                      (not (= ?bsvh ?bsvg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsvj Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsvk Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsvk ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsvj ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsvj ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsvk ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsvl Real)
                  (assert
                    (forall ((?bnyg Real) )(or (= ?bsvl ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bsvj ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bsvj ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bsvl ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (declare-const ?bsvm Real)
                (declare-const ?bsvn Real)
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?bsvo Real)
                  (declare-const ?bsvp Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bsvn ?bsvm))
                              (not (= ?bsvn ?blqw))
                              )
                            (not (= ?bsvm ?blqw))
                            )
                          (or (or (= ?bsvp ?bsvo)
                              (= ?bsvp ?blqw)
                              )
                            (= ?bsvo ?blqw)
                            )
                          )
                        (or (or (or (= ?bsvn ?bsvm)
                              (= ?bsvn ?blqw)
                              )
                            (= ?bsvm ?blqw)
                            )
                          (not (= ?bsvp ?bsvo))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bsvq Real)
                  (declare-const ?bsvr Real)
                  (assert
                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bsvn ?bsvm))
                              (not (= ?bsvn ?blqw))
                              )
                            (not (= ?bsvm ?blqw))
                            )
                          (or (or (= ?bsvr ?bsvq)
                              (= ?bsvr ?blqw)
                              )
                            (= ?bsvq ?blqw)
                            )
                          )
                        (or (or (or (= ?bsvn ?bsvm)
                              (= ?bsvn ?blqw)
                              )
                            (= ?bsvm ?blqw)
                            )
                          (not (= ?bsvr ?bsvq))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (push 1)
                (assert
                  (or (and (or (or (= ?bsuj ?bsui)
                          (= ?bsuj ?bsuk)
                          )
                        (= ?bsui ?bsuk)
                        )
                      (and (and (not (= ?bsup ?bsuo))
                          (not (= ?bsup ?bsuq))
                          )
                        (not (= ?bsuo ?bsuq))
                        )
                      )
                    (and (and (and (not (= ?bsuj ?bsui))
                          (not (= ?bsuj ?bsuk))
                          )
                        (not (= ?bsui ?bsuk))
                        )
                      (or (or (= ?bsup ?bsuo)
                          (= ?bsup ?bsuq)
                          )
                        (= ?bsuo ?bsuq)
                        )
                      )
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bsvs Real)
            (declare-const ?bsvt Real)
            (declare-const ?bsvu Real)
            (declare-const ?bsvv Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bsvw Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bsvx Real)
          (declare-const ?bsvy Real)
          (declare-const ?bsvz Real)
          (declare-const ?bswa Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bswb Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswc Real)
            (declare-const ?bswd Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswe Real)
            (declare-const ?bswf Real)
            (declare-const ?bswg Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswh Real)
            (declare-const ?bswi Real)
            (declare-const ?bswj Real)
            (declare-const ?bswk Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswl Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
          (declare-const ?bswm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bswn Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswo Real)
            (declare-const ?bswp Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswq Real)
            (declare-const ?bswr Real)
            (declare-const ?bsws Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswt Real)
            (declare-const ?bswu Real)
            (declare-const ?bswv Real)
            (declare-const ?bsww Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bswx Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bswy Real)
        (declare-const ?bswz Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?bste ?bstd))
                    (not (= ?bste ?blqw))
                    )
                  (not (= ?bstd ?blqw))
                  )
                (or (or (= ?bswz ?bswy)
                    (= ?bswz ?blqw)
                    )
                  (= ?bswy ?blqw)
                  )
                )
              (or (or (or (= ?bste ?bstd)
                    (= ?bste ?blqw)
                    )
                  (= ?bstd ?blqw)
                  )
                (not (= ?bswz ?bswy))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bsxa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bsxb Real)
    (declare-const ?bsxc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsxd Real)
        (declare-const ?bsxe Real)
        (declare-const ?bsxf Real)
        (assert
          (or (or (= ?bsxf ?bsxe)
              (= ?bsxf ?bsxd)
              )
            (= ?bsxe ?bsxd)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsxg Real)
          (declare-const ?bsxh Real)
          (declare-const ?bsxi Real)
          (assert
            (or (or (= ?bsxi ?bsxh)
                (= ?bsxi ?bsxg)
                )
              (= ?bsxh ?bsxg)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsxj Real)
        (declare-const ?bsxk Real)
        (declare-const ?bsxl Real)
        (assert
          (or (or (= ?bsxl ?bsxk)
              (= ?bsxl ?bsxj)
              )
            (= ?bsxk ?bsxj)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsxm Real)
          (declare-const ?bsxn Real)
          (declare-const ?bsxo Real)
          (assert
            (and (and (not (= ?bsxo ?bsxn))
                (not (= ?bsxo ?bsxm))
                )
              (not (= ?bsxn ?bsxm))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bsxp Real)
        (declare-const ?bsxq Real)
        (declare-const ?bsxr Real)
        (assert
          (and (and (not (= ?bsxr ?bsxq))
              (not (= ?bsxr ?bsxp))
              )
            (not (= ?bsxq ?bsxp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsxs Real)
          (declare-const ?bsxt Real)
          (declare-const ?bsxu Real)
          (assert
            (or (or (= ?bsxu ?bsxt)
                (= ?bsxu ?bsxs)
                )
              (= ?bsxt ?bsxs)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsxv Real)
          (declare-const ?bsxw Real)
          (declare-const ?bsxx Real)
          (assert
            (or (or (= ?bsxx ?bsxw)
                (= ?bsxx ?bsxv)
                )
              (= ?bsxw ?bsxv)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsxy Real)
          (declare-const ?bsxz Real)
          (declare-const ?bsya Real)
          (assert
            (and (and (not (= ?bsya ?bsxz))
                (not (= ?bsya ?bsxy))
                )
              (not (= ?bsxz ?bsxy))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bsyb Real)
        (declare-const ?bsyc Real)
        (declare-const ?bsyd Real)
        (assert
          (and (and (not (= ?bsyd ?bsyc))
              (not (= ?bsyd ?bsyb))
              )
            (not (= ?bsyc ?bsyb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsye Real)
        (declare-const ?bsyf Real)
        (declare-const ?bsyg Real)
        (assert
          (or (or (= ?bsyg ?bsyf)
              (= ?bsyg ?bsye)
              )
            (= ?bsyf ?bsye)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsyh Real)
          (declare-const ?bsyi Real)
          (declare-const ?bsyj Real)
          (assert
            (and (and (not (= ?bsyj ?bsyi))
                (not (= ?bsyj ?bsyh))
                )
              (not (= ?bsyi ?bsyh))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bsyk Real)
        (declare-const ?bsyl Real)
        (declare-const ?bsym Real)
        (assert
          (and (and (not (= ?bsym ?bsyl))
              (not (= ?bsym ?bsyk))
              )
            (not (= ?bsyl ?bsyk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsyn Real)
          (declare-const ?bsyo Real)
          (declare-const ?bsyp Real)
          (assert
            (or (or (= ?bsyp ?bsyo)
                (= ?bsyp ?bsyn)
                )
              (= ?bsyo ?bsyn)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsyq Real)
          (declare-const ?bsyr Real)
          (declare-const ?bsys Real)
          (assert
            (or (or (= ?bsys ?bsyr)
                (= ?bsys ?bsyq)
                )
              (= ?bsyr ?bsyq)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bsyt Real)
          (declare-const ?bsyu Real)
          (declare-const ?bsyv Real)
          (assert
            (and (and (not (= ?bsyv ?bsyu))
                (not (= ?bsyv ?bsyt))
                )
              (not (= ?bsyu ?bsyt))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bsyw Real)
        (declare-const ?bsyx Real)
        (declare-const ?bsyy Real)
        (assert
          (and (and (not (= ?bsyy ?bsyx))
              (not (= ?bsyy ?bsyw))
              )
            (not (= ?bsyx ?bsyw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bsyz Real)
        (declare-const ?bsza Real)
        (declare-const ?bszb Real)
        (assert
          (and (and (not (= ?bszb ?bsza))
              (not (= ?bszb ?bsyz))
              )
            (not (= ?bsza ?bsyz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bszc Real)
          (declare-const ?bszd Real)
          (declare-const ?bsze Real)
          (assert
            (and (and (not (= ?bsze ?bszd))
                (not (= ?bsze ?bszc))
                )
              (not (= ?bszd ?bszc))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bszf Real)
          (declare-const ?bszg Real)
          (declare-const ?bszh Real)
          (assert
            (and (and (not (= ?bszh ?bszg))
                (not (= ?bszh ?bszf))
                )
              (not (= ?bszg ?bszf))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bszi Real)
        (declare-const ?bszj Real)
        (declare-const ?bszk Real)
        (assert
          (and (and (not (= ?bszk ?bszj))
              (not (= ?bszk ?bszi))
              )
            (not (= ?bszj ?bszi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bszl Real)
          (declare-const ?bszm Real)
          (declare-const ?bszn Real)
          (assert
            (and (and (not (= ?bszn ?bszm))
                (not (= ?bszn ?bszl))
                )
              (not (= ?bszm ?bszl))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bszo Real)
          (declare-const ?bszp Real)
          (declare-const ?bszq Real)
          (assert
            (and (and (not (= ?bszq ?bszp))
                (not (= ?bszq ?bszo))
                )
              (not (= ?bszp ?bszo))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bszj Real) (?bszi Real) )(and (not (= ?bszj ?bszi))
              (exists ((?bszk Real) )(and (not (= ?bszk ?bszj))
                  (and (not (= ?bszk ?bszi))
                    (or (or (= ?bszk ?bszj)
                        (= ?bszk ?bszi)
                        )
                      (= ?bszj ?bszi)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bsza Real) (?bsyz Real) )(and (not (= ?bsza ?bsyz))
              (exists ((?bszb Real) )(and (not (= ?bszb ?bsza))
                  (and (not (= ?bszb ?bsyz))
                    (or (or (= ?bszb ?bsza)
                        (= ?bszb ?bsyz)
                        )
                      (= ?bsza ?bsyz)
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bszr Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bszs Real)
        (declare-const ?bszt Real)
        (declare-const ?bszu Real)
        (assert
          (or (or (= ?bszu ?bszt)
              (= ?bszu ?bszs)
              )
            (= ?bszt ?bszs)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bszv Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?bszv ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bszr ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bszv ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bszw Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?bszw ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bszr ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?bszw ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bszx Real)
          (declare-const ?bszy Real)
          (declare-const ?bszz Real)
          (assert
            (or (or (= ?bszz ?bszy)
                (= ?bszz ?bszx)
                )
              (= ?bszy ?bszx)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btaa Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?btaa ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bszr ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?btaa ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?btab Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?btab ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bszr ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?btab ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?btac Real)
        (declare-const ?btad Real)
        (declare-const ?btae Real)
        (assert
          (and (and (not (= ?btae ?btad))
              (not (= ?btae ?btac))
              )
            (not (= ?btad ?btac))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btaf Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?btaf ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bszr ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?btaf ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btag Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?btag ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bszr ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?btag ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?btah Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?btah ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?bszr ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?btah ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btai Real)
          (declare-const ?btaj Real)
          (declare-const ?btak Real)
          (assert
            (and (and (not (= ?btak ?btaj))
                (not (= ?btak ?btai))
                )
              (not (= ?btaj ?btai))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?bszw Real) )(forall ((?bnyg Real) )(or (= ?bszw ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bszr ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?bszr ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?bszw ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bszt Real) (?bszs Real) )(or (= ?bszt ?bszs)
              (exists ((?bszu Real) )(or (= ?bszu ?bszt)
                  (= ?bszu ?bszs)
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?btal Real)
    (declare-const ?btam Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?btan Real)
        (declare-const ?btao Real)
        (declare-const ?btap Real)
        (assert
          (or (or (= ?btap ?btao)
              (= ?btap ?btan)
              )
            (= ?btao ?btan)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btaq Real)
          (declare-const ?btar Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                      (not (= ?btam ?blqw))
                      )
                    (not (= ?btal ?blqw))
                    )
                  (or (or (= ?btar ?btaq)
                      (= ?btar ?blqw)
                      )
                    (= ?btaq ?blqw)
                    )
                  )
                (or (or (or (= ?btam ?btal)
                      (= ?btam ?blqw)
                      )
                    (= ?btal ?blqw)
                    )
                  (not (= ?btar ?btaq))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?btas Real)
        (declare-const ?btat Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                    (not (= ?btam ?blqw))
                    )
                  (not (= ?btal ?blqw))
                  )
                (or (or (= ?btat ?btas)
                    (= ?btat ?blqw)
                    )
                  (= ?btas ?blqw)
                  )
                )
              (or (or (or (= ?btam ?btal)
                    (= ?btam ?blqw)
                    )
                  (= ?btal ?blqw)
                  )
                (not (= ?btat ?btas))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btau Real)
          (declare-const ?btav Real)
          (declare-const ?btaw Real)
          (assert
            (or (or (= ?btaw ?btav)
                (= ?btaw ?btau)
                )
              (= ?btav ?btau)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btax Real)
          (declare-const ?btay Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                      (not (= ?btam ?blqw))
                      )
                    (not (= ?btal ?blqw))
                    )
                  (or (or (= ?btay ?btax)
                      (= ?btay ?blqw)
                      )
                    (= ?btax ?blqw)
                    )
                  )
                (or (or (or (= ?btam ?btal)
                      (= ?btam ?blqw)
                      )
                    (= ?btal ?blqw)
                    )
                  (not (= ?btay ?btax))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?btaz Real)
        (declare-const ?btba Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                    (not (= ?btam ?blqw))
                    )
                  (not (= ?btal ?blqw))
                  )
                (or (or (= ?btba ?btaz)
                    (= ?btba ?blqw)
                    )
                  (= ?btaz ?blqw)
                  )
                )
              (or (or (or (= ?btam ?btal)
                    (= ?btam ?blqw)
                    )
                  (= ?btal ?blqw)
                  )
                (not (= ?btba ?btaz))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?btbb Real)
        (declare-const ?btbc Real)
        (declare-const ?btbd Real)
        (assert
          (and (and (not (= ?btbd ?btbc))
              (not (= ?btbd ?btbb))
              )
            (not (= ?btbc ?btbb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btbe Real)
          (declare-const ?btbf Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                      (not (= ?btam ?blqw))
                      )
                    (not (= ?btal ?blqw))
                    )
                  (or (or (= ?btbf ?btbe)
                      (= ?btbf ?blqw)
                      )
                    (= ?btbe ?blqw)
                    )
                  )
                (or (or (or (= ?btam ?btal)
                      (= ?btam ?blqw)
                      )
                    (= ?btal ?blqw)
                    )
                  (not (= ?btbf ?btbe))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btbg Real)
          (declare-const ?btbh Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                      (not (= ?btam ?blqw))
                      )
                    (not (= ?btal ?blqw))
                    )
                  (or (or (= ?btbh ?btbg)
                      (= ?btbh ?blqw)
                      )
                    (= ?btbg ?blqw)
                    )
                  )
                (or (or (or (= ?btam ?btal)
                      (= ?btam ?blqw)
                      )
                    (= ?btal ?blqw)
                    )
                  (not (= ?btbh ?btbg))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?btbi Real)
        (declare-const ?btbj Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                    (not (= ?btam ?blqw))
                    )
                  (not (= ?btal ?blqw))
                  )
                (or (or (= ?btbj ?btbi)
                    (= ?btbj ?blqw)
                    )
                  (= ?btbi ?blqw)
                  )
                )
              (or (or (or (= ?btam ?btal)
                    (= ?btam ?blqw)
                    )
                  (= ?btal ?blqw)
                  )
                (not (= ?btbj ?btbi))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btbk Real)
          (declare-const ?btbl Real)
          (declare-const ?btbm Real)
          (assert
            (and (and (not (= ?btbm ?btbl))
                (not (= ?btbm ?btbk))
                )
              (not (= ?btbl ?btbk))
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?btbn Real)
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?btbo Real)
        (assert
          (forall ((?bnyg Real) )(or (= ?btbo ?bnyg)
              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?btbn ?bnyg))
                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                            (= ?bnza ?blqw)
                            )
                          (= ?bnyz ?blqw)
                          )
                        (and (not (= ?btbn ?blqw))
                          (not (= ?bnyg ?blqw))
                          )
                        )
                      )
                    )
                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                          (not (= ?bnza ?blqw))
                          )
                        (not (= ?bnyz ?blqw))
                        )
                      (or (= ?btbo ?blqw)
                        (= ?bnyg ?blqw)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btbp Real)
          (declare-const ?btbq Real)
          (assert
            (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                      (not (= ?btam ?blqw))
                      )
                    (not (= ?btal ?blqw))
                    )
                  (or (or (= ?btbq ?btbp)
                      (= ?btbq ?blqw)
                      )
                    (= ?btbp ?blqw)
                    )
                  )
                (or (or (or (= ?btam ?btal)
                      (= ?btam ?blqw)
                      )
                    (= ?btal ?blqw)
                    )
                  (not (= ?btbq ?btbp))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?btbr Real)
        (declare-const ?btbs Real)
        (assert
          (forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                    (not (= ?btam ?blqw))
                    )
                  (not (= ?btal ?blqw))
                  )
                (or (or (= ?btbs ?btbr)
                    (= ?btbs ?blqw)
                    )
                  (= ?btbr ?blqw)
                  )
                )
              (or (or (or (= ?btam ?btal)
                    (= ?btam ?blqw)
                    )
                  (= ?btal ?blqw)
                  )
                (not (= ?btbs ?btbr))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?btbt Real)
          (assert
            (forall ((?bnyg Real) )(or (= ?btbt ?bnyg)
                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?btbn ?bnyg))
                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                              (= ?bnza ?blqw)
                              )
                            (= ?bnyz ?blqw)
                            )
                          (and (not (= ?btbn ?blqw))
                            (not (= ?bnyg ?blqw))
                            )
                          )
                        )
                      )
                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                            (not (= ?bnza ?blqw))
                            )
                          (not (= ?bnyz ?blqw))
                          )
                        (or (= ?btbt ?blqw)
                          (= ?bnyg ?blqw)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (or (exists ((?btas Real) (?btat Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                        (not (= ?btam ?blqw))
                        )
                      (not (= ?btal ?blqw))
                      )
                    (or (or (= ?btat ?btas)
                        (= ?btat ?blqw)
                        )
                      (= ?btas ?blqw)
                      )
                    )
                  (or (or (or (= ?btam ?btal)
                        (= ?btam ?blqw)
                        )
                      (= ?btal ?blqw)
                      )
                    (not (= ?btat ?btas))
                    )
                  )
                )
              )
            (exists ((?btao Real) (?btan Real) )(or (= ?btao ?btan)
                (exists ((?btap Real) )(or (= ?btap ?btao)
                    (= ?btap ?btan)
                    )
                  )
                )
              )
            )
          (or (exists ((?btbr Real) (?btbs Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?btam ?btal))
                        (not (= ?btam ?blqw))
                        )
                      (not (= ?btal ?blqw))
                      )
                    (or (or (= ?btbs ?btbr)
                        (= ?btbs ?blqw)
                        )
                      (= ?btbr ?blqw)
                      )
                    )
                  (or (or (or (= ?btam ?btal)
                        (= ?btam ?blqw)
                        )
                      (= ?btal ?blqw)
                      )
                    (not (= ?btbs ?btbr))
                    )
                  )
                )
              )
            (forall ((?btbn Real) )(exists ((?btbo Real) )(forall ((?bnyg Real) )(or (= ?btbo ?bnyg)
                    (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?btbn ?bnyg))
                          (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                  (= ?bnza ?blqw)
                                  )
                                (= ?bnyz ?blqw)
                                )
                              (and (not (= ?btbn ?blqw))
                                (not (= ?bnyg ?blqw))
                                )
                              )
                            )
                          )
                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                (not (= ?bnza ?blqw))
                                )
                              (not (= ?bnyz ?blqw))
                              )
                            (or (= ?btbo ?blqw)
                              (= ?bnyg ?blqw)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?btbu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?btbv Real)
    (declare-const ?btbw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                        (forall ((?boig Real) )(or (= ?boig ?boif)
                            (= ?boig ?boie)
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bofe))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bofe ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (= ?bnuc ?bofe)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bocc))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bocc ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (= ?bnuc ?bocc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                  (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                      (= ?bobe ?bobc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnyg))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnuc ?bnyg)
                                              )
                                            )
                                          )
                                        (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnxp ?bnyg)
                                                  (= ?bnxp ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnxp ?bnyg))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnuq))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnuq ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (= ?bnuc ?bnuq)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                    (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                        (not (= ?bqki ?bqkg))
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (not (= ?bqhv ?blqw))
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqgr ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                  (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (not (= ?bqef ?blqw))
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqdm ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                              (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                  (not (= ?bqdb ?bqcz))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                          (exists ((?boig Real) )(and (not (= ?boig ?boif))
                              (not (= ?boig ?boie))
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bofe)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bofe ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (not (= ?bnuc ?bofe))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bocc)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bocc ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (not (= ?bnuc ?bocc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                    (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                        (not (= ?bobe ?bobc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnyg)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnyg))
                                                )
                                              )
                                            )
                                          (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnxp ?bnyg))
                                                    (not (= ?bnxp ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnxp ?bnyg)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnuq)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnuq ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnuq))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                  (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                      (not (= ?bqki ?bqkg))
                      )
                    )
                  )
                )
              )
            (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                    (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                        (= ?bqki ?bqkg)
                        )
                      )
                    )
                  )
                )
              (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqhv ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bqgr ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                            (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqhv ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqgr ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqef ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (= ?bqdm ?blqw)
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                            (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                (not (= ?bqdb ?bqcz))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                  (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (= ?bqef ?blqw)
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqdm ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                              (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                  (= ?bqdb ?bqcz)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                        (forall ((?boig Real) )(or (= ?boig ?boif)
                            (= ?boig ?boie)
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bofe))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bofe ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (= ?bnuc ?bofe)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bocc))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bocc ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (= ?bnuc ?bocc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                  (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                      (= ?bobe ?bobc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnyg))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnuc ?bnyg)
                                              )
                                            )
                                          )
                                        (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnxp ?bnyg)
                                                  (= ?bnxp ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnxp ?bnyg))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnuq))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnuq ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (= ?bnuc ?bnuq)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                    (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                        (not (= ?bqki ?bqkg))
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (not (= ?bqhv ?blqw))
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqgr ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                  (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (not (= ?bqef ?blqw))
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqdm ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                              (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                  (not (= ?bqdb ?bqcz))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                          (exists ((?boig Real) )(and (not (= ?boig ?boif))
                              (not (= ?boig ?boie))
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bofe)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bofe ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (not (= ?bnuc ?bofe))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bocc)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bocc ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (not (= ?bnuc ?bocc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                    (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                        (not (= ?bobe ?bobc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnyg)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnyg))
                                                )
                                              )
                                            )
                                          (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnxp ?bnyg))
                                                    (not (= ?bnxp ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnxp ?bnyg)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnuq)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnuq ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnuq))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                  (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                      (not (= ?bqki ?bqkg))
                      )
                    )
                  )
                )
              )
            (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                    (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                        (= ?bqki ?bqkg)
                        )
                      )
                    )
                  )
                )
              (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqhv ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bqgr ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                            (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqhv ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqgr ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqef ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (= ?bqdm ?blqw)
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                            (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                (not (= ?bqdb ?bqcz))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                  (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (= ?bqef ?blqw)
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqdm ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                              (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                  (= ?bqdb ?bqcz)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (assert
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                        (forall ((?boig Real) )(or (= ?boig ?boif)
                            (= ?boig ?boie)
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bofe))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bofe ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (= ?bnuc ?bofe)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bocc))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bocc ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (= ?bnuc ?bocc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                  (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                      (= ?bobe ?bobc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnyg))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnuc ?bnyg)
                                              )
                                            )
                                          )
                                        (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnxp ?bnyg)
                                                  (= ?bnxp ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnxp ?bnyg))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnuq))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnuq ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (= ?bnuc ?bnuq)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                    (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                        (not (= ?bqki ?bqkg))
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (not (= ?bqhv ?blqw))
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqgr ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                  (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (not (= ?bqef ?blqw))
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqdm ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                              (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                  (not (= ?bqdb ?bqcz))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                          (exists ((?boig Real) )(and (not (= ?boig ?boif))
                              (not (= ?boig ?boie))
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bofe)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bofe ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (not (= ?bnuc ?bofe))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bocc)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bocc ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (not (= ?bnuc ?bocc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                    (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                        (not (= ?bobe ?bobc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnyg)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnyg))
                                                )
                                              )
                                            )
                                          (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnxp ?bnyg))
                                                    (not (= ?bnxp ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnxp ?bnyg)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnuq)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnuq ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnuq))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                  (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                      (not (= ?bqki ?bqkg))
                      )
                    )
                  )
                )
              )
            (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                    (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                        (= ?bqki ?bqkg)
                        )
                      )
                    )
                  )
                )
              (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqhv ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bqgr ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                            (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqhv ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqgr ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqef ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (= ?bqdm ?blqw)
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                            (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                (not (= ?bqdb ?bqcz))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                  (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (= ?bqef ?blqw)
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqdm ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                              (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                  (= ?bqdb ?bqcz)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?btbx Real)
  (push 1)
    (assert
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                        (forall ((?boig Real) )(or (= ?boig ?boif)
                            (= ?boig ?boie)
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bofe))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bofe ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (= ?bnuc ?bofe)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bocc))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bocc ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (= ?bnuc ?bocc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                  (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                      (= ?bobe ?bobc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnyg))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnuc ?bnyg)
                                              )
                                            )
                                          )
                                        (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnxp ?bnyg)
                                                  (= ?bnxp ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnxp ?bnyg))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnuq))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnuq ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (= ?bnuc ?bnuq)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                    (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                        (not (= ?bqki ?bqkg))
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (not (= ?bqhv ?blqw))
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqgr ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                  (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (not (= ?bqef ?blqw))
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqdm ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                              (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                  (not (= ?bqdb ?bqcz))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                          (exists ((?boig Real) )(and (not (= ?boig ?boif))
                              (not (= ?boig ?boie))
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bofe)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bofe ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (not (= ?bnuc ?bofe))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bocc)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bocc ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (not (= ?bnuc ?bocc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                    (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                        (not (= ?bobe ?bobc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnyg)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnyg))
                                                )
                                              )
                                            )
                                          (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnxp ?bnyg))
                                                    (not (= ?bnxp ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnxp ?bnyg)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnuq)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnuq ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnuq))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                  (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                      (not (= ?bqki ?bqkg))
                      )
                    )
                  )
                )
              )
            (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                    (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                        (= ?bqki ?bqkg)
                        )
                      )
                    )
                  )
                )
              (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqhv ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bqgr ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                            (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqhv ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqgr ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqef ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (= ?bqdm ?blqw)
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                            (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                (not (= ?bqdb ?bqcz))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                  (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (= ?bqef ?blqw)
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqdm ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                              (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                  (= ?bqdb ?bqcz)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?btby Real)
  (declare-const ?btbz Real)
  (push 1)
    (assert
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                        (forall ((?boig Real) )(or (= ?boig ?boif)
                            (= ?boig ?boie)
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bofe))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bofe ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (= ?bnuc ?bofe)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bocc))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bocc ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (= ?bnuc ?bocc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                  (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                      (= ?bobe ?bobc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnyg))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnuc ?bnyg)
                                              )
                                            )
                                          )
                                        (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnxp ?bnyg)
                                                  (= ?bnxp ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnxp ?bnyg))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnuq))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnuq ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (= ?bnuc ?bnuq)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                    (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                        (not (= ?bqki ?bqkg))
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (not (= ?bqhv ?blqw))
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqgr ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                  (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (not (= ?bqef ?blqw))
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqdm ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                              (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                  (not (= ?bqdb ?bqcz))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                          (exists ((?boig Real) )(and (not (= ?boig ?boif))
                              (not (= ?boig ?boie))
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bofe)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bofe ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (not (= ?bnuc ?bofe))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bocc)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bocc ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (not (= ?bnuc ?bocc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                    (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                        (not (= ?bobe ?bobc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnyg)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnyg))
                                                )
                                              )
                                            )
                                          (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnxp ?bnyg))
                                                    (not (= ?bnxp ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnxp ?bnyg)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnuq)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnuq ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnuq))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                  (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                      (not (= ?bqki ?bqkg))
                      )
                    )
                  )
                )
              )
            (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                    (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                        (= ?bqki ?bqkg)
                        )
                      )
                    )
                  )
                )
              (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqhv ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bqgr ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                            (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqhv ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqgr ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqef ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (= ?bqdm ?blqw)
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                            (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                (not (= ?bqdb ?bqcz))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                  (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (= ?bqef ?blqw)
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqdm ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                              (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                  (= ?bqdb ?bqcz)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                  (= ?bmnf ?bmnk)
                  )
                )
              )
            )
          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                        (not (= ?blvm ?blvk))
                        )
                      )
                    )
                  )
                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                        (= ?bmca ?bmdy)
                        )
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                          (= ?blpf ?bluu)
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                (= ?blpf ?blsx)
                                )
                              )
                            )
                          )
                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                (not (= ?blrl ?blrj))
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                      (= ?blpg ?blqw)
                                      )
                                    (= ?blpf ?blqw)
                                    )
                                  (and (and (not (= ?blqq ?blqp))
                                      (not (= ?blqq ?blqw))
                                      )
                                    (not (= ?blqp ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?blpg ?blpf))
                                      (not (= ?blpg ?blqw))
                                      )
                                    (not (= ?blpf ?blqw))
                                    )
                                  (or (or (= ?blqq ?blqp)
                                      (= ?blqq ?blqw)
                                      )
                                    (= ?blqp ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                      (= ?blpf ?blqc)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                          (= ?blpf ?blpj)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                              (= ?blkl ?blkr)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                (= ?blem ?bler)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                      (not (= ?boig ?boie))
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                  (not (= ?bogj ?blqw))
                                  )
                                (not (= ?bogi ?blqw))
                                )
                              (or (or (= ?bnuc ?bofe)
                                  (= ?bnuc ?blqw)
                                  )
                                (= ?bofe ?blqw)
                                )
                              )
                            (or (or (or (= ?bogj ?bogi)
                                  (= ?bogj ?blqw)
                                  )
                                (= ?bogi ?blqw)
                                )
                              (not (= ?bnuc ?bofe))
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                        (not (= ?bocw ?blqw))
                                        )
                                      (not (= ?bocv ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bocc)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bocc ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bocw ?bocv)
                                        (= ?bocw ?blqw)
                                        )
                                      (= ?bocv ?blqw)
                                      )
                                    (not (= ?bnuc ?bocc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                (not (= ?bobe ?bobc))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bnyg)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (not (= ?bnuc ?bnyg))
                                        )
                                      )
                                    )
                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (and (not (= ?bnxp ?bnyg))
                                            (not (= ?bnxp ?blqw))
                                            )
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (= ?bnxp ?bnyg)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                              (not (= ?bnvl ?blqw))
                                              )
                                            (not (= ?bnvk ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnuq)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnuq ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnvl ?bnvk)
                                              (= ?bnvl ?blqw)
                                              )
                                            (= ?bnvk ?blqw)
                                            )
                                          (not (= ?bnuc ?bnuq))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                    (not (= ?bqki ?bqkg))
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                        (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqhv ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                    (not (= ?bnza ?blqw))
                                    )
                                  (not (= ?bnyz ?blqw))
                                  )
                                (or (= ?bqgr ?blqw)
                                  (= ?bnyg ?blqw)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                              (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqef ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqdm ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                          (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                              (not (= ?bqdb ?bqcz))
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?btca Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?btcb Real)
    (declare-const ?btcc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (and (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                    (not (= ?bmnf ?bmnk))
                    )
                  )
                )
              )
            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                          (= ?blvm ?blvk)
                          )
                        )
                      )
                    )
                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                          (not (= ?bmca ?bmdy))
                          )
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                            (not (= ?blpf ?bluu))
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                  (not (= ?blpf ?blsx))
                                  )
                                )
                              )
                            )
                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                  (= ?blrl ?blrj)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                        (not (= ?blpf ?blqc))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                            (not (= ?blpf ?blpj))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                (not (= ?blkl ?blkr))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                  (not (= ?blem ?bler))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                    (forall ((?boig Real) )(or (= ?boig ?boif)
                        (= ?boig ?boie)
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (and (and (not (= ?bnuc ?bofe))
                                    (not (= ?bnuc ?blqw))
                                    )
                                  (not (= ?bofe ?blqw))
                                  )
                                )
                              (and (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (= ?bnuc ?bofe)
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bocc))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bocc ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (= ?bnuc ?bocc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                  (= ?bobe ?bobc)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bnyg))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnuc ?bnyg)
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnxp ?bnyg)
                                              (= ?bnxp ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnxp ?bnyg))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnuq))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnuq ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (= ?bnuc ?bnuq)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                      (= ?bmnf ?bmnk)
                      )
                    )
                  )
                )
              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                            (not (= ?blvm ?blvk))
                            )
                          )
                        )
                      )
                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                            (= ?bmca ?bmdy)
                            )
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                              (= ?blpf ?bluu)
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                    (= ?blpf ?blsx)
                                    )
                                  )
                                )
                              )
                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                    (not (= ?blrl ?blrj))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                          (= ?blpf ?blqc)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                              (= ?blpf ?blpj)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                  (= ?blkl ?blkr)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                    (= ?blem ?bler)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                        (not (= ?bmnf ?bmnk))
                        )
                      )
                    )
                  )
                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                              (= ?blvm ?blvk)
                              )
                            )
                          )
                        )
                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                              (not (= ?bmca ?bmdy))
                              )
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                (not (= ?blpf ?bluu))
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                      (not (= ?blpf ?blsx))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                      (= ?blrl ?blrj)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                            (not (= ?blpf ?blqc))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                (not (= ?blpf ?blpj))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                    (not (= ?blkl ?blkr))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                      (not (= ?blem ?bler))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                          (not (= ?boig ?boie))
                          )
                        )
                      )
                    )
                  )
                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                        (forall ((?boig Real) )(or (= ?boig ?boif)
                            (= ?boig ?boie)
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (or (or (= ?bnuc ?bofe)
                                      (= ?bnuc ?blqw)
                                      )
                                    (= ?bofe ?blqw)
                                    )
                                  )
                                (or (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (not (= ?bnuc ?bofe))
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (and (and (not (= ?bnuc ?bofe))
                                        (not (= ?bnuc ?blqw))
                                        )
                                      (not (= ?bofe ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (= ?bnuc ?bofe)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bocc)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bocc ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (not (= ?bnuc ?bocc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                    (not (= ?bobe ?bobc))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bocc))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bocc ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (= ?bnuc ?bocc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                  (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                      (= ?bobe ?bobc)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnyg)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnuc ?bnyg))
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnxp ?bnyg))
                                                (not (= ?bnxp ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnxp ?bnyg)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnyg))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnuc ?bnyg)
                                              )
                                            )
                                          )
                                        (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnxp ?bnyg)
                                                  (= ?bnxp ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnxp ?bnyg))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnuq)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnuq ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (not (= ?bnuc ?bnuq))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnuq))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnuq ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (= ?bnuc ?bnuq)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                        (not (= ?blem ?bler))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                          (forall ((?boig Real) )(or (= ?boig ?boif)
                              (= ?boig ?boie)
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (and (and (not (= ?bnuc ?bofe))
                                          (not (= ?bnuc ?blqw))
                                          )
                                        (not (= ?bofe ?blqw))
                                        )
                                      )
                                    (and (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (= ?bnuc ?bofe)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bocc))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bocc ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (= ?bnuc ?bocc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                    (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                        (= ?bobe ?bobc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bnyg))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnuc ?bnyg)
                                                )
                                              )
                                            )
                                          (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnxp ?bnyg)
                                                    (= ?bnxp ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnxp ?bnyg))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnuq))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnuq ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (= ?bnuc ?bnuq)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                  (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                      (= ?bqki ?bqkg)
                      )
                    )
                  )
                )
              )
            (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                            (= ?bmnf ?bmnk)
                            )
                          )
                        )
                      )
                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                  (not (= ?blvm ?blvk))
                                  )
                                )
                              )
                            )
                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                  (= ?bmca ?bmdy)
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                    (= ?blpf ?bluu)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                          (= ?blpf ?blsx)
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                          (not (= ?blrl ?blrj))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                (= ?blpf ?blqc)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                    (= ?blpf ?blpj)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                        (= ?blkl ?blkr)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                          (= ?blem ?bler)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                            (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                (not (= ?boig ?boie))
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (or (or (= ?bnuc ?bofe)
                                            (= ?bnuc ?blqw)
                                            )
                                          (= ?bofe ?blqw)
                                          )
                                        )
                                      (or (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (not (= ?bnuc ?bofe))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bocc)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bocc ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (not (= ?bnuc ?bocc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                      (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                          (not (= ?bobe ?bobc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnyg)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnyg))
                                                  )
                                                )
                                              )
                                            (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnxp ?bnyg))
                                                      (not (= ?bnxp ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnxp ?bnyg)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnuq)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnuq ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnuq))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                    (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                        (not (= ?bqki ?bqkg))
                        )
                      )
                    )
                  )
                )
              (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                              (not (= ?bmnf ?bmnk))
                              )
                            )
                          )
                        )
                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                    (= ?blvm ?blvk)
                                    )
                                  )
                                )
                              )
                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                    (not (= ?bmca ?bmdy))
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                      (not (= ?blpf ?bluu))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                            (not (= ?blpf ?blsx))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                            (= ?blrl ?blrj)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                  (not (= ?blpf ?blqc))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                      (not (= ?blpf ?blpj))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                          (not (= ?blkl ?blkr))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                            (not (= ?blem ?bler))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                              (forall ((?boig Real) )(or (= ?boig ?boif)
                                  (= ?boig ?boie)
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (and (and (not (= ?bnuc ?bofe))
                                              (not (= ?bnuc ?blqw))
                                              )
                                            (not (= ?bofe ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (= ?bnuc ?bofe)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bocc))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bocc ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (= ?bnuc ?bocc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                        (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                            (= ?bobe ?bobc)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnyg))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnuc ?bnyg)
                                                    )
                                                  )
                                                )
                                              (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnxp ?bnyg)
                                                        (= ?bnxp ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnxp ?bnyg))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnuq))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnuq ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (= ?bnuc ?bnuq)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                          (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqhv ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                      (= ?bnza ?blqw)
                                      )
                                    (= ?bnyz ?blqw)
                                    )
                                  (and (not (= ?bqgr ?blqw))
                                    (not (= ?bnyg ?blqw))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                    (not (= ?boig ?boie))
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bofe)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bofe ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (not (= ?bnuc ?bofe))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bocc)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bocc ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bocc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                          (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                              (not (= ?bobe ?bobc))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnyg)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnyg))
                                                      )
                                                    )
                                                  )
                                                (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnxp ?bnyg))
                                                          (not (= ?bnxp ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnxp ?bnyg)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnuq)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnuq ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnuq))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                            (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                  (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                          (= ?bnza ?blqw)
                                          )
                                        (= ?bnyz ?blqw)
                                        )
                                      (and (not (= ?bqhv ?blqw))
                                        (not (= ?bnyg ?blqw))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                        (not (= ?bnza ?blqw))
                                        )
                                      (not (= ?bnyz ?blqw))
                                      )
                                    (or (= ?bqgr ?blqw)
                                      (= ?bnyg ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                  (forall ((?boig Real) )(or (= ?boig ?boif)
                                      (= ?boig ?boie)
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bofe))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bofe ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (= ?bnuc ?bofe)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bocc))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bocc ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (= ?bnuc ?bocc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                            (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                (= ?bobe ?bobc)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnyg))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnuc ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnxp ?bnyg)
                                                            (= ?bnxp ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnxp ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnuq))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnuq ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (= ?bnuc ?bnuq)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqef ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                            (= ?bnza ?blqw)
                                            )
                                          (= ?bnyz ?blqw)
                                          )
                                        (and (not (= ?bqdm ?blqw))
                                          (not (= ?bnyg ?blqw))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                            (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                (= ?bqdb ?bqcz)
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                  (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                        (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (not (= ?bqef ?blqw))
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (= ?bqdm ?blqw)
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                              (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                  (not (= ?bqdb ?bqcz))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      (or (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                    (= ?bmnf ?bmnk)
                    )
                  )
                )
              )
            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                          (not (= ?blvm ?blvk))
                          )
                        )
                      )
                    )
                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                          (= ?bmca ?bmdy)
                          )
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                            (= ?blpf ?bluu)
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                  (= ?blpf ?blsx)
                                  )
                                )
                              )
                            )
                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                  (not (= ?blrl ?blrj))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                        (= ?blpg ?blqw)
                                        )
                                      (= ?blpf ?blqw)
                                      )
                                    (and (and (not (= ?blqq ?blqp))
                                        (not (= ?blqq ?blqw))
                                        )
                                      (not (= ?blqp ?blqw))
                                      )
                                    )
                                  (and (and (and (not (= ?blpg ?blpf))
                                        (not (= ?blpg ?blqw))
                                        )
                                      (not (= ?blpf ?blqw))
                                      )
                                    (or (or (= ?blqq ?blqp)
                                        (= ?blqq ?blqw)
                                        )
                                      (= ?blqp ?blqw)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                        (= ?blpf ?blqc)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                            (= ?blpf ?blpj)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                (= ?blkl ?blkr)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                  (= ?blem ?bler)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                        (not (= ?boig ?boie))
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                    (not (= ?bogj ?blqw))
                                    )
                                  (not (= ?bogi ?blqw))
                                  )
                                (or (or (= ?bnuc ?bofe)
                                    (= ?bnuc ?blqw)
                                    )
                                  (= ?bofe ?blqw)
                                  )
                                )
                              (or (or (or (= ?bogj ?bogi)
                                    (= ?bogj ?blqw)
                                    )
                                  (= ?bogi ?blqw)
                                  )
                                (not (= ?bnuc ?bofe))
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                          (not (= ?bocw ?blqw))
                                          )
                                        (not (= ?bocv ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bocc)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bocc ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bocw ?bocv)
                                          (= ?bocw ?blqw)
                                          )
                                        (= ?bocv ?blqw)
                                        )
                                      (not (= ?bnuc ?bocc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                  (not (= ?bobe ?bobc))
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bnyg)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bnyg ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (not (= ?bnuc ?bnyg))
                                          )
                                        )
                                      )
                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (and (not (= ?bnxp ?bnyg))
                                              (not (= ?bnxp ?blqw))
                                              )
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?bnza ?bnyz))
                                              (not (= ?bnza ?blqw))
                                              )
                                            (not (= ?bnyz ?blqw))
                                            )
                                          (= ?bnxp ?bnyg)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                (not (= ?bnvl ?blqw))
                                                )
                                              (not (= ?bnvk ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bnuq)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bnuq ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnvl ?bnvk)
                                                (= ?bnvl ?blqw)
                                                )
                                              (= ?bnvk ?blqw)
                                              )
                                            (not (= ?bnuc ?bnuq))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                      (not (= ?bmnf ?bmnk))
                      )
                    )
                  )
                )
              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                            (= ?blvm ?blvk)
                            )
                          )
                        )
                      )
                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                            (not (= ?bmca ?bmdy))
                            )
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                              (not (= ?blpf ?bluu))
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                    (not (= ?blpf ?blsx))
                                    )
                                  )
                                )
                              )
                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                    (= ?blrl ?blrj)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                          (not (= ?blpg ?blqw))
                                          )
                                        (not (= ?blpf ?blqw))
                                        )
                                      (or (or (= ?blqq ?blqp)
                                          (= ?blqq ?blqw)
                                          )
                                        (= ?blqp ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?blpg ?blpf)
                                          (= ?blpg ?blqw)
                                          )
                                        (= ?blpf ?blqw)
                                        )
                                      (and (and (not (= ?blqq ?blqp))
                                          (not (= ?blqq ?blqw))
                                          )
                                        (not (= ?blqp ?blqw))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                          (not (= ?blpf ?blqc))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                              (not (= ?blpf ?blpj))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                  (not (= ?blkl ?blkr))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                    (not (= ?blem ?bler))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                        (= ?bmnf ?bmnk)
                        )
                      )
                    )
                  )
                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                          (not (= ?bmnf ?bmnk))
                          )
                        )
                      )
                    )
                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                              (not (= ?blvm ?blvk))
                              )
                            )
                          )
                        )
                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                              (= ?bmca ?bmdy)
                              )
                            )
                          )
                        )
                      )
                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                (= ?blvm ?blvk)
                                )
                              )
                            )
                          )
                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                (not (= ?bmca ?bmdy))
                                )
                              )
                            )
                          )
                        )
                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                (= ?blpf ?bluu)
                                )
                              )
                            )
                          )
                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                  (not (= ?blpf ?bluu))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                      (= ?blpf ?blsx)
                                      )
                                    )
                                  )
                                )
                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                      (not (= ?blrl ?blrj))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                        (not (= ?blpf ?blsx))
                                        )
                                      )
                                    )
                                  )
                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                        (= ?blrl ?blrj)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                            (= ?blpg ?blqw)
                                            )
                                          (= ?blpf ?blqw)
                                          )
                                        (and (and (not (= ?blqq ?blqp))
                                            (not (= ?blqq ?blqw))
                                            )
                                          (not (= ?blqp ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?blpg ?blpf))
                                            (not (= ?blpg ?blqw))
                                            )
                                          (not (= ?blpf ?blqw))
                                          )
                                        (or (or (= ?blqq ?blqp)
                                            (= ?blqq ?blqw)
                                            )
                                          (= ?blqp ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                            (= ?blpf ?blqc)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                              (not (= ?blpf ?blqc))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                (= ?blpf ?blpj)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                  (not (= ?blpf ?blpj))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                    (= ?blkl ?blkr)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                      (not (= ?blkl ?blkr))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                      (= ?blem ?bler)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                      (forall ((?boig Real) )(or (= ?boig ?boif)
                          (= ?boig ?boie)
                          )
                        )
                      )
                    )
                  )
                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                        (exists ((?boig Real) )(and (not (= ?boig ?boif))
                            (not (= ?boig ?boie))
                            )
                          )
                        )
                      )
                    )
                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                      (= ?bogj ?blqw)
                                      )
                                    (= ?bogi ?blqw)
                                    )
                                  (and (and (not (= ?bnuc ?bofe))
                                      (not (= ?bnuc ?blqw))
                                      )
                                    (not (= ?bofe ?blqw))
                                    )
                                  )
                                (and (and (and (not (= ?bogj ?bogi))
                                      (not (= ?bogj ?blqw))
                                      )
                                    (not (= ?bogi ?blqw))
                                    )
                                  (= ?bnuc ?bofe)
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                        (not (= ?bogj ?blqw))
                                        )
                                      (not (= ?bogi ?blqw))
                                      )
                                    (or (or (= ?bnuc ?bofe)
                                        (= ?bnuc ?blqw)
                                        )
                                      (= ?bofe ?blqw)
                                      )
                                    )
                                  (or (or (or (= ?bogj ?bogi)
                                        (= ?bogj ?blqw)
                                        )
                                      (= ?bogi ?blqw)
                                      )
                                    (not (= ?bnuc ?bofe))
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                            (= ?bocw ?blqw)
                                            )
                                          (= ?bocv ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bocc))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bocc ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bocw ?bocv))
                                            (not (= ?bocw ?blqw))
                                            )
                                          (not (= ?bocv ?blqw))
                                          )
                                        (= ?bnuc ?bocc)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                    (= ?bobe ?bobc)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                              (not (= ?bocw ?blqw))
                                              )
                                            (not (= ?bocv ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bocc)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bocc ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bocw ?bocv)
                                              (= ?bocw ?blqw)
                                              )
                                            (= ?bocv ?blqw)
                                            )
                                          (not (= ?bnuc ?bocc))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                  (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                      (not (= ?bobe ?bobc))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                      (not (= ?blem ?bler))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bnyg))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bnyg ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (= ?bnuc ?bnyg)
                                            )
                                          )
                                        )
                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (or (= ?bnxp ?bnyg)
                                                (= ?bnxp ?blqw)
                                                )
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bnza ?bnyz)
                                                (= ?bnza ?blqw)
                                                )
                                              (= ?bnyz ?blqw)
                                              )
                                            (not (= ?bnxp ?bnyg))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bnyg)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bnyg ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (not (= ?bnuc ?bnyg))
                                              )
                                            )
                                          )
                                        (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                  (= ?bnza ?blqw)
                                                  )
                                                (= ?bnyz ?blqw)
                                                )
                                              (and (and (not (= ?bnxp ?bnyg))
                                                  (not (= ?bnxp ?blqw))
                                                  )
                                                (not (= ?bnyg ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnza ?bnyz))
                                                  (not (= ?bnza ?blqw))
                                                  )
                                                (not (= ?bnyz ?blqw))
                                                )
                                              (= ?bnxp ?bnyg)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                  (= ?bnvl ?blqw)
                                                  )
                                                (= ?bnvk ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bnuq))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bnuq ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                  (not (= ?bnvl ?blqw))
                                                  )
                                                (not (= ?bnvk ?blqw))
                                                )
                                              (= ?bnuc ?bnuq)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                    (not (= ?bnvl ?blqw))
                                                    )
                                                  (not (= ?bnvk ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnuq)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnuq ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnvl ?bnvk)
                                                    (= ?bnvl ?blqw)
                                                    )
                                                  (= ?bnvk ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnuq))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                          (= ?bmnf ?bmnk)
                          )
                        )
                      )
                    )
                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                (not (= ?blvm ?blvk))
                                )
                              )
                            )
                          )
                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                (= ?bmca ?bmdy)
                                )
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                  (= ?blpf ?bluu)
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                        (= ?blpf ?blsx)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                        (not (= ?blrl ?blrj))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                              (= ?blpg ?blqw)
                                              )
                                            (= ?blpf ?blqw)
                                            )
                                          (and (and (not (= ?blqq ?blqp))
                                              (not (= ?blqq ?blqw))
                                              )
                                            (not (= ?blqp ?blqw))
                                            )
                                          )
                                        (and (and (and (not (= ?blpg ?blpf))
                                              (not (= ?blpg ?blqw))
                                              )
                                            (not (= ?blpf ?blqw))
                                            )
                                          (or (or (= ?blqq ?blqp)
                                              (= ?blqq ?blqw)
                                              )
                                            (= ?blqp ?blqw)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                              (= ?blpf ?blqc)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                  (= ?blpf ?blpj)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                      (= ?blkl ?blkr)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                        (= ?blem ?bler)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                (= ?bmnf ?bmnk)
                                )
                              )
                            )
                          )
                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                      (not (= ?blvm ?blvk))
                                      )
                                    )
                                  )
                                )
                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                      (= ?bmca ?bmdy)
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                        (= ?blpf ?bluu)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                              (= ?blpf ?blsx)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                              (not (= ?blrl ?blrj))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                    (= ?blpf ?blqc)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                        (= ?blpf ?blpj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                            (= ?blkl ?blkr)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                              (= ?blem ?bler)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                          (exists ((?boig Real) )(and (not (= ?boig ?boif))
                              (not (= ?boig ?boie))
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                          (not (= ?bogj ?blqw))
                                          )
                                        (not (= ?bogi ?blqw))
                                        )
                                      (or (or (= ?bnuc ?bofe)
                                          (= ?bnuc ?blqw)
                                          )
                                        (= ?bofe ?blqw)
                                        )
                                      )
                                    (or (or (or (= ?bogj ?bogi)
                                          (= ?bogj ?blqw)
                                          )
                                        (= ?bogi ?blqw)
                                        )
                                      (not (= ?bnuc ?bofe))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                (not (= ?bocw ?blqw))
                                                )
                                              (not (= ?bocv ?blqw))
                                              )
                                            (or (or (= ?bnuc ?bocc)
                                                (= ?bnuc ?blqw)
                                                )
                                              (= ?bocc ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?bocw ?bocv)
                                                (= ?bocw ?blqw)
                                                )
                                              (= ?bocv ?blqw)
                                              )
                                            (not (= ?bnuc ?bocc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                    (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                        (not (= ?bobe ?bobc))
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bnyg)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bnyg ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (not (= ?bnuc ?bnyg))
                                                )
                                              )
                                            )
                                          (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                    (= ?bnza ?blqw)
                                                    )
                                                  (= ?bnyz ?blqw)
                                                  )
                                                (and (and (not (= ?bnxp ?bnyg))
                                                    (not (= ?bnxp ?blqw))
                                                    )
                                                  (not (= ?bnyg ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bnza ?bnyz))
                                                    (not (= ?bnza ?blqw))
                                                    )
                                                  (not (= ?bnyz ?blqw))
                                                  )
                                                (= ?bnxp ?bnyg)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                      (not (= ?bnvl ?blqw))
                                                      )
                                                    (not (= ?bnvk ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bnuq)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bnuq ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnvl ?bnvk)
                                                      (= ?bnvl ?blqw)
                                                      )
                                                    (= ?bnvk ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bnuq))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?bqkh Real) (?bqkg Real) )(and (not (= ?bqkh ?bqkg))
                  (exists ((?bqki Real) )(and (not (= ?bqki ?bqkh))
                      (not (= ?bqki ?bqkg))
                      )
                    )
                  )
                )
              )
            (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                            (not (= ?bmnf ?bmnk))
                            )
                          )
                        )
                      )
                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                  (= ?blvm ?blvk)
                                  )
                                )
                              )
                            )
                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                  (not (= ?bmca ?bmdy))
                                  )
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                    (not (= ?blpf ?bluu))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                          (not (= ?blpf ?blsx))
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                          (= ?blrl ?blrj)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                (not (= ?blpg ?blqw))
                                                )
                                              (not (= ?blpf ?blqw))
                                              )
                                            (or (or (= ?blqq ?blqp)
                                                (= ?blqq ?blqw)
                                                )
                                              (= ?blqp ?blqw)
                                              )
                                            )
                                          (or (or (or (= ?blpg ?blpf)
                                                (= ?blpg ?blqw)
                                                )
                                              (= ?blpf ?blqw)
                                              )
                                            (and (and (not (= ?blqq ?blqp))
                                                (not (= ?blqq ?blqw))
                                                )
                                              (not (= ?blqp ?blqw))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                (not (= ?blpf ?blqc))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                    (not (= ?blpf ?blpj))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                        (not (= ?blkl ?blkr))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                          (not (= ?blem ?bler))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                  (not (= ?bmnf ?bmnk))
                                  )
                                )
                              )
                            )
                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                        (= ?blvm ?blvk)
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                        (not (= ?bmca ?bmdy))
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                          (not (= ?blpf ?bluu))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                (not (= ?blpf ?blsx))
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                (= ?blrl ?blrj)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                      (not (= ?blpf ?blqc))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                          (not (= ?blpf ?blpj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                              (not (= ?blkl ?blkr))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                (not (= ?blem ?bler))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                            (forall ((?boig Real) )(or (= ?boig ?boif)
                                (= ?boig ?boie)
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                            (= ?bogj ?blqw)
                                            )
                                          (= ?bogi ?blqw)
                                          )
                                        (and (and (not (= ?bnuc ?bofe))
                                            (not (= ?bnuc ?blqw))
                                            )
                                          (not (= ?bofe ?blqw))
                                          )
                                        )
                                      (and (and (and (not (= ?bogj ?bogi))
                                            (not (= ?bogj ?blqw))
                                            )
                                          (not (= ?bogi ?blqw))
                                          )
                                        (= ?bnuc ?bofe)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                  (= ?bocw ?blqw)
                                                  )
                                                (= ?bocv ?blqw)
                                                )
                                              (and (and (not (= ?bnuc ?bocc))
                                                  (not (= ?bnuc ?blqw))
                                                  )
                                                (not (= ?bocc ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?bocw ?bocv))
                                                  (not (= ?bocw ?blqw))
                                                  )
                                                (not (= ?bocv ?blqw))
                                                )
                                              (= ?bnuc ?bocc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                      (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                          (= ?bobe ?bobc)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bnyg))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bnyg ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (= ?bnuc ?bnyg)
                                                  )
                                                )
                                              )
                                            (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                      (not (= ?bnza ?blqw))
                                                      )
                                                    (not (= ?bnyz ?blqw))
                                                    )
                                                  (or (or (= ?bnxp ?bnyg)
                                                      (= ?bnxp ?blqw)
                                                      )
                                                    (= ?bnyg ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bnza ?bnyz)
                                                      (= ?bnza ?blqw)
                                                      )
                                                    (= ?bnyz ?blqw)
                                                    )
                                                  (not (= ?bnxp ?bnyg))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                        (= ?bnvl ?blqw)
                                                        )
                                                      (= ?bnvk ?blqw)
                                                      )
                                                    (and (and (not (= ?bnuc ?bnuq))
                                                        (not (= ?bnuc ?blqw))
                                                        )
                                                      (not (= ?bnuq ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnvl ?bnvk))
                                                        (not (= ?bnvl ?blqw))
                                                        )
                                                      (not (= ?bnvk ?blqw))
                                                      )
                                                    (= ?bnuc ?bnuq)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (forall ((?bqkh Real) (?bqkg Real) )(or (= ?bqkh ?bqkg)
                    (forall ((?bqki Real) )(or (= ?bqki ?bqkh)
                        (= ?bqki ?bqkg)
                        )
                      )
                    )
                  )
                )
              (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                              (= ?bmnf ?bmnk)
                              )
                            )
                          )
                        )
                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                    (not (= ?blvm ?blvk))
                                    )
                                  )
                                )
                              )
                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                    (= ?bmca ?bmdy)
                                    )
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                      (= ?blpf ?bluu)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                            (= ?blpf ?blsx)
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                            (not (= ?blrl ?blrj))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                  (= ?blpg ?blqw)
                                                  )
                                                (= ?blpf ?blqw)
                                                )
                                              (and (and (not (= ?blqq ?blqp))
                                                  (not (= ?blqq ?blqw))
                                                  )
                                                (not (= ?blqp ?blqw))
                                                )
                                              )
                                            (and (and (and (not (= ?blpg ?blpf))
                                                  (not (= ?blpg ?blqw))
                                                  )
                                                (not (= ?blpf ?blqw))
                                                )
                                              (or (or (= ?blqq ?blqp)
                                                  (= ?blqq ?blqw)
                                                  )
                                                (= ?blqp ?blqw)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                  (= ?blpf ?blqc)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                      (= ?blpf ?blpj)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                          (= ?blkl ?blkr)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                            (= ?blem ?bler)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                              (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                  (not (= ?boig ?boie))
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                              (not (= ?bogj ?blqw))
                                              )
                                            (not (= ?bogi ?blqw))
                                            )
                                          (or (or (= ?bnuc ?bofe)
                                              (= ?bnuc ?blqw)
                                              )
                                            (= ?bofe ?blqw)
                                            )
                                          )
                                        (or (or (or (= ?bogj ?bogi)
                                              (= ?bogj ?blqw)
                                              )
                                            (= ?bogi ?blqw)
                                            )
                                          (not (= ?bnuc ?bofe))
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                    (not (= ?bocw ?blqw))
                                                    )
                                                  (not (= ?bocv ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bocc)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bocc ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bocw ?bocv)
                                                    (= ?bocw ?blqw)
                                                    )
                                                  (= ?bocv ?blqw)
                                                  )
                                                (not (= ?bnuc ?bocc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                        (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                            (not (= ?bobe ?bobc))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bnyg)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bnyg ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bnyg))
                                                    )
                                                  )
                                                )
                                              (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                        (= ?bnza ?blqw)
                                                        )
                                                      (= ?bnyz ?blqw)
                                                      )
                                                    (and (and (not (= ?bnxp ?bnyg))
                                                        (not (= ?bnxp ?blqw))
                                                        )
                                                      (not (= ?bnyg ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?bnza ?bnyz))
                                                        (not (= ?bnza ?blqw))
                                                        )
                                                      (not (= ?bnyz ?blqw))
                                                      )
                                                    (= ?bnxp ?bnyg)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                          (not (= ?bnvl ?blqw))
                                                          )
                                                        (not (= ?bnvk ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bnuq)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bnuq ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnvl ?bnvk)
                                                          (= ?bnvl ?blqw)
                                                          )
                                                        (= ?bnvk ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bnuq))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?bqgr Real) )(exists ((?bqhv Real) )(forall ((?bnyg Real) )(or (= ?bqgr ?bnyg)
                          (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqhv ?bnyg))
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqhv ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                      (not (= ?bnza ?blqw))
                                      )
                                    (not (= ?bnyz ?blqw))
                                    )
                                  (or (= ?bqgr ?blqw)
                                    (= ?bnyg ?blqw)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                (not (= ?bmnf ?bmnk))
                                )
                              )
                            )
                          )
                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                      (= ?blvm ?blvk)
                                      )
                                    )
                                  )
                                )
                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                      (not (= ?bmca ?bmdy))
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                        (not (= ?blpf ?bluu))
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                              (not (= ?blpf ?blsx))
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                              (= ?blrl ?blrj)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                    (not (= ?blpg ?blqw))
                                                    )
                                                  (not (= ?blpf ?blqw))
                                                  )
                                                (or (or (= ?blqq ?blqp)
                                                    (= ?blqq ?blqw)
                                                    )
                                                  (= ?blqp ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?blpg ?blpf)
                                                    (= ?blpg ?blqw)
                                                    )
                                                  (= ?blpf ?blqw)
                                                  )
                                                (and (and (not (= ?blqq ?blqp))
                                                    (not (= ?blqq ?blqw))
                                                    )
                                                  (not (= ?blqp ?blqw))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                    (not (= ?blpf ?blqc))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                        (not (= ?blpf ?blpj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                            (not (= ?blkl ?blkr))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                              (not (= ?blem ?bler))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                (forall ((?boig Real) )(or (= ?boig ?boif)
                                    (= ?boig ?boie)
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                (= ?bogj ?blqw)
                                                )
                                              (= ?bogi ?blqw)
                                              )
                                            (and (and (not (= ?bnuc ?bofe))
                                                (not (= ?bnuc ?blqw))
                                                )
                                              (not (= ?bofe ?blqw))
                                              )
                                            )
                                          (and (and (and (not (= ?bogj ?bogi))
                                                (not (= ?bogj ?blqw))
                                                )
                                              (not (= ?bogi ?blqw))
                                              )
                                            (= ?bnuc ?bofe)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                      (= ?bocw ?blqw)
                                                      )
                                                    (= ?bocv ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bocc))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bocc ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bocw ?bocv))
                                                      (not (= ?bocw ?blqw))
                                                      )
                                                    (not (= ?bocv ?blqw))
                                                    )
                                                  (= ?bnuc ?bocc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                          (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                              (= ?bobe ?bobc)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bnyg))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bnyg ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (= ?bnuc ?bnyg)
                                                      )
                                                    )
                                                  )
                                                (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                          (not (= ?bnza ?blqw))
                                                          )
                                                        (not (= ?bnyz ?blqw))
                                                        )
                                                      (or (or (= ?bnxp ?bnyg)
                                                          (= ?bnxp ?blqw)
                                                          )
                                                        (= ?bnyg ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bnza ?bnyz)
                                                          (= ?bnza ?blqw)
                                                          )
                                                        (= ?bnyz ?blqw)
                                                        )
                                                      (not (= ?bnxp ?bnyg))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                            (= ?bnvl ?blqw)
                                                            )
                                                          (= ?bnvk ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bnuq))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bnuq ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnvl ?bnvk))
                                                            (not (= ?bnvl ?blqw))
                                                            )
                                                          (not (= ?bnvk ?blqw))
                                                          )
                                                        (= ?bnuc ?bnuq)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (forall ((?bqgr Real) )(forall ((?bqhv Real) )(exists ((?bnyg Real) )(and (not (= ?bqgr ?bnyg))
                            (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqhv ?bnyg)
                                  (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                          (not (= ?bnza ?blqw))
                                          )
                                        (not (= ?bnyz ?blqw))
                                        )
                                      (or (= ?bqhv ?blqw)
                                        (= ?bnyg ?blqw)
                                        )
                                      )
                                    )
                                  )
                                (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                        (= ?bnza ?blqw)
                                        )
                                      (= ?bnyz ?blqw)
                                      )
                                    (and (not (= ?bqgr ?blqw))
                                      (not (= ?bnyg ?blqw))
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (or (and (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                  (= ?bmnf ?bmnk)
                                  )
                                )
                              )
                            )
                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                        (not (= ?blvm ?blvk))
                                        )
                                      )
                                    )
                                  )
                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                        (= ?bmca ?bmdy)
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                          (= ?blpf ?bluu)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                (= ?blpf ?blsx)
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                (not (= ?blrl ?blrj))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                      (= ?blpg ?blqw)
                                                      )
                                                    (= ?blpf ?blqw)
                                                    )
                                                  (and (and (not (= ?blqq ?blqp))
                                                      (not (= ?blqq ?blqw))
                                                      )
                                                    (not (= ?blqp ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?blpg ?blpf))
                                                      (not (= ?blpg ?blqw))
                                                      )
                                                    (not (= ?blpf ?blqw))
                                                    )
                                                  (or (or (= ?blqq ?blqp)
                                                      (= ?blqq ?blqw)
                                                      )
                                                    (= ?blqp ?blqw)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                      (= ?blpf ?blqc)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                          (= ?blpf ?blpj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                              (= ?blkl ?blkr)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                (= ?blem ?bler)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                      (= ?blem ?bler)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                  (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                      (not (= ?boig ?boie))
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                  (not (= ?bogj ?blqw))
                                                  )
                                                (not (= ?bogi ?blqw))
                                                )
                                              (or (or (= ?bnuc ?bofe)
                                                  (= ?bnuc ?blqw)
                                                  )
                                                (= ?bofe ?blqw)
                                                )
                                              )
                                            (or (or (or (= ?bogj ?bogi)
                                                  (= ?bogj ?blqw)
                                                  )
                                                (= ?bogi ?blqw)
                                                )
                                              (not (= ?bnuc ?bofe))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                        (not (= ?bocw ?blqw))
                                                        )
                                                      (not (= ?bocv ?blqw))
                                                      )
                                                    (or (or (= ?bnuc ?bocc)
                                                        (= ?bnuc ?blqw)
                                                        )
                                                      (= ?bocc ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?bocw ?bocv)
                                                        (= ?bocw ?blqw)
                                                        )
                                                      (= ?bocv ?blqw)
                                                      )
                                                    (not (= ?bnuc ?bocc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                            (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                (not (= ?bobe ?bobc))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bnyg)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bnyg ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bnyg))
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                            (= ?bnza ?blqw)
                                                            )
                                                          (= ?bnyz ?blqw)
                                                          )
                                                        (and (and (not (= ?bnxp ?bnyg))
                                                            (not (= ?bnxp ?blqw))
                                                            )
                                                          (not (= ?bnyg ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bnza ?bnyz))
                                                            (not (= ?bnza ?blqw))
                                                            )
                                                          (not (= ?bnyz ?blqw))
                                                          )
                                                        (= ?bnxp ?bnyg)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                              (not (= ?bnvl ?blqw))
                                                              )
                                                            (not (= ?bnvk ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnuq)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnuq ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnvl ?bnvk)
                                                              (= ?bnvl ?blqw)
                                                              )
                                                            (= ?bnvk ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnuq))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (exists ((?bqdm Real) )(exists ((?bqef Real) )(forall ((?bnyg Real) )(or (= ?bqdm ?bnyg)
                                (forall ((?bnza Real) (?bnyz Real) )(or (and (not (= ?bqef ?bnyg))
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqef ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                            (not (= ?bnza ?blqw))
                                            )
                                          (not (= ?bnyz ?blqw))
                                          )
                                        (or (= ?bqdm ?blqw)
                                          (= ?bnyg ?blqw)
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (exists ((?bqda Real) (?bqcz Real) )(and (not (= ?bqda ?bqcz))
                            (exists ((?bqdb Real) )(and (not (= ?bqdb ?bqda))
                                (not (= ?bqdb ?bqcz))
                                )
                              )
                            )
                          )
                        )
                      )
                    (and (or (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (forall ((?bqdm Real) )(forall ((?bqef Real) )(exists ((?bnyg Real) )(and (not (= ?bqdm ?bnyg))
                                  (exists ((?bnza Real) (?bnyz Real) )(and (or (= ?bqef ?bnyg)
                                        (forall ((?blqw Real) )(or (and (and (not (= ?bnza ?bnyz))
                                                (not (= ?bnza ?blqw))
                                                )
                                              (not (= ?bnyz ?blqw))
                                              )
                                            (or (= ?bqef ?blqw)
                                              (= ?bnyg ?blqw)
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?blqw Real) )(and (or (or (= ?bnza ?bnyz)
                                              (= ?bnza ?blqw)
                                              )
                                            (= ?bnyz ?blqw)
                                            )
                                          (and (not (= ?bqdm ?blqw))
                                            (not (= ?bnyg ?blqw))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (forall ((?bqda Real) (?bqcz Real) )(or (= ?bqda ?bqcz)
                              (forall ((?bqdb Real) )(or (= ?bqdb ?bqda)
                                  (= ?bqdb ?bqcz)
                                  )
                                )
                              )
                            )
                          )
                        )
                      (and (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                    (not (= ?bmnf ?bmnk))
                                    )
                                  )
                                )
                              )
                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                          (= ?blvm ?blvk)
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                          (not (= ?bmca ?bmdy))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                            (not (= ?blpf ?bluu))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                  (not (= ?blpf ?blsx))
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                  (= ?blrl ?blrj)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  (or (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                        (not (= ?blpf ?blqc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                            (not (= ?blpf ?blpj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                (not (= ?blkl ?blkr))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                  (not (= ?blem ?bler))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                      (= ?bmnf ?bmnk)
                                      )
                                    )
                                  )
                                )
                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                        (not (= ?bmnf ?bmnk))
                                        )
                                      )
                                    )
                                  )
                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                            (not (= ?blvm ?blvk))
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                            (= ?bmca ?bmdy)
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                              (= ?blvm ?blvk)
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                              (not (= ?bmca ?bmdy))
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                              (= ?blpf ?bluu)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                (not (= ?blpf ?bluu))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                    (= ?blpf ?blsx)
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                    (not (= ?blrl ?blrj))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                      (not (= ?blpf ?blsx))
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                      (= ?blrl ?blrj)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                          (= ?blpf ?blqc)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                            (not (= ?blpf ?blqc))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                              (= ?blpf ?blpj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                (not (= ?blpf ?blpj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                  (= ?blkl ?blkr)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                    (not (= ?blkl ?blkr))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                    (= ?blem ?bler)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                          (not (= ?bmnf ?bmnk))
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                (= ?blvm ?blvk)
                                                )
                                              )
                                            )
                                          )
                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                (not (= ?bmca ?bmdy))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                  (not (= ?blpf ?bluu))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                        (not (= ?blpf ?blsx))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                        (= ?blrl ?blrj)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                              (not (= ?blpf ?blqc))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                  (not (= ?blpf ?blpj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                      (not (= ?blkl ?blkr))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                        (not (= ?blem ?bler))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                    (forall ((?boig Real) )(or (= ?boig ?boif)
                                        (= ?boig ?boie)
                                        )
                                      )
                                    )
                                  )
                                )
                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                            (= ?bmnf ?bmnk)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                  (not (= ?blvm ?blvk))
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                  (= ?bmca ?bmdy)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                    (= ?blpf ?bluu)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                          (= ?blpf ?blsx)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                          (not (= ?blrl ?blrj))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                (= ?blpf ?blqc)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                    (= ?blpf ?blpj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                        (= ?blkl ?blkr)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                          (= ?blem ?bler)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                      (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                          (not (= ?boig ?boie))
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                              (not (= ?bmnf ?bmnk))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                    (= ?blvm ?blvk)
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                    (not (= ?bmca ?bmdy))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                      (not (= ?blpf ?bluu))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                            (not (= ?blpf ?blsx))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                            (= ?blrl ?blrj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                  (not (= ?blpf ?blqc))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                      (not (= ?blpf ?blpj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                          (not (= ?blkl ?blkr))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                            (not (= ?blem ?bler))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (and (and (not (= ?bnuc ?bofe))
                                                    (not (= ?bnuc ?blqw))
                                                    )
                                                  (not (= ?bofe ?blqw))
                                                  )
                                                )
                                              (and (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (= ?bnuc ?bofe)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                (= ?bmnf ?bmnk)
                                                )
                                              )
                                            )
                                          )
                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                      (not (= ?blvm ?blvk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                      (= ?bmca ?bmdy)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                        (= ?blpf ?bluu)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                              (= ?blpf ?blsx)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                              (not (= ?blrl ?blrj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                    (= ?blpf ?blqc)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                        (= ?blpf ?blpj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                            (= ?blkl ?blkr)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                              (= ?blem ?bler)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (or (or (= ?bnuc ?bofe)
                                                      (= ?bnuc ?blqw)
                                                      )
                                                    (= ?bofe ?blqw)
                                                    )
                                                  )
                                                (or (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (not (= ?bnuc ?bofe))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                  (not (= ?bmnf ?bmnk))
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                        (= ?blvm ?blvk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                        (not (= ?bmca ?bmdy))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                          (not (= ?blpf ?bluu))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                (not (= ?blpf ?blsx))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                (= ?blrl ?blrj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                (or (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                      (not (= ?blpf ?blqc))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                          (not (= ?blpf ?blpj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                              (not (= ?blkl ?blkr))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                            (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                (not (= ?blem ?bler))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (and (and (not (= ?bnuc ?bocc))
                                                          (not (= ?bnuc ?blqw))
                                                          )
                                                        (not (= ?bocc ?blqw))
                                                        )
                                                      )
                                                    (and (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (= ?bnuc ?bocc)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                              (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                  (= ?bobe ?bobc)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                    (= ?bmnf ?bmnk)
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                          (not (= ?blvm ?blvk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                          (= ?bmca ?bmdy)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                            (= ?blpf ?bluu)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                  (= ?blpf ?blsx)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                  (not (= ?blrl ?blrj))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  (and (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                        (= ?blpf ?blqc)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                            (= ?blpf ?blpj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                (= ?blkl ?blkr)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                  (= ?blem ?bler)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (or (or (= ?bnuc ?bocc)
                                                            (= ?bnuc ?blqw)
                                                            )
                                                          (= ?bocc ?blqw)
                                                          )
                                                        )
                                                      (or (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (not (= ?bnuc ?bocc))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                                (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                    (not (= ?bobe ?bobc))
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                      (not (= ?bmnf ?bmnk))
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                            (= ?blvm ?blvk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                            (not (= ?bmca ?bmdy))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                              (not (= ?blpf ?bluu))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                    (not (= ?blpf ?blsx))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                    (= ?blrl ?blrj)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    (or (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                          (not (= ?blpf ?blqc))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                              (not (= ?blpf ?blpj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                  (not (= ?blkl ?blkr))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                    (not (= ?blem ?bler))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnuc ?bnyg))
                                                              (not (= ?bnuc ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnuc ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnxp ?bnyg)
                                                              (= ?bnxp ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnxp ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                        (= ?bmnf ?bmnk)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                              (not (= ?blvm ?blvk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                              (= ?bmca ?bmdy)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                (= ?blpf ?bluu)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                      (= ?blpf ?blsx)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                      (not (= ?blrl ?blrj))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      (and (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                            (= ?blpf ?blqc)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                (= ?blpf ?blpj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                    (= ?blkl ?blkr)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                  (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                      (= ?blem ?bler)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnyg)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnxp ?bnyg))
                                                                (not (= ?bnxp ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnxp ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                      (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                          (not (= ?bmnf ?bmnk))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                            (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                (= ?blvm ?blvk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                            (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                (not (= ?bmca ?bmdy))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                  (not (= ?blpf ?bluu))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                        (not (= ?blpf ?blsx))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                    (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                        (= ?blrl ?blrj)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        (or (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                              (not (= ?blpf ?blqc))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                  (not (= ?blpf ?blpj))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                  (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                      (not (= ?blkl ?blkr))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                    (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                        (not (= ?blem ?bler))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnuq))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnuq ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (= ?bnuc ?bnuq)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (or (or (= ?bnuc ?bnuq)
                                                                  (= ?bnuc ?blqw)
                                                                  )
                                                                (= ?bnuq ?blqw)
                                                                )
                                                              )
                                                            (or (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (not (= ?bnuc ?bnuq))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                            (= ?blem ?bler)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                    (= ?bmnf ?bmnk)
                                    )
                                  )
                                )
                              )
                            (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                      (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                          (not (= ?blvm ?blvk))
                                          )
                                        )
                                      )
                                    )
                                  (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                      (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                          (= ?bmca ?bmdy)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                        (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                            (= ?blpf ?bluu)
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                              (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                  (= ?blpf ?blsx)
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                              (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                  (not (= ?blrl ?blrj))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                        (= ?blpg ?blqw)
                                                        )
                                                      (= ?blpf ?blqw)
                                                      )
                                                    (and (and (not (= ?blqq ?blqp))
                                                        (not (= ?blqq ?blqw))
                                                        )
                                                      (not (= ?blqp ?blqw))
                                                      )
                                                    )
                                                  (and (and (and (not (= ?blpg ?blpf))
                                                        (not (= ?blpg ?blqw))
                                                        )
                                                      (not (= ?blpf ?blqw))
                                                      )
                                                    (or (or (= ?blqq ?blqp)
                                                        (= ?blqq ?blqw)
                                                        )
                                                      (= ?blqp ?blqw)
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                        (= ?blpf ?blqc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                            (= ?blpf ?blpj)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                            (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                (= ?blkl ?blkr)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                              (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                  (= ?blem ?bler)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                  (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                      (not (= ?bmnf ?bmnk))
                                      )
                                    )
                                  )
                                )
                              (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                    (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                        (= ?bmnf ?bmnk)
                                        )
                                      )
                                    )
                                  )
                                (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                        (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                            (= ?blvm ?blvk)
                                            )
                                          )
                                        )
                                      )
                                    (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                        (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                            (not (= ?bmca ?bmdy))
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                          (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                              (not (= ?blvm ?blvk))
                                              )
                                            )
                                          )
                                        )
                                      (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                          (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                              (= ?bmca ?bmdy)
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                          (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                              (not (= ?blpf ?bluu))
                                              )
                                            )
                                          )
                                        )
                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                            (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                (= ?blpf ?bluu)
                                                )
                                              )
                                            )
                                          )
                                        (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                    (not (= ?blpf ?blsx))
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                    (= ?blrl ?blrj)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                      (= ?blpf ?blsx)
                                                      )
                                                    )
                                                  )
                                                )
                                              (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                  (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                      (not (= ?blrl ?blrj))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                          (not (= ?blpg ?blqw))
                                                          )
                                                        (not (= ?blpf ?blqw))
                                                        )
                                                      (or (or (= ?blqq ?blqp)
                                                          (= ?blqq ?blqw)
                                                          )
                                                        (= ?blqp ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?blpg ?blpf)
                                                          (= ?blpg ?blqw)
                                                          )
                                                        (= ?blpf ?blqw)
                                                        )
                                                      (and (and (not (= ?blqq ?blqp))
                                                          (not (= ?blqq ?blqw))
                                                          )
                                                        (not (= ?blqp ?blqw))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                            (= ?blpg ?blqw)
                                                            )
                                                          (= ?blpf ?blqw)
                                                          )
                                                        (and (and (not (= ?blqq ?blqp))
                                                            (not (= ?blqq ?blqw))
                                                            )
                                                          (not (= ?blqp ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?blpg ?blpf))
                                                            (not (= ?blpg ?blqw))
                                                            )
                                                          (not (= ?blpf ?blqw))
                                                          )
                                                        (or (or (= ?blqq ?blqp)
                                                            (= ?blqq ?blqw)
                                                            )
                                                          (= ?blqp ?blqw)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                          (not (= ?blpf ?blqc))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                            (= ?blpf ?blqc)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                              (not (= ?blpf ?blpj))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                (= ?blpf ?blpj)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                              (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                  (not (= ?blkl ?blkr))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                    (= ?blkl ?blkr)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                    (not (= ?blem ?bler))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                          (= ?bmnf ?bmnk)
                                          )
                                        )
                                      )
                                    )
                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                (not (= ?blvm ?blvk))
                                                )
                                              )
                                            )
                                          )
                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                (= ?bmca ?bmdy)
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                  (= ?blpf ?bluu)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                        (= ?blpf ?blsx)
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                        (not (= ?blrl ?blrj))
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                              (= ?blpg ?blqw)
                                                              )
                                                            (= ?blpf ?blqw)
                                                            )
                                                          (and (and (not (= ?blqq ?blqp))
                                                              (not (= ?blqq ?blqw))
                                                              )
                                                            (not (= ?blqp ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?blpg ?blpf))
                                                              (not (= ?blpg ?blqw))
                                                              )
                                                            (not (= ?blpf ?blqw))
                                                            )
                                                          (or (or (= ?blqq ?blqp)
                                                              (= ?blqq ?blqw)
                                                              )
                                                            (= ?blqp ?blqw)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                              (= ?blpf ?blqc)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                  (= ?blpf ?blpj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                      (= ?blkl ?blkr)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                        (= ?blem ?bler)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                (exists ((?boif Real) (?boie Real) )(and (not (= ?boif ?boie))
                                    (exists ((?boig Real) )(and (not (= ?boig ?boif))
                                        (not (= ?boig ?boie))
                                        )
                                      )
                                    )
                                  )
                                )
                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                            (not (= ?bmnf ?bmnk))
                                            )
                                          )
                                        )
                                      )
                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                  (= ?blvm ?blvk)
                                                  )
                                                )
                                              )
                                            )
                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                  (not (= ?bmca ?bmdy))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                    (not (= ?blpf ?bluu))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                          (not (= ?blpf ?blsx))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                          (= ?blrl ?blrj)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                (not (= ?blpg ?blqw))
                                                                )
                                                              (not (= ?blpf ?blqw))
                                                              )
                                                            (or (or (= ?blqq ?blqp)
                                                                (= ?blqq ?blqw)
                                                                )
                                                              (= ?blqp ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?blpg ?blpf)
                                                                (= ?blpg ?blqw)
                                                                )
                                                              (= ?blpf ?blqw)
                                                              )
                                                            (and (and (not (= ?blqq ?blqp))
                                                                (not (= ?blqq ?blqw))
                                                                )
                                                              (not (= ?blqp ?blqw))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                (not (= ?blpf ?blqc))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                    (not (= ?blpf ?blpj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                        (not (= ?blkl ?blkr))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                          (not (= ?blem ?bler))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (forall ((?boif Real) (?boie Real) )(or (= ?boif ?boie)
                                      (forall ((?boig Real) )(or (= ?boig ?boif)
                                          (= ?boig ?boie)
                                          )
                                        )
                                      )
                                    )
                                  )
                                (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                              (= ?bmnf ?bmnk)
                                              )
                                            )
                                          )
                                        )
                                      (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                    (not (= ?blvm ?blvk))
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                    (= ?bmca ?bmdy)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                      (= ?blpf ?bluu)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                            (= ?blpf ?blsx)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                            (not (= ?blrl ?blrj))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                  (= ?blpg ?blqw)
                                                                  )
                                                                (= ?blpf ?blqw)
                                                                )
                                                              (and (and (not (= ?blqq ?blqp))
                                                                  (not (= ?blqq ?blqw))
                                                                  )
                                                                (not (= ?blqp ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                  (not (= ?blpg ?blqw))
                                                                  )
                                                                (not (= ?blpf ?blqw))
                                                                )
                                                              (or (or (= ?blqq ?blqp)
                                                                  (= ?blqq ?blqw)
                                                                  )
                                                                (= ?blqp ?blqw)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                  (= ?blpf ?blqc)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                      (= ?blpf ?blpj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                          (= ?blkl ?blkr)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                        (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                            (= ?blem ?bler)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (exists ((?bnuc Real) )(exists ((?bofe Real) )(exists ((?bogi Real) (?bogj Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bogj ?bogi))
                                                    (not (= ?bogj ?blqw))
                                                    )
                                                  (not (= ?bogi ?blqw))
                                                  )
                                                (or (or (= ?bnuc ?bofe)
                                                    (= ?bnuc ?blqw)
                                                    )
                                                  (= ?bofe ?blqw)
                                                  )
                                                )
                                              (or (or (or (= ?bogj ?bogi)
                                                    (= ?bogj ?blqw)
                                                    )
                                                  (= ?bogi ?blqw)
                                                  )
                                                (not (= ?bnuc ?bofe))
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                (not (= ?bmnf ?bmnk))
                                                )
                                              )
                                            )
                                          )
                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                      (= ?blvm ?blvk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                      (not (= ?bmca ?bmdy))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                        (not (= ?blpf ?bluu))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                              (not (= ?blpf ?blsx))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                              (= ?blrl ?blrj)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                    (not (= ?blpg ?blqw))
                                                                    )
                                                                  (not (= ?blpf ?blqw))
                                                                  )
                                                                (or (or (= ?blqq ?blqp)
                                                                    (= ?blqq ?blqw)
                                                                    )
                                                                  (= ?blqp ?blqw)
                                                                  )
                                                                )
                                                              (or (or (or (= ?blpg ?blpf)
                                                                    (= ?blpg ?blqw)
                                                                    )
                                                                  (= ?blpf ?blqw)
                                                                  )
                                                                (and (and (not (= ?blqq ?blqp))
                                                                    (not (= ?blqq ?blqw))
                                                                    )
                                                                  (not (= ?blqp ?blqw))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                    (not (= ?blpf ?blqc))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                        (not (= ?blpf ?blpj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                            (not (= ?blkl ?blkr))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                              (not (= ?blem ?bler))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (forall ((?bnuc Real) )(forall ((?bofe Real) )(forall ((?bogi Real) (?bogj Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bogj ?bogi)
                                                      (= ?bogj ?blqw)
                                                      )
                                                    (= ?bogi ?blqw)
                                                    )
                                                  (and (and (not (= ?bnuc ?bofe))
                                                      (not (= ?bnuc ?blqw))
                                                      )
                                                    (not (= ?bofe ?blqw))
                                                    )
                                                  )
                                                (and (and (and (not (= ?bogj ?bogi))
                                                      (not (= ?bogj ?blqw))
                                                      )
                                                    (not (= ?bogi ?blqw))
                                                    )
                                                  (= ?bnuc ?bofe)
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                  (= ?bmnf ?bmnk)
                                                  )
                                                )
                                              )
                                            )
                                          (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                        (not (= ?blvm ?blvk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                        (= ?bmca ?bmdy)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                          (= ?blpf ?bluu)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                (= ?blpf ?blsx)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                (not (= ?blrl ?blrj))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                      (= ?blpg ?blqw)
                                                                      )
                                                                    (= ?blpf ?blqw)
                                                                    )
                                                                  (and (and (not (= ?blqq ?blqp))
                                                                      (not (= ?blqq ?blqw))
                                                                      )
                                                                    (not (= ?blqp ?blqw))
                                                                    )
                                                                  )
                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                      (not (= ?blpg ?blqw))
                                                                      )
                                                                    (not (= ?blpf ?blqw))
                                                                    )
                                                                  (or (or (= ?blqq ?blqp)
                                                                      (= ?blqq ?blqw)
                                                                      )
                                                                    (= ?blqp ?blqw)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                      (= ?blpf ?blqc)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                          (= ?blpf ?blpj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                              (= ?blkl ?blkr)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                            (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                (= ?blem ?bler)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (and (exists ((?bnuc Real) )(exists ((?bocc Real) )(exists ((?bocv Real) (?bocw Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bocw ?bocv))
                                                          (not (= ?bocw ?blqw))
                                                          )
                                                        (not (= ?bocv ?blqw))
                                                        )
                                                      (or (or (= ?bnuc ?bocc)
                                                          (= ?bnuc ?blqw)
                                                          )
                                                        (= ?bocc ?blqw)
                                                        )
                                                      )
                                                    (or (or (or (= ?bocw ?bocv)
                                                          (= ?bocw ?blqw)
                                                          )
                                                        (= ?bocv ?blqw)
                                                        )
                                                      (not (= ?bnuc ?bocc))
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (exists ((?bobc Real) (?bobd Real) )(and (not (= ?bobd ?bobc))
                                              (exists ((?bobe Real) )(and (not (= ?bobe ?bobd))
                                                  (not (= ?bobe ?bobc))
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                    (not (= ?bmnf ?bmnk))
                                                    )
                                                  )
                                                )
                                              )
                                            (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                      (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                          (= ?blvm ?blvk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                      (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                          (not (= ?bmca ?bmdy))
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                        (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                            (not (= ?blpf ?bluu))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                              (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                  (not (= ?blpf ?blsx))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                              (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                  (= ?blrl ?blrj)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                        (not (= ?blpg ?blqw))
                                                                        )
                                                                      (not (= ?blpf ?blqw))
                                                                      )
                                                                    (or (or (= ?blqq ?blqp)
                                                                        (= ?blqq ?blqw)
                                                                        )
                                                                      (= ?blqp ?blqw)
                                                                      )
                                                                    )
                                                                  (or (or (or (= ?blpg ?blpf)
                                                                        (= ?blpg ?blqw)
                                                                        )
                                                                      (= ?blpf ?blqw)
                                                                      )
                                                                    (and (and (not (= ?blqq ?blqp))
                                                                        (not (= ?blqq ?blqw))
                                                                        )
                                                                      (not (= ?blqp ?blqw))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                        (not (= ?blpf ?blqc))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                            (not (= ?blpf ?blpj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                            (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                (not (= ?blkl ?blkr))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                              (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                  (not (= ?blem ?bler))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (or (forall ((?bnuc Real) )(forall ((?bocc Real) )(forall ((?bocv Real) (?bocw Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bocw ?bocv)
                                                            (= ?bocw ?blqw)
                                                            )
                                                          (= ?bocv ?blqw)
                                                          )
                                                        (and (and (not (= ?bnuc ?bocc))
                                                            (not (= ?bnuc ?blqw))
                                                            )
                                                          (not (= ?bocc ?blqw))
                                                          )
                                                        )
                                                      (and (and (and (not (= ?bocw ?bocv))
                                                            (not (= ?bocw ?blqw))
                                                            )
                                                          (not (= ?bocv ?blqw))
                                                          )
                                                        (= ?bnuc ?bocc)
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (forall ((?bobc Real) (?bobd Real) )(or (= ?bobd ?bobc)
                                                (forall ((?bobe Real) )(or (= ?bobe ?bobd)
                                                    (= ?bobe ?bobc)
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                  (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                      (= ?bmnf ?bmnk)
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                        (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                            (not (= ?blvm ?blvk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                        (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                            (= ?bmca ?bmdy)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                          (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                              (= ?blpf ?bluu)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                    (= ?blpf ?blsx)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                    (not (= ?blrl ?blrj))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                          (= ?blpg ?blqw)
                                                                          )
                                                                        (= ?blpf ?blqw)
                                                                        )
                                                                      (and (and (not (= ?blqq ?blqp))
                                                                          (not (= ?blqq ?blqw))
                                                                          )
                                                                        (not (= ?blqp ?blqw))
                                                                        )
                                                                      )
                                                                    (and (and (and (not (= ?blpg ?blpf))
                                                                          (not (= ?blpg ?blqw))
                                                                          )
                                                                        (not (= ?blpf ?blqw))
                                                                        )
                                                                      (or (or (= ?blqq ?blqp)
                                                                          (= ?blqq ?blqw)
                                                                          )
                                                                        (= ?blqp ?blqw)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                          (= ?blpf ?blqc)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                              (= ?blpf ?blpj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                              (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                  (= ?blkl ?blkr)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                    (= ?blem ?bler)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (exists ((?bnuc Real) (?bnxp Real) )(exists ((?bnyg Real) )(exists ((?bnyz Real) (?bnza Real) )(and (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (or (or (= ?bnuc ?bnyg)
                                                              (= ?bnuc ?blqw)
                                                              )
                                                            (= ?bnyg ?blqw)
                                                            )
                                                          )
                                                        (or (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (not (= ?bnuc ?bnyg))
                                                          )
                                                        )
                                                      )
                                                    (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                              (= ?bnza ?blqw)
                                                              )
                                                            (= ?bnyz ?blqw)
                                                            )
                                                          (and (and (not (= ?bnxp ?bnyg))
                                                              (not (= ?bnxp ?blqw))
                                                              )
                                                            (not (= ?bnyg ?blqw))
                                                            )
                                                          )
                                                        (and (and (and (not (= ?bnza ?bnyz))
                                                              (not (= ?bnza ?blqw))
                                                              )
                                                            (not (= ?bnyz ?blqw))
                                                            )
                                                          (= ?bnxp ?bnyg)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                    (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                        (not (= ?bmnf ?bmnk))
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                          (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                              (= ?blvm ?blvk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                          (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                              (not (= ?bmca ?bmdy))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                            (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                (not (= ?blpf ?bluu))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                      (not (= ?blpf ?blsx))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                  (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                      (= ?blrl ?blrj)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                            (not (= ?blpg ?blqw))
                                                                            )
                                                                          (not (= ?blpf ?blqw))
                                                                          )
                                                                        (or (or (= ?blqq ?blqp)
                                                                            (= ?blqq ?blqw)
                                                                            )
                                                                          (= ?blqp ?blqw)
                                                                          )
                                                                        )
                                                                      (or (or (or (= ?blpg ?blpf)
                                                                            (= ?blpg ?blqw)
                                                                            )
                                                                          (= ?blpf ?blqw)
                                                                          )
                                                                        (and (and (not (= ?blqq ?blqp))
                                                                            (not (= ?blqq ?blqw))
                                                                            )
                                                                          (not (= ?blqp ?blqw))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                            (not (= ?blpf ?blqc))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                (not (= ?blpf ?blpj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                    (not (= ?blkl ?blkr))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                  (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                      (not (= ?blem ?bler))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (forall ((?bnuc Real) (?bnxp Real) )(forall ((?bnyg Real) )(forall ((?bnyz Real) (?bnza Real) )(or (exists ((?blqw Real) )(or (and (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (and (and (not (= ?bnuc ?bnyg))
                                                                (not (= ?bnuc ?blqw))
                                                                )
                                                              (not (= ?bnyg ?blqw))
                                                              )
                                                            )
                                                          (and (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (= ?bnuc ?bnyg)
                                                            )
                                                          )
                                                        )
                                                      (forall ((?blqw Real) )(and (or (and (and (not (= ?bnza ?bnyz))
                                                                (not (= ?bnza ?blqw))
                                                                )
                                                              (not (= ?bnyz ?blqw))
                                                              )
                                                            (or (or (= ?bnxp ?bnyg)
                                                                (= ?bnxp ?blqw)
                                                                )
                                                              (= ?bnyg ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnza ?bnyz)
                                                                (= ?bnza ?blqw)
                                                                )
                                                              (= ?bnyz ?blqw)
                                                              )
                                                            (not (= ?bnxp ?bnyg))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            (or (and (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                      (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                          (= ?bmnf ?bmnk)
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                            (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                (not (= ?blvm ?blvk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                            (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                (= ?bmca ?bmdy)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                              (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                  (= ?blpf ?bluu)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                        (= ?blpf ?blsx)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                    (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                        (not (= ?blrl ?blrj))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                              (= ?blpg ?blqw)
                                                                              )
                                                                            (= ?blpf ?blqw)
                                                                            )
                                                                          (and (and (not (= ?blqq ?blqp))
                                                                              (not (= ?blqq ?blqw))
                                                                              )
                                                                            (not (= ?blqp ?blqw))
                                                                            )
                                                                          )
                                                                        (and (and (and (not (= ?blpg ?blpf))
                                                                              (not (= ?blpg ?blqw))
                                                                              )
                                                                            (not (= ?blpf ?blqw))
                                                                            )
                                                                          (or (or (= ?blqq ?blqp)
                                                                              (= ?blqq ?blqw)
                                                                              )
                                                                            (= ?blqp ?blqw)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                              (= ?blpf ?blqc)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                  (= ?blpf ?blpj)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                  (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                      (= ?blkl ?blkr)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                    (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                        (= ?blem ?bler)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (exists ((?bnuc Real) )(exists ((?bnuq Real) )(exists ((?bnvk Real) (?bnvl Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?bnvl ?bnvk))
                                                                (not (= ?bnvl ?blqw))
                                                                )
                                                              (not (= ?bnvk ?blqw))
                                                              )
                                                            (or (or (= ?bnuc ?bnuq)
                                                                (= ?bnuc ?blqw)
                                                                )
                                                              (= ?bnuq ?blqw)
                                                              )
                                                            )
                                                          (or (or (or (= ?bnvl ?bnvk)
                                                                (= ?bnvl ?blqw)
                                                                )
                                                              (= ?bnvk ?blqw)
                                                              )
                                                            (not (= ?bnuc ?bnuq))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              (and (or (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                        (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                            (not (= ?bmnf ?bmnk))
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                          (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                              (= ?bmnf ?bmnk)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                              (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                  (= ?blvm ?blvk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                              (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                  (not (= ?bmca ?bmdy))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                    (not (= ?blvm ?blvk))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                    (= ?bmca ?bmdy)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                    (not (= ?blpf ?bluu))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                  (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                      (= ?blpf ?bluu)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                          (not (= ?blpf ?blsx))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                      (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                          (= ?blrl ?blrj)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                        (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                            (= ?blpf ?blsx)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                        (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                            (not (= ?blrl ?blrj))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          (or (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            (and (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                (not (= ?blpf ?blqc))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                              (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                  (= ?blpf ?blqc)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                    (not (= ?blpf ?blpj))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                      (= ?blpf ?blpj)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                    (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                        (not (= ?blkl ?blkr))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                      (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                          (= ?blkl ?blkr)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                      (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                          (not (= ?blem ?bler))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (forall ((?bnuc Real) )(forall ((?bnuq Real) )(forall ((?bnvk Real) (?bnvl Real) )(exists ((?blqw Real) )(or (and (or (or (= ?bnvl ?bnvk)
                                                                  (= ?bnvl ?blqw)
                                                                  )
                                                                (= ?bnvk ?blqw)
                                                                )
                                                              (and (and (not (= ?bnuc ?bnuq))
                                                                  (not (= ?bnuc ?blqw))
                                                                  )
                                                                (not (= ?bnuq ?blqw))
                                                                )
                                                              )
                                                            (and (and (and (not (= ?bnvl ?bnvk))
                                                                  (not (= ?bnvl ?blqw))
                                                                  )
                                                                (not (= ?bnvk ?blqw))
                                                                )
                                                              (= ?bnuc ?bnuq)
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                (or (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                        (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                            (= ?bmnf ?bmnk)
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                              (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                  (not (= ?blvm ?blvk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                              (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                  (= ?bmca ?bmdy)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                    (= ?blpf ?bluu)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                          (= ?blpf ?blsx)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                      (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                          (not (= ?blrl ?blrj))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                (= ?blpg ?blqw)
                                                                                )
                                                                              (= ?blpf ?blqw)
                                                                              )
                                                                            (and (and (not (= ?blqq ?blqp))
                                                                                (not (= ?blqq ?blqw))
                                                                                )
                                                                              (not (= ?blqp ?blqw))
                                                                              )
                                                                            )
                                                                          (and (and (and (not (= ?blpg ?blpf))
                                                                                (not (= ?blpg ?blqw))
                                                                                )
                                                                              (not (= ?blpf ?blqw))
                                                                              )
                                                                            (or (or (= ?blqq ?blqp)
                                                                                (= ?blqq ?blqw)
                                                                                )
                                                                              (= ?blqp ?blqw)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                (= ?blpf ?blqc)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                    (= ?blpf ?blpj)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                    (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                        (= ?blkl ?blkr)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                      (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                          (= ?blem ?bler)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                          (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                              (not (= ?bmnf ?bmnk))
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                    (= ?blvm ?blvk)
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                    (not (= ?bmca ?bmdy))
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                  (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                      (not (= ?blpf ?bluu))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                        (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                            (not (= ?blpf ?blsx))
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                        (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                            (= ?blrl ?blrj)
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                  (not (= ?blpg ?blqw))
                                                                                  )
                                                                                (not (= ?blpf ?blqw))
                                                                                )
                                                                              (or (or (= ?blqq ?blqp)
                                                                                  (= ?blqq ?blqw)
                                                                                  )
                                                                                (= ?blqp ?blqw)
                                                                                )
                                                                              )
                                                                            (or (or (or (= ?blpg ?blpf)
                                                                                  (= ?blpg ?blqw)
                                                                                  )
                                                                                (= ?blpf ?blqw)
                                                                                )
                                                                              (and (and (not (= ?blqq ?blqp))
                                                                                  (not (= ?blqq ?blqw))
                                                                                  )
                                                                                (not (= ?blqp ?blqw))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                              (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                  (not (= ?blpf ?blqc))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                      (not (= ?blpf ?blpj))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                      (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                          (not (= ?blkl ?blkr))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                        (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                            (not (= ?blem ?bler))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    (and (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                            (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                (not (= ?bmnf ?bmnk))
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                              (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                  (= ?bmnf ?bmnk)
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                  (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                      (= ?blvm ?blvk)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                  (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                      (not (= ?bmca ?bmdy))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                    (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                        (not (= ?blvm ?blvk))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                    (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                        (= ?bmca ?bmdy)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                    (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                        (not (= ?blpf ?bluu))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                      (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                          (= ?blpf ?bluu)
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                          (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                              (not (= ?blpf ?blsx))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                          (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                              (= ?blrl ?blrj)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                            (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                                (= ?blpf ?blsx)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                            (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                                (not (= ?blrl ?blrj))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              (or (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                (and (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                    (not (= ?blpf ?blqc))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                  (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                      (= ?blpf ?blqc)
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                    (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                        (not (= ?blpf ?blpj))
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                      (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                          (= ?blpf ?blpj)
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                        (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                            (not (= ?blkl ?blkr))
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                          (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                              (= ?blkl ?blkr)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (forall ((?blem Real) (?blen Real) )(and (not (= ?blen ?blem))
                                                                                          (forall ((?bler Real) )(and (not (= ?blen ?bler))
                                                                                              (not (= ?blem ?bler))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      (or (exists ((?bmnf Real) (?bmng Real) )(or (= ?bmng ?bmnf)
                                                            (exists ((?bmnk Real) )(or (= ?bmng ?bmnk)
                                                                (= ?bmnf ?bmnk)
                                                                )
                                                              )
                                                            )
                                                          )
                                                        (and (forall ((?bmnf Real) (?bmng Real) )(and (not (= ?bmng ?bmnf))
                                                              (forall ((?bmnk Real) )(and (not (= ?bmng ?bmnk))
                                                                  (not (= ?bmnf ?bmnk))
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          (or (and (exists ((?blvl Real) (?blvk Real) )(and (not (= ?blvl ?blvk))
                                                                  (exists ((?blvm Real) )(and (not (= ?blvm ?blvl))
                                                                      (not (= ?blvm ?blvk))
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (exists ((?bmca Real) (?bmcb Real) )(or (= ?bmcb ?bmca)
                                                                  (exists ((?bmdy Real) )(or (= ?bmcb ?bmdy)
                                                                      (= ?bmca ?bmdy)
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            (and (or (forall ((?blvl Real) (?blvk Real) )(or (= ?blvl ?blvk)
                                                                    (forall ((?blvm Real) )(or (= ?blvm ?blvl)
                                                                        (= ?blvm ?blvk)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (forall ((?bmca Real) (?bmcb Real) )(and (not (= ?bmcb ?bmca))
                                                                    (forall ((?bmdy Real) )(and (not (= ?bmcb ?bmdy))
                                                                        (not (= ?bmca ?bmdy))
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                    (exists ((?bluu Real) )(or (= ?blpg ?bluu)
                                                                        (= ?blpf ?bluu)
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                      (forall ((?bluu Real) )(and (not (= ?blpg ?bluu))
                                                                          (not (= ?blpf ?bluu))
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  (or (and (exists ((?blpg Real) (?blpf Real) )(or (= ?blpg ?blpf)
                                                                          (exists ((?blsx Real) )(or (= ?blpg ?blsx)
                                                                              (= ?blpf ?blsx)
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (exists ((?blrj Real) (?blrk Real) )(and (not (= ?blrk ?blrj))
                                                                          (exists ((?blrl Real) )(and (not (= ?blrl ?blrk))
                                                                              (not (= ?blrl ?blrj))
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    (and (or (forall ((?blpg Real) (?blpf Real) )(and (not (= ?blpg ?blpf))
                                                                            (forall ((?blsx Real) )(and (not (= ?blpg ?blsx))
                                                                                (not (= ?blpf ?blsx))
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (forall ((?blrj Real) (?blrk Real) )(or (= ?blrk ?blrj)
                                                                            (forall ((?blrl Real) )(or (= ?blrl ?blrk)
                                                                                (= ?blrl ?blrj)
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      (or (exists ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(exists ((?blqw Real) )(or (and (or (or (= ?blpg ?blpf)
                                                                                    (= ?blpg ?blqw)
                                                                                    )
                                                                                  (= ?blpf ?blqw)
                                                                                  )
                                                                                (and (and (not (= ?blqq ?blqp))
                                                                                    (not (= ?blqq ?blqw))
                                                                                    )
                                                                                  (not (= ?blqp ?blqw))
                                                                                  )
                                                                                )
                                                                              (and (and (and (not (= ?blpg ?blpf))
                                                                                    (not (= ?blpg ?blqw))
                                                                                    )
                                                                                  (not (= ?blpf ?blqw))
                                                                                  )
                                                                                (or (or (= ?blqq ?blqp)
                                                                                    (= ?blqq ?blqw)
                                                                                    )
                                                                                  (= ?blqp ?blqw)
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        (and (forall ((?blqp Real) (?blqq Real) (?blpf Real) (?blpg Real) )(forall ((?blqw Real) )(and (or (and (and (not (= ?blpg ?blpf))
                                                                                      (not (= ?blpg ?blqw))
                                                                                      )
                                                                                    (not (= ?blpf ?blqw))
                                                                                    )
                                                                                  (or (or (= ?blqq ?blqp)
                                                                                      (= ?blqq ?blqw)
                                                                                      )
                                                                                    (= ?blqp ?blqw)
                                                                                    )
                                                                                  )
                                                                                (or (or (or (= ?blpg ?blpf)
                                                                                      (= ?blpg ?blqw)
                                                                                      )
                                                                                    (= ?blpf ?blqw)
                                                                                    )
                                                                                  (and (and (not (= ?blqq ?blqp))
                                                                                      (not (= ?blqq ?blqw))
                                                                                      )
                                                                                    (not (= ?blqp ?blqw))
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                (exists ((?blqc Real) )(or (= ?blpg ?blqc)
                                                                                    (= ?blpf ?blqc)
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                  (forall ((?blqc Real) )(and (not (= ?blpg ?blqc))
                                                                                      (not (= ?blpf ?blqc))
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              (or (exists ((?blpf Real) (?blpg Real) )(or (= ?blpg ?blpf)
                                                                                    (exists ((?blpj Real) )(or (= ?blpg ?blpj)
                                                                                        (= ?blpf ?blpj)
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                (and (forall ((?blpf Real) (?blpg Real) )(and (not (= ?blpg ?blpf))
                                                                                      (forall ((?blpj Real) )(and (not (= ?blpg ?blpj))
                                                                                          (not (= ?blpf ?blpj))
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  (or (exists ((?blkl Real) (?blkm Real) )(or (= ?blkm ?blkl)
                                                                                        (exists ((?blkr Real) )(or (= ?blkm ?blkr)
                                                                                            (= ?blkl ?blkr)
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    (and (forall ((?blkl Real) (?blkm Real) )(and (not (= ?blkm ?blkl))
                                                                                          (forall ((?blkr Real) )(and (not (= ?blkm ?blkr))
                                                                                              (not (= ?blkl ?blkr))
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      (exists ((?blem Real) (?blen Real) )(or (= ?blen ?blem)
                                                                                          (exists ((?bler Real) )(or (= ?blen ?bler)
                                                                                              (= ?blem ?bler)
                                                                                              )
                                                                                            )
                                                                                          )
                                                                                        )
                                                                                      )
                                                                                    )
                                                                                  )
                                                                                )
                                                                              )
                                                                            )
                                                                          )
                                                                        )
                                                                      )
                                                                    )
                                                                  )
                                                                )
                                                              )
                                                            )
                                                          )
                                                        )
                                                      )
                                                    )
                                                  )
                                                )
                                              )
                                            )
                                          )
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (exit)

